function run_gbt_nested_frames
% the run program for the applicationn GBT on nested frames

% suppose nbr_levels sensors
%
% sensor s1 domain is t1,  t2, t3
%
% sensor s2 domain is t11, t12, t13, t21, t22, t31
% where t11, t12, t13 are refinment of t1, t21, t22 of t2, t31 of t3
%
% sensor s3 domain is a refinement of the previous level, etc....
%
% a refinement is a one to many transformation where each parent has 1 to several children, 
% and each child has 1 and only 1 parent

% example 	level 2 = 	Destroyer (node 2) Fregate (node 3) Submarine (node 4)
% 			level 3 = 	Destroyer1 (5) Destroyer2 (6)
%						Fregate1 (7) Fregate2 (8) Fregate3 (9) 
%						Submarine1 (10)
% 			level 4 = 	each level 2 objects has two forms ....

% input see the run_ program
% output bel and pl on singletons 


% triple excecution with (a,b) = .08 .05 or 1 1 or 1E-10 1E-10    (0 0) crash
% a and b are lkh

for i_test = 1:3
	switch i_test
	case 1
		a = .08; b = .05;
		am=a;bm=b;
	case 2 
		a = 1-1E-15;b= a;
	case 3
		a = 1E-15; b = a;
	end

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% defining data only for this applcation, later needs a future GUI
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% % % % var(k).level = 1;
	% % % % var(k).value = 1;
	% % % % var(k).child = {1 2 3};
	% % % % var(k).name = 't1';
	% % % % var(k).lkh = 1;
	
	nbr_levels = 3;
	nbr_elem_per_level = [3 9 39];
	
	k=0;
	k=k+1;var(k) = made_var(1,1,[1,2,3],'t1',.2);
	k=k+1;var(k) = made_var(1,2,[4,5,6],'t2',.7);
	k=k+1;var(k) = made_var(1,3,[7,8,9],'t3',.1);
	
	% a = .08;
	
	k=k+1;var(k) = made_var(2,1,[1:4],'t11',a);
	k=k+1;var(k) = made_var(2,2,[5:7],'t12',.1);
	k=k+1;var(k) = made_var(2,3,[8:9],'t13',.12);
	k=k+1;var(k) = made_var(2,4,[10:20],'t21',.3);
	k=k+1;var(k) = made_var(2,5,[21:25],'t22',a);
	k=k+1;var(k) = made_var(2,6,[26:29],'t23',.6);
	k=k+1;var(k) = made_var(2,7,[30:33],'t31',.08);
	k=k+1;var(k) = made_var(2,8,[34:37],'t32',a);
	k=k+1;var(k) = made_var(2,9,[38:39],'t33',a);
	
	% b = .05;
	
	ipos = 3;
	kk = 0;
	
	for i = 1:3
		for j = 1:3
			ipos = ipos + 1;
			for k1 = 1:length(var(ipos).child)
				kk = kk + 1;
				if k1 <= 9
					name = ['t',num2str(i),num2str(j),num2str(k1)];
				elseif k1 == 10
					name = ['t',num2str(i),num2str(j),'A'];
				elseif k1 == 11
					name = ['t',num2str(i),num2str(j),'B'];
				end	
				k=k+1;var(k) = made_var(3,kk,[],name,b);
			end
		end
	end	

	var( find( strcmp({var(:).name},'t123'))).lkh = .05;
	var( find( strcmp({var(:).name},'t131'))).lkh = .08;
	var( find( strcmp({var(:).name},'t215'))).lkh = .22;
	var( find( strcmp({var(:).name},'t216'))).lkh = .2;
	var( find( strcmp({var(:).name},'t231'))).lkh = .6;
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% building the wc vectors for level 2 only, the frsit is included by vacuous extension, not the last
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	wc = ones(pow2(nbr_elem_per_level(2)),1);
	
	wc(1+bit2num([0 0 0 1 1 1 1 1 1])) = var(1).lkh;
	wc(1+bit2num([1 1 1 0 0 0 1 1 1])) = var(2).lkh;
	wc(1+bit2num([1 1 1 1 1 1 0 0 0])) = var(3).lkh;
	
	for i = 1 : nbr_elem_per_level(2)
		ipos = [1 1 1 1 1 1 1 1 1];
		ipos(i) = 0;
		wc(1+bit2num(ipos))= var(3+i).lkh;
	end

	% wc is built for level 1 and level 2
	% we get the m,pl,betp on level 2
	q = fmt(wc,'w','q');  % q is column
	m = fmt(q,'q','m');
	betp = fmt(m,'m','betp');
	m0 = m(1);
	Q = q./ (1-m0);
	M = m./(1-m0);
	
	fprintf(1,'values of a = %7.4f and b = %7.4f  \n',[a,b]);
	fprintf(1,'      name   index      Bel     BetP       Pl \n',[]);
	for i = 1: nbr_elem_per_level(2)
		fprintf(1,'%10s',var(3+i).name);
		fprintf(1,'   %5i %8.4f %8.4f %8.4f \n',[i M(1+pow2(i-1)) betp(i) Q(1+pow2(i-1))]);
	end

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% level 3: pl123 on singletons
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	kk = 0; kj = 0;
	for i = 1:3
		for j = 1:3
			kj = kj + 1;
			for k = 1:length(var(3+kj).child)
				kk = kk + 1;
				pl123(kk) = var(i).lkh * var(3+kj).lkh * var(12+kk).lkh;
			end
		end
	end

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% level 3: m123({})
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% preparing t(i) : i = 1:9
	
	for i = 1:9
		wb = 12 + var(3+i).child;
		npl = 1-[var(wb).lkh];
		t(i) = prod(npl);
	end

	bb = 1;
	for i = 1:9
		bb = [bb bb*t(i)];
	end

	% 	size(bb) = 1:512
	% 	size(m) = 512 1
	cf123 = bb*m;
	Pl123 = pl123/(1-cf123);	
	fprintf(1,'mass to empty set = %7.4f \n',cf123)
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% level 3: bel123(singleton)
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
	
	for i = 1:9
		tf(i) = 0;
		sps = supersets(pow2(i-1),9);		
		for j = 1:length(sps)
			bits = bits_on(sps(j),9);	
			tf(i) = tf(i) + m(sps(j)+1)*prod([t(bits)]);
		end
	end

	kk = 0; ki = 0; 
	for i=1:3
		for j = 1:3
			ki = ki + 1;
			for k1 = 1:length(var(3+ki).child)
				kk = kk + 1;
				bel123(kk) = (var(12+kk).lkh/(1-var(12+kk).lkh))*tf(ki);
			end
		end
	end	
	Bel123 = bel123/(1-cf123);
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% level 3: BetP limits
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
	
	fprintf(1,'      name   index      Bel       Pl \n',[]);
	for i = 1: length(Pl123)
		fprintf(1,'%10s', var(12+i).name);
		fprintf(1,'   %5i %8.4f %8.4f \n',[i Bel123(i)  Pl123(i)]);
	end


	m_Bel123{i_test} = abs(Bel123) ;
	m_Pl123{i_test} = Pl123;
	m_M{i_test} = abs(M);
	m_Q{i_test} = Q;
	m_betp{i_test} = betp;
	
end
fprintf(1,'\n\n\n');
fprintf(1,'         a = %5.2f, b = %5.2f                  a = b = 1                       a = b = 0  \n',[am,bm]);
fprintf(1,'name      Bel     BetP       Pl          Bel     BetP       Pl           Bel     BetP       Pl \n',[]);
for i = 1: nbr_elem_per_level(2)
	fprintf(1,'%4s',var(3+i).name);
	fprintf(1,' %8.4f %8.4f %8.4f     %8.4f %8.4f %8.4f      %8.4f %8.4f %8.4f \n',...
	[m_M{1}(1+pow2(i-1)) m_betp{1}(i) m_Q{1}(1+pow2(i-1)) ...
	m_M{2}(1+pow2(i-1)) m_betp{2}(i) m_Q{2}(1+pow2(i-1))   ...
	m_M{3}(1+pow2(i-1)) m_betp{3}(i) m_Q{3}(1+pow2(i-1))]);
end
fprintf(1,'\n\n\n');
fprintf(1,'    a = %5.2f, b = %5.2f          a = b = 1             a = b = 0  \n',[am,bm]);
fprintf(1,'name      Bel       Pl          Bel       Pl          Bel       Pl \n',[]);
for i = 1: length(Pl123)
	fprintf(1,'%4s',var(12+i).name);
	fprintf(1,' %8.4f %8.4f     %8.4f %8.4f     %8.4f %8.4f \n',...
	[m_Bel123{1}(i)  m_Pl123{1}(i) ...
	 m_Bel123{2}(i)  m_Pl123{2}(i)   ...
	 m_Bel123{3}(i)  m_Pl123{3}(i)]);
end

