function comparing2bp(ib1,ip1,if1,ib2,ip2,if2)
% entering two bp' and verifying if they are equal
% bp are in belief(ibj).bp(ipj).form(ifj)
% wgere we enter the indexes

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief




[ib3, not_ok] = permute_var_bel(ib2,belief(ib1).domain_variable,'new'); 

for i = 1:3
	belief(ib1).bp(ip1).form(if1).values(i)
	display_set(belief(ib1).bp(ip1).form(if1).focal_sets(i,:),128)	
	belief(ib2).bp(ip2).form(if2).values(i)
	display_set(belief(ib2).bp(ip2).form(if2).focal_sets(i,:),128)	
	belief(ib3).bp(ip2).form(if2).values(i)
	display_set(belief(ib3).bp(ip2).form(if2).focal_sets(i,:),128)	
end

val1 = belief(ib1).bp(ip1).form(if1).values;
foc1 = belief(ib1).bp(ip1).form(if1).focal_sets;
var1 = belief(ib1).domain_variable;
car1 = belief(ib1).domain_cardinality;

val2 = belief(ib3).bp(ip2).form(if2).values;
foc2 = belief(ib3).bp(ip2).form(if2).focal_sets;
var2 = belief(ib3).domain_variable;
car2 = belief(ib3).domain_cardinality;

% comparing the 2 bp().form

fv1 = sortrows([val1 , clean_bits_focal_sets(foc1,prod(car1)) ]);
fv2 = sortrows([val2 , clean_bits_focal_sets(foc2,prod(car2)) ]);

if size(fv1) ~= size(fv2)
	hdw = warndlg('The two bp do not have the same numbers of focal sets.');
	uiwait(hdw);
	return
end

[nr nc] = size(fv1);

if fv1(:,2:nc) == fv2(:,2:nc) 
	fsok = 1;
else
	fsok = 0;
end
if abs(fv1(:,2:nc) - fv2(:,2:nc)) <= 1e-12
	valok = 1;
else
	valok = 0;
end

if valok & fsok	
	hdw = warndlg('The two bp are the same.');
	uiwait(hdw);
elseif valok & ~fsok
	hdw = warndlg('The two bp are equal but do not share the same focal sets');
	uiwait(hdw);
elseif  ~valok & fsok
	hdw = warndlg('The two bp are not equal, but they share the same focal sets');
	uiwait(hdw);
elseif  ~valok & ~fsok
	hdw = warndlg('The two bp are not equal and do not share the same focal sets');
	uiwait(hdw);
end

if ~valok | ~fsok		
	% finding where are the differences, hence printing only those lines where there is a diff
	
	fprintf(1, 'size of set 1: %4i  %4i \n',size(fv1));
	fprintf(1, 'size of set 2: %4i  %4i \n',size(fv2));
	
	indeq1 = find(ismember(fv1,fv2,'rows'));	
	indeq2 = find(ismember(fv2,fv1,'rows'));
	
	fv1(indeq1,:) = [];
	fv2(indeq2,:) = [];
	
	fprintf(1, 'size of set 1 after elimination of equal sets %4i  %4i \n',size(fv1));
	fprintf(1, 'size of set 2 after elimination of equal sets %4i  %4i \n',size(fv2));
	
	cardinality = prod(car1);
	[nr nc] = size( fv1);
	
	for ii = 1:min([10,size(fv1,1),size(fv2,1)])
		i = size(fv1,1)+1-ii; % so we get the largest masses first
		fprintf(1,'\n \nmasses are %g  %g , difference =  %g \n',[fv1(i,1),fv2(i,1), fv1(i,1)-fv2(i,1)]);
		display_set(fv1(i,2:nc),cardinality)	
		display_set(fv2(i,2:nc),cardinality)
		b1 = long_num2bit(fv1(i,2:nc),cardinality);
		b2 = long_num2bit(fv2(i,2:nc),cardinality);
		xfv = long_bit2num(xor(b1,b2),cardinality);
		display_set(xfv,cardinality)		
	end
end	


