function [bel_index, bp_index, form_index] = selecting_one_bel_fct
% selecting one particular belief(bel_index).bp(bp_index).form(form_index) 

% can be quit at each selection step

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global gui_position belief

[index_fig, hd_fig] = handling_all_figures('put_in_front',{'General Window'});
detail_handle = hd_fig(1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% selecting the belief object
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
hlist = listing_existing('belief',gui_position(:,6),detail_handle);
text = 'select in the list, the belief which potential you want to use, then Done';
set(hlist(2),'Enable','on','max',1,'min',0,'Value',[1]);
[choice] = text_with_n_buttons(detail_handle,text, {'Done','Cancel'}, []);
if choice == 2
	return
end
% get the index for the requested belief object
bel_index = pin_manipulation('belief','pos2ind',get(hlist(2),'Value'));
% the index of the object you want to see		
delete(hlist)  % put listbox away	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% selecting the bp in the selected belief object
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if length(belief(bel_index).bp) <= 1
	bp_index = 1;
else
	hlist = listing_existing('potential',gui_position(:,6),detail_handle,bel_index);	
	text = 'select in the list, the potential you want to use, then Done';
	set(hlist(2),'Enable','on','max',1,'min',0,'Value',[1]);
	[choice] = text_with_n_buttons(detail_handle,text, {'Select','Quit'}, []);
	if choice == 2
		return
	end
	% get the position,index,number for the requested structure
	bp_index  = get(hlist(2),'Value'); % position = index for bp	
	% the index of the object you want to see		
	delete(hlist)  % put listbox away	
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% selecting the form in the selected bp in the selected belief object
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if length(belief(bel_index).bp(bp_index).form) <= 1
	form_index = 1;
else
	% selecting the form for that belief(bel_index).bp(bp_index).form
	hlist = listing_existing('form',gui_position(:,6),detail_handle,[bel_index,bp_index]);	
	text = 'select in the list, the bp_form you want to use, then Done';
	set(hlist(2),'Enable','on','max',1,'min',0,'Value',[1]);
	[choice] = text_with_n_buttons(detail_handle,text, {'Select','Quit'}, []);
	if choice == 2
		return
	end
	% get the position,index,number for the requested structure
	form_index  = get(hlist(2),'Value'); % position = index for bp	
	% the index of the object you want to see		
	delete(hlist)  % put listbox away	
end
