function [bp_index, form_index, ok] = get_my_bp(ind_bel,calculator_handle)
% you get bp index and form where  belief with ind_bel, num_bel
% store its m fct
% if no m,  I  generate it
% i don't profit from q and b products

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global gui_position belief pin_belief

% I check there is a bp
% OK code 0 = no bp, 1 = several m types in one bp, 2 = no m for one bp,   9 = OK
if length(belief(ind_bel).bp) == 0
	% there is no bp for that belief, not OK, 
	hdw = warndlg(['There is NO potential for belief ',...
	belief(ind_bel).full_name,'. I skip this belief object.']);
	uiwait(hdw)
	ok = 0;
	form_index = [];
	bp_index = [];
elseif length(belief(ind_bel).bp) == 1
	% only one, I take it if m
	bp_index = 1;		
	% I build a m if lacking
	[computed_forms,uncomputed_forms, error_mode] = transform_bp(ind_bel,bp_index,{'m'});
	form_index = find(strcmp({belief(ind_bel).bp(1).form(:).type},'m'));	
else 
	% several bp, ask which one to user
	hd_bp = listing_existing('potential',gui_position(:,6),calculator_handle,ind_bel);
	text = 'Select the bp you want me to use.';
	set(hd_bp(2),'max',1,'enable','on','value',1);
	choice = text_with_n_buttons(calculator_handle, text, {'OK','Cancel'}, gui_position(:,13));
	if choice == 2
		delete(hd_bp)
		ok = 0;
		form_index = [];
		bp_index = [];		
		return
	else
		bp_index = get(hd_bp(2),'value');		
		delete(hd_bp)	
		% I build a m if lacking
		[computed_forms,uncomputed_forms, error_mode] = transform_bp(ind_bel,bp_index,{'m'});
		form_index = find(strcmp({belief(ind_bel).bp(bp_index).form(:).type},'m'));
	end
end

if length(form_index) == 1
	ok = 9;
elseif length(form_index) == 0
	ok = 2 ; % no m function in that bp, I am stuck
	hdw = warndlg(['There is NO m function for this potential ',...
	belief(ind_bel).full_name,'. Go the Tools/Get new forms menu, and build the m function.',...
	'I skip this belief object.']);	
	uiwait(hdw)		
else
	ok = 1;
	hdw = warndlg(['There is more than one m function for this potential ',...
	belief(ind_bel).full_name,'. Clean up your belief object.',...
	'I skip this belief object.']);	
	uiwait(hdw)					
	% too many m forms with 1 bp. Several m should never occur, none can.
end	


