%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the pure AND or OR combinations
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global flags

switch which_combi
case 'and'
	how = 'conjunctively (AND)';
	bitwhat = 'bitand';
case 'or'
	how = 'disjunctively (OR)';
	bitwhat = 'bitor';
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% unique belief objects wit a m have been selected
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% building expr with bitand / bitor only. expr is only for storing origin in belief object

eval_expr = strcat(bitwhat,'(B(:,:,1),B(:,:,2))');

expr = ['<', num2str(num_belief(1)),'.', num2str(index_belief(1)),'.', ...
num2str(bp_index(1)),'.', num2str(form_index(1)),'>'];

expr = [expr, ' ', which_combi,' <', num2str(num_belief(2)),'.', num2str(index_belief(2)),'.', ...
num2str(bp_index(2)),'.', num2str(form_index(2)),'>'];

for i = 3:nbr_m
	ln = num2str(i);
	eval_expr = strcat(bitwhat,'(',eval_expr,',B(:,:,',ln,'))');
	
	expr = [expr, ' ',which_combi,' <', num2str(num_belief(i)),'.', num2str(index_belief(i)),'.', ...
	num2str(bp_index(i)),'.', num2str(form_index(i)),'>'];
end

expr_ok = 1;
fprintf(1,'\nList of beliefs used in the combination. \n  index  number index_belief index_potential  index_form\n',[])
list_bbf_unique = [num_belief', index_belief', bp_index', form_index'];	

for i = 1:nbr_m
	fprintf(1,'%5i%8i%13i%16i%12i\n',[i list_bbf_unique(i,:)]);
	ln = num2str(i);
	list_bbf_labels(i,:) = strcat('B[:,:,',ln,']'); 
end														


