%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the mixed combinations
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global Which_Courier

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the conversation boxes to build the logical expression
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

h_expr(1) = uicontrol(...
'Parent',calculator_handle, ...
'Position',gui_position(:,15)' + [.002 .002 -.004 -.004], ...
'Style','edit', ...
'HorizontalAlignment','left', ...
'FontName',Which_Courier,...
'String',' ');

h_expr(3) = uicontrol(...
'Parent',calculator_handle, ...
'Position',gui_position(:,15)' + [.002 .006+gui_position(4,15)  -.004 -.004], ...
'Style','frame');

h_expr(2) = uicontrol(...
'Parent',calculator_handle, ...
'Position',gui_position(:,15)' + [.004 .008+gui_position(4,15)  -.008 -.008], ...
'Style','text', ...
'HorizontalAlignment','left', ...
'FontName',Which_Courier,...
'String',' ');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% building the logical operators
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

log_expr_wrong  = 1; % we proceed up to a correct expression, unused in fact
expr_name = [];
expr = [];

while log_expr_wrong 
	
	gogo_on = 1;
	
	while gogo_on 
		bbf = [];
		
		% we proceed and know where to store results
		
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% list of logical operators
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		button_operator = {'and','or','not','(',')','end','clear','cancel'};		
		
		hd_but1 = button_list(calculator_handle, gui_position(:,7), 'Logical Operators', ...
		button_operator, 'clb_button_list_DistCombi(1,'); % )
		
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% list of bp
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		hd_but2 = button_list(calculator_handle, gui_position(:,6), 'Belief List', ...
		belief_list, 'clb_button_list_DistCombi(2,');
		% order of button = order of the bp )
		% list_num_bp = [45 6 32] ...
		% located at list_ind_bp = [2 7 4] in buttons position flag(1) = [1 2 3]
		% so var 32 is index 4 in button 3
		figure(calculator_handle);
		uiwait(calculator_handle)	 
		
		butt = flags(1); % flags(1) is callback return number
		logbp = flags(2);
		
		switch logbp
		case 1 % logical operator
			switch butt
			case 6  % End
				gogo_on = 0;
			case 7 % clear
				expr_name = [];
				expr = [];
				% and display them
				set(h_expr(1),'String', expr);	
				set(h_expr(2),'String', expr_name)						
			case 8 % cancel
				expr_name = [];
				expr = [];
				choice19 = 2; % skip next comput	 				
				return
			otherwise
				% we add a new operator to the logical epxression
				expr = [expr,' ',button_operator{butt}];
				expr_name = [expr_name,' ',button_operator{butt}];
				% and display them
				set(h_expr(1),'String', expr);	
				set(h_expr(2),'String', expr_name)						
			end
		
		case 2 % bp 
	
			% produced by get_bel_bp_forms: [index_belief' bp_index' form_index' num_belief']	
			% butt = 1,2... same order as as index_belief
			index_belief_sel = index_belief(butt);
			num_belief_sel   = num_belief(butt);						
			bp_index_sel = bp_index(butt);	
			form_index_sel = form_index(butt);	
			
			bbf = [bbf ; index_belief_sel bp_index_sel form_index_sel num_belief_sel]; 
			% numerical representation of used bp
			
			bbf_str = strcat('<',num2str(num_belief_sel),'.',num2str(index_belief_sel),'.',...
			num2str(bp_index_sel),'.',num2str(form_index_sel),'>');
			% I need 9 char for being able to create  B(:,:,ii) for the eval 
			% with <n.x.y.z> I have at least 9 char, 
			% I may not use () here as they mean something for the logical expression
			% so I put < and >, to be replaced later
			
			% we add a new bp to the logical expression 
			expr = [expr,' ',bbf_str]; % the line with <n.x.y.z>, used for computing mixed combi
			
			% we build the full_name display, just for display
			expr_name = [expr_name,' ',belief_list{butt}];
			
			% and display both
			set(h_expr(1),'String', expr)		
			set(h_expr(2),'String', expr_name)		
			
		end % switch logbp
	end % while gogo_on where we build the logical expression    
	% request input over
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% translating request expr into an evaluable fct evel_expr
	% expr_ok = 1 if the expression expr is logically evaluable
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	[eval_expr,list_bbf_unique,list_bbf_labels,expr_ok] = translating_request(expr);
	if expr_ok == 1
		log_expr_wrong = 0;
	end
end		
