function param_out = deleting_objects(what_object, which_object)
% deleting the what_objects with object().number = which_object
% which_object is a vector with the numbers of the object to delete

%
%   Version : Jan 10, 03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief

% I define once param_out otherwise Matlab makes an ugly comment
param_out{1} = [];

del_fra_ind_mem = [];
del_str_ind_mem = [];
del_map_ind_mem = [];
del_att_ind_mem = [];
del_var_ind_mem = [];
del_bel_ind_mem = [];

del_fra_num_mem = [];
del_str_num_mem = [];
del_map_num_mem = [];
del_att_num_mem = [];
del_var_num_mem = [];
del_bel_num_mem = [];

del_fra_ind = [];
del_str_ind = [];
del_map_ind = [];
del_att_ind = [];
del_var_ind = [];
del_bel_ind = [];

del_fra_num = [];
del_str_num = [];
del_map_num = [];
del_att_num = [];
del_var_num = [];
del_bel_num = [];

switch what_object	
case 'frame'
	task_begin = 1;
	del_fra_num = which_object;
	del_fra_ind = pin_manipulation('frame','num2ind',del_fra_num);
case 'structure'
	task_begin = 2;
	del_str_num = which_object;
	del_str_ind = pin_manipulation('structure','num2ind',del_str_num);
case 'mapping'
	task_begin = 3;
	del_map_num = which_object;		
	del_fra_ind = pin_manipulation('mapping','num2ind',del_fra_num);
case 'attribute'
	task_begin = 5;
	del_att_num = which_object;
	del_att_ind = pin_manipulation('attribute','num2ind',del_att_num);
case 'variable'
	task_begin = 6;
	del_var_num = which_object;
	del_var_ind = pin_manipulation('variable','num2ind',del_var_num);
case 'belief'
	task_begin = 7;
	del_bel_num = which_object;
	del_bel_ind = pin_manipulation('belief','num2ind',del_bel_num);
end		

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% structure
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if task_begin <= 2 
	% add delete structure where frame is the most refined one
	if length(structure) & length(del_fra_num)
		for i = 1:length(structure)
			if ismember( structure(i).most_refined , del_fra_num)
				del_str_ind = [del_str_ind i];
			end
		end
		del_str_ind = unique(del_str_ind);
		del_str_num = pin_manipulation('structure','ind2num',del_str_ind);
	end
end

% To be kept for future mapping
%
% 	if task_begin <= 3 % mapping		
% 		% delete all mapping where this frame is used
% 		if length(mapping)
% 			nbr_out = intersect([mapping(:).finer  mapping(:).coarser] , del_fra_num);
% 			del_map_ind = unique([...
% 			find(ismember([mapping(:).finer],nbr_out)) ...
% 			find(ismember([mapping(:).coarser],nbr_out)) ]);
% 			del_map_num = pin_manipulation('mapping','ind2num',del_map_ind);
% 		end		
% 	end
% 
% 	% putting 0 in mapping of structure using deleted mapping
% 	for jj = 1:length(del_map_num)
% 		for ii = 1:length(structure)
% 			[i, j] = find([structure(ii).mapping] == del_map_num(jj));				
% 			for k =1:length(i)
% 				structure(ii).mapping(i(k),j(k)) = 0;
% 			end
% 		end
% 	end
% 

% eliminate frame from the structure sub_frames, done here
% adapting structure.mapping. Row column delete, done here. 
% Only for subframes, as deleting most refined implies deleting the whole strucuture

if length(del_fra_num)
	for i = 1:length(structure)	
		if ~isempty(structure(i).sub_frames) 
			strsf_ind = find( [structure(i).sub_frames] == del_fra_num);			
			structure(i).sub_frames(strsf_ind) = [];
			% structure(i).mapping(strsf_ind+1,:) = []; % + 1 for the most refined frame
			% structure(i).mapping(:,strsf_ind+1) = [];
		end
	end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% attribute
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if task_begin <= 5 
	% eliminate attribute using a deleted structure or where an index uses a deleted frame
	del_sup = [];
	if length(attribute) & length(del_str_num)
		for i = 1:length(attribute)
			if ismember(attribute(i).structure, del_str_num)
				del_att_ind = [del_att_ind i];
			end
		end
	end
	if length(attribute) & length(del_fra_num)
		for i = 1:length(attribute)	
			if length(attribute(i).index) 
				if ~isempty(intersect( [attribute(i).index(:).frame] , del_fra_num));
					del_att_ind = [del_att_ind i];
				end
			end
		end
	end

	del_att_ind = unique([del_att_ind]);
	del_att_num = pin_manipulation('attribute','ind2num',del_att_ind);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% variable
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if task_begin <= 6 
	% eliminate variable using a deleted frame or attribute
	if length(variable) 		
		for i = 1:length(variable)
			if length(del_att_num)
				if ismember(variable(i).attribute, del_att_num)
					del_var_ind = [del_var_ind i];
				end
			end
			if length(del_fra_num)
				if ismember(variable(i).frame, del_fra_num)
					del_var_ind = [del_var_ind i];
				end
			end
		end
		del_var_ind = unique([del_var_ind]);
		del_var_num = pin_manipulation('variable','ind2num',del_var_ind);		
	end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% belief
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if task_begin <= 7 
	% eliminate all belief using deleted variable as domain_variable or conditioning_variable	
	if length(belief) & length(del_var_num)
		for i = 1:length(belief) 
			if  max([ismember([belief(i).domain_variable],del_var_num)]) | ...
				max([ismember([belief(i).conditioning_variable],del_var_num)])
				del_bel_ind = [del_bel_ind i];
			end	
		end
		del_bel_ind = unique([del_bel_ind]);
		del_bel_num = pin_manipulation('belief','ind2num',del_bel_ind);
	end
end
% beware belief().domain_variable is a list, not a single number.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% end
%	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% I am careful and ask if you agree in calling fcn (object_editor). 
if ismember(what_object,{'frame','structure','attribute','variable'})	
	param_out{1} = del_fra_ind;
	param_out{2} = del_str_ind;
	param_out{3} = del_map_ind;
	param_out{4} = del_att_ind;
	param_out{5} = del_var_ind;
	param_out{6} = del_bel_ind;	
else
	% deleting what must be so
	if length(del_fra_ind);   	frame(del_fra_ind) = [];     	end
	if length(del_str_ind);  	structure(del_str_ind) = []; 	end
	% 	if length(del_map_ind); 	mapping(del_map_ind) = []; 		end
	if length(del_att_ind); 	attribute(del_att_ind) = []; 	end
	if length(del_var_ind); 	variable(del_var_ind) = []; 	end
	if length(del_bel_ind); 	belief(del_bel_ind) = []; 		end	
	% rebuilding the pin tables
	get_all_pin_tables;
end

return

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%    I quit here all done        %%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% what is behind is past archive to delete one day

del_bel_ind_mem = [del_bel_ind_mem del_bel_ind];
del_var_ind_mem = [del_var_ind_mem del_var_ind];
del_att_ind_mem = [del_att_ind_mem del_att_ind];
del_map_ind_mem = [del_map_ind_mem del_map_ind];
del_str_ind_mem = [del_str_ind_mem del_str_ind];
del_fra_ind_mem = [del_fra_ind_mem del_fra_ind];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% case 'structure'
%	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% case 'structure'

del_str_num = which_object;
del_str_ind = pin_manipulation('structure','num2ind',del_str_num);

% eliminate attribute using a deleted structure
del_att_num = [];
if length(attribute)
	del_att_ind = find(ismember([attribute(:).structure],...
	intersect([attribute(:).structure] , del_str_num)));
	del_att_num = pin_manipulation('attribute','ind2num',del_att_ind);
end

% eliminate variable using a deleted attribute
if length(variable)
	del_var_ind = find(ismember([variable(:).attribute],...
	intersect([variable(:).attribute] , del_att_num)));
	del_var_num = pin_manipulation('variable','ind2num',del_var_ind);
end

% eliminate all belief using that variable as variable or conditioning_variable		
for i = 1:length(belief)
	nbr_out = intersect([belief(:).domain_variable   belief(:).conditioning_variable] , del_var_num);					
	if  max([ismember([belief(i).domain_variable],nbr_out)]) | ...
		max([ismember([belief(i).conditioning_variable],nbr_out)])
		del_bel_ind = [del_bel_ind i];
	end	
end
% beware belief().domain_variable is a list, not a single number.

del_str_ind_mem = [del_str_ind_mem del_str_ind];
del_att_ind_mem = [del_att_ind_mem del_att_ind];
del_var_ind_mem = [del_var_ind_mem del_var_ind];
del_bel_ind_mem = [del_bel_ind_mem del_bel_ind];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% case 'mapping'
%	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% case 'mapping'

del_map_num = which_object;
del_map_ind = pin_manipulation('mapping','num2ind',del_map_num);	

% delete structure using a delete mapping
for j = 1:lengtgh(del_map_num)
	for i = 1:length(structure)
		if ~isempty(find([structure(i).mapping] == del_map_num(j)))
			del_str_ind = [ del_str_ind i];
		end
	end
end
del_str_ind = unique([del_str_ind]);
del_str_num= pin_manipulation('structure','ind2num',del_str_ind);

% eliminate attribute using a deleted structure
if length(attribute)
	del_att_ind = find(ismember([attribute(:).structure],...
	intersect([attribute(:).structure] , del_str_num)));
	del_att_num = pin_manipulation('attribute','ind2num',del_att_ind);
end

% eliminate variable using a deleted attribute
if length(variable)
	del_var_ind = find(ismember([variable(:).attribute],...
	intersect([variable(:).attribute] , del_att_num)));
	del_var_num = pin_manipulation('variable','ind2num',del_var_ind);
end

% eliminate all belief using that variable as variable or conditioning_variable		
nbr_out = intersect([belief(:).domain_variable   belief(:).conditioning_variable] , del_var_num);					
for i = 1:length(belief)
	if  max([ismember([belief(i).domain_variable],nbr_out)]) | ...
		max([ismember([belief(i).conditioning_variable],nbr_out)])
		del_bel_ind = [del_bel_ind i];
	end	
end
% beware belief().domain_variable is a list, not a single number.

del_str_ind_mem = [del_str_ind_mem del_str_ind];
del_map_ind_mem = [del_map_ind_mem del_map_ind];
del_att_ind_mem = [del_att_ind_mem del_att_ind];
del_var_ind_mem = [del_var_ind_mem del_var_ind];
del_bel_ind_mem = [del_bel_ind_mem del_bel_ind];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% case 'attribute'
%	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% case 'attribute'
del_att_num = which_object;
del_att_ind = pin_manipulation('attribute','num2ind', del_att_num);

% eliminate variable using a deleted attribute
if length(variable)
	del_var_ind = find(ismember([variable(:).attribute],...
	intersect([variable(:).attribute] , del_att_num)));
	del_var_num = pin_manipulation('variable','ind2num',del_var_ind);
end

% eliminate all belief using that variable as variable or conditioning_variable	
if length(belief) & length(del_var_num)
	if isfield(belief,'domain_variable') 
		if isfield(belief,'conditioning_variable') 
			nbr_out = intersect([belief(:).domain_variable   belief(:).conditioning_variable] , del_var_num);
			% beware belief().domain_variable is a list, not a single number.
			for i = 1:length(belief)
				if  max([ismember([belief(i).domain_variable],nbr_out)]) | ...
					max([ismember([belief(i).conditioning_variable],nbr_out)])
					del_bel_ind = [del_bel_ind i];
				end	
			end
		end
	end
end

del_att_ind_mem = [del_att_ind_mem del_att_ind];
del_var_ind_mem = [del_var_ind_mem del_var_ind];
del_bel_ind_mem = [del_bel_ind_mem del_bel_ind];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% case 'variable'
%	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% case 'variable'

del_var_num = which_object;
del_var_ind = pin_manipulation('variable','num2ind',del_var_num);

nbr_out = [];
if isfield(belief,'domain_variable') 
	if isfield(belief,'conditioning_variable') 
		% eliminate all belief using that variable as variable or conditioning_variable	
		nbr_out = intersect([belief(:).domain_variable   belief(:).conditioning_variable] , del_var_num);					
	end
	nbr_out = intersect([belief(:).domain_variable] , del_var_num);	
end
if length(nbr_out)
	for i = 1:length(belief)
		if  max([ismember([belief(i).domain_variable],nbr_out)]) | ...
			max([ismember([belief(i).conditioning_variable],nbr_out)])
			del_bel_ind = [del_bel_ind i];
		end	
	end
end
% beware belief().domain_variable is a list, not a single number.

del_var_ind_mem = [del_var_ind_mem del_var_ind];
del_bel_ind_mem = [del_bel_ind_mem del_bel_ind];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% case 'belief'
%	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% case 'belief'

del_bel_num_mem = [del_bel_num_mem   which_object];
del_bel_ind_mem = pin_manipulation('belief','num2ind', del_bel_num_mem);	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% end
%	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

del_fra_ind_mem = unique(del_fra_ind_mem);
del_str_ind_mem = unique(del_str_ind_mem);
del_map_ind_mem = unique(del_map_ind_mem);
del_att_ind_mem = unique(del_att_ind_mem);
del_var_ind_mem = unique(del_var_ind_mem);
del_bel_ind_mem = unique(del_bel_ind_mem); 
% I have here the list of indexes of object to be deleted

% I am careful and ask if you agree in calling fcn (object_editor). 

if ismember(what_object,{'frame','structure','attribute','variable'})	
	param_out{1} = del_fra_ind_mem;
	param_out{2} = del_str_ind_mem;
	param_out{3} = del_map_ind_mem;
	param_out{4} = del_att_ind_mem;
	param_out{5} = del_var_ind_mem;
	param_out{6} = del_bel_ind_mem;	
else
	% deleting what must be so
	if length(del_fra_ind_mem);   	frame(del_fra_ind_mem) = [];     	end
	if length(del_str_ind_mem);  	structure(del_str_ind_mem) = []; 	end
	if length(del_map_ind_mem); 	mapping(del_map_ind_mem) = []; 		end
	if length(del_att_ind_mem); 	attribute(del_att_ind_mem) = []; 	end
	if length(del_var_ind_mem); 	variable(del_var_ind_mem) = []; 	end
	if length(del_bel_ind_mem); 	belief(del_bel_ind_mem) = []; 		end	
	% rebuilding the pin tables
	get_all_pin_tables;
end
