function [univd,univci] = get_universe_dci(ind_bel,option)
% building universe for option = domain or conditioning 
% valid if only ONE variable  
% for discr, build their produt space
% for CI, we can have several

% univd : universe discrete, one long_number
% univci: [min, max; min max; ....]

% for continuous, card = infinity, universe is [min, max]
% for integers,   card = integers, universe is [min, max]
% but there is no focal set for them.

global belief frame variable

if nargin == 1
	option = 'domain'
end

switch option
case 'domain'
	num_var = belief(ind_bel).domain_variable;
case 'conditioning'
	num_var = belief(ind_bel).conditioning_variable;
end

univci = [];
univd = [];

[list_discr, list_continuous, list_integers] = type_variable(num_var);

if ~isempty(list_discr)
	switch option
	case 'domain'
		univd = get_universe(prod(belief(ind_bel).domain_cardinality(list_discr.pos)));
	case 'conditioning'
		univd = get_universe(prod(belief(ind_bel).conditioning_cardinality(list_discr.pos)));
	end
end

if ~isempty(list_continuous) | ~isempty(list_integers)
	[ind_fra] = frame_of_belief(ind_bel);	
	[list_ci_pos useless] = sort([list_continuous.pos list_integers.pos]);
	ind_ci_fr = ind_fra(list_ci_pos); % may be a vector
	univci = [[frame(ind_ci_fr).min]'    [frame(ind_ci_fr).max]'];
end

