function info = information_content(m,foset,card)
% computing some info content in m

% INPUT : 
% 	m = the bba
%	foset = the focal set as long numbers
% 	card = nbr element in frame of discernement of m

% OUTPUT:
%	info(1) = sum |A| m(A)
% 	info(2) = sum log(|A|) m(A)
%	info(3) = sum |A| M(A)
% 	info(4) = sum log(|A|) M(A)

%
%   Version : June 19, 03
%   Copyright (c) 2003 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

info(1) = 0;
info(2) = 0;
info(3) = 0;
info(4) = 0;

m0 = 0;
for i = 1:length(m)
	bit_on = long_num2onbit([foset(i,:)], card);
	info(1) = info(1) + m(i)*length(bit_on);
	if length(bit_on)
		info(2) = info(2) + m(i)*log(length(bit_on));
	else
		m0 = m0 + m(i);
	end
end
info(3) = info(1)/(1-m0);
info(4) = info(2)/(1-m0);
