function [new_focal, new_card,partition] = minimal_space(focal_sets,cardinality)
% finds the smallest space that underlies a set of focal sets
% the new space is just a coarsening of the initial one
% worlds arfe lableed 1 to cardinality in input domain
% and 1 to new_card in output domain

% we also produce the caqrdinality relation 

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%




global nbr_bit_per_word 

nbr_bit_per_word = 50;

[nw rm] = words_for_set(cardinality);

if rm == 0
	nw = nw-1;
	rm = nbr_bit_per_word;
end
% so we are sure rm is not 0

[nbr_w useless] = size(focal_sets);


space = [ focal_sets(1,:) ; ...
bitcmp(focal_sets(1,1:nw),nbr_bit_per_word) ...
bitcmp(focal_sets(1,nw+1),rm)];

for iw = 2:nbr_w
	[nsp useless] = size(space);
	in = 0;
	for i = 1:nsp
		new_foc = bitand(space(i,:),focal_sets(iw,:));
		if new_foc ~= 0
			in = in + 1;
			new_space(in,:) = new_foc;
		end			
		notfoc = [bitcmp(focal_sets(iw,1:nw),nbr_bit_per_word) ...
		bitcmp(focal_sets(iw,nw+1),rm) ];
		new_foc = bitand(space(i,:),notfoc);
		if new_foc ~= 0
			in = in + 1;
			new_space(in,:) = new_foc;
		end	
	end
	space = new_space;
end
% space = a list of subsets of the initial space, 
% each element of the list is a granule in the new space

[new_card useless] = size(space);
partition(1:cardinality) = 0;
for i = 1:new_card
	partition(long_num2onbit(space(i,:), cardinality)) = i;
end
% partition tells which new gramule the element of the initial space falls in

if ~isempty(find(partition == 0))
	BOUM % It should NEVER be empty
end

% building the focal sets with the new elements
for i = 1:nbr_w
	long_num2onbit(focal_sets(i,:), cardinality);
	elem = unique(partition(long_num2onbit(focal_sets(i,:), cardinality)));
	new_set(1:new_card) = 0; % all 0
	new_set(elem) = 1; % those on 
	new_focal(i,:) = long_bit2num(new_set,new_card);
end



