function okreturn = build_ordered_from_sel(bel_ind,bp_ind)
% tranformikng a bp m in selected mode intgo a ordered mode
% ok if cardinality <= 18

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%


global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief

form_ind = find(~isempty(belief(bel_ind).bp(bp_ind).form(:)));

switch length(form_ind) 

case 0
	% stupid, you ask transfo of nothing
	hdw = warndlg('Error: transforming an empty bp. Back to menus');
	uiwait(hdw);
	okreturn = 0;
	return
	
case 1 
	form_type = belief(bel_ind).bp(bp_ind).form(form_ind).type;
	switch form_type
	
	case 'm'
		okreturn = 1;	
		nbr_elem = prod(belief(bel_ind).domain_cardinality);
		if nbr_elem > 18	
			hdw = warndlg('Error: cardibnality too large: Max = 18. Back to menus');
			uiwait(hdw);
			okreturn = 0;
			return
		else	
			if strcmp(belief(bel_ind).bp(bp_ind).form(form_ind).representation,'selected')
				okreturn = 1;
				% this is what is normaly expected: a single selected m
				bbm = belief(bel_ind).bp(bp_ind).form(form_ind).values;
				foset = belief(bel_ind).bp(bp_ind).form(form_ind).focal_sets;				
				m = zeros(pow2(nbr_elem),1);
				for i = 1:length(bbm)
					% as there is <= 18 element, ONE word is enough for focal sets
					m(foset(i)+1,1) = bbm(i);
				end	
				% storing it 
				new_form_ind = length(belief(bel_ind).bp(bp_ind).form(:)) + 1;
				belief(bel_ind).bp(bp_ind).form(new_form_ind).type = 'm';
				belief(bel_ind).bp(bp_ind).form(new_form_ind).representation = 'ordered';
				belief(bel_ind).bp(bp_ind).form(new_form_ind).values = m;
				
			else		
				% it was already ordered so I skip			
				return
			end
		end	
	
	otherwise
		hdw = warndlg('Error: transforming a bp without m. Back to menus');
		uiwait(hdw);
		okreturn = 0;
		return
		
	end

otherwise
	hdw = warndlg('Error: several m fct for this bp. Back to menus');
	uiwait(hdw);
	okreturn = 0;
	return
	
end						
