function [out_foset] = get_n_random_foset(nbr,card)
% produce nbr subsets among the nbr_subsets = pow2(card)
% data are 0 to nbr_subsets-1
% out_foset is vertical, ready for focal_sets

global nbr_bit_per_word

if card <= nbr_bit_per_word	 % the classical case
	nbr_subsets = pow2(card);
	if nbr == nbr_subsets
		out_foset = [0:nbr-1]'; % exhaustive selection
	else
		if card > 13 % very many elements
			out_foset = unique(fix(nbr_subsets*rand(1,nbr))) + 1;
			if length(out_foset) < nbr
				while length(out_foset) < nbr
					j = fix(nbr_subsets*rand(1)) + 1;	
					if ~ismember(j,out_foset)
						out_foset = [out_foset j];
					end
				end		
			end
		else
			nbr_left = nbr;
			j = 0;
			for i = 0:nbr_subsets-1		
				if rand(1) < nbr_left/(nbr_subsets - i)
					j = j + 1;
					out_foset(j) = i;
					nbr_left = nbr_left - 1;
				end
			end	
		end
		out_foset = out_foset';
	end	
else  % card > 50  and normaly nbr <= 512	
	for i = 1:nbr
		temp_foset(i,:) = long_onbit2num(find(rand(1,card)>.5),card);
	end	
	out_foset = unique(temp_foset,'rows');
	if size(out_foset,1) < nbr
		while size(out_foset,1) < nbr
			j = long_onbit2num(find(rand(1,card)>.5),card);
			if ~ismember(j,out_foset,'rows')
				out_foset = [out_foset;j];
			end
		end		
	end
end	
