function ok_out = exist_object(str_object,num_obj,set_str_fields)
% check that one given object exist and has requestes fields

% str_object = 'frame' or ... 'belief'
% set_str_fields = {'field1','field2',...}
% ok_out = 0 = object is empty (after eliminating those with empty number)
% ok_out = 1 object(ind_obj) exist, and object(ind_obj).number exists
% and object(ind_obj).set_str_fields{i} exists for all i

%
%   Version : Jan 9,03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief

eval(['object =',str_object,';']'   , 'object = [];');
eval(['pin_object = pin_',str_object,';']'   , 'pin_object = [];');

if length(num_obj) == 0;
	% what a stupid request
	ok_out = [];
	return
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% I check object is clean
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if length(object) == 0
	ok_out = 0;
	useless = pin_manipulation(str_object,'all',[]);
	return
end

% when object not empty, delete those with number = ''
kill_obj = [];
for i = 1:length(object) 		
	if isempty(object(i).number)
		% I kill that stupid obkect without a number
		kill_obj = [kill_obj i];
	end
end	

if length(kill_obj)
	object(kill_obj) = [];
	% i must rebuild pin_... as there were empty numbers
	useless = pin_manipulation(str_object,'all',[]);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% I verify object(obj_ind)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if length(object) == 0
	ok_out(1:length(num_obj)) = 0; % no object
	return
end

% there are still object, so it is worth testing for the fields
for i = 1:length(num_obj)
	ind_obj = pin_manipulation(str_object,'num2ind',num_obj(i));	
	ok_out(i) = 1;
	for j = 1:length(set_str_fields)
		if isempty(object(ind_obj).set_str_fields{j})
			ok_out(i) = 0;
		end
	end
end
