function index = find_field(obj,fld,val)
% find index of object of type obj the field of type fld that contains val

% INPUT: 
% obj =	'frame', .... 'belief'
%		'belief(3).bp', 'belief(3).bp(5).form'
% not OK is 'belief(ind).bp' as ind is not known here
% fld = filed name
% val :   5  or 'my_words', can be a number or a string
% OUTPUT:
% index = the index of obj such that obj(index).fld = val
%		  -1 if not OK, like fld is not a field, or obj is not an object...
%         0  if val not found
%
%   Version : June 12,03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute  pin_variable 
global pin_mapping pin_belief 

ok = 1; % used when checking the existence of obj and fld, in eval
if isnumeric(val)
	eval(['list_fld = [',obj,'(:).',fld,'];'], 'ok = 0;');
	if ok == 0
		index = -1;
		return
	end
	% beware empty have been deleted so position is not index
	list_index = [];
	for i = 1:length(eval(obj))
		if ~isempty(eval([obj,'(i).',fld]))
			list_index = [list_index i];
		end
	end
	% so I know relation position / index
	pos = find(list_fld==val);
	if length(pos) ~= 1
		index = 0;
	else
		index = list_index(pos);
	end
else
	eval(['list_fld = {',obj,'(:).',fld,'};'],'ok=0;');
		if ok == 0
		index = -1;
		return
	end
	pos = find(strcmp(list_fld,val));
	if length(pos) ~= 1
		index = 0;
	else
		index = pos;
	end
end
