function [kwfn, kwobj] = list_field_kw_fn
% list of key word and full name for every field
% kwobj{i} : the name of the various objects (FRAME, ATTRIBUTE, .. BELIEF,... CCR...)
% kwfn(i_obj,j_seq,1) = one of the labels for kwobj{i_obj}
% kwfn(i_obj,j_seq,2) = the field name related to this label


i = 0;
% frame
i = i + 1; j = 0;
kwobj{i} = 'FRAME';
j=j+1;kwfn{i,j,1} = 'FNUM';kwfn{i,j,2} = 'number';
j=j+1;kwfn{i,j,1} = 'FSHN';kwfn{i,j,2} = 'short_name';
j=j+1;kwfn{i,j,1} = 'FFLN';kwfn{i,j,2} = 'full_name';
j=j+1;kwfn{i,j,1} = 'FTYP';kwfn{i,j,2} = 'type';
j=j+1;kwfn{i,j,1} = 'FCRD';kwfn{i,j,2} = 'cardinality';
j=j+1;kwfn{i,j,1} = 'ELEM';kwfn{i,j,2} = 'elements';
j=j+1;kwfn{i,j,1} = 'FORD';kwfn{i,j,2} = 'ordered';
j=j+1;kwfn{i,j,1} = 'FMIN';kwfn{i,j,2} = 'min';
j=j+1;kwfn{i,j,1} = 'FMAX';kwfn{i,j,2} = 'max';
j=j+1;kwfn{i,j,1} = 'DO_VAR';kwfn{i,j,2} = 'make variable with frame';

% mapping
i = i + 1; j = 0;
kwobj{i} = 'MAPPING';
j=j+1;kwfn{i,j,1} = 'MNUM';kwfn{i,j,2} = 'number';
j=j+1;kwfn{i,j,1} = 'MDOM';kwfn{i,j,2} = 'domain';
j=j+1;kwfn{i,j,1} = 'MRNG';kwfn{i,j,2} = 'range';

% structure
i = i + 1; j = 0;
kwobj{i} = 'STRUCTURE';
j=j+1;kwfn{i,j,1} = 'SNUM';kwfn{i,j,2} = 'number';
j=j+1;kwfn{i,j,1} = 'SSHN';kwfn{i,j,2} = 'short_name';
j=j+1;kwfn{i,j,1} = 'SFLN';kwfn{i,j,2} = 'full_name';
j=j+1;kwfn{i,j,1} = 'SMRF';kwfn{i,j,2} = 'most_refined';
j=j+1;kwfn{i,j,1} = 'SSFR';kwfn{i,j,2} = 'sub_frames';
j=j+1;kwfn{i,j,1} = 'SMAP';kwfn{i,j,2} = 'mapping';

% attribute
i = i + 1; j = 0;
kwobj{i} = 'ATTRIBUTE';
j=j+1;kwfn{i,j,1} = 'ANUM';kwfn{i,j,2} = 'number';
j=j+1;kwfn{i,j,1} = 'ASHN';kwfn{i,j,2} = 'short_name';
j=j+1;kwfn{i,j,1} = 'AFLN';kwfn{i,j,2} = 'full_name';
j=j+1;kwfn{i,j,1} = 'ASTR';kwfn{i,j,2} = 'structure';
% index
j=j+1;kwfn{i,j,1} = 'AIXN';kwfn{i,j,2} = 'index(#).name';
j=j+1;kwfn{i,j,1} = 'AIXF';kwfn{i,j,2} = 'index(#).frame';

% variable
i = i + 1; j = 0;
kwobj{i} = 'VARIABLE';
j=j+1;kwfn{i,j,1} = 'VNUM';kwfn{i,j,2} = 'number';
j=j+1;kwfn{i,j,1} = 'VSHN';kwfn{i,j,2} = 'short_name';
j=j+1;kwfn{i,j,1} = 'VFLN';kwfn{i,j,2} = 'full_name';
j=j+1;kwfn{i,j,1} = 'VATT';kwfn{i,j,2} = 'attribute';
j=j+1;kwfn{i,j,1} = 'VFRM';kwfn{i,j,2} = 'frame';
j=j+1;kwfn{i,j,1} = 'VINX';kwfn{i,j,2} = 'index_value';
j=j+1;kwfn{i,j,1} = 'MAKE_ALL_VARIABLES';kwfn{i,j,2} = 'Var for every index';

% belief
i = i + 1; j = 0;
kwobj{i} = 'BELIEF';
j=j+1;kwfn{i,j,1} = 'BNUM';kwfn{i,j,2} = 'number';
j=j+1;kwfn{i,j,1} = 'BSHN';kwfn{i,j,2} = 'short_name';
j=j+1;kwfn{i,j,1} = 'BFLN';kwfn{i,j,2} = 'full_name';
j=j+1;kwfn{i,j,1} = 'BDVR';kwfn{i,j,2} = 'domain_variable';
j=j+1;kwfn{i,j,1} = 'BDCR';kwfn{i,j,2} = 'domain_cardinality';
j=j+1;kwfn{i,j,1} = 'BCVR';kwfn{i,j,2} = 'conditioning_variable';
j=j+1;kwfn{i,j,1} = 'BCCR';kwfn{i,j,2} = 'conditioning_cardinality';
j=j+1;kwfn{i,j,1} = 'BAGN';kwfn{i,j,2} = 'agent';
j=j+1;kwfn{i,j,1} = 'BTME';kwfn{i,j,2} = 'time';
j=j+1;kwfn{i,j,1} = 'BEVC';kwfn{i,j,2} = 'ec';
j=j+1;kwfn{i,j,1} = 'BDIS';kwfn{i,j,2} = 'disposable';
j=j+1;kwfn{i,j,1} = 'BCMP';kwfn{i,j,2} = 'computed ';
% potential
j=j+1;kwfn{i,j,1} = 'BPCN';kwfn{i,j,2} = 'conditioning element';
% form
j=j+1;kwfn{i,j,1} = 'PFRM';kwfn{i,j,2} = 'bp(#).form(#).type';
j=j+1;kwfn{i,j,1} = 'PREP';kwfn{i,j,2} = 'bp(#).form(#).representation';
j=j+1;kwfn{i,j,1} = 'PBEG';kwfn{i,j,2} = 'begin focal sets and masses';
j=j+1;kwfn{i,j,1} = 'PEND';kwfn{i,j,2} = 'begin focal sets and masses';
j=j+1;kwfn{i,j,1} = 'RANDOM';kwfn{i,j,2} = 'get random bba';
j=j+1;kwfn{i,j,1} = 'RANDOM_N';kwfn{i,j,2} = 'get normlaized random bba';

% file operation
i = i + 1; j = 0;
kwobj{i} = 'LOAD';

% file operation
i = i + 1; j = 0;
kwobj{i} = 'SAVE';

% RUN can be anywhere
i = i + 1; j = 0;
kwobj{i} = 'RUN';

% Computation

% margin + vacuouc ext
i = i + 1; j = 0;
kwobj{i} = 'CHANGE_FRAME';
j=j+1;kwfn{i,j,1} = 'BSHN';kwfn{i,j,2} = 'short_name result';
j=j+1;kwfn{i,j,1} = 'BFLN';kwfn{i,j,2} = 'full_name result';
j=j+1;kwfn{i,j,1} = 'BELF';kwfn{i,j,2} = 'used belief short_names';
j=j+1;kwfn{i,j,1} = 'PVAR';kwfn{i,j,2} = 'list var numbers for new space'; 

% cautious combination  rule 
i = i + 1; j = 0;
kwobj{i} = 'CAUTIOUSCC';
j=j+1;kwfn{i,j,1} = 'BSHN';kwfn{i,j,2} = 'short_name result';
j=j+1;kwfn{i,j,1} = 'BFLN';kwfn{i,j,2} = 'full_name result';
j=j+1;kwfn{i,j,1} = 'BELF';kwfn{i,j,2} = 'used belief short_names';
 
% VBS
i = i + 1; j = 0;
kwobj{i} = 'VBS';
j=j+1;kwfn{i,j,1} = 'BSHN';kwfn{i,j,2} = 'short_name result';
j=j+1;kwfn{i,j,1} = 'BFLN';kwfn{i,j,2} = 'full_name result';
j=j+1;kwfn{i,j,1} = 'BELF';kwfn{i,j,2} = 'used belief object numbers or short_names';
j=j+1;kwfn{i,j,1} = 'PVAR';kwfn{i,j,2} = 'list var numbers for marginalization';

% GBT
i = i + 1; j = 0;
kwobj{i} = 'GBT';
j=j+1;kwfn{i,j,1} = 'BSHN';kwfn{i,j,2} = 'short_name result';
j=j+1;kwfn{i,j,1} = 'BFLN';kwfn{i,j,2} = 'full_name result';
j=j+1;kwfn{i,j,1} = 'CNDB';kwfn{i,j,2} = 'number/short_name of the used conditional belief object';
j=j+1;kwfn{i,j,1} = 'PRBT';kwfn{i,j,2} = 'announces prior belief on T (bba,categorical,vacuous';
j=j+1;kwfn{i,j,1} = 'PRBX';kwfn{i,j,2} = 'announces prior belief on X (bba,categorical,vacuous';
j=j+1;kwfn{i,j,1} = 'COMP';kwfn{i,j,2} = 'announces data for GBT entered';

% DRC
i = i + 1; j = 0;
kwobj{i} = 'DRC';
j=j+1;kwfn{i,j,1} = 'BSHN';kwfn{i,j,2} = 'short_name result';
j=j+1;kwfn{i,j,1} = 'BFLN';kwfn{i,j,2} = 'full_name result';
j=j+1;kwfn{i,j,1} = 'CNDB';kwfn{i,j,2} = 'number/short_name of the used conditional belief object';
j=j+1;kwfn{i,j,1} = 'PRBT';kwfn{i,j,2} = 'announces prior belief on T (bba,categorical,vacuous';
j=j+1;kwfn{i,j,1} = 'PRBX';kwfn{i,j,2} = 'announces prior belief on X (bba,categorical,vacuous';
j=j+1;kwfn{i,j,1} = 'COMP';kwfn{i,j,2} = 'announces data for GBT entered';

% CCR
i = i + 1; j = 0;
kwobj{i} = 'CCR';
j=j+1;kwfn{i,j,1} = 'BSHN';kwfn{i,j,2} = 'short_name result';
j=j+1;kwfn{i,j,1} = 'BFLN';kwfn{i,j,2} = 'full_name result';
j=j+1;kwfn{i,j,1} = 'BELF';kwfn{i,j,2} = 'number/short_name of one used belief objects';
j=j+1;kwfn{i,j,1} = 'DISC';kwfn{i,j,2} = 'individual discounting factors';
j=j+1;kwfn{i,j,1} = 'COMP';kwfn{i,j,2} = 'announces data for GBT entered';

% DCR
i = i + 1; j = 0;
kwobj{i} = 'DCR';
j=j+1;kwfn{i,j,1} = 'BSHN';kwfn{i,j,2} = 'short_name result';
j=j+1;kwfn{i,j,1} = 'BFLN';kwfn{i,j,2} = 'full_name result';
j=j+1;kwfn{i,j,1} = 'BELF';kwfn{i,j,2} = 'number/short_name of one used belief objects';
j=j+1;kwfn{i,j,1} = 'DISC';kwfn{i,j,2} = 'individual discounting factors';
j=j+1;kwfn{i,j,1} = 'COMP';kwfn{i,j,2} = 'announces data for GBT entered';

% GBTPDF
i = i + 1; j = 0;
kwobj{i} = 'GBTPDF';
j=j+1;kwfn{i,j,1} = 'BSHN';kwfn{i,j,2} = 'short_name result';
j=j+1;kwfn{i,j,1} = 'BFLN';kwfn{i,j,2} = 'full_name result';
j=j+1;kwfn{i,j,1} = 'CNDB';kwfn{i,j,2} = 'number/short_name of the used conditional belief object';
j=j+1;kwfn{i,j,1} = 'DATA';kwfn{i,j,2} = 'two (one) reals, the limits of the observed interval (point).';

% don't build RUN as each j is a blok to be reordonned, so to keep RUN where it is, don't mention it
% % % % RUN
% % % i = i + 1; j = 0;
% % % kwobj{i} = 'RUN';
% % % j=j+1;kwfn{i,j,1} = ' ';kwfn{i,j,2} = 'a MATLAB instruction xxx that will be evaluated by eval(xxx)';

% PRINT
i = i + 1; j = 0;
kwobj{i} = 'PRINT';
j=j+1;kwfn{i,j,1} = 'FILE';kwfn{i,j,2} = 'name of file where data saved';
j=j+1;kwfn{i,j,1} = 'BELF';kwfn{i,j,2} = 'number/short_name of belief objects to be printed or ALL';

% TBMLAB END





