function [value_out] = pin_manipulation(str_object,what,value)
% for every object one has a pin table (pin = position index number)
% it helps localizing objects

% position is needed when listing those existing objects
% uicontrol returns value fgiving the position
% index as in object(index).number 
% number as in object( ).number is 35

% example : object has 4 elements
% object(1).number = 4
% object(3).number = 2
% object(5).number = 9
% object(8).number = 5
% then pin is 
% [ 1	1	4 ;
%	2	3	2 ;
%	3	5	9 ;
%	4	8	5 ]

% str_object is 'frame', 'structure', etc...
%
% what can be :
% 'all' 		(re)build the whole pin table for the object in str_object 
% find position, index, number from any of position, index, number
% using pos ind num labels
% 'num2ind'		get index 		from number
% 'num2pos'		get position 	from number
% 'ind2num'		get number 		from index
% 'ind2pos'		get position 	from index
% 'pos2num'		get number 		from position
% 'pos2ind'		get index 		from position

% value is the value of x in   x2y    for which we want y
% and y is put in value_out 
% if x is a vector, then y is a vector of same length
% value_out is a row vector

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%


global frame structure mapping attribute variable belief
global node link histo

global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief
global pin_node pin_link pin_histo

% only for initializing value out, encountyereed when what = 'all'
if isempty(value)
	value_out = [];
end

eval(['object =',str_object,';']'   , 'object = [];');
eval(['pin_list = pin_',str_object,';'],'pin_list = [];');

if length(object)==0 
	% the pin_list of an empty list is [0 0 0]
	pin_list = [0 0 0];
	eval(strcat('pin_',str_object,'= pin_list;'));
	% pin_XXX stored in global and saved
else
	if length(pin_list)==0 
		% if it had not yet been built, it is empty so...
		pin_list = [0 0 0]; % to be sure to have something in it
		% the reult is output through the global
	end	

	if strcmp(what,'all')
		% building the table with all [position  index  number]
		k = 0;
		pin_list = []; 
		% pin_list was as long as pin_xxx and maybe number object smaller as deleted
		for i = 1:length(object)
			if ~isempty(object(i).number)
				k = k+1;
				pin_list(k,1:3) = [k i object(i).number];
				% once an object exist, the 0 pin value disappear as they should.
			end
		end		
		eval(['pin_',str_object,'= [];']); % so I clear pin_xxx (safer in case I delete objects)
		eval(['pin_',str_object,'= pin_list;']);
		% pin_XXX stored in global and saved	
		
		% when using 'all', instruc tion should be 
		% useless = pin_manipulation('xxx','all',[])
		% to avoid crash we can still tolerate
		% pin_XXX = pin_manipulation('XXX','all',[])
		% but it is bad programming as pin_XXX is communiccatyed also through the glogal
		value_out = pin_list; % a safety bell.
		
	else
		switch what
		case 'num2ind'
			in = 3; out = 2;
		case 'num2pos'
			in = 3; out = 1;
		case 'ind2num'
			in = 2; out = 3;
		case 'ind2pos'
			in = 2; out = 1;
		case 'pos2num'
			in = 1; out = 3;
		case 'pos2ind'
			in = 1; out = 2;
		end
		if length(value) == 1
			value_out = pin_list(find([pin_list(:,in)]==value),out);
		else
			value_out = [];
			for i = 1:length(value)					
				L = pin_list(find(pin_list(:,in)==value(i)),out);
                if ~isempty(L),
					value_out = [value_out  L]; 
				end
			end
		end
	end
end	
