function set_all_paths
% initialization of all paths

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Before running tbmlab for the first time, you must:
% 1: get folder TBMLAB 
% 1: create a folder called TBMLAB_Folder and located in MatLab/toolbox
% 2: drop the folder TBMLAB in TBMLAB_Folder
% 3 create the path for set_all_paths, a .m function located in TBMLAB
% a) run set_all_paths and every path is created
% none is saved, so you must do it each time you restart MatLab itself,
% b) you can also save the paths yourself by going in the path window
% in which case you should not need to (re)run set_all_paths
% 
% You can also use the path command 
% BUT be sure to click on the 'Add subfolders' option.
%
% When paths have been established, run tbmlab
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global pathname2TBMLABvers

build_pathname

switch computer
case 'MAC2'
	skip_dir = 1;	
case 'PCWIN'
	skip_dir = 3;	
	% I need it as PC add two directories with name . and .., in front
otherwise 
	skip_dir = 3;
end	

path_pending_dir{1}= pathname2TBMLABvers;
pending_index = [1];
to = 1;

while ~isempty(pending_index)	 
	eval('err = 0;cd(path_pending_dir{pending_index(1)});','err = 1;path_pending_dir{pending_index(1)}'); % this is now directory
	if err == 0
		fn = dir; % the names of the files in nos directory
		% finding the files that are (sub)directories
		file_dir = {fn(find([fn(:).isdir])).name};
		if ~isempty(file_dir{1})  
			if length(file_dir) >= skip_dir
				file_dir1 = file_dir(skip_dir:length(file_dir));		
				from = to+1;
				to = to + length(file_dir1);		
				pending_index = [pending_index from:to];
				ik = 0;
				for i = from:to
					ik = ik + 1;
					path_pending_dir{i} = fullfile( path_pending_dir{ pending_index(1) }, ...
					file_dir1{ik} ,'') ;
				end
			end
		end
	else
		disp('problem: this name created an error')
		path_pending_dir{pending_index(1)}
	end
	pending_index(1)=[]; % we eliminate the one done
	
end

for i=1:length(path_pending_dir)
	path(path_pending_dir{i}, path);
end
