function out = gauss(m,s,x1,x2)
% the gaussian integral from x1 to x2 , parameters m,s.

% erf((x-m)/s) from 0 to 1, erf(1.96/sqrt(2)) = .95

if nargin == 3
	% int -inf to x1
	if x1 < m
		out = .5 - erf((m-x1)/(sqrt(2)*s))/2; 
	else
		out = .5 + erf(-(m-x1)/(sqrt(2)*s))/2; 
	end
else
	out = gauss(m,s,x2) - gauss(m,s,x1);
end
