function [y] = laplace_gamma(u,a,b,n,x1,x2,option)
% pdf laplace   
% int p:q  1/b  exp(- x/b) dx = - exp(- x/b)| p:q  = exp(-q/b) - exp(-q/b)
% option = 'in' for bel, = 'out' for pl and q

fois = +1;
if strcmp(option,'out')
	fois = -1;
end

for i = 1:length(u)
	v1 = x1 + fois*u(i); v2 = x2 - fois*u(i);	
	if v1 >= a		% v2 > v1 >= a
		y(i) = (exp(-(v1-a)/b) - exp(-(v2-a)/b))/2;
	elseif v2 > a  % v1 < a
		y(i) = 1 - (exp(-(a-v1)/b) + exp(-(v2-a)/b))/2;
	else  % v1 < v2 <= 0
		y(i) = (exp(-(a-v2)/b) - exp(-(a-v1)/b))/2;
	end
	y(i) = y(i) * u(i)^(n-1)*exp(-u(i))/gamma(n);
end

% % % % % % % if length(u) == 14
% % % % % % [length(u) a b x1 x2]
% % % % % % [u'  y']
% % % % % % % end
