function out = long_onbit2num(bit,card)
% build a long number with bits in bit being on
% bit is the index of the one that is on
% bit = [4 7 72] means bit 4 7 and 72 are 1, all others 0.
% output out(1,n) is a vector of n numbers storing the card bits

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global nbr_bit_per_word 

% when asking it for empty list, get bits = empty
out = [];

[nw, nr] =  words_for_set(card);
out = zeros(1,nw+1);

for i = 1:length(bit)
	[n,r] = words_for_set(bit(i));
	out(n+1) = bitor( out(n+1), pow2(r-1));
end
