function [vect] = decompose(x,base)
% n_ary decpomposition of integer x into its n_ary variables
% looks like transforming an intefer into its bits, 
% but variables can be any n_ary, and n depends on each variable

% BEWARE:  x varies from 0 to prod(base) - 1
% x = 0 then vect = [0 0 0 ... 0]
% x = prod(base) - 1 then vect = base - 1

% example base = [2 5 4], x = 35 = (2-1)*5*4 + (4-1)*4 + (3-1)*1 + 1 
% and output are with values 0,1...base()-1

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%


nbr_var = length(base);

nbr_base(nbr_var) = 1;
for ivar = nbr_var-1:-1:1 
	nbr_base(ivar) = nbr_base(ivar + 1) * base(ivar + 1);
end

w = x;
for ivar = 1:nbr_var
	vect(ivar) = fix(w/nbr_base(ivar));
	w = w - vect(ivar) * nbr_base(ivar);
end

	
