function [values, children, position_power_set] = ...
		marg_and_cyl_ext(fixed_var,n,option)

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%


% UNUSED

% Omega = X1 * X2 * ... *Xk , k = length(n),  
% n(i) = nunber of possible values of Xi, always 0, 1 ... n(i)-1
% n is the vector with the cardinalities of each variable
% bits are such that X1 is at right, X2 to its left, ... Xk at left
% so  0100 ( = 4 if all binary) means variable X1 = 0, X2 = 0, X3 = 1, X4 = 0 (k=4)
% values is a list of the  values of 0, 1, 2.... 

% children{i} contains lists of elements (not subsets) in Omega that share same marginal 
% which bits are i-1 
% where i-1 is in the power set of fixed variables (domain of projection)

% position_power_set is the list of position of the elements of the poxer set of Omega 
% that correspond to the elements of the power set of margianl domain.
% so b on marginal is b originbal at values in position_power_set

% option = 0 output = b and m on marginals
% option = 1 output = b and m on Omega
% option = -1  for program verification and many intermediate printings

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% example. 
% Let n = [2 2 3] so cardinality Omega = XYZ = 12.
% it means card(X) = 2, card(Y) = 2, card(Z) = 3.
%
% let fixed_var = [3], then the marginal is on Z and we get then XYZ |v Z  (|v is down arrow)
% thus m is build on a space of size 3 and thus length(m) = 2^3 = 8
%
% let fixed_var = [2 3], then the marginal is on YZ and we get then XYZ |v YZ
% thus m is build on a space of size 6 and thus length(m) = 2^6 = 64
%
% let fixed_var = [1 2], then the marginal is on XY and we get then XYZ |v XY
% thus m is build on a space of size 4 and thus length(m) = 2^4 = 16
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

k = length(n); %there are k vcariables
n_omega = prod(n); % f is of lenght nQ
div(1) = 1;
for j = 1:k-1
	div = [div div(length(div))*n(j)];
end

%n_omega = 3;
% values is a list of the  values of 0, 1, 2.... 
for i = 0:n_omega-1
	x(k) = fix(i/div(k));x(k);
	res = i-x(k)*div(k);
	for j = k-1:-1:1
		x(j) = fix(res/div(j));
		res = res-x(j)*div(j);
	end
	values(i+1,:) = [x];
	%x(1) = weakest bit (unit)  x(k) biggest one ( = thousands)
end

% for control only
if option == -1
	fprintf(1,'\n\n\nControl output for function bbm_on_cyl_ext\n',[])
	fprintf(1,'list of values of each singleton in Omega with cardinality = %3i \n',n_omega)
	disp('    bits   1     2     3   ....')
	[[0:n_omega-1]' values]
end


% determination of cylindrical ext
% 
% set of marginals

sorted_fixed_var = sort(fixed_var);
mul(1) = 1;   n_mul = 1;
for j = sorted_fixed_var
	mul = [mul mul(length(mul))*n(j)];
	n_mul = n_mul +1;
end

% regrouping children who share same values for the fixed_var variables
for i = 1:mul(n_mul)
	children{i} = [];
end

for i = 0:n_omega-1
	posit_val =  values(i+1,sorted_fixed_var)*[mul(1:n_mul-1)]' + 1;
	children{posit_val} = [children{posit_val} i];
end
% children contains lists of elements not the subsets) in Omega that share same marginal

% for control only
if option == -1
	fprintf(1,'power set of marginals cardinality = %3i\n',mul(n_mul))
	disp('values of children = list of elements in Omega that share same marginal')
	disp('    bits   the children......')
	for i = 1:mul(n_mul)
		[i-1 children{i}]
	end
end

% building position of union of children in power set Omega
for i = 1:mul(n_mul)
	a = 0;
		for ii = 1:length(children{i})
			a = bitset(a,children{i}(ii)+1);
		end
	bits_singletons_on_fixed(i) = a ;
end

% determinatiopn of position of those b values needed for the marginal
for i = 0:2^mul(n_mul)-1
	position_power_set(i+1) = bitget(i,1:mul(n_mul))*bits_singletons_on_fixed'+1;
end

% for control only
if option == -1
	disp('bits of singletons of marginal in Omega space')
	bits_singletons_on_fixed
	disp('position in Omega of the cylindrical extensions of the subsets of Marginal')
	position_power_set
end
