function general_print_test
% printing a figure
% user select a figure, in its menu select print, which always call this fct
% user may change parameters in THIS function.

%
%   Version : July 5,03.
%   Copyright (c) 2003 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global pathname2TBMLABvers  screen_size

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% closing all past windows that might have survived
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

close all force

wanted_screen_size
build_pathname
close all force
% I open the directory to save printed figures
cd([pathname2TBMLABvers,filesep,'User_Data',filesep,'Printed_data'])



sz = screen_size;

sz(3) = sz(3) - 5;
sz(4) = sz(4) - 5;


hd_fig = figure('color',[1 1 1],'Units','Pixels');
set(hd_fig,'position', [5 5 sz(3)-10 sz(4)-10]);

hd_axes = axes('position',[0 0 1 1],'TickDir','out','color',[1 1 1],'box','on');

%t{1} = 'TBMLAB';
text('position',[0 0],'String','BL','fontsize',12,'verticalalignment','baseline');
text('position',[1 0],'String','BR','fontsize',12,'verticalalignment','baseline','horizontalAlignment','right');
text('position',[0 1],'String','TL','fontsize',12,'verticalalignment','top');
text('position',[1 1],'String','TR','fontsize',12,'verticalalignment','top','horizontalAlignment','right');
text('position',[.5 .5],'String','middle','fontsize',12,'verticalalignment','top','horizontalAlignment','right');

text('position',[0.1 0],'String','bl','fontsize',12,'verticalalignment','baseline');
text('position',[0.1 1],'String','tl','fontsize',12,'verticalalignment','top');


uicontrol('string','button','position',[150 50 40 30]);

set(gcf,'PaperOrientation','landscape',...
'PaperUnits','normalized',...
'PaperPositionMode','auto',...
'PaperPosition',[0 0 1 1],...
'InvertHardcopy','off')

% don't use   'PaperType','A4',...   this breaks it, I MUST use default paper type US
% needed : 'InvertHardcopy','off', else image disappears.

print -djpeg  -loose   the_pr_file

% -dps2 with uicontrol  kills matlab
% -deps -deps2 NOT with append, and without append + with uicontrol blows up
% -djpeg is OK with uicontrol, but -append does not act under jpeg?



% look at help print for other choices
% latex is happy ? with -deps2  (with c for color)
% when  I omit -noui, matlab blows up.
