function run_transform_bp
% user ask for trnasforming forms among them

% called from menu Tools
% prepare the real request for a transformation to be done by transform_bp
%
% I produce 	index for use belief(ind_bel).bp(ind_bp)....
% 				out_form1 : a list of forms like {'b','q'} BE SURE TO PUT {}, else BOUM
% done from GUI panles
%
% If no form available, new are vacuous

%
%   Version : May, 15, 03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief
global gui_position  figure_data  flags  help_level help_label

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% query: select belief, then bp.
% show forms available, 
% ask which one needed, 
% do and store done by tansform_bp
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get the figure
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_fig = figure('name','Inter form transformtaion.');
set(hd_fig,'position',gui_position(:,5));
ind_fig = length(figure_data) + 1;
figure_data(ind_fig).name = 'Inter form transformtaion.';
figure_data(ind_fig).handle = hd_fig;
figure_data(ind_fig).position = gui_position(:,5);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% which belief objerct
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

handle_list1 = listing_existing('belief', gui_position(:,7), gcf,'');
select_list(handle_list1,'on','one');

text = 'Select the belief object with the forms.';
choice = text_with_n_buttons(gcf, text, {'Done','Cancel'}, 1);
val_sel = get(handle_list1(2),'value');
select_list(handle_list1,'off','one')

if choice == 2
	delete(handle_list1);
	return
end
ind_bel = pin_manipulation('belief','pos2ind',val_sel);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% which bp objerct
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% how many potential    ??? problem with pot index, am I OK???? delete XXXXXbelief().bp(i).number ????
pot_list = belief(ind_bel).bp; 

switch length(pot_list)
case 0
	% no potential, skip
	hwd = warndlg('There is no potential, I skip.');
	uiwait(hwd)
	delete(handle_list1);
	delete(handle_list2);
	return
case 1
	ind_bp = 1;
otherwise
	param(1) = ind_bel;
	handle_list2 = listing_existing('potential', gui_position(:,12), gcf,param);
	select_list(handle_list2,'on','one')
	
	text = 'Select the potential object with the forms.';
	choice = text_with_n_buttons(gcf, text, {'Done','Cancel'}, 1);
	val_sel = get(handle_list2(2),'value');
	select_list(handle_list2,'off','one')
	
	if choice == 2
		delete(handle_list1);
		delete(handle_list2);
		return
	end
	ind_bp = val_sel;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% what forms you want
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

param = [];
param = {'m','b','q','bel','pl','wc','wd','M','Bel','Pl','Q','BetP'};

handle_list3 = listing_existing('general', gui_position(:,6), gcf,param);
set(handle_list3(1),'string','Form List');
select_list(handle_list3,'on','many')

text = 'Select the forms you want to build. Forms name starting with a capital are normalized.';
choice = text_with_n_buttons(gcf, text, {'Done','Cancel'}, 1);
sel_val = get(handle_list3(2),'value');
select_list(handle_list3,'off','many')

if choice == 2
	delete(handle_list1);
	if exist('handle_list2'); delete(handle_list2);end
	delete(handle_list3);
	return
end
if length(sel_val) == 0
	hwd = warndlg('You must ask for at least one form. I skip.');
	uiwait(hwd)
	delete(handle_list1);
	if exist('handle_list2'); delete(handle_list2);end
	delete(handle_list3);
	return	
end
for i = 1:length(sel_val)
	out_form_req{i} = param{sel_val(i)};
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the call for computing the forms 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[computed_forms,uncomputed_forms, error_mode] = transform_bp(ind_bel,ind_bp,out_form_req);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% summary of results
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if length(error_mode{1}) == 0
	txt = 'No error.';
else
	txt = 'Error message : ';
	for i = 1:length(error_mode)
		txt = [txt,' ',error_mode{i}];
	end	
end

if ~isempty(uncomputed_forms{1})
	txt = [txt,' ','Those not computed :'];
	for i = 1:length(uncomputed_forms)
		txt = [txt,' ',uncomputed_forms{i}];
	end
end
if ~isempty(computed_forms{1})
	txt = [txt,' ','Those computed :'];
	for i = 1:length(computed_forms)
		txt = [txt,' ',computed_forms{i}];
	end
end
choice = text_with_n_buttons(gcf, txt, {'Go on'}, 1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% closing the window
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

delete(hd_fig)
figure_data(ind_fig) = [];
