function num_post_belief = full_gbt_computer(num_cd_bel,X_info, T_info,option) 
% given conditional belief on X for each ti in T, compute bel on X (DRC) or on T (GBT) with prioirs and noisu data

% num_cd_bel = number of the conditional belief object with all the conditional belief on X given ecah t
% belief(ind_cd_bel).bp(i) = conditional belief on X given ti

% X_info = [categorical_X,data_X]
% categorical_X = 0, conditioning event X is noisy, hence a bba on X, its number in data_X [0,45]
% categorical_X = 1, conditioning event X is categorical and value focal set is in data_X (a long_number) [1, [3 6]]
% categorical_X = 2, conditioning event X is vacuous   [2,[]]

% T_info = [categorical_T,data_T]
% categorical_T = 0, a priori on T is noisy, hence a bba on T, its number in data_X [0,34]
% categorical_T = 1, a priori on T is categorical and value focal set is in data_T (a long_number) [1,[4 7]]
% categorical_T = 2, a priori on T is vacuous   [2,[]]

% option = 'T' : marginalization on T  (GBT)
% option = 'X' : marginalization on X  (DRC)
% num_post_belief = the number of the posterior belief on X or T depending on option

% computation done with FMT, 
% hence limited to small spaces X and T, both with carinality <= max_card_fmt  (18 by now, but later???)

% written for ONE domain_variable and ONE conditioning_variable, else crashes
% X may be continuous, T may NOT be continuous or integers

%
%   Version : Sept 8, 2003
%   Copyright (c) 2003 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief
global max_card_fmt

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% preliminary parameters
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

X_categ = X_info(1);
T_categ = T_info(1);

ind_cd_bel = pin_manipulation('belief','num2ind',num_cd_bel);

X_continuous = is_var_cont(belief(ind_cd_bel).domain_variable);
T_continuous = is_var_cont(belief(ind_cd_bel).conditioning_variable);
T_integers = is_var_int(belief(ind_cd_bel).conditioning_variable);

if X_continuous
	cardX = 1;
else
	cardX = prod(belief(ind_cd_bel).domain_cardinality);
end	

if T_continuous == 0 & T_integers == 0
	cardT = prod(belief(ind_cd_bel).conditioning_cardinality);
end	

num_post_belief = [] ; % just to get something when leaving

if X_info(1) == 0
	num_prior_X = X_info(2);
	ind_prior_X = pin_manipulation('belief','num2ind',num_prior_X);
end
if T_info(1) == 0
	num_prior_T = T_info(2);
	ind_prior_T = pin_manipulation('belief','num2ind',num_prior_T);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% testing that computation can be performed
% I can only handle case with cardX < max_card_fmt  (18 by now, but laqter???)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if T_continuous | T_integers
	% T must be non cont non intger (NIC)
	hdw = warndlg('I am not ready to apply the GBT when T is continuous or integers. I skip.');
	uiwait(hdw)
	return	
elseif length(belief(ind_cd_bel).domain_variable) > 1 | length(belief(ind_cd_bel).conditioning_variable) > 1
	% I am not ready for multivariate domains
	hdw = warndlg('I am not ready to apply the GBT when X or T are multivariate. I skip.');
	uiwait(hdw)
	return	
elseif cardT <= 1
	% control all bp are available: they should (lot of vacuous maybe)
	% I use FMT just for one number, not clever, but simpler for the moment. 
	% to redo in case of necessity	
	hdw = warndlg('You ask to apply the GBT when there is no conditioning variables. I skip.');
	uiwait(hdw)
	return		
elseif cardX > max_card_fmt | cardT > max_card_fmt
	hdw = warndlg(['Sorry. I am programmed only for small domains, i.e., with <= ',...
	num2str(max_card_fmt),' elements'])
	uiwait(hdw)	
	return
	% later for larger daomina I should 
	% control all bp are available: they should (lot of vacuous maybe)	
	% I need likelihood vector pl[ti](condit_event)
	% prefrence order to get a likelihood
	% I have pl or Pl use it
	% I have b, bel, Bel, get by complement
	% I have m or M, use add
	% I have q or Q, aih 
	% I have wd, get b
	% I have wc, get q and pl from q by add
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% I can work
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

switch option

case 'T' % the GBT case
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%%%%%%%%                the GBT case               %%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% preparing the belief obejct where results are saved
	ind_new_bel_T = make_empty('belief');	
	belief(ind_new_bel_T).short_name = ['GBT_',belief(ind_cd_bel).short_name];
	belief(ind_new_bel_T).full_name = ['GBT_',belief(ind_cd_bel).full_name];	
	belief(ind_new_bel_T).domain_variable = belief(ind_cd_bel).conditioning_variable;
	belief(ind_new_bel_T).domain_cardinality = belief(ind_cd_bel).conditioning_cardinality;
	get_its_dci(ind_new_bel_T);
	belief(ind_new_bel_T).computed = ['GBT ',num2str(num_cd_bel)];
	
	if X_categ == 2 % vacuous prior on X
		CardX = prod(belief(ind_cd_bel).domain_cardinality);
		X_info(2) = get_universe(CardX)
		X_categ_now = 1;
	else
		X_categ_now = X_categ;
	end

	switch X_categ_now	
	
	case 0 
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		% categorical_X = 0, conditioning event X is noisy, hence a bba on X, its number in X_info [0,45]
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		num_prior_X = X_info(2);
		ind_prior_X = pin_manipulation('belief','num2ind',num_prior_X);
		ind_form_m_X = min(find(strcmp({belief(ind_prior_X).bp(1).form(:).type},'m')));
		
		for ind_bp = 1:cardT
			[computed_forms,uncomputed_forms, error_mode] = transform_bp(ind_cd_bel,ind_bp,{'pl'});
			ind_pl_form(ind_bp) = min(find(strcmp({belief(ind_cd_bel).bp(ind_bp).form(:).type},'pl')));			
		end
		q_final = zeros(pow2(cardT),1);
		for i_foc = 1:length(belief(ind_prior_X).bp(1).form(ind_form_m_X).values)
			k_foc = belief(ind_prior_X).bp(1).form(ind_form_m_X).focal_sets(i_foc,:);
			m_foc = belief(ind_prior_X).bp(1).form(ind_form_m_X).values(i_foc);		
			kl = k_foc + 1;	
			for ind_bp = 1:cardT
				lkh(ind_bp) = belief(ind_cd_bel).bp(ind_bp).form(ind_pl_form(ind_bp)).values(kl);
			end
			% I store lkh as wc in a new belief object
			wc = ones(pow2(cardT),1);
			wc([pow2(cardT) - pow2([0:cardT-1])]) = lkh';
			q_final = q_final + m_foc*fmt(wc,'wc','q');
			% this can really be speed up 
		end
	
		% if there is an a priori on T
		switch T_categ 
		case 0
			% a full bba on T, gets its wc and multiply it with previous wc from GBT
			[computed_forms,uncomputed_forms, error_mode] = transform_bp(ind_prior_T,1,{'q'});	
			ind_form_q_T = min(find(strcmp({belief(ind_prior_T).bp(1).form(:).type},'q')));			
			q_final = q_final .* belief(ind_prior_T).bp(1).form(ind_form_q_T).values;
		case 1
			% a categorical bba on T, lot of the q = 0
			q_final(supersets(T_info(2),cardT) + 1) = 0;
		case 2
			% vacuous do noting
		end
	
		% the m form
		ind_pot = make_empty('bp',ind_new_bel_T); % i get both bp and 1 form
		belief(ind_new_bel_T).bp(ind_pot).form(1).type = 'm';
		belief(ind_new_bel_T).bp(ind_pot).form(1).representation = 'selected';	
		belief(ind_new_bel_T).bp(ind_pot).form(1).focal_sets = [0:pow2(cardT)-1]';
		belief(ind_new_bel_T).bp(ind_pot).form(1).values = fmt(q_final,'q','m');
		
		% the q form
		ind_form = make_empty('form',ind_new_bel_T,ind_pot);
		belief(ind_new_bel_T).bp(ind_pot).form(ind_form).type = 'q';
		belief(ind_new_bel_T).bp(ind_pot).form(ind_form).representation = 'selected';	
		belief(ind_new_bel_T).bp(ind_pot).form(ind_form).focal_sets = [0:pow2(cardT)-1]';
		belief(ind_new_bel_T).bp(ind_pot).form(ind_form).values = q_final;
		useless = pin_manipulation('belief','all',[]);
		% when there is no a prioir it simplifies as:
		% belief(ind_obj).bp(1).form(2).focal_sets = [pow2(cardT) - pow2([0:cardT-1])]'-1;
		% belief(ind_obj).bp(1).form(2).values = lkh';
		
	case 1 
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		% categorical_X = 1, conditioning event X is categorical and value focal set is in X_info (a long_number) [1, [3 6]]
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		condit_event = X_info(2); % always ONE number as small spaces
		for ind_bp = 1:cardT
			[computed_forms,uncomputed_forms, error_mode] = transform_bp(ind_cd_bel,ind_bp,{'pl'});
			ind_for = min(find(strcmp({belief(ind_cd_bel).bp(ind_bp).form(:).type},'pl')));			
			kl = condit_event + 1;			
			lkh(ind_bp) = belief(ind_cd_bel).bp(ind_bp).form(ind_for).values(kl);
		end	
		% I store lkh as wc in a new belief object
		
		wc = ones(pow2(cardT),1);
		wc([pow2(cardT) - pow2([0:cardT-1])]) = lkh';
		% this can really be speed up 
		
		% if therer is an a priori on T
		switch T_categ 
		case 0
			% a full bba on T, gets its wc and multiply it with previous wc from GBT
			ind_prior_T = pin_manipulation('belief','num2ind',T_info(2));
			[computed_forms,uncomputed_forms, error_mode] = transform_bp(ind_prior_T,1,{'wc'});	
			ind_form_wc_T = min(find(strcmp({belief(ind_prior_T).bp(1).form(:).type},'wc')));						
			wc = wc .* belief(ind_prior_T).bp(1).form(ind_form_wc_T).values;
		case 1
			% a categorical bba on T, one of the wc = 0
			wc(T_info(2) + 1) = 0;			
		case 2
			% vacuous do noting
		end
	
		% handling the a priori on T
		% the m form
		ind_pot = make_empty('bp',ind_new_bel_T); % i get both bp and 1 form
		belief(ind_new_bel_T).bp(ind_pot).form(1).type = 'm';
		belief(ind_new_bel_T).bp(ind_pot).form(1).representation = 'selected';	
		belief(ind_new_bel_T).bp(ind_pot).form(1).focal_sets = [0:pow2(cardT)-1]';
		belief(ind_new_bel_T).bp(ind_pot).form(1).values = fmt(wc,'wc','m');
		
		% the wc form
		ind_form = make_empty('form',ind_new_bel_T,ind_pot);
		belief(ind_new_bel_T).bp(ind_pot).form(ind_form).type = 'wc';
		belief(ind_new_bel_T).bp(ind_pot).form(ind_form).representation = 'selected';	
		ind_wc1 = find(wc == 1);
		wc(ind_wc1) = [];
		foc = [0:pow2(cardT)-1]';
		foc(ind_wc1) = [];		
		belief(ind_new_bel_T).bp(ind_pot).form(ind_form).focal_sets = foc;
		belief(ind_new_bel_T).bp(ind_pot).form(ind_form).values = wc;
		useless = pin_manipulation('belief','all',[]);
		% when there is no a prioir it simplifies as:
		% belief(ind_obj).bp(1).form(2).focal_sets = [pow2(cardT) - pow2([0:cardT-1])]'-1;
		% belief(ind_obj).bp(1).form(2).values = lkh';
		
	case 2 % categorical_X = 2, conditioning event X is vacuous   [2,[]]
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		% categorical_X = 2, conditioning event X is vacuous   [2,[]]
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		% was made == 1 with a universe on X, so I never comes here
	end

	num_post_belief = belief(ind_new_bel_T).number;
	
case 'X' % the DRC case		

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%%%%%%%%                the DRC case               %%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% preparing the belief object where results are saved
	ind_new_bel_X = make_empty('belief');	
	belief(ind_new_bel_X).short_name = ['DRC_',belief(ind_cd_bel).short_name];
	belief(ind_new_bel_X).full_name = ['DRC_',belief(ind_cd_bel).full_name];	
	belief(ind_new_bel_X).domain_variable = belief(ind_cd_bel).domain_variable;
	belief(ind_new_bel_X).domain_cardinality = belief(ind_cd_bel).domain_cardinality;
	belief(ind_new_bel_X).dci_var.pin_d = belief(ind_cd_bel).dci_var.pin_d;
	belief(ind_new_bel_X).dci_var.pin_c = belief(ind_cd_bel).dci_var.pin_c;
	belief(ind_new_bel_X).dci_var.pin_i = belief(ind_cd_bel).dci_var.pin_i;
	belief(ind_new_bel_X).computed = ['DRC ',num2str(num_cd_bel)];
	
	if T_categ == 2 % vacuous prior on T
		cardT = prod(belief(ind_cd_bel).conditioning_cardinality)
		T_info(2) = get_universe(cardT)
		T_categ_now = 1;
	else
		T_categ_now = T_categ;
	end

	switch T_categ_now
	
	case 0
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		% categorical_T = 0, a priori on T is noisy, hence a bba on T, its number in T_info [0,34]
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		num_prior_T = T_info(2);
		ind_prior_T = pin_manipulation('belief','num2ind',num_prior_T);
		ind_form_m_T = min(find(strcmp({belief(ind_prior_T).bp(1).form(:).type},'m')));
		
		for ind_bp = 1:cardT
			[computed_forms,uncomputed_forms, error_mode] = transform_bp(ind_cd_bel,ind_bp,{'b'});
			ind_b_form(ind_bp) = min(find(strcmp({belief(ind_cd_bel).bp(ind_bp).form(:).type},'b')));			
		end
		b_final = zeros(pow2(cardX),1);
		for i_foc = 1:length(belief(ind_prior_T).bp(1).form(ind_form_m_T).values)
			k_foc = belief(ind_prior_T).bp(1).form(ind_form_m_T).focal_sets(i_foc,:);
			m_foc = belief(ind_prior_T).bp(1).form(ind_form_m_T).values(i_foc);		
			sel_bp = long_num2onbit(k_foc,cardT);			
			b = ones(pow2(cardX),1);			
			for ind_bp = sel_bp
				b = b .* belief(ind_cd_bel).bp(ind_bp).form(ind_b_form(ind_bp)).values;
			end
			b_final = b_final + m_foc * b;
		end
	
		% if there is an a priori on X
		switch X_categ 
		case 0
			% a full bba on X, gets its q and multiply it withthe q from the previous b from DRC
			[computed_forms,uncomputed_forms, error_mode] = transform_bp(ind_prior_X,1,{'q'});	
			ind_form_q_X = min(find(strcmp({belief(ind_prior_X).bp(1).form(:).type},'q')));			
			q = fmt(b_final,'b','q') .* belief(ind_prior_X).bp(1).form(ind_form_q_X).values;	
			m = fmt(q,'q','m');
		case 1
			% condition b on subset of X		
			% b[X](a) = b(a U not X)  any a , even not subset X		
			nx = long_bitcmp(X_info(2), cardX);	
			b_final = b_final(bitor([0:pow2(cardX)-1]',nx)+1);
			m = fmt(b_final,'b','m');		
		case 2
			% vacuous do noting, i store b_final and its m
			m = fmt(b_final,'b','m');
		end
	
		% the m form
		ind_pot = make_empty('bp',ind_new_bel_X); % i get both bp and 1 form
		belief(ind_new_bel_X).bp(ind_pot).form(1).type = 'm';
		belief(ind_new_bel_X).bp(ind_pot).form(1).representation = 'selected';	
		belief(ind_new_bel_X).bp(ind_pot).form(1).focal_sets = [0:pow2(cardX)-1]';
		belief(ind_new_bel_X).bp(ind_pot).form(1).values = m;
		
		% the q or b form
		if X_categ == 0
			ind_form = make_empty('form',ind_new_bel_X,ind_pot);
			belief(ind_new_bel_X).bp(ind_pot).form(ind_form).type = 'q';
			belief(ind_new_bel_X).bp(ind_pot).form(ind_form).representation = 'selected';	
			belief(ind_new_bel_X).bp(ind_pot).form(ind_form).focal_sets = [0:pow2(cardX)-1]';
			belief(ind_new_bel_X).bp(ind_pot).form(ind_form).values = q;
		else
			ind_form = make_empty('form',ind_new_bel_X,ind_pot);
			belief(ind_new_bel_X).bp(ind_pot).form(ind_form).type = 'b';
			belief(ind_new_bel_X).bp(ind_pot).form(ind_form).representation = 'selected';	
			belief(ind_new_bel_X).bp(ind_pot).form(ind_form).focal_sets = [0:pow2(cardX)-1]';
			belief(ind_new_bel_X).bp(ind_pot).form(ind_form).values = b_final;	
		end
		useless = pin_manipulation('belief','all',[]);
		num_post_belief = belief(ind_new_bel_X).number;
		
	case 1
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		% categorical_T = 1, a priori on T is categorical and value focal set is in T_info (a long_number) [1,[4 7]]
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		% get index of included elements in order to select the bp
		sel_bp = long_num2onbit(T_info(2),cardT);
		
		b_final = ones(pow2(cardX),1);		
		for ind_bp = sel_bp
			[computed_forms,uncomputed_forms, error_mode] = transform_bp(ind_cd_bel,ind_bp,{'b'});
			ind_for = min(find(strcmp({belief(ind_cd_bel).bp(ind_bp).form(:).type},'b')));	
			b_final = b_final .* belief(ind_cd_bel).bp(ind_bp).form(ind_for).values;
		end
	
	case 2
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		% categorical_T = 2, a priori on T is vacuous   [2,[]]
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		% the classical DRC, done with case 1, so we never pass here
		
	end

	% handling a priori on X
	switch X_categ 	
	case 0 % prior on X
		% get q from both b_final and prior, product, get m
		[computed_forms,uncomputed_forms, error_mode] = transform_bp(ind_prior_X,1,{'q'});
		ind_for = min(find(strcmp({belief(ind_prior_X).bp(1).form(:).type},'q')));			
		q = fmt(b_final,'b','q').* belief(ind_prior_X).bp(1).form(ind_for).values;
		m = fmt(q,'q','m');
		
	case 1 % categorical on X
		% condition b on subset of X		
		% b[X](a) = b(a U not X)  any a , even not subset X		
		nx = long_bitcmp(X_info(2), cardX);	
		b_final = b_final(bitor([0:pow2(cardX)-1]',nx)+1);
		m = fmt(b_final,'b','m');
		
	case 2 % vacuous on X
		% do nothing
		% b_final = b_final;
		m = fmt(b_final,'b','m');		
	end

	% the m form
	ind_pot = make_empty('bp',ind_new_bel_X); % i get both bp and 1 form
	belief(ind_new_bel_X).bp(ind_pot).form(1).type = 'm';
	belief(ind_new_bel_X).bp(ind_pot).form(1).representation = 'selected';	
	belief(ind_new_bel_X).bp(ind_pot).form(1).focal_sets = [0:pow2(cardX)-1]';
	belief(ind_new_bel_X).bp(ind_pot).form(1).values = m;
	
	% the q or b form
	if X_categ == 0
		ind_form = make_empty('form',ind_new_bel_X,ind_pot);
		belief(ind_new_bel_X).bp(ind_pot).form(ind_form).type = 'q';
		belief(ind_new_bel_X).bp(ind_pot).form(ind_form).representation = 'selected';	
		belief(ind_new_bel_X).bp(ind_pot).form(ind_form).focal_sets = [0:pow2(cardX)-1]';
		belief(ind_new_bel_X).bp(ind_pot).form(ind_form).values = q;
	else
		ind_form = make_empty('form',ind_new_bel_X,ind_pot);
		belief(ind_new_bel_X).bp(ind_pot).form(ind_form).type = 'b';
		belief(ind_new_bel_X).bp(ind_pot).form(ind_form).representation = 'selected';	
		belief(ind_new_bel_X).bp(ind_pot).form(ind_form).focal_sets = [0:pow2(cardX)-1]';
		belief(ind_new_bel_X).bp(ind_pot).form(ind_form).values = b_final;	
	end
	useless = pin_manipulation('belief','all',[]);
	
	num_post_belief = belief(ind_new_bel_X).number;
	
end			

if isempty(num_post_belief)
	% something wrong
	hdw = warndlg('Something wrong happened in GBT/DRC. New belief not created.');
	uiwait(hdw)
end
