function run_gbt
% getting ind bel and cond ev ent to apply GBT

%
%   Version : June 10, 2003
%   Copyright (c) 2003 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute  pin_variable 
global pin_mapping pin_belief 
global screen_size
global gui_position  figure_data  flags  help_level help_label figure_handles

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get the figure
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_fig = figure('name','GBT Window');
set(hd_fig,'position',gui_position(:,5));
ind_fig = length(figure_data) + 1;
figure_data(ind_fig).name = 'GBT Window';
figure_data(ind_fig).handle = hd_fig;
figure_data(ind_fig).position = gui_position(:,5);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% select the conditonal belief object 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
proceed = 1;
kill_list = 0;
gui_pos = gui_position(:,7)';
gui_pos(3) = .35;

ik = 0;
for i = 1:length(belief)
	if length(belief(i).bp) > 1
		ik = ik + 1;
		param{ik} = belief(i).full_name;
		index_bel(ik) = i;
	end
end

if length(index_bel) == 0
	hdw = warndlg('There are no conditional beliefs. I skip')
	uiwait(hdw)
	proceed = 0;
end

if proceed	
	handle_list_belief = listing_existing('general', gui_pos, gcf,param);
	set(handle_list_belief(1),'string','Beliefs with Conditional Potentials')
	
	text = 'Select the belief object with the conditional beliefs for GBT/DRC.';
	select_list(handle_list_belief,'on','one');
	
	choice = text_with_n_buttons(gcf,text, {'Done','Cancel'},[1]);
	if choice == 1
		% get the position,index,number for the requested belief
		selected_item = get(handle_list_belief(2),'Value'); % position
		ind_cd_bel = index_bel(selected_item);
		% pin_manipulation('belief','pos2ind',selected_item);
		num_cd_bel = pin_manipulation('belief','ind2num',ind_cd_bel);	
		delete(handle_list_belief)
		
		X_var_num = belief(ind_cd_bel).domain_variable;
		T_var_num = belief(ind_cd_bel).conditioning_variable;
		X_var_ind = pin_manipulation('variable','num2ind',X_var_num);
		T_var_ind = pin_manipulation('variable','num2ind',T_var_num);
		param = [];
		for i = 1:length(X_var_ind)
			param{i} = variable(X_var_ind(i)).full_name;
		end
		handle_list_X = listing_existing('general', [.005 .05 .49 .35], figure_handles(1),param);
		set(handle_list_X(1),'string','Domain Variables = X')
		param = [];
		for i = 1:length(T_var_ind)
			param{i} = variable(T_var_ind(i)).full_name;
		end
		handle_list_T = listing_existing('general', [.505 .05 .49 .35], figure_handles(1),param);
		set(handle_list_T(1),'string','Conditioning Variables = T')
		
		kill_list = 1;
	else
		proceed = 0;
	end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% select the a priori on X belief object 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if proceed
	
	param = [];
	index_bel = [];
	ik = 0;
	for i = 1:length(belief)
		if i ~=ind_cd_bel &  isempty(setxor(X_var_num,belief(i).domain_variable))
			ik = ik + 1;
			param{ik} = belief(i).full_name;
			index_bel(ik) = i;
		end
	end

	if length(index_bel) 
		handle_list_belief = listing_existing('general', gui_pos, gcf,param);
		set(handle_list_belief(1),'string','Beliefs for X-Domain')
		select_list(handle_list_belief,'on','one');
		text = 'X_Var : select the belief object with the a priori beliefs on X for the GBT/DRC.';	
		choice = text_with_n_buttons(gcf,text, {'bba','Categor','Vacuous','Cancel'},[1]);
		list_to_kill = 1;
	else
		text = 'X_Var : select the conditioning event for X for the GBT/DRC.';	
		choice = text_with_n_buttons(gcf,text, {'Categor','Vacuous','Cancel'},[1]);
		choice = choice + 1; % as i did not propose bba
		list_to_kill = 0;
	end		


	switch choice 	
	
	case 1 % I use a prior bba
		X_info(1) = 0;
		% get the position,index,number for the requested belief
		selected_item = get(handle_list_belief(2),'Value'); % position
		ind_bel = index_bel(selected_item);
		num_bel = pin_manipulation('belief','ind2num',ind_bel);
		X_info(2) = num_bel;
		
	case 2 % categorical data
		X_info(1) = 1;
		% I build a belief object so I can use edit_bp_with_sets, I will delete it later
		ind_obj = make_empty('belief');
		ind_pot = make_empty('bp',ind_obj);	
		belief(ind_obj).short_name = 'GBT_CondEv';
		belief(ind_obj).domain_variable = belief(ind_cd_bel).domain_variable;
		belief(ind_obj).domain_cardinality = belief(ind_cd_bel).domain_cardinality;
		
		card = prod(belief(ind_obj).domain_cardinality);
		belief(ind_obj).bp(1).form(1).focal_sets(1,:) = get_universe(card);
		belief(ind_obj).bp(1).form(1).values = 1;
		
		text = 'Build ONE focal set and give it a mass 1.';
		choice = text_with_n_buttons(gcf,text, {'OK','Cancel'},[1]);
		if choice == 1		
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			% getting the conditioning event
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			flag_str{1} = '';
			
			edit_bp_with_sets(ind_obj,1,1); 
			
			if length(belief(ind_obj).bp(1).form(1).values) ~= 1
				hdw = warndlg('I said ONE focal set. I cancel.')
				uiwait(hdw)
				proceed = 0;
			else
				condit_event = belief(ind_obj).bp(1).form(1).focal_sets;
			end
			% delete(hd_fig) done in edit_bp_with_sets
		else
			proceed = 0;
		end
		X_info(2) = belief(ind_obj).bp(1).form(1).focal_sets;
		belief(ind_obj) = [];
		
	case 3
		X_info = [2 , []];
		
	case 4
		proceed = 0;
	end
	if list_to_kill 
		delete(handle_list_belief);
	end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% select the a priori on T belief object 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if proceed
	
	param = [];
	index_bel = [];
	
	ik = 0;
	for i = 1:length(belief)
		if i ~=ind_cd_bel &  isempty(setxor(T_var_num,belief(i).domain_variable))
			ik = ik + 1;
			param{ik} = belief(i).full_name;
			index_bel(ik) = i;
		end
	end

	if length(index_bel) 
		handle_list_belief = listing_existing('general', gui_pos, gcf,param);
		set(handle_list_belief(1),'string','Beliefs for T-Domain')
		select_list(handle_list_belief,'on','one');
		text = 'T_Var : select the belief object with the a priori beliefs on T for the GBT/DRC.';	
		choice = text_with_n_buttons(gcf,text, {'bba','Categor','Vacuous','Cancel'},[1]);
		list_to_kill = 1;
	else
		text = 'T_Var : select the conditioning event for T for the GBT/DRC.';	
		choice = text_with_n_buttons(gcf,text, {'Categor','Vacuous','Cancel'},[1]);
		choice = choice + 1; % as i did not propose bba
		list_to_kill = 0;
	end	

	switch choice 	
	
	case 1 % I use a prior bba
		T_info(1) = 0;
		% get the position,index,number for the requested belief
		selected_item = get(handle_list_belief(2),'Value'); % position
		ind_bel = index_bel(selected_item);
		num_bel = pin_manipulation('belief','ind2num',ind_bel);
		T_info(2) = num_bel;
		
	case 2 % categorical data
		T_info(1) = 1;
		% I build a bnelief obzejct so I can use edit_bp_with_sets, I will delete it later
		ind_obj = make_empty('belief');
		ind_pot = make_empty('bp',ind_obj);	
		belief(ind_obj).short_name = 'GBT_CondEv';
		belief(ind_obj).domain_variable = belief(ind_cd_bel).conditioning_variable;
		belief(ind_obj).domain_cardinality = belief(ind_cd_bel).conditioning_cardinality;
		
		card = prod(belief(ind_obj).conditioning_cardinality);
		belief(ind_obj).bp(1).form(1).focal_sets(1,:) = get_universe(card);
		belief(ind_obj).bp(1).form(1).values = 1;
		
		text = 'Build ONE focal set and give it a mass 1.';
		choice1 = text_with_n_buttons(gcf,text, {'OK','Cancel'},[1]);
		if choice1 == 1		
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			% getting the conditioning event
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			flag_str{1} = '';
			
			edit_bp_with_sets(ind_obj,1,1); 
			
			if length(belief(ind_obj).bp(1).form(1).values) ~= 1
				hdw = warndlg('I said ONE focal set. I cancel.')
				uiwait(hdw)
				proceed = 0;
			else
				condit_event = belief(ind_obj).bp(1).form(1).focal_sets;
			end
			% delete(hd_fig) done in edit_bp_with_sets
		else
			proceed = 0;
		end
		T_info(2) = condit_event;
		belief(ind_obj) = [];
		
	case 3
		T_info = [2 , []];
		
	case 4
		proceed = 0;
	end
	if list_to_kill 
		delete(handle_list_belief);
	end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% option between GBT or DRC
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if proceed	
	text = 'Choose between GBT (marginal on T) and DRC (marginal on X).';
	choice = text_with_n_buttons(gcf,text, {'GBT','DRC','Cancel'},[1]);
	switch choice 	
	case 1
		option = 'T';
	case 2
		option = 'X';
	case 3
		proceed = 0;
	end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% run GBT/DRC
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if proceed
	num_post_belief = full_gbt_computer(num_cd_bel,X_info, T_info,option); 
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% displaying results
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	ind_bel = pin_manipulation('belief','num2ind',num_post_belief);
	if strcmp(option,'T') 
		belief(ind_bel).computed = 'GBT';
	else
		belief(ind_bel).computed = 'DRC';
	end
	belief(ind_bel).origin = [num_cd_bel 0];
	results_display(ind_bel,1,1) % adapt bp form #
	
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% quitting
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if kill_list 
	delete(handle_list_X)
	delete(handle_list_T)
end

delete(hd_fig)
figure_data(ind_fig) = [];
