function [m, mat_focal] = get_LCm_from_BetP(BetPr,focal)
% you feed in BetPr on the elements of a frame of discernment omega
% omega is made of sets of words with bits representation of subsets 

% m is the LC bba that fits with BetPr (isopignistic)

% input BetPr(i), focal(i,n)
% n is the nbr of words needed to store a subset
% at input, sum BetPr = 1 required

% focal = [1:cardinal]
% BetPr is the column vector with BetP for every element in order focal

%
%   Version : Aug 15,03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global nbr_bit_per_word

card = length(BetPr);

[sorted_data ind_sort] = sortrows([BetPr focal]);
m = diff([0; sorted_data(:,1)]) .* [card:-1:1]';

bit(1:card) = 1;
mat_focal(1,:) = long_bit2num(bit,card);
for i = 2:card
	bit(sorted_data(i-1,2)) = 0;
	mat_focal(i,:) = long_bit2num(bit,card);
end

id_sel = find(m == 0);
if ~isempty(id_sel)
	m(id_sel) = [];
	mat_focal(id_sel,:) = [];
end

