function combinedbel=multcombine(list_bels)
%MULTCOMBINE combine a list of beliefs
% LIST_BELS: list of belief numbers to be combined
% COMBINEDBEL: the id_number of combination final result

global BELIEF;                      % VARIABLE MOFI ATTRIBUTE STRUCTURE FRAME;

allbelnumbers=[BELIEF(:).number];
bel_indx=extfind(list_bels, allbelnumbers);
if ~isempty(find(bel_indx==0))
    error('A belief to be combined does not exists.')
end

nofbels=length(list_bels);

if nofbels==1
    combinedbel=list_bels(1);        % nothing to do; return the input bel
else                                 % normal case multi combination
    varbelstruct=varbelcross(list_bels);
    if ~(nofbels==length(varbelstruct.belnums))
        error('Error in extracting belief information');
    end

    while nofbels > 2               % there are at least 3 bels in the list
        twobels=choosetwobel(varbelstruct);
		newbel=bcombine(twobels(1), twobels(2));
        indxusedbels = extfind(twobels, list_bels);
        list_bels(indxusedbels) = [];           % remove used bels
        list_bels = [newbel list_bels];         % add new bel in
        varbelstruct = varbelcross(list_bels);
        nofbels=length(list_bels);
    end
%     fprintf('The last two bels is [%s]\n', num2str(list_bels));
    combinedbel=bcombine(list_bels(1), list_bels(2));
end
%%%%%%%%%%%% end of MULTCOMBINE
