function twobeliefs
%TWOBELIEF creates 2 belief potentials for testing BCOMBINE function
% Phan Giang 04/06/02
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% This part enter focal set in the form of index list for testing purpose.
% Also summarizes the var information in a structure VAR.
var.nums=[ 1 2 3  4  5];
var.card=[10 2 8 10 10];
foset(1).domain=    [1  2  3];
foset(1).indices=   [1  1  2; 
                     5  1  4;
                    -1 -1 -1;
                     0  0  0;
                    -1 -1 -1; 
                     8  1  7;
                    10  2  4; 
                     5  1  4;
                    -1 -1 -1];
foset(1).values= [.7; .2; .1];
foset(2).domain=   [2  3  4  5];
foset(2).indices=  [1  4  5  6;
                    2  4  1  5;
                   -1 -1 -1 -1;
                    2  7  5  2;
                    2  7  4  2;
                    1  8  3  1;
                   -1 -1 -1 -1];
foset(2).values= [.9; .1];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This part construct 2 valid belief potentials
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
belief(1).number = 1; 			% each belief state has a number
belief(1).disposable = [];		% 1 = may be erased (clear) , 0 = [] = must be kept (default)
belief(1).agent = 'You';		% who is the belief holder
belief(1).time = 1;				% at what epoch
belief(1).ec = [];	            % ec = evidential corpus, on what bel is based, blabla	
belief(1).domain = [1 2 3];
belief(1).conditioning_variable = [];
belief(1).bp(1).form(1).type = 'm'; 
belief(1).bp(1).form(1).ordered = 1; % 1 = ordered by masses
belief(1).bp(1).form(1).focal_sets = set2intmat(var, foset(1));        % for 4 focal sets address in bin form
belief(1).bp(1).form(1).values = foset(1).values; % masses given

belief(2).number = 2; 			% each belief state has a number
belief(2).disposable = [];		% 1 = may be erased (clear) , 0 = [] = must be kept (default)
belief(2).agent = 'You';		% who is the belief holder
belief(2).time = 1;				% at what epoch
belief(2).ec = [];	            % ec = evidential corpus, on what bel is based
belief(2).domain = [2 3 4 5];
belief(2).conditioning_variable = [];
belief(2).bp(1).form(1).type = 'm'; 
belief(2).bp(1).form(1).ordered = 1;            % 1 = ordered by masses
belief(2).bp(1).form(1).focal_sets = set2intmat(var, foset(2));        % 5 focal sets
belief(2).bp(1).form(1).values = foset(2).values;   % masses given

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
variable(1).number = 1;   				% the number of the variable
variable(1).full_name = 'A';	        % full name of the variable
variable(1).short_name = 'a';	        % short name of the variable
variable(1).mofi = 1;
variable(1).frame = 1;

variable(2).number = 2; 
variable(2).full_name = 'B';
variable(2).short_name = 'b';
variable(2).mofi = 2;
variable(2).frame = 2;

variable(3).number = 3;
variable(3).full_name = 'C';
variable(3).short_name = 'c';
variable(3).mofi = 3;
variable(3).frame = 3;

variable(4).number = 5;
variable(4).full_name = 'D';
variable(4).short_name = 'd';
variable(4).mofi = 5;
variable(4).frame = 1;

variable(5).number = 4;
variable(5).full_name = 'E';
variable(5).short_name = 'e';
variable(5).mofi = 4;
variable(5).frame = 1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mofi(1).number=1;
mofi(1).full_name='mofi 1';
mofi(1).short_name='mofi_1';
mofi(1).attribute=1;
mofi(1).individual = 1;
mofi(1).index(1).name=[];
mofi(1).index(1).value=[];

mofi(2).number=2;
mofi(2).full_name='mofi 2';
mofi(2).short_name='mofi_2';
mofi(2).attribute=2;
mofi(2).individual = 1;
mofi(2).index(1).name=[];
mofi(2).index(1).value=[];

mofi(3).number=3;
mofi(3).full_name='mofi 3';
mofi(3).short_name='mofi_3';
mofi(3).attribute=3;
mofi(3).individual = 1;
mofi(3).index(1).name=[];
mofi(3).index(1).value=[];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
attribute(1).number = 1;  					% the number of the attribute
attribute(1).full_name = 'attribute 1';   	% full name of the attribute
attribute(1).short_name = 'att_1';			% short name of the attribute
attribute(1).structure=1;

attribute(1).number = 2;   					% the number of the attribute
attribute(1).full_name = 'attribute 2';   	% full name of the attribute
attribute(1).short_name = 'att_2';			% short name of the attribute
attribute(1).structure=2;

attribute(1).number = 3;   					% the number of the attribute
attribute(1).full_name = 'attribute 3';   	% full name of the attribute
attribute(1).short_name = 'att_3';			% short name of the attribute
attribute(1).structure=3;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
structure(1).number=1;
structure(1).frames=[1];     % the list of frames in the structure
structure(1).mapping=[1];

structure(1).number=2;
structure(1).frames=[2];     % the list of frames in the structure
structure(1).mapping=[2];

structure(1).number=3;
structure(1).frames=[3];     % the list of frames in the structure
structure(1).mapping=[3];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
frame(1).number = 1;
frame(1).name='Frame 1';
frame(1).type = 1;
frame(1).min=1;
frame(1).max=10;   % frame size = 10

frame(2).number = 2;
frame(2).name='Frame 2';
frame(2).type = 1;
frame(2).min=0;
frame(2).max=1;     % frame size = 2

frame(3).number = 3;
frame(3).name='Frame 3';
frame(3).type = 1;
frame(3).min=1;
frame(3).max=8;   % frame size = 8

BELIEF=belief;
VARIABLE=variable;
MOFI=mofi;
ATTRIBUTE=attribute;
STRUCTURE=structure;
FRAME=frame;

save testdata BELIEF VARIABLE MOFI ATTRIBUTE STRUCTURE FRAME;
%%%%%%%%%%%%%%%%% end of TWOBELIEF