function [ind_bel] = finishing_belief_from_VBS(bel_idnum,list_bels_number)

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global BELIEF belief variable attribute strucure mapping frame nbr_bit_per_word

% storing results
ind_BEL = find([BELIEF(:).number] == bel_idnum);
% ind_BEL may be longer than 1

for i = 1:length(ind_BEL)
	ind_bel = make_empty('belief');
	uselss  = pin_manipulation('belief','all',[]);
	ind_pot = make_empty('bp',ind_bel);	

	belief(ind_bel).full_name = ['B_VBS_',num2str(BELIEF(ind_BEL(i)).number)];
	% I store the number of BELIEF in belief full_name
	
	% don't use put_in_fields as it destroys many fields build by make_empty	
	% belief(ind_bel) = put_in_fields(BELIEF(ind_BEL(i)),belief(ind_bel))
	belief(ind_bel).domain_variable = BELIEF(ind_BEL(i)).domain_variable;
	belief(ind_bel).bp(ind_pot).form(1).values   = BELIEF(ind_BEL(i)).bp(ind_pot).form(1).values;
	belief(ind_bel).bp(ind_pot).form(1).focal_sets   = BELIEF(ind_BEL(i)).bp(ind_pot).form(1).focal_sets;

	for ii = 1:length(belief(ind_bel).bp(ind_pot).form(1).values)
		belief(ind_bel).bp(ind_pot ).form(1).log_expr{ii} = [];
	end
	get_its_dci(ind_bel)

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% Saving results, make it a query XXXX
	% I have to fill all the fields of belief, all I got from VBS is 
	% a number, domain variable and domain cardinilaity and bp
	% with the foset (lrflip done)
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% building the computed field.
	
	computed = 'dc(';
	for i = list_bels_number
		computed = [computed, num2str(i),','];
	end
	belief(ind_bel).computed  = [computed,')marginal(',num2str([belief(ind_bel).domain_variable]),')'];
	
	ind_var_marg = pin_manipulation('variable','num2ind',belief(ind_bel).domain_variable);
	num_frames = [variable(ind_var_marg).frame];
	cardi = [frame(pin_manipulation('frame','num2ind',num_frames)).cardinality];
	belief(ind_bel).domain_cardinality = cardi;
	% belief(ind_bel).domain_variable came with BELIEF, but not the cardinalities. Done here

	% get back VBS results, but foset to reorder
	% making TBMLAB foset from VBS foset
	belief(ind_bel).bp(ind_pot).form(1).focal_sets = foset_interface(...
	belief(ind_bel).bp(ind_pot).form(1).focal_sets,...
	belief(ind_bel).domain_cardinality);
	% Einstein foset_interface = 150 sec  HIGHLY INEFFICIENT

	% control that focal sets are indeed a column
	[nl nc] = size(belief(ind_bel).bp(ind_pot).form(1).focal_sets);

	if prod(cardi) <= nbr_bit_per_word & nc > 1
		belief(ind_bel).bp(ind_pot).form(1).focal_sets = belief(ind_bel).bp(ind_pot).form(1).focal_sets';
	end

	% verifying no missing mass 
	tot = sum(belief(ind_bel).bp(ind_pot).form(1).values);
	if abs(1-tot) > 1E-12
		disp('The sume of the masses is NOT one. Belief object erroneous.')
		fprintf(1,'index belief = %3i , index potential = %3i\nMasses are:',[ind_bel   ind_pot]);
		belief(ind_bel).bp(ind_pot).form(1).values
		fprintf(1,'1 - total masses = %10.6g\n',[1-tot]);		
		hdw = warndlg('The sume of the masses is NOT one. Belief object erroneous.');
		uiwait(hdw)
	end
end % each ind_BEL
