function frame_change(ind_bel,ind_pot,out_type,out_var_ind)
% input a belief on space X, output a new belief on Y

% step 1 = marginalise on those in X and Y
% step 2 = extend vacuously on those in Y
% out_type limited to 'm' 'wc' 'wd', else I need transform and cardinal becomes serious
% out_var = list of variable indexes in Y

% if marginal, only one bp generated, 
% if conditional done for every bp at once

% asked in the menu   tools

%
%   Version :Nov 21, 03.
%   Copyright (c) 2003 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%


global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief
global gui_position  figure_data  flags flag_str help_level help_label

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get paramleters
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if nargin == 0
	% get ind_bel
	pin_bel = get_ind_object('belief','one');
	ind_bel = pin_bel(2);
else
	% variable list entered in call
	if ~ismember(out_type,{'m','M','wc','wd','azertyuiop'})
		hdw = warndlg('I cannot proceed. I need at least one of m, wc or wd. I cancel.')
		uiwait(hdw)
		return
	end
end

for i = 1:length(belief(ind_bel).bp)
	% select form, OK for m, wc, wd.
	if ismember({'m'}, {belief(ind_bel).bp(i).form(:).type}) | ...
		ismember({'M'}, {belief(ind_bel).bp(i).form(:).type})
		% default done on m
		ind_for(i) =  min(find(strcmp({belief(ind_bel).bp(i).form(:).type},{'m'})));
		out_type = 'm';
	elseif ismember({'wc'}, {belief(ind_bel).bp(i).form(:).type})
		ind_for(i) =  min(find(strcmp({belief(ind_bel).bp(i).form(:).type},{'wc'})));
		out_type = 'wc';
	elseif ismember({'wd'}, {belief(ind_bel).bp(i).form(:).type})
		ind_for(i) =  min(find(strcmp({belief(ind_bel).bp(i).form(:).type},{'wd'})));
		out_type = 'wd';
	else
		hdw = warndlg('I cannot proceed. I need at least one of m, M, wc or wd. I cancel.')
		uiwait(hdw)
		return
	end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get the variables of the space
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if nargin == 0
	% I must entered by GUI the variable list 
	% 2 list, those in, and those new, deleted or added
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% get the figure for entering variable new space
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	hd_fig = figure('name','Query window');
	set(hd_fig,'position',gui_position(:,5));
	ind_fig = length(figure_data) + 1;
	figure_data(ind_fig).name = 'Querry window';
	figure_data(ind_fig).handle = hd_fig;
	figure_data(ind_fig).position = gui_position(:,5);
	
	hd_help = forced_display_help(0,58);
	
	% listing all objects
	hd_list_old = listing_existing('variable', gui_position(:,7), hd_fig);
	hd_list_new = listing_existing('variable', gui_position(:,6), hd_fig);
	
	select_list(hd_list_old,'on','many');	
	select_list(hd_list_new,'on','many');	
	set(hd_list_old(1),'string','INITIAL Variables');
	set(hd_list_new(1),'string','FINAL Variables');
	
	% list old variables
	list_old = belief(ind_bel).domain_variable;
	pos_old = pin_manipulation('variable','num2pos',list_old);
	in_var_ind = pin_manipulation('variable','num2ind',list_old);
	set(hd_list_old(2),'value',pos_old);
	set(hd_list_new(2),'value',pos_old);
	
	% box with button
	% new variables
	text = ['Get variables for FINAL space.'];
	good_select = 0;
	while good_select == 0
		choice = text_with_n_buttons(hd_fig,text,{'Done','Cancel'}, [1]);
		if choice == 1
			out_var_pos = get(hd_list_new(2),'value');
			out_var_ind = pin_manipulation('variable','pos2ind',out_var_pos);
			temp_old = get(hd_list_old(2),'value');
			if length(temp_old) ~= length(pos_old) |   max(abs(temp_old - pos_old)) > 0
				hdw = warndlg('Why did you modify the INITIAL list at right? Not important, but modify the FINAL at left');
				uiwait(hdw)
				set(hd_list_old(2),'value',pos_old);
				good_select = 0;
			else
				good_select = 1;
			end
		end		
	end
	delete(hd_fig)
	delete(hd_help)
	figure_data(ind_fig) = [];
	if choice == 2
		return
	end
else
	% there is data an input  ind_bel,ind_pot,out_type,out_var_ind
	list_old = belief(ind_bel).domain_variable
	in_var_ind = pin_manipulation('variable','num2ind',list_old);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% to be done for every potential in belief
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ind_bel_new = make_empty('belief');
useless = pin_manipulation('belief','all',[]);
num_var_in = pin_manipulation('variable','ind2num',in_var_ind);
num_var_out = pin_manipulation('variable','ind2num',out_var_ind);
ind_fra = pin_manipulation('frame','num2ind',[variable(out_var_ind).frame]);
list_fr_card_out = [frame(ind_fra).cardinality];
common_var = intersect(in_var_ind,out_var_ind); 
% tose that remain after marginalization
list_new = setdiff(out_var_ind,common_var);	
% those added by vacuous extension
belief(ind_bel_new).short_name = ['FrCh_',belief(ind_bel).short_name];
belief(ind_bel_new).full_name =  ['FrCh_',belief(ind_bel).full_name];
belief(ind_bel_new).domain_variable = num_var_out;
belief(ind_bel_new).domain_cardinality = list_fr_card_out;
belief(ind_bel_new).conditioning_variable = belief(ind_bel).conditioning_variable;
belief(ind_bel_new).conditioning_cardinality = belief(ind_bel).conditioning_cardinality;
orig = [];
for i=1:length(belief(ind_bel).bp)
	orig = [orig; pin_manipulation('belief','ind2num',ind_bel)  i];	
end
belief(ind_bel_new).origin = orig;
belief(ind_bel_new).computed = ['change_frame from',num2str(num_var_in),' to ',num2str(num_var_out)];
get_its_dci(ind_bel_new);

for ind_pot = 1:length(belief(ind_bel).bp)
	useless = make_empty('potential',ind_bel_new);
	% with each bp comes one empty form
	if length(belief(ind_bel).bp) > 1
		belief(ind_bel_new).bp(ind_pot).number = belief(ind_bel).bp(ind_pot).number;
		belief(ind_bel_new).bp(ind_pot).full_name = belief(ind_bel).bp(ind_pot).full_name;
		belief(ind_bel_new).bp(ind_pot).cd_focal_set = belief(ind_bel).bp(ind_pot).cd_focal_set;
		belief(ind_bel_new).bp(ind_pot).condition = belief(ind_bel).bp(ind_pot).condition;		
	end

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% marginalise
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% in_var_ind and out_var_ind
	
	% marginalization parameters
	
	foc_in = belief(ind_bel).bp(ind_pot).form(ind_for(ind_pot)).focal_sets;
	in_var_card = belief(ind_bel).domain_cardinality;
	
	foc_marg = marginalization_long_foc(foc_in,in_var_ind,out_var_ind,in_var_card);  
	
	switch out_type
	case {'m','M'}
		[new_w,new_focal] = pack_add(belief(ind_bel).bp(ind_pot).form(ind_for(ind_pot)).values,foc_marg);
	case {'w','wc','wd'}
		[new_w,new_focal] = pack_wc(belief(ind_bel).bp(ind_pot).form(ind_for(ind_pot)).values,foc_marg);
	end

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% vacuous extension
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	if ~isempty(list_new)
		foc_out = vacuous_ext_long_focal(new_focal, common_var, list_new, out_var_ind, list_fr_card_out);
	else
		foc_out = foc_marg;
	end

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% store in new belief object
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	belief(ind_bel_new).bp(ind_pot).form(1).type = out_type;
	belief(ind_bel_new).bp(ind_pot).form(1).values = new_w;
	belief(ind_bel_new).bp(ind_pot).form(1).focal_sets = foc_out;
	
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% announces Done and whay is done
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hdw = warndlg(['Request done. Results in belief with short_name = ',belief(ind_bel_new).short_name, ... 
' and full_name = ', belief(ind_bel_new).full_name]);
uiwait(hdw)
