function run_initiating_TBM
% the function that MUST be run before anything else

% it creates all windows, 
% then all pull-down menus attached to the UL window (the Root Window)
% then the initail help text
% and when acknowledge, TBM enters in the short cut menu.

% BEWARE: when changing menu, change also   text_menu_help   back_to_menu (why?)  init_stored_texts (for max help) 

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global  flags    flag_str  stored_text
global  screen_size   help_level
global  gui_position   pull_down_menu 
global  pathname2TBMLABvers  

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the only correct way out is thru the menu Control:Quit to MatLab 
% the ctrl C stops also everything and brings you back to the MatLab Command Window
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% building all Figures (windows)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[index_fig, hd_fig] = handling_all_figures('create',[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Part 1 : creating the pull-down menus in menu bar 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% getting the Root window so menus are attached to it
[index_fig, hd_fig] = handling_all_figures('put_in_front',{'Root Window'});

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% initiating the 5 TBM menus
% when changing name of a menu go to      text_menu_help 
% and verify option of the kill_menu and life_menu
% the kill_menu are in myself and in run_short_cuts
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

handle_file = uimenu('Label','File'); 
pull_down_menu(1).hd = handle_file;
pull_down_menu(1).label = 'File';
pull_down_menu(1).status = 1;
pull_down_menu(1).fig_parent = 'Root Window';
pull_down_menu(1).father = 'root';  % label of my direct father

handle_edit = uimenu('Label','Edit'); 
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).hd = handle_edit;
pull_down_menu(ind).label = 'Edit';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).fig_parent = 'Root Window';
pull_down_menu(ind).father = 'root';
gui_position_setting
handle_view = uimenu('Label','View'); 
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).hd = handle_view;
pull_down_menu(ind).label = 'View';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).fig_parent = 'Root Window';
pull_down_menu(ind).father = 'root';

handle_comput = uimenu('Label','Tools'); 
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).hd = handle_comput;
pull_down_menu(ind).label = 'Tools';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).fig_parent = 'Root Window';
pull_down_menu(ind).father = 'root';

handle_tutorials = uimenu('Label','Tutorials'); 
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).hd = handle_tutorials;
pull_down_menu(ind).label = 'Tutorials';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).fig_parent = 'Root Window';
pull_down_menu(ind).father = 'root';

switch computer
case 'MAC2'
	hname = 'TBM Help';
otherwise
	hname = 'Help';
end
handle_help = uimenu('Label',hname); 
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).hd = handle_help;
pull_down_menu(ind).label = hname;
pull_down_menu(ind).status = 1;
pull_down_menu(ind).fig_parent = 'Root Window';
pull_down_menu(ind).father = 'root';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File menu
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ik = 0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ik = ik + 1;
hand_file(ik) = build_uimenu(handle_file,'Open','handling_files(''open'')','File');
life_menu('Open')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ik = ik + 1;
hand_file(ik) = build_uimenu(handle_file,'Save','handling_files(''save_obj'')','File');
kill_menu('Save')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ik = ik + 1;
hand_file(ik) = build_uimenu(handle_file,'Print Report','run_short_cuts(6)','File');
life_menu('Print Report')
set(hand_file(ik),'Separator','on')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ik = ik + 1;
hand_file(ik) = uimenu(handle_file,'label','Quit','callback','run_quit_init_all_objects;uiresume;');
% special case as we quit only
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).hd = hand_file(ik);
pull_down_menu(ind).label = 'Quit';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).fig_parent = 'Root Window';
pull_down_menu(ind).father = 'File';
set(hand_file(ik),'Separator','on')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Edit menu
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ik=1;
hand_edit(ik) = build_uimenu(handle_edit,'Variables','life_menu(''Save'');life_menu(''Save As'');object_editor','Edit');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ik = ik + 1; 
hand_edit(ik) = uimenu(handle_edit,'Label','Short Cuts');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).hd = hand_edit(ik);
pull_down_menu(ind).label = 'Short Cuts';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).fig_parent = 'Root Window';
pull_down_menu(ind).father = 'Edit';

ikk = ik;
ik=ik+1;hand_edit(ik) = build_uimenu(hand_edit(ikk),'Natural frames','life_menu(''Save'');life_menu(''Save As'');run_short_cuts(4)','Edit');
ik=ik+1;hand_edit(ik) = build_uimenu(hand_edit(ikk),'Logical propositions','life_menu(''Save'');life_menu(''Save As'');run_short_cuts(5)','Edit');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ik=ik+1;
hand_edit(ik) = build_uimenu(handle_edit,'Mapping NA','life_menu(''Save'');life_menu(''Save As'');run_mapping','Edit');
kill_menu('Mapping NA')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ik=ik+1;
hand_edit(ik) = build_uimenu(handle_edit,'Belief','life_menu(''Save'');life_menu(''Save As'');run_belief(''menu'')','Edit');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ik = ik + 1;
hand_edit(ik) = build_uimenu(handle_edit,'Data Verification','verifying_object_data','Edit');
set(hand_edit(ik),'Separator','on')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ik = ik + 1;
hand_edit(ik) = build_uimenu(handle_edit,'Clear unused beliefs','run_clear_data','Edit');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% View menu
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% listing useful info for all objects on MatLab Command Window or on a file 
ik=1;
hand_view(ik) = uimenu(handle_view,'Label','All objects');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).hd = hand_view(ik);
pull_down_menu(ind).label = 'All objects';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).fig_parent = 'Root Window';
pull_down_menu(ind).father = 'View';

jk = ik;
ik=ik+1;hand_view(ik) = build_uimenu(hand_view(jk),'Objects on Cmd_Window','display_usefull_object_data(1)','View');
ik=ik+1;hand_view(ik) = build_uimenu(hand_view(jk),'Objects in file','display_usefull_object_data(2)','View');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% listing the whole information for all objects on MatLab Command Window
ik=ik+1;
hand_view(ik) = uimenu(handle_view,'Label','All object fields');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).hd = hand_view(ik);
pull_down_menu(ind).label = 'All object fields';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).fig_parent = 'Root Window';
pull_down_menu(ind).father = 'View';

jk = ik;
ik=ik+1;hand_view(ik) = build_uimenu(hand_view(jk),'Fields on Cmd_Window','run_show_all(1)','View');
ik=ik+1;hand_view(ik) = build_uimenu(hand_view(jk),'Fields in file NA','run_show_all(2)','View');
kill_menu('Fields in file NA')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% listing details on a selected object on MatLab Command Window or on a file
ik=ik+1;
hand_view(ik) = uimenu(handle_view,'Label','One object fields');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).hd = hand_view(ik);
pull_down_menu(ind).label = 'One object fields';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).fig_parent = 'Root Window';
pull_down_menu(ind).father = 'View';

jk = ik;
ik=ik+1;hand_view(ik) = build_uimenu(hand_view(jk),'Field on Cmd_Window','run_print_one_object(1)','View');
ik=ik+1;hand_view(ik) = build_uimenu(hand_view(jk),'Field in file NA','run_print_one_object(2)','View');
kill_menu('Field in file NA')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% detail road map that displays the architecture of all objects starting from belief
ik=ik+1;
hand_view(ik) = build_uimenu(handle_view,'Object Road Map','road_map_objects','View');
set(hand_view(ik),'Separator','on')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% the menu for hiding the windows
ik = ik + 1;
hand_view(ik) = build_uimenu(handle_view,'Hide Windows','hide_figures','View');
set(hand_view(ik),'Separator','on')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Tools menu
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ik = 1;
hand_comput(ik) = build_uimenu(handle_comput,'Run a .m fct','run_short_cuts(3)','Tools');
kill_menu('Run a .m fct NA')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Valuation Base System (undirected or directed) for belief potentials induced by distinct pieces of evidence
ik=ik+1;
hand_comput(ik) = build_uimenu(handle_comput,'Valuation Base Systems (Dir/UnDir)','run_VBS(''from_Tools_Menu'')','Tools');


% hand_comput(ik) = uimenu(handle_comput,'Label','Valuation Base Systems');
% ind = length(pull_down_menu) + 1;
% pull_down_menu(ind).hd = hand_comput(ik);
% pull_down_menu(ind).label = 'Valuation Base Systems';
% pull_down_menu(ind).status = 1;
% pull_down_menu(ind).fig_parent = 'Root Window';
% pull_down_menu(ind).father = 'Tools';
set(hand_comput(ik),'Separator','on')
% 
% jk = ik; 
% ik=ik+1;hand_comput(ik) = build_uimenu(hand_comput(jk),'Undirected VBS','run_VBS(''from_Tools_Menu'')','Tools');
% ik=ik+1;hand_comput(ik) = build_uimenu(hand_comput(jk),'Directed VBS','run_VBS(''from_Tools_Menu'')','Tools');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ik=ik+1;hand_comput(ik) = build_uimenu(handle_comput,'Graphical Method','run_plot_network','Tools');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% mixed conjunctive and disjunctive combinations (plus negations) for belief potentials induced by distinct pieces of evidence
ik=ik+1;
hand_comput(ik) = uimenu(handle_comput,'Label','Distinct Combination');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).hd = hand_comput(ik);
pull_down_menu(ind).label = 'Distinct Combination';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).fig_parent = 'Root Window';
pull_down_menu(ind).father = 'Tools';

jk = ik; 
ik=ik+1;hand_comput(ik) = build_uimenu(hand_comput(jk),'Distinct AND','run_distinct_combi(''and'')','Tools');
ik=ik+1;hand_comput(ik) = build_uimenu(hand_comput(jk),'Distinct OR','run_distinct_combi(''or'')','Tools');
ik=ik+1;hand_comput(ik) = build_uimenu(hand_comput(jk),'Distinct mixed','run_distinct_combi(''mixed'')','Tools');
% kill_menu('Distinct mixed NA')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% conjunctive and disjunctive combinations for belief potentials induced by maximaly correlated pieces of evidence
ik=ik+1;
hand_comput(ik) = build_uimenu(handle_comput,'Cautious Combination','run_cautious_conj_combi','Tools');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GBT. 
ik=ik+1;
hand_comput(ik) = uimenu(handle_comput,'Label','GBT');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).hd = hand_comput(ik);
pull_down_menu(ind).label = 'GBT';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).fig_parent = 'Root Window';
pull_down_menu(ind).father = 'Tools';

set(hand_comput(ik),'Separator','on')
jk = ik; 
ik=ik+1;hand_comput(ik) = build_uimenu(hand_comput(jk),'GBT: X/T both discrete','run_gbt','Tools');
ik=ik+1;hand_comput(ik) = build_uimenu(hand_comput(jk),'GBT: X Cont-Int, T Discr','run_gbt_cont_int','Tools');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% TBM_Tabulator
ik=ik+1;
% hand_comput(ik) = build_uimenu(handle_comput,'TBM Tabulator','tbm_tabulator','Tools');
ik=ik+1;hand_comput(ik) = uimenu(handle_comput,'Label','TBM Tabulator','callback','clbfmttab(101);');
% it is not OK to run tbm_tabulator from menu. Selectred cells keep their double frame, when they should not.
% One way is to get an index and to run tbm_tabulator from the main program, in which case it is ok 
% so clbfmttab(101) which bring back the number 101 in flag is used and back_to_menu handle the call
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).hd = hand_comput(ik);
pull_down_menu(ind).label = 'TBM Tabulator';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).fig_parent = 'Root Window';
pull_down_menu(ind).father = 'Tools';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% New Forms/Frames 
ik=ik+1;
hand_comput(ik) = uimenu(handle_comput,'Label','New Forms/Frames');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).hd = hand_comput(ik);
pull_down_menu(ind).label = 'New Forms/Frames';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).fig_parent = 'Root Window';
pull_down_menu(ind).father = 'Tools';

set(hand_comput(ik),'Separator','on')
jk = ik; 
ik=ik+1;hand_comput(ik) = build_uimenu(hand_comput(jk),'Get New Forms','run_transform_bp','Tools');
ik=ik+1;hand_comput(ik) = build_uimenu(hand_comput(jk),'Extension/Marginalization','frame_change','Tools');
ik=ik+1;hand_comput(ik) = build_uimenu(hand_comput(jk),'Conditioning NA','','Tools');
ik=ik+1;hand_comput(ik) = build_uimenu(hand_comput(jk),'Ballooning Ext. NA','','Tools');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Approximator calculator. 
ik=ik+1;
hand_comput(ik) = build_uimenu(handle_comput,'Approximate Distinct Combination NA','run_approx_combi','Tools');
kill_menu('Approx. Distinct Combi. NA')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ik = ik + 1;
hand_comput(ik) = build_uimenu(handle_comput,'Compare 2 belief potentials NA','run_comparing2bp','Tools');
kill_menu('Compare 2 belief potentials NA')

ik=ik+1;
hand_comput(ik) = build_uimenu(handle_comput,'EvClus: dissimil -> m','life_menu(''Save'');life_menu(''Save As'');para_evclus','Tools');
set(hand_comput(ik),'Separator','on')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ik = ik + 1;
hand_comput(ik) = uimenu(handle_comput,'Label','Preferences');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).hd = hand_comput(ik);
pull_down_menu(ind).label = 'Preferences';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).fig_parent = 'Root Window';
pull_down_menu(ind).father = 'Tools';
set(hand_comput(ik),'Separator','on');

ikk = ik;

ik=ik+1;hand_comput(ik) = build_uimenu(hand_comput(ikk),'Default','run_preferences(''default'')','Tools');
ik=ik+1;hand_comput(ik) = build_uimenu(hand_comput(ikk),'Open','run_preferences(''load'')','Tools');
ik=ik+1;hand_comput(ik) = build_uimenu(hand_comput(ikk),'Save','run_preferences(''save'')','Tools');
ik=ik+1;hand_comput(ik) = build_uimenu(hand_comput(ikk),'GUI','run_reset_param(1)','Tools');
% concerns some GUI parameters like
% BackGroundColor of all windows (default is white)
% FontSize : default = 10
% FontName : default = Times Roman
set(hand_comput(ik),'Separator','on')

ik=ik+1;hand_comput(ik) = build_uimenu(hand_comput(ikk),'TBM','run_reset_param(2)','Tools');
% concerns some parameters is the TBM computation
ik = ik + 1;
hand_comput(ik) = build_uimenu(hand_comput(ikk),'Help Level','run_help_level','Tools');
set(hand_comput(ik),'Separator','on')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Tutorials menu
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ik = 1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Fast Mobius Transform calculator. Require storing vector length 2^cardinal, so cardinal frame < 16 singletons
ik=ik+1;
hand_tutorials(ik) = uimenu(handle_tutorials,'Label','Mobius Transformations');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).hd = hand_tutorials(ik);
pull_down_menu(ind).label = 'Mobius Transformations';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).fig_parent = 'Root Window';
pull_down_menu(ind).father = 'Tutorials';

jk = ik; 
ik=ik+1;hand_tutorials(ik) = build_uimenu(hand_tutorials(jk),'Potential Demo','potential_tabulator','Tutorials');
ik=ik+1;hand_tutorials(ik) = build_uimenu(hand_tutorials(jk),'Mobius Transf Operators','mobius_matrices','Tutorials');
ik=ik+1;hand_tutorials(ik) = build_uimenu(hand_tutorials(jk),'Explaining FMT','fmt_explaining','Tutorials');
ik=ik+1;hand_tutorials(ik) = build_uimenu(hand_tutorials(jk),'Specialization Demo','specialization_tabulator','Tutorials');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GBT. 
ik=ik+1;
hand_tutorials(ik) = uimenu(handle_tutorials,'Label','GBT Demo');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).hd = hand_tutorials(ik);
pull_down_menu(ind).label = 'GBT Demo';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).fig_parent = 'Root Window';
pull_down_menu(ind).father = 'Tutorials';

jk = ik; 
ik=ik+1;hand_tutorials(ik) = build_uimenu(hand_tutorials(jk),'GBT Demo','gbt_demo','Tutorials');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% topic tutorials
tutor_list = get_tutorial_list;
ik=ik+1;
hand_tutorials(ik) = uimenu(handle_tutorials,'Label','Lectures');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).hd = hand_tutorials(ik);
pull_down_menu(ind).label = 'Lectures';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).fig_parent = 'Root Window';
pull_down_menu(ind).father = 'Tutorials';

jk = ik; 
for i = 1:length(tutor_list) 
	to = findstr('.tutor.',tutor_list{i}) - 1;
	clbk_run = ['run_tutorials(''',tutor_list{i},''')'];
	ik=ik+1;hand_tutorials(ik) = build_uimenu(hand_tutorials(jk),tutor_list{i}(1:to),clbk_run,'Tutorials');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% topic tutorials
ik=ik+1;
hand_tutorials(ik) = uimenu(handle_tutorials,'Label','Application Demo');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).hd = hand_tutorials(ik);
pull_down_menu(ind).label = 'Application Demo';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).fig_parent = 'Root Window';
pull_down_menu(ind).father = 'Tutorials';

jk = ik; 
ik=ik+1;hand_tutorials(ik) = build_uimenu(hand_tutorials(jk),'Classifier Repeated Data','self_repeating_sensor','Tutorials');
ik=ik+1;hand_tutorials(ik) = build_uimenu(hand_tutorials(jk),'Sensor VarGran LimCap LimKn','sensors_granul_lazy_limK','Tutorials');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% TBM Help menu
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ik = ik + 1;
hand_help(ik) = build_uimenu(handle_help,'Menu Actions','run_menu_help','Help');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ik=ik+1;hand_help(ik) =  build_uimenu(handle_help,'Demos','show_demos','Help');
% set(hand_help(ik),'Separator','on')
ik=ik+1;hand_help(ik) =  build_uimenu(handle_help,'Object','run_object_help(7)','Help');
set(hand_help(ik),'Separator','on')
ik=ik+1;hand_help(ik) =  build_uimenu(handle_help,'Frame','run_object_help(1)','Help');
ik=ik+1;hand_help(ik) =  build_uimenu(handle_help,'Structure','run_object_help(2)','Help');
ik=ik+1;hand_help(ik) =  build_uimenu(handle_help,'Mapping NA','run_object_help(3)','Help');
ik=ik+1;hand_help(ik) =  build_uimenu(handle_help,'Attribute','run_object_help(4)','Help');
ik=ik+1;hand_help(ik) =  build_uimenu(handle_help,'Variable','run_object_help(5)','Help');
ik=ik+1;hand_help(ik) =  build_uimenu(handle_help,'Belief','run_object_help(6)','Help');

ik=ik+1;hand_help(ik) =  build_uimenu(handle_help,'About TBMLAB','run_about_TBMLAB','Help');
set(hand_help(ik),'Separator','on')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% print all helps
ik=ik+1;hand_help(ik) = build_uimenu(handle_help,'Help Texts','print_all_help','Help');
set(hand_help(ik),'Separator','on')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% we have finished with the construction of all the menus
%
% turning all menu off initialy

menu_off

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Part 2: displaying initial help texts
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% displaying the TITLE in nice Blue 0 .5 .5
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% the version level
fr = max(findstr('TBMLAB_',pathname2TBMLABvers));
fullname = pathname2TBMLABvers(fr:length(pathname2TBMLABvers));

fprintf(1,'Report on file manipulation: pathname2TBMLABvers = %s\n\n',pathname2TBMLABvers); 

% we need root window

[index_fig, hd_fig] = handling_all_figures('put_in_front',{'Root Window'});
h(1) = uicontrol(...
'Style','Text',...
'Position',gui_position(:,2),...
'String',fullname,...
'ForegroundColor','blue',...
'HorizontalAlignment','center',...
'FontSize',18,...
'FontName','Times New Roman');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% displaying initial help text: 2 to 5
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if help_level < 2
	help_text_handles = forced_display_helps(0,2); % short welcome message
else	
	help_text_handles = display_helps(1,[2 3]);  % full welcome message
end
set(help_text_handles,'userdata','I_am_iddle') % used to delete it once I hit a menu

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% reating pin_tables
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
get_all_pin_tables; % so pin_tables exist at least (with [0 0 0] as default)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Part 3 : exit by running the real control center = back_to_menu
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% % to get a list of all menu  uncomment the 3 next lines
% for i = 1:length(pull_down_menu)
% 	fprintf(1,'%s \n',[pull_down_menu(i).father, '       ', pull_down_menu(i).label]);
% end

% the real control of the whole tbmlab occurs in back_to_menu from where I select any menu
back_to_menu;
% to be here = I ask quit in back_to_menu, so I go to tbmlab, and I quit
