function hd_title = tbmlab_title
% The title display

%
%   Version : June 13,03.
%   Copyright (c) 2003 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global screen_size

t{1} = 'TBMLAB';
t{2} = 'Transferable Belief Model';
t{3} = 'Belief Functions';
t{4} = 'Weighted Opinions';
t{5} = 'Weighted Beliefs';
t{6} = 'Uncertainty on Imprecise Data';
t{7} = 'Copyright (c) 2003, Philippe Smets';
t{8} = 'Click anywhere to proceed';

screen_size_here = screen_size;

switch computer
case 'MAC2'
	ft_name = 'Times';
	n = [96 72 .8];
case 'PCWIN'
	ft_name = 'Times New Roman'; % 'FixedWidth'
	screen_size_here(2) = 80;
	screen_size_here(4) = screen_size(4) - screen_size_here(2);
	n = [84 60 .75];
case 'MAC'
	ft_name = 'FixedWidth';
	screen_size_here(2) = 90;
	screen_size_here(4) = screen_size(4) - screen_size_here(2);
	n = [84 60 .75];	
otherwise
	ft_name = 'FixedWidth';
	screen_size_here(2) = 90;
	screen_size_here(4) = screen_size(4) - screen_size_here(2);
	n = [84 60 .75];
end

hd_fig = figure('position',screen_size_here,...
'Color',[.8 .8 .8],...
'WindowButtonDownFcn','uiresume;',...
'NumberTitle','off',...
'MenuBar','non');

set(hd_fig,'Units','Normalized');

hd_axes = axes('position',[0 0 1 1],'TickDir','out','Color',[.7 .7 .7]);

%t{1} = 'TBMLAB';
text('position',[0.25 .80],'String',t{1},'fontsize',n(1),...
'FontName',ft_name,...
'FontWeight','Bold','Color','r','HorizontalAlignment','center');

% t{2} = 'Transferable Belief Model';
text('position',[0.5 .55],'String',t{2},'fontsize',n(2),...
'FontName',ft_name,...
'rotation',30,...
'FontWeight','Bold','Color','b','HorizontalAlignment','center');

% t{3} = 'Belief Functions';
text('position',[0.2 .1],'String',t{3},'fontsize',30,...
'FontName',ft_name,...
'FontWeight','Bold','Color','r','HorizontalAlignment','center');

% t{6} = 'Uncertainty on Imprecise Data';
text('position',[0.66 .1],'String',t{6},'fontsize',30,...
'FontName',ft_name,...
'FontWeight','Bold','Color','r','HorizontalAlignment','center');

% t{4} = 'Weighted Opinions';
text('position',[n(3) .40],'String',t{4},'fontsize',36,...
'FontName',ft_name,...
'FontWeight','Bold','Color','y','HorizontalAlignment','center');

% t{5} = 'Weighted Beliefs';
text('position',[n(3) .30],'String',t{5},'fontsize',36,...
'FontName',ft_name,...
'FontWeight','Bold','Color','y','HorizontalAlignment','center');

% t{7} = 'Copyright 2003, Philippe Smets';
text('position',[.01 .01],'String',t{7},'fontsize',12,...
'FontName',ft_name,...
'FontWeight','Bold','Color','k','HorizontalAlignment','left');

% t{8} = 'Click on me';
text('position',[.99 .01],'String',t{8},'fontsize',12,...
'FontName',ft_name,...
'FontWeight','Bold','Color','k','HorizontalAlignment','right');

% uiwait(gcf)
% delete(hd_fig)
hd_title = hd_fig;
