function [exp] = get_logic_expression(log_expr)
% tranform in evaluable the input logical expression
% produce also the printable version with & ~ v -> and <-> symbols

% exp is the logical expression ready for eval 

%
%   Version : Feb 18,03
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global variable

% % % % global beta symb_and symb_or symb_impl symb_equiv symb_neg
% % % % exp(length(exp)+1:length(exp)+10) = ' ';
% % % % % i need a string at least as long as ' equiv ', 
% % % % % as findstr looks for the presence of the shortest in the longest

exp = log_expr; % this will become what we evaluate
var = exp; % this is only for finding the variables involved

exp = strrep(exp,' universe ',' 1 ');
exp = strrep(exp,' contradiction ',' 0 ');

exp = strrep(exp,' and ',' & ');
exp = strrep(exp,' or ',' | ');
exp = strrep(exp,' not ',' ~ ');

% var = strrep(var,' and ',' ');
% var = strrep(var,' or ',' ');
% var = strrep(var,' not ',' ');
% var = strrep(var,'[',' ');
% var = strrep(var,']',' ');
% var = strrep(var,'{',' ');
% var = strrep(var,'}',' ');
% var = strrep(var,' impl ',' ');
% var = strrep(var,' equiv ',' ');
% var is not used in fact


% % % % from = findstr(' and ',exp);
% % % % if ~isempty(from) 
% % % % 	for i = 1:length(from)
% % % % 		from(i) = from(i)+1;
% % % % 		exp(from(i):from(i)+2) = '&  ';
% % % % 		var(from(i):from(i)+2) = '   ';
% % % % 	end
% % % % end
% % % % 
% % % % from = findstr(' or ',exp);
% % % % if ~isempty(from) 
% % % % 	for i = 1:length(from)
% % % % 		from(i) = from(i)+1;
% % % % 		exp(from(i):from(i)+1) = '| ';
% % % % 		var(from(i):from(i)+1) = '  ';	
% % % % 	end
% % % % end
% % % % 
% % % % from = findstr(' not ',exp);
% % % % if ~isempty(from) 
% % % % 	for i = 1:length(from)
% % % % 		from(i) = from(i)+1;
% % % % 		exp(from(i):from(i)+2) = '  ~';
% % % % 		var(from(i):from(i)+2) = '   ';
% % % % 	end
% % % % end

% % % % % % getting rid of what is between [] or {}
% % % % % from = findstr('[',var);
% % % % % if ~isempty(from)
% % % % % 	to = findstr(']',var);
% % % % % 	for i = 1:length(from)
% % % % % 		var(from(i):to(i)) = ' ';
% % % % % 	end
% % % % % end
% % % % % 
% % % % % from = findstr('{',var);
% % % % % if ~isempty(from)
% % % % % 	to = findstr('}',var);
% % % % % 	for i = 1:length(from)
% % % % % 		var(from(i):to(i)) = ' ';
% % % % % 	end
% % % % % end
% % % % % % up to here var and exp are same length, not after doing impl



from = findstr(' impl ',exp);
if ~isempty(from) 
	ok_for_eq = 0;
	if length(from) > 1 | from == 1 | from == length(exp)
		disp('Max ONE implication, antecedent consequent not empty')
		ok = 0;
	else	
		from = from+1;
		% % % % 		var(from:from+3) = ' ';		
		t1 = exp(1:from-1);
		t2 = exp(from+4:length(exp));
		exp = strcat(' ~ ( ',t1,' ) | ( ',t2,' ) ');
	end	
else
	ok_for_eq = 1;
end

from = findstr(' equiv ',exp);
if ~isempty(from)
	% handling the var
	if ok_for_eq == 0
		ok = 0;
	else		
		if length(from) > 1 | from == 1 | from == length(exp)
			disp('Max ONE equivalence, both terms not empty')
			ok = 0;
		else	
			frvar = findstr(' equiv ',var);
			% % % % 			var(frvar+1:frvar+5) = ' ';
			t1 = exp(1:frvar);
			t2 = exp(frvar+6:length(exp));
			exp = strcat(' ( ( ',t1,' ) & ( ',t2,' ) ) | ( ~ ( ',t1,' ) & ~ ( ',t2,' ) ) ');
		end	
	end
end

% % % % % % % % expr_for_text = strrep(expr_for_text,' and ',' & ');
% % % % % % % % expr_for_text = strrep(expr_for_text,' or ',' v ');
% % % % % % % % expr_for_text = strrep(expr_for_text,' not ',' ~ ');
% % % % % % % % expr_for_text = strrep(expr_for_text,' impl ',' -> ');
% % % % % % % % expr_for_text = strrep(expr_for_text,' equiv ',' <-> ');
% % % % % % % % expr_for_text = strrep(expr_for_text,' ','');

% % % % % % % % 
% % % % % % % % fr = findstr(expr_for_text,' and ');
% % % % % % % % if ~isempty(fr)
% % % % % % % % 	for i = fr
% % % % % % % % 		expr_for_text(i+1:i+3) = [' ',symb_and,' '];
% % % % % % % % 	end
% % % % % % % % end
% % % % % % % % fr = findstr(expr_for_text,' or ');
% % % % % % % % if ~isempty(fr)
% % % % % % % % 	for i = fr
% % % % % % % % 		expr_for_text(i+1:i+2)  = [' ',symb_or];
% % % % % % % % 	end
% % % % % % % % end
% % % % % % % % fr = findstr(expr_for_text,' not ');
% % % % % % % % if ~isempty(fr)
% % % % % % % % 	for i = fr
% % % % % % % % 		expr_for_text(i+1:i+3)  = [' ',symb_neg,' '];
% % % % % % % % 	end
% % % % % % % % end
% % % % % % % % fr = findstr(expr_for_text,' impl ');
% % % % % % % % if ~isempty(fr)
% % % % % % % % 	for i = fr
% % % % % % % % 		expr_for_text(i+1:i+4) = ' -> ';
% % % % % % % % 	end
% % % % % % % % end
% % % % % % % % fr = findstr(expr_for_text,' equiv ');
% % % % % % % % if ~isempty(fr)
% % % % % % % % 	for i = fr
% % % % % % % % 		expr_for_text(i+1:i+5)= ' <-> ';
% % % % % % % % 	end
% % % % % % % % end
% % % % % fr = findstr(expr_for_text,blank);
% % % % % if ~isempty(fr)
% % % % % 	expr_for_text(fr)= ' ';
% % % % % end
% % % % % % 
% % % % % % fr = findstr(expr_for_text,'  ');
% % % % % % if ~isempty(fr)
% % % % % % 	expr_for_text(fr)= [];
% % % % % % end

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %
% % finding the list of involved variables
% % kept but unused
% %
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% % in var we still have in, ==, ( )
% var(findstr(')',var)  ) = ' '; % an empty list is Ok, nothing changes
% var(findstr('(',var)  ) = ' ';
% var(findstr('=',var)  ) = ' ';
% fr = findstr(' in ',var);
% for i = 1:length(fr)  ; % the if is not done if length = 0
% 	var(fr(i)+1:fr(i)+2) = ' ';
% end
% % var is clean of everything except variable names 
% 
% %listing the variables involved in expression
% % by now the only characters are ismember and the short_names
% i_new = 0;
% var(length(var)+1) = ' '; % to be sure of no accident at the end
% i = 0;
% while i < length(var)
% 	i = i+1;
% 	ggoo = 0;
% 	j = i;
% 	while ~strcmp(var(i),' ') 
% 		ggoo = 1;
% 		i = i+1;		
% 	end
% 	if ggoo
% 		i_new = i_new + 1;
% 		list_var{i_new} = var(j:i-1);
% 	end
% end
% 
% % eliminate duplicate, list of variables encountered in the expresion
% list_var = unique(list_var); % alphabetically sorted by unique
% 
% % quality control  unused as now, but maybe later XXXX
% var_ok = 1;
% if isempty(list_var)
% 	var_ok = 0; % these is no variable in your expression????
% end

% % checking all these names are short_names for the variables of this belief
% var_ind = []; % list of variable index
% for i = 1:length(list_var)
% 	if ~ismember({list_var{i}},{shn_list{:}})
% 		var_ok = 0;
% 	else
% 		var_ind = [var_ind ...
% 		ind_var_in_bel(find(strcmp(list_var{i},{shn_list{:}})))];
% 	end
% end	

% var_ind are the index in variable(index). same order as 
% the variables encountered in the expression and stored in list_var
% after sort (from unique)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% back to exp for the in case (in = ismember of)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

inok = 1; 
while inok
	from = findstr(' in ',exp);
	if ~isempty(from) 
		fr = from(1);
		% when tghere is a in: find previous ( and next )
		
		% It can only be
		%( var in {'cc','r'} )  
		%( var in [4 6 9] )  
		%( var(r,n) in {'cc','r'} )  
		%( var(r,n) in [4 6 9] )  
		
		parl = max(  find( exp(1:fr) == '('));
		parrbad = max(find( exp(1:fr) == ')'));
		if parrbad > parl
			parl = max(find( exp(1:parrbad-1) == '('));
			parl = max(find( exp(1:parl-1) == '('));
		end	
	
		parr = min(find(exp(fr:length(exp)) == ')')) + fr - 1;
		parrbad = min(find(exp(fr:length(exp)) =='(')) + fr - 1;
		if parrbad < parr
			parr = min(find(exp(parrbad+1:length(exp)) ==')')) + parrbad;
			parr = min(find(exp(parr+1:length(exp)) ==')')) + parr;
		end	
	
		t1 = exp(1:parl);
		t2 = exp(parl+1:fr-1);
		t3 = exp(fr+4:parr);
		if parr + 1 <= length(exp)		
			t4 = exp(parr+1:length(exp));
		else
			t4 = ' ';
		end	
		exp = [t1,' ismember(',t2,',',t3,') ',t4];		
	else
		inok = 0;
	end
end

