function ok = get_m_from_logic_expr_new( option, belief_index,bp_index,for_ind, ...
ind_foset,last_log_expr)
% getting all bbm from logical expressions
% everything with mouse or from a batch file

% ok = 1 if all OK, = 0 if not.
% if option = batch mode ok = 0 == bad logical expression

%
%   Version : Feb 14,03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global variable frame belief 
global hd_help_object   hd_help_menu    name_calling_window  figure_data gui_position
global help_level

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% rules for logical epxressions

% term t can be
% p : 	p is the short name of a logical variable (obtain from short cut  get n propositions)
% (v == 3) : 	v is the short name of a variable , element is a number
% (v in [3 5 8])
% (v in [3:9 20:45])   ( and ) forbidden inside [] and inside v in [3:9 20:45]
% (v in {'C1','C4'})   	when elements are strings	 
% (v in {'C1'}) 	 	for the equality, don't use (v == 'C1')
% beware (v = 4) accident must be ==

% beware that and, or, not, in, impl, equiv are preceded and followed by a space

% in variable short names, no blank allowed, put a _ in place,
% if in reality you had put a blank in the variable().short_name, the system adds the _

% expressions, with t,t1,t2 terms or expresssions, with classical ( )
% t
% not t
% t1 and t2
% t1 or t2
% t1 impl t2 (implication, becomes not t1 or t2) max 1 implic
% t1 equiv t2 (equivalence becomes (t1 and t2) or (not t1 and not t2)) max 1 equiv

% VERY easy for simple implication rules
% you feed one line like (p and q) impl (f or g) and its mass
% and that is all

% list of short names in shn_list
% order same as the one of belief(belief_index).domain_variable

% I store several forms for the logical expression
% displayed_expr = the expr as displayed, variables short name as when created (even blank and () , OK)
% mem_expr = the expr as stored. Variables are represented as Vnnn where nnn is the variable index.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% replacing space in short names of variables involved in the bel
% and its frame elements labels.
% why: suppose label is 'aaa and bbb', how to distinguish this 'and' from the 'and' in the logical epxression
% In mem_expr, I replace it by V43 in {'aaa and bbb'}, so the and in wiyhin ' '
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Overall architecture

% Needs: 	entering a request for ONE mass, 	from screen editor, 
%												from batch mode
%			entering request for ONE bba (sev eral masses) from screen editor, 
%			rfetrieving one logical expr, displaying it on from screen editor, editing expr and/or mass
%
% handle by option = 'bbm_scr', 'bbm_batch', 'bba', 'edit'
% edit called from editor, or from the EVN, or some future fct
% bba is just a loop with several bbm_scr
% edit is bbm_scr with non empty intialization
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the handles: hd_logexp{i}(j)
%
% i = 1 : the 2 boxes
% j = 1 = the box for the logical expr
% j = 2 = the title of 1
% j = 3 = the box for the mass
% j = 4 = the title of 3
%
% i = 2 : the control buttons
% j = n = element n of {'OK','Clear Expr.','Cancel','Quit'}
%
% i = 3 : the logical operator buttons
% j = n = element n of {'and','or','not','impl','equiv','(',')'}
%
% i = 4 : the variable buttons
% j = n = n'trh variobale, same order as in domain_variable
%
% button_operator{1} = {'OK','Clear Expr.','Cancel','Quit'}
% button_operator{2} = {'and','or','not','impl','equiv','(',')'}
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% hd_logexp{2}(i)   i = 1 frame, 2 = title 3 = uicontextmenu , 4 = OK,   6 = Clear ...
% similar for hd_logexp{3}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% initating variables, etc
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[ind_var_in_bel, shn_list, frame_list,list_typ_var,card] = get_m_log_init_variable(belief_index);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% if not batch, create display
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if ~strcmp(option,'bbm_batch')
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% get the figure
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	bp_handle_fig = figure(...
	'KeyPressFcn','callback_key_hit;uiresume;',...
	'name','Bba Editor: logical mode');
	set(gcf,'position',gui_position(:,5));
	ind_fig = length(figure_data) + 1;
	figure_data(ind_fig).name = 'Bba Editor: logical mode';
	figure_data(ind_fig).handle = bp_handle_fig;
	figure_data(ind_fig).position = gui_position(:,5);
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% put its menus
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	k=0;
	k=k+1;make_fig_menu(ind_fig,k,'File',0,'','on');
	k=k+1;make_fig_menu(ind_fig,k,'Quit',1,'clb_button_list(3,4);uiresume;','on');
	% see get_m_log_init_screen to undersatnd clb 3,4  (it was where quit was put initially in multi panel button lists)
	
	menu_manager('create',ind_fig)
	
	help_level_mem = help_level;
	help_level = 1; % I must put help level = 1 in order help to be displayed
	hd_help = display_helps(0,24);
	% there is only one help so I just show it 
	% display_helps put the Root Window in front with a help text
	help_level = help_level_mem;	
	
	% building the content of editor window
	[hd_logexp,button_operator] = get_m_log_init_screen(bp_handle_fig,shn_list);	
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the 4 options
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ok = 1;

switch option

case 'bbm_scr' % get ONE NEW mass in mass(ind_foset),... 
	
	[log_expr,foset,mass,cancel] = get_m_log_one_bbm(belief_index,bp_handle_fig,...
	0,1,'',shn_list,frame_list,list_typ_var,ind_var_in_bel,hd_logexp,button_operator);
	% sum_masses = 0,   log_expr_correct = 1, last_log_expr = ''
	
	if cancel == 0 
		% data OK, we proceed, otherwise we just skip		
		if ind_foset == 0
			% it is a NEW bp.form
			belief(belief_index).bp(bp_index).form(for_ind).type = 'm';
			belief(belief_index).bp(bp_index).form(for_ind).representation = 'selected';
			ind_foset = 1;
		end
		belief(belief_index).bp(bp_index).form(for_ind).focal_sets(ind_foset,:) = foset;
		belief(belief_index).bp(bp_index).form(for_ind).values(ind_foset) = mass;
		belief(belief_index).bp(bp_index).form(for_ind).log_expr{ind_foset} = log_expr;	
	end

case 'edit' % get a version of ONE OLD mass	that may be edited

	% used to correct ONE mass 
	last_log_expr = belief(belief_index).bp(bp_index).form(for_ind).log_expr{ind_foset};
	
	[log_expr,foset,mass,cancel] = get_m_log_one_bbm(belief_index,bp_handle_fig,...
	0,0,last_log_expr,shn_list,frame_list,list_typ_var,ind_var_in_bel,hd_logexp,button_operator);		
	% sum_masses = 0,   log_expr_correct = 0, 
	
	% I store, and will save only when I use quit option
	if cancel == 0 
		belief(belief_index).bp(bp_index).form(for_ind).focal_sets(ind_foset,:) = foset;
		belief(belief_index).bp(bp_index).form(for_ind).values(ind_foset) = mass;	
		belief(belief_index).bp(bp_index).form(for_ind).log_expr{ind_foset} = log_expr;		
	end

case 'bbm_batch'
	% mass handled in the calling instruction,  not needed here
	% last_log_expr entered from calling instruction
	last_log_expr =	belief(belief_index).bp(bp_index).form(for_ind).log_expr{ind_foset};
	log_expr = get_logic_expression(last_log_expr);
	[foset, bad_exp] = get_m_log_foset(log_expr,belief_index,ind_var_in_bel, shn_list);
	
	if bad_exp == 0
		belief(belief_index).bp(bp_index).form(for_ind).focal_sets(ind_foset,:) = foset;
	else
		% this a not OK in batch mode, just to tell calling instruction that batch instr is a bad expr
		ok = 0;
	end

case 'bba' % getting all masses for one bba

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% begin building masses
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	st_focal = []; 			st_mass = []; 
	ind_foset = 0; 			go_on = 1;
	log_expr_correct = 1; 	last_log_expr = '';
	
	while go_on
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% for every mass (except mass to universe, given automatically)
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		sum_masses = sum(st_mass);	
		[log_expr,foset,mass, cancel] = get_m_log_one_bbm(belief_index,bp_handle_fig,...
		sum_masses,log_expr_correct,last_log_expr,shn_list,frame_list,list_typ_var,ind_var_in_bel,...
		hd_logexp,button_operator);
		
		switch cancel 
		case 0 % ok 
			ind_foset = ind_foset + 1;
			st_log_exp{ind_foset} = log_expr;		
			st_focal = [st_focal ; foset];
			st_mass = [st_mass; mass];
		case 1 % cancel it
			go_on = 0;
		case 2 % quit and save 
			go_on = 0;
			if mass
				ind_foset = ind_foset + 1;
				st_log_exp{ind_foset} = log_expr;		
				st_focal = [st_focal ; foset];
				st_mass = [st_mass; mass];
			end
		end	
	end % while go_on for each focal set, one by one

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% storing bba 
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	if cancel ~= 1 % there is something to save 
		if sum(st_mass) < 1 % left over mass to universe
			st_mass = [st_mass; 1 - sum(st_mass)];
			st_focal = [st_focal ;get_universe(card)]; 
			ind_foset = ind_foset + 1;
			st_log_exp{ind_foset} = 'universe';	
		end
		% we store the bba here only
		ok = build_form(belief_index,bp_index,for_ind,'m','selected',st_focal,st_mass,st_log_exp);
	end

end	

% I must delete the content of the window if I had open it (thus always except batch)
if ~strcmp(option,'bbm_batch')
	delete(bp_handle_fig);
	delete(hd_help);
	figure_data(ind_fig) = [];
end
