function [hd_logexp,button_operator] = get_m_log_init_screen(bp_handle_fig,shn_list)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the handles: hd_logexp{i}(j)
%
% i = 1 : the 2 boxes
% j = 1 = the box for the logical expr
% j = 2 = the title of 1
% j = 3 = the box for the mass
% j = 4 = the title of 3
%
% i = 2 : the control buttons
% j = n = element n of {'OK','Clear Expr.','Cancel','Quit'}
%
% i = 3 : the logical operator buttons
% j = n = element n of {'and','or','not','impl','equiv','(',')'}
%
% i = 4 : the variable buttons
% j = n = n'trh variobale, same order as in domain_variable
%
% button_operator{1} = {'OK','Clear Expr.','Cancel'}
% button_operator{2} = {'and','or','not','impl','equiv','(',')'}
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%
%   Version : Feb 18,03
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global button_size gui_position

set(bp_handle_fig,'KeyPressFcn','callback_key_hit;uiresume;');
% keyhit becomes 1-2-3 when I hit CR, Esc, Erase in the figure area

% button_size 
posFig = get(bp_handle_fig,'Position');	
height_but= min(button_size(2)/posFig(4),.99);
width_but = min(button_size(1)/posFig(3),.99); 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the conversation boxes where the logical expression is displayed
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_logexp{1}(1) = uicontrol(...
'Parent',bp_handle_fig, ...
'Position',gui_position(:,15)', ...
'Style','edit', ...
'HorizontalAlignment','left', ...
'String','',...
'Tag','logop',...
'Callback','callback_CR_edit;uiresume;');
% keyhit becomes 1 when I hit CR and pointer in the box area

hd_logexp{1}(2) = uicontrol(...
'Parent',bp_handle_fig, ...
'Position',gui_position(:,15)' + [0  gui_position(4,15)+.005 0  .03-gui_position(4,15)], ...
'Style','text', ...
'HorizontalAlignment','left', ...
'String','Logical expression',...
'Tag','logop');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% set of control buttons for end formula and for cancel for this focal set, or full cance
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

button_operator{1} = {'OK','Quit','Clear Expr.','Cancel No Save'};
% beware 3,4 used for the quit in the menu File

tooltip{1} = 'Accept Expression or Accept mass.';
tooltip{2} = 'Accept created bba. Back to Belief Potential window.';
tooltip{3} = 'Delete expression in text box.';
tooltip{4} = 'Stop logical construction. Store nothing.';

hidden_buttons = [];
hd_logexp{2} = button_list(bp_handle_fig, gui_position(:,12), 'Control', ...
button_operator{1}, 'clb_button_list(3,', hidden_buttons, tooltip );%)
% flag(2) = 3, flag(1) = selected button

% hd_logexp{2}(i)   i = 1 frame, 2 = title 3 = uicontextmenu , 4 = OK,   6 = Clear ...
% similar for hd_logexp{3}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% button list of logical operators 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

button_operator{2} = {'and','or','not','impl','equiv','(',')'};

hd_logexp{3} = button_list(bp_handle_fig, gui_position(:,7), 'Logical Operators', ...
button_operator{2}, 'clb_button_list(1,',{},[]);%)
% flag(2) = 1, flag(1) = selected button

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% button list of variables   
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_logexp{4} = button_list(bp_handle_fig, gui_position(:,6)', 'Variable List', ...
shn_list, 'clb_button_list(2,',{},[]); %)
% flag(2) = 2, flag(1) = selected buttonnb
% order of button = order of the variables 
% list_num_var = [45 6 32] ...
% located at list_ind_var = [2 7 4] in buttons position flag(1) = [1 2 3]
% so var 32 is index 4 in button 3

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% entering the mass input area
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% for entering the mass
hd_logexp{1}(3) = uicontrol(...
'Parent',bp_handle_fig, ...
'Position',gui_position(:,21)', ...
'Style','edit', ...
'HorizontalAlignment','left', ...
'String','0',...
'CallBack','callback_CR_edit;uiresume;');
% keyhit becomes 1 when I hit CR and pointer in the box area

text_mass = {'Enter mass.','End with RETURN;','Total mass = 0'};

hd_logexp{1}(4) = uicontrol(...
'Parent',bp_handle_fig, ...
'Position',gui_position(:,22)', ...
'Style','text', ...
'HorizontalAlignment','left', ...
'String',text_mass);

