function edit_bp_with_sets(ind_bel,ind_bp,ind_for,req_forms) 
% for the bp in belief(ind_bel).bp(ind_bp).form(ind_for), display every focal set and its mass
% at top the number of the focal sets
% then a line with every mass.
% focal sets are represented vertically
% at left: names of the elements, 
% table of x . . Elements with x belong to the focal set.

% req_forms is the list of requested forms, default = m.

%
%   Version : June 1, 03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global flags button_size belief
global frame variable help_label  help_level figure_data
global Which_Courier screen_size stored_text figure_handles help_level

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% comments on architecture
%
% we have four components, and a space of top_sh and left_sh  piwels at top and at left
% UL : with the variables manes, ht = 2*pos_box(4), wd = width_elements
% UR : the number and mass of the focal sets, ht = 2*pos_box(4), wd = (to_hor-from_hor+1)*poss_box(3)
% LL : the description of the elements: ht = (to_vert-from_vert+1)*pos_box(4), wd = width_elements
% LR : tha table with the 0/1 (x/.): ht = (to_vert-from_vert+1)*pos_box(4), wd = (to_hor-from_hor+1)*pos_box(3),
%
% their handles are : UL = hd_var_name, UR = hd_nbr, LL = hd_elements, LR = hd
%
% then we draw all lines: handle = hd_line
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





% % % % % % adding a help
% % % % % help_numbers = 42;
% % % % % clb1 = ['callback_help_menu_bp(',num2str(help_numbers),',1);'];  
% % % % % k = 0;ind=1; % use only here
% % % % % k=k+1;hd_help_menu(ind,k) = uimenu('Label',help_label); 
% % % % % k=k+1;hd_help_menu(ind,k) = uimenu(hd_help_menu(ind,1),'Label','View','Callback',clb1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% producing req_forms if none
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if nargin == 3
	req_forms{1} = 'm';
end
% when asking only m, focal sets are those is focal_sets (thus usually selected)
% when asking more than m, we display ALL subsets in their lexicographical order

cardinal = prod(belief(ind_bel).domain_cardinality);

if length(req_forms) > 1 & cardinal > 12
	% you ask for several forms, limited to 12 elemnts (1024 columns!!!)
	% up to 12 I can do it, above forget it, too long, absurd
	return
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get the figure
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

scrsize = screen_size;
height_window = scrsize(4)-100;
width_window = scrsize(3)-20;
pos_fig = [10 50  width_window height_window];

hd_fig = figure(...
'Units','pixels',...
'Color',[1 1 1], ...
'name','Bba Editor: set mode');
set(gcf,'position',pos_fig);
ind_fig = length(figure_data) + 1;
figure_data(ind_fig).name = 'Bba Editor: set mode';
figure_data(ind_fig).handle = hd_fig;
figure_data(ind_fig).position = pos_fig;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% put its menus
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

k=0;
k=k+1;make_fig_menu(ind_fig,k,'File',0,'','on');
k=k+1;make_fig_menu(ind_fig,k,'Quit',1,'general_clb(7)','on');
k=k+1;make_fig_menu(ind_fig,k, help_label,0,'','on');
k=k+1;make_fig_menu(ind_fig,k,'Show Help', 3,'general_clb(98)','on');

menu_manager('create',ind_fig)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% ftsz = fontsize for Which_Courier, + other machine dependent parameters
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% button_size in pixels, defined as 50 20
switch computer
case 'MAC2'
	ftsz = 10;
	butcolor = [1 0.5 0.5]; % color of half tone buttons
	height_control = 60; % height used for control area at bottom figure
case 'PCWIN'
	ftsz = 9;
	butcolor = [1 0.6 0.6];
	height_control = 76; % height used for control area at bottom figure
otherwise
	ftsz = 9;
	butcolor = [1 0.6 0.6];
	height_control = 76; % height used for control area at bottom figure	
end

% what is displayed whenbit = 0 and when bit = 1  (1 = element is set)
show0 = '  . ';
show1 = '  x ';
% distance between 2 vertical lines (nbr of data)
dist_inter_vert = 5;
dist_inter_horiz = 5;

top_sh = 1; % vertical shift at top
left_sh = 1; % horiz shift at left
height_sets =  height_window - height_control;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% initial parameters
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

nbr_forms = length(req_forms);
[var_name, tb, element_numbers, label_details] = creating_elements(belief(ind_bel).domain_variable);	
% the variable names are in var_name
% the elements are in tb{1}...tb{cardinal}
% the masses are in (1) ... (nbr_masses)
% the bits are in bits(i,j) i = 1:cardinale, j = 1:nbr_masses.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% storing the masses shown_m{1:nbr_fosets} / store_m(1:nbr_fosets) and 
% the bits of the focal sets bits(i,j):i=1:cardinal, j = 1:nbr_fosets
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if length(req_forms) == 1 & strcmp(req_forms{1},'m')
	
	what_case = 1; % it states only m asked for
	% finding the ind_for with the selected form m
	ind_for = find(strcmp({belief(ind_bel).bp(ind_bp).form(:).type},req_forms{1}));	
	
	% if m exist, OK, else, it is an error as the forms are created in the caller
	if isempty(ind_for)
		BOUM_empty_ind_for_in_edit_bp_with_sets
	end
	
	skip_me = 0;
	nbr_fosets = length(belief(ind_bel).bp(ind_bp).form(ind_for).values);
	for i = 1:nbr_fosets	
		val = num2str(belief(ind_bel).bp(ind_bp).form(ind_for).values(i),'%5.3f');	
		if length(val) < 5
			val(length(val)+1:5) = '0';
		end
		if belief(ind_bel).bp(ind_bp).form(ind_for).values(i) > .9995 
			shown_m{1,i} = ' 1.0';
		else
			shown_m{1,i} = val(2:5);
		end
	end
	store_m = belief(ind_bel).bp(ind_bp).form(ind_for).values;
	bits = long_num2bit(belief(ind_bel).bp(ind_bp).form(ind_for).focal_sets,cardinal)';	
	nbr_shown = length(store_m);
	
else
	what_case = 2; % it states several forms
	
	% building the bits matrix as ordered lexicographic 		
	bits = long_num2bit([0:pow2(cardinal)-1]',cardinal)';
	
	% building the 'masses' matrix	
	for ik = 1:length(req_forms)
		% finding the ind_for with the selected form
		ind_for = find(strcmp({belief(ind_bel).bp(ind_bp).form(:).type},req_forms{ik}));
		
		% ordered or not?
		if strcmp(belief(ind_bel).bp(ind_bp).form(ind_for).representation,'ordered')
			val_vector = belief(ind_bel).bp(ind_bp).form(ind_for).values;
		else
			switch  belief(ind_bel).bp(ind_bp).form(ind_for).type
			case {'m','M'}
				% if m M , I put 0, and the m selected put in place
				val_vector = zeros(pow2(cardinal),1);				
				val_vector(belief(ind_bel).bp(ind_bp).form(ind_for).focal_sets+1,1) = ...
				belief(ind_bel).bp(ind_bp).form(ind_for).values;					
			case {'wc','wd','w'}
				% if wc,wd , I put 1, and the wc/wd value selected put in place
				val_vector = ones(pow2(cardinal),1);				
				val_vector(belief(ind_bel).bp(ind_bp).form(ind_for).focal_sets+1,1) = ...
				belief(ind_bel).bp(ind_bp).form(ind_for).values;					
			case 'BetP'
				% if Betp, I build a fake m vector, and then build bel from it (this is also BetP)		
				fake_m = zeros(pow2(cardinal),1);
				fake_m(pow2([0:cardinal-1])+1) = belief(ind_bel).bp(ind_bp).form(ind_for).values;
				val_vector = fmt(fake_m,'m','bel');			
			otherwise
				% if anything else (b,bel,pl,q,Bel,Pl,Q),  do not exist, as anything but m,M,wc,wd always as oredred 
				% if cardinal is small enough and 12 is very small, so OK
				% I do nothing as I never comes here
				% just to check I put BOUM
				BOUM_AT_edit_bp_with_sets
			end			
		end
		nbr_shown = length(belief(ind_bel).bp(ind_bp).form(ind_for).values);
		
		for i = 1:pow2(cardinal)	
			val = num2str(val_vector(i,1),'%5.3f');	
			if length(val) < 5
				val(length(val)+1:5) = '0';
			end
			if val_vector(i,1) > .9995 
				shown_m{ik,i} = ' 1.0';
			else
				shown_m{ik,i} = val; % this is longer than the case m only
			end
		end
		store_m = []; % used for editing, and if several forms, no editing allowed		
	end

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% getting the dimension of the boxes for the mass and 0/1 data
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_temp = uicontrol(hd_fig,'fontname',Which_Courier,'fontsize',ftsz,'units','pixels',...
'style','edit','position',[30 30 500 200]); % any pos OK, just to run textwrap

if what_case == 1
	[outtext, pos_box] = textwrap(hd_temp,{'1234'});
else
	[outtext, pos_box] = textwrap(hd_temp,{'12345'});
end

pos_box(3) = ceil(pos_box(3));
pos_box(4) = ceil(pos_box(4));
% pos_box = size of the box with mass and 1 0

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the width of the left most column, in pos_tb(3)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[outtext, pos_tb]  = textwrap(hd_temp,tb);
[outtext, pos_tb1] = textwrap(hd_temp,{var_name});
[outtext, pos_tb2] = textwrap(hd_temp,{'BetP'}); % so I an even write BetP
pos_tb(3) = max([pos_tb(3),pos_tb1(3),pos_tb2]); 
delete(hd_temp) 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% number of lines in one screen
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

nbr_lines_per_scr = fix((height_sets-top_sh-(nbr_forms+1)*pos_box(4))/pos_box(4));
nbr_lines_per_scr = dist_inter_horiz*fix(nbr_lines_per_scr/dist_inter_horiz);
nbr_vert_scr = fix((cardinal-1)/nbr_lines_per_scr)+1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the upper left corner with the var names (in var_name) in UL
% made of lines for each forms and below var names and the numbers 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

pos_tb_now = [left_sh  pos_fig(4)-top_sh  pos_tb(3) pos_box(4)];

% the title
for ik = 1:nbr_forms
	pos_tb_now(2) = pos_tb_now(2) - pos_box(4);
	hd_var_name(ik) = uicontrol(hd_fig,...
	'fontname',Which_Courier,'fontsize',ftsz,'units','pixels',...
	'style','text','position',pos_tb_now,...
	'backgroundcolor',[1 1 1],...
	'ButtonDownFcn','clb_edit_bp;uiresume(gcf);',...
	'HorizontalAlignment','left',...
	'string',req_forms{ik});
end

pos_tb_now(2) = pos_tb_now(2) - pos_box(4);
hd_var_name(ik+1) = uicontrol(hd_fig,...
'fontname',Which_Courier,'fontsize',ftsz,'units','pixels',...
'style','text',...
'position',pos_tb_now,...
'backgroundcolor',[1 1 1],...
'ButtonDownFcn','clb_edit_bp;uiresume(gcf);',...
'HorizontalAlignment','left',...
'string',var_name);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% show a bloc of elements in LL (the names of the elements)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

i_vert_scr = 1;
show_bloc_elements

% width of the elements
width_elements = pos_tb_now(1) + pos_tb_now(3);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% number of sets (columns) in one screen
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

nbr_columns_per_scr = fix((width_window-width_elements-1)/pos_box(3));
nbr_columns_per_scr = dist_inter_vert*fix(nbr_columns_per_scr/dist_inter_vert);

if what_case == 1
	total_nbr_of_sets = length(belief(ind_bel).bp(ind_bp).form(ind_for).values);
else
	total_nbr_of_sets = pow2(cardinal);
end

nbr_hor_scr = fix((total_nbr_of_sets-1)/nbr_columns_per_scr) + 1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% getting the button up down left right (those needed), quit_store, cancel_no_store
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

get_buttons_editbp

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% display the number_mass in UR  
% where value lines can be one line editable or several lines non editable
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

i_hor_scr = 1;
show_bloc_nbr_mass

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% display the sets in LR  (the x . matrix)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

i_hor_scr = 1;
show_bloc_sets

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% display the lines for separating parts of table (simplify reading)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

show_lines

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% first plot is displayed
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the loop for (editing the focal sets if only one mass line) and showing the values 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

go_on = 1;	
while go_on	
	flags = [];
	flags(1) = 0;
	option = 0;
	% 	gco = 0;
	
	uiwait(hd_fig)
	
	option = flags(1);
	
	% finding what I have selected, hd defines in show_bloc_sets	
	if option
		% case I hit a button or a menu
		wh_next = 'ctrl';
	else
		% case I select bits or mass or wrong place
		j_mass = find([hd_nbr(2,:)] == gco);
		[i,j] = find(hd == gco);
		if ~isempty(j_mass)
			% case mass
			wh_next = 'mass';	
			j = j_mass;
		elseif ~isempty(i)
			% case bit
			wh_next = 'bits'; % bits area 
		else
			wh_next = 'nogood';
			% I have selected one button in wrong region
		end
	end

	switch wh_next
	case 'nogood'
		% wrong choice, I do nothing
	case 'mass'
		if what_case == 1
			mass = get(hd_nbr(2,j),'string');
			pos_ij = get(hd_nbr(2,j),'Position');
			
			hd_temp = uicontrol(hd_fig,...
			'fontname',Which_Courier,'fontsize',ftsz,'units','pixels',...
			'style','edit','position',[pos_ij(1)-20  pos_ij(2)-22   pos_ij(3)+40   pos_ij(4)+20],...
			'backgroundcolor',[1 1 1],...
			'string','0.',...
			'Callback','uiresume');	
			
			% I cannot find how to select the edit box so that when I hit reeturn I don't jump out
			% as per now I MUST first click the box, then return OK
			% figure('CurrentObject',hd_temp) does not work	
			
			go_on_mass = 1;
			while go_on_mass	
				uiwait(hd_fig)			
				mass = get(hd_temp,'string');
				if isempty(mass)
					mass = '.000';
				end
				ok = 0;
				if is_one_number(mass)
					val_mass = str2num(mass);
					if val_mass >= 0 & val_mass <= 1
						ok = 1;
					end
				end
				if ok == 0
					hd_warn = warndlg('I need a real in [0, 1]');
					uiwait(hd_warn)
				else
					go_on_mass = 0;
				end
			end	% while go_on_mass			
			delete(hd_temp)
			% store/show the mass
			val = num2str(val_mass,'%5.3f');
			if length(val) < 5
				val(length(val)+1:5) = '0';
			end
			if val_mass > .9995
				shown_m{from_hor-1+j} = ' 1.0';
			else
				shown_m{from_hor-1+j} = val(2:5);
			end
			store_m(from_hor-1+j) = val_mass;
			set(hd_nbr(2,j),'string',shown_m{from_hor-1+j});		
			
			total_bbm = sum(store_m);
			if total_bbm > 1
				hdw = warndlg('Error. The sum of the masses entered is > 1. I proceed but you must correct them.');
				uiwait(hdw)
			end	
		end
	
	case 'bits' % sets
		if what_case == 1
			newstr = get(hd(i,j),'string');
			if strcmp(newstr,show1)
				newstr = show0;
				bits(from_vert-1+i,from_hor-1+j) = 0;
			else
				newstr = show1;
				bits(from_vert-1+i,from_hor-1+j) = 1;
			end
			set(hd(i,j),'string',newstr);		
			% if I change a set, the logical expr is no more OK, hence []
			belief(ind_bel).bp(ind_bp).form(ind_for).log_expr{from_hor-1+j} = [];
		end
	case 'ctrl' % button
		% handles : hd = bits, 
		% hd_nbr = mass at upper
		% hd_elements = elemetns at left
		% hd_line = heavy lines, 
		switch option
		case 1 % left
			if i_hor_scr > 1
				i_hor_scr = i_hor_scr - 1;
				delete(hd);delete(hd_nbr);delete(hd_line)			
				clear hd hd_nbr hd_line
				show_bloc_nbr_mass
				show_bloc_sets
				show_lines
			end
		case 2 % up
			if i_vert_scr > 1
				i_vert_scr = i_vert_scr - 1;
				delete(hd);delete(hd_elements);delete(hd_line);
				clear hd hd_line hd_elements
				show_bloc_elements
				show_bloc_sets
				show_lines
			end		
		case 3 % down
			if i_vert_scr < nbr_vert_scr
				i_vert_scr = i_vert_scr + 1;
				delete(hd);delete(hd_elements);delete(hd_line);
				clear hd hd_line hd_elements
				show_bloc_elements
				show_bloc_sets
				show_lines
			end		
		case 4 % right
			if i_hor_scr < nbr_hor_scr
				i_hor_scr = i_hor_scr + 1;
				delete(hd);delete(hd_nbr);delete(hd_line)			
				clear hd hd_nbr hd_line
				show_bloc_nbr_mass
				show_bloc_sets
				show_lines
			end	
		case 5 % add
			if what_case == 1
				total_nbr_of_sets = total_nbr_of_sets + 1;
				belief(ind_bel).bp(ind_bp).form(ind_for).log_expr{total_nbr_of_sets} = [];
				if total_nbr_of_sets > nbr_columns_per_scr*nbr_hor_scr
					% I must start a new screen
					nbr_hor_scr = nbr_hor_scr + 1;
				end
				i_hor_scr = nbr_hor_scr;
				shown_m{total_nbr_of_sets} = '.000';
				store_m(total_nbr_of_sets) = 0;
				bits(1:cardinal,total_nbr_of_sets) = 0;			
				delete(hd);delete(hd_nbr);delete(hd_line);	
				clear hd hd_nbr hd_line
				show_bloc_nbr_mass
				show_bloc_sets
				show_lines
				nbr_shown = nbr_shown + 1;
				set(hd_buttons(7),'string',['#=',num2str(nbr_shown)]);
			end			
		case 6 % cancel, do nothing
			delete(hd_fig)
			figure_data(ind_fig) = [];
			go_on = 0;
		case 7 % quit with store data
			if what_case == 1
				nm = size(bits,2);
				if isfield(belief(ind_bel).bp(ind_bp).form(ind_for),'log_expr')
					logexp = belief(ind_bel).bp(ind_bp).form(ind_for).log_expr;
					if length(logexp) < nm
						logexp{nm} = [];
					end
				else
					logexp{nm} = [];
				end
				% so every mass has a log exp		
				if sum(store_m) < 1;
					nm = nm+1;
					store_m(nm) = 1-sum(store_m);
					bits(1:cardinal,nm) = 1; % universe
					logexp{nm} = 'universe';
				end
			
				j = 0; m = [];
				belief(ind_bel).bp(ind_bp).form(ind_for).type = 'm';
				belief(ind_bel).bp(ind_bp).form(ind_for).representation = 'selected';
				for i = 1:size(bits,2) % for every mass
					if store_m(i) > 0
						j = j + 1;	
						m = [m ; store_m(i)];
						belief(ind_bel).bp(ind_bp).form(ind_for).focal_sets(j,:) ...
						= long_bit2num(bits(:,i)',cardinal);
						belief(ind_bel).bp(ind_bp).form(ind_for).log_expr{j} = logexp{i}; 
					end
				end
				belief(ind_bel).bp(ind_bp).form(ind_for).values = m;
			end
			delete(hd_fig)
			figure_data(ind_fig) = [];
			go_on = 0;
		case 98 % the show help menu
			hd_help = forced_display_helps(1,[42]); 
			delete(hd_help);
			figure(hd_fig)
		end
	end % switch wh_next
end % while go_on	
