function [bp_index] = select_bp(belief_index)
% select one bp in the belief object 

% bp_index 	= 0 : cancel
% 			> 0 : the index of the bp we want to work on
% 			= -1: do it for every bp (case conditional bp, and creating every bp)

global belief  gui_position

if length(belief(belief_index).bp) > 1
	
	% I rebuild bp.full_name as maybe new forms have been created
	for i = 1:length(belief(belief_index).bp)
		typ = ' ';
		for j = 1:length(belief(belief_index).bp(i).form)
			typ = [typ,' ',belief(belief_index).bp(i).form(j).type];  
		end	
		belief(belief_index).bp(i).full_name = ['bp',num2str(i), typ];		
	end

	% I need to select the bp		
	position = gui_position(:,6)';
	position(3) = .995 - position(1); % very wide list	
	handle_list = listing_existing('potential',position ,gcf,[belief_index]);
	set(handle_list(2),'Enable','on','max',1,'value',1);
	text = {'Select one potential, then button Done.','or','Select button All and we proceed through every potential.'};   					
	choice = text_with_n_buttons(gcf,text,{'Done','All','Cancel'}, [1]);
	switch choice 
	case 1
		bp_index = get(handle_list(2),'value');
	case 2
		if length(belief(belief_index).domain_variable) == 1;
			bp_index = -1;
		else
			hdw = warndlg('You may choose the pdf option only in there is one domain_variable. I cancel.')
			uiwait(hdw)
			bp_index = 0;
		end	
	case 3
		bp_index = 0;
	end	
	delete(handle_list);
else		
	bp_index = 1;
end
