function enter_bbd_cont_int(ind_bel,ind_pot)
% entering the bba for continuous or integer variables

% two possible cases
% the bba is a bayesian belief function, given as a proba dist fct
% the bba is the LC bba isopignistic with the entered pignistic proba 

% it works only for ONE variable, so length(domain_variable) = 1

% if nargin = 2, done on the ind_pot bp 
% if nargin = 1, done for every bp of that belief object


%
%   Version : Oct 13, 03.
%   Copyright (c) 2003 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global gui_position  help_level
global stored_text figure_data help_label
global flags flag_str flags2
global nbr_bit_per_word
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief
global infinity

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get the figure that contains the possible pdf
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

namefig = ['Potential Control for belief ',num2str(belief(ind_bel).full_name),...
', bp number = ',num2str(1)];
hd_fig = figure('name',namefig);
set(gcf,'position',gui_position(:,5))
ind_fig = length(figure_data) + 1;
figure_data(ind_fig).name = namefig;
figure_data(ind_fig).handle = hd_fig;
figure_data(ind_fig).position = gui_position(:,5);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% put its menus
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% k=0;
% k=k+1;make_fig_menu(ind_fig,k,'File',0,'','on');
% k=k+1;make_fig_menu(ind_fig,k,'Quit',1,'push_set_buttons(7,1)','on');
% 
% k=k+1;make_fig_menu(ind_fig,k, help_label,0,'','on');
% k=k+1;make_fig_menu(ind_fig,k,'Window Helps On', 3,'general_clb(2)','on');
% 
% XXX % XXXXXXXXXXXXXXXXXXX HELP NOT done
% menu_manager('create',ind_fig)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get pdf
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

proceed = 1;

cont = is_var_cont(belief(ind_bel).domain_variable);
int = is_var_int(belief(ind_bel).domain_variable);
if int == 0 & cont == 0
	hdw = warndlg('I am supposed to get only one continuous or integer variable. Something wrong, I cancel')
	uiwait(hdw)
	return	
end

% nature decided by domain
% 'For Integers: ';
% 'Case 1.1: domain = [0+i,n+i] and pdf is binomial(p)';
% 'For Continous: ';
% 'Case 2.1: domain = [0,1] 					and pdf = Beta(a,b)';                 (
% 'Case 2.2: domain = [0, infinity)  			and pdf = Gamma(t,n)';   ]
% 'Case 2.3: domain = (-infinity, infinity)  	and pdf = Gaussian(mu,sigma)';
% 'Case 2.4: domain = (-infinity, infinity)  	and pdf = Laplace(mu,sigma)';


ind_var = pin_manipulation('variable','num2ind',belief(ind_bel).domain_variable);
ind_fra = pin_manipulation('frame','num2ind',variable(ind_var).frame);
switch frame(ind_fra).type
case 'Integers'
	% must be 0,n, beware domain can be shifted
	if frame(ind_fra).min ~= 0 & frame(ind_fra).max < 1
		parameter(2) = frame(ind_fra).max;
		pdf_nature = 'binomial';
	else
		proceed = 0;
		hdw = warndlg('For integers, I can only use [0,n]');
		uiwait(hdw)
		return
	end
case 'Continuous'
	% must be [0,1] or 0,infinity or -infinity infinity
	if frame(ind_fra).min == 0 & frame(ind_fra).max == 1
		pdf_nature = 'beta';
	elseif frame(ind_fra).min == 0 & frame(ind_fra).max == infinity
		pdf_nature = 'gamma';
	elseif frame(ind_fra).min == -infinity & frame(ind_fra).max == infinity
		% i can use gauss or laplace
		choice = text_with_n_buttons(gcf,'Choose between Gaussian and Laplace pdf.',{'Gaussian','Laplace','Cancel'}, []);
		switch choice 
		case 1
			pdf_nature = 'gaussian';
		case 2
			pdf_nature = 'laplace';
		case 3
			return
		end
	else % not OK
		proceed = 0;
		hdw = warndlg('For continuous, I can only use [0,1] (beta),[0,infinity) (gamma) and (-infinity,infinity) (Gaussian or Laplace).');%]
		uiwait(hdw)
		return
	end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% for which potentials 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if nargin == 1
	forall = 1;
	ind_pot = [1:length(belief(ind_bel).bp)];
else
	forall = 0;
end	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% for every potential
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
go_on = 1;
while go_on
	while proceed 
		for i_pot = ind_pot 
			% enter you pdf
			set(hd_fig,'name',['Potential Control for belief ',num2str(belief(ind_bel).full_name),...
			', bp number = ',num2str(i_pot)]);
			text = 'Is this pdf a Bayesian belief function (Bbf) or a pignistic probability function (BetP).';
			choice_pig = text_with_n_buttons(hd_fig,text,{'Bbf','BetP','Cancel'}, []);
			if choice_pig == 3
				proceed = 0;
			else	
		
				entering_pdf
				
				if proceed
					object(i_pot).pdf = pdf_nature;
					object(i_pot).param = parameter;
					if choice_pig == 1
						object(i_pot).nature = 'bbf';
					else
						object(i_pot).nature = 'BetP';
					end
				end
			end
		end	
	end

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% showing entered data for every potential
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% hd_fig is empty here
	% index bp, object(i_pot).nature, object(i_pot).pdf, object(i_pot).param, belief(ind_bel).bp(ind_pot).condition, 
	% title frame
	
	list{1} = ['ind nature pdf param1 param2 condition']
	for i_pot = 1:length(object)
		list{i_pot+1} = [num2str(i_pot,'%3i'),' ',object(i_pot).nature, ' ',...
		object(i_pot).pdf, ' ',object(i_pot).param, ' ', belief(ind_bel).bp(i_pot).condition];
	end

	% list box with list of potential pdf
	handle_list = uicontrol(...
	'style','listbox',...
	'position',[.005 .005 .99 .99],...
	'string',list,...
	'min',0,...
	'max',1000,...
	'value',[], ...
	'Callback', 'uiresume;',...
	'Enable','on');
	
	% asking if all OK, or change which ones
	text = 'Selected data to be edited. None selected = all OK.';
	choice_data = text_with_n_buttons(hd_fig,text,{'Done','Cancel'}, []);
	
	sel_item = get(handle_list,'value');
	delete(handle_list)
	
	switch choice_data
	case 1 % ok
		if length(sel_item) == 0 | (length(sel_item)==1 & sel_item == 1)
			go_on = 0;
		else
			ind_pot = sel_item - 1; % -1 as one extra line at top
		end
	case 2
		proceed = 0;
		go_on = 0;
	end
end % while go_on

if proceed
	% putting data in belief object
	for i_pot = ind_pot 
		% I erase previous forms XXXXXXXX OK if new, but if I only read the data????
		belief(ind_bel).bp(i_pot).form = [];
		ind_for = make_empty('form',ind_bel,i_pot,1);
		switch object(i_pot).nature % bbf or BetP
		case 'bbf'
			belief(ind_bel).bp(i_pot).form(1).type = 'm_pdf';
			belief(ind_bel).bp(i_pot).form(1).representation = object(i_pot).pdf; 
			% the pdf name (binomial,...gaussian)
			belief(ind_bel).bp(i_pot).form(1).values = object(i_pot).param; 
			% the (4) parameters of the pdf [a,b,m,std_dev]
		case 'BetP'
			belief(ind_bel).bp(i_pot).form(1).type = 'BetP_pdf';
			belief(ind_bel).bp(i_pot).form(1).representation = object(i_pot).pdf;
			belief(ind_bel).bp(i_pot).form(1).values = object(i_pot).param;
			ind_for = make_empty('form',ind_bel,i_pot,2);
			belief(ind_bel).bp(i_pot).form(2).type = 'm_from_BetP_pdf';
			belief(ind_bel).bp(i_pot).form(2).representation = [object(i_pot).pdf,'_based'];
			belief(ind_bel).bp(i_pot).form(2).values = object(i_pot).param;
		end		
	end
end

figure_data(ind_fig) = [];
delete(hdfig)
