function param_out = pdf_parameters(pdf,param_in,option)
% compute the m,s from a,b or versa for various pdf
% option = 1, in = a,b
% option = 2, in = m,s

x = param_in(1);
y = param_in(2);

switch pdf
case 'binomial' % param = [p, n]
	if option == 1
		param_out(1:2) = param_in;
		param_out(3) = y*x;
		param_out(4) = sqrt(y*x*(1-x)); 
	else
		param_out(3:4) = param_in;
		param_out(1) = 1-(y^2)/x;
		param_out(2) =  x/param_out(1);
	end	
case 'beta' % param = [a, b]  m = a/(a+b)   s = sqrt ( ab / ( (a+b)^2 . (a+b+1) )
	if option == 1
		param_out(1:2) = param_in;
		param_out(3) = x/(x+y);
		param_out(4) = sqrt( x*y /( (x+y)^2 *(x+y+1))); 
	else
		param_out(3:4) = param_in;
		r = (1-x)/x;v=y^2;
		param_out(1) = (r- v*(1+r)^2) / (v*(1+r)^3);
		param_out(2) = r*param_out(1) ; 
	end
case 'gamma' % param = [t, n],  m = n/t   s = sqrt(n)/t   with n = 1 == exponential
	if option == 1
		param_out(1:2) = param_in;
		param_out(3) = y/x;
		param_out(4) = sqrt(y)/x; 
	else
		param_out(3:4) = param_in;
		param_out(1) = x/(y^2);
		param_out(2) = x*param_out(1) ; 
	end
case 'gaussian' % param = [mu, sigma]
	param_out = [param_in param_in];	
case 'laplace' % param = [ alpha, beta]  m = alpha, s = beta.sqrt(2)
	if option == 1
		param_out(1:2) = param_in;
		param_out(3) = x;
		param_out(4) = y*sqrt(2); 
	else
		param_out(3:4) = param_in;
		param_out(1) = x;
		param_out(2) = y/sqrt(2) ; 
	end
end	
