function get_bp_m(belief_index,bp_index)
% building ONE new belief potential
% how 	'selected'  if focal sets are selected    Cont/Int (Disc not efficient)
% only remaining option

% for 'selected' bp is new if vacuous, old if not vacuous

%
%   Version : Jan 11, 03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global gui_position  
global stored_text 
global flags flag_str figure_data help_level help_label Which_Courier
global nbr_bit_per_word
global keyhit  var_continuous_integers


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% building the labels for the worlds of the product space, ready for display
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[list_discr,list_continuous, list_integers] = ...
type_variable(belief(belief_index).domain_variable);

[var_name_list, element_list, element_numbers,useless] = ...
creating_elements(belief(belief_index).domain_variable);

cardinal = max(size(element_numbers,1),1);
nbr_initial_masses = 0;

if length(belief(belief_index).bp) == 0
	% if there are NO pot, I just build one
	bp_index =  make_empty('bp',belief_index); % vac bf form also built
	ind_form = 1; % given by previous call
end

is_vac = is_vacuous(belief_index,bp_index);
% normaly there is always at least a vac m for a potential
switch is_vac
case - 1
	% absurd, I got losted
	return
case 0
	age = 'old';
	% get the m form
	ind_form = find(strcmp({belief(belief_index).bp(bp_index).form(:).type},'m'));	
	
	text = 'Do you want to edit or to clear the exisitng potential?';
	choice = text_with_n_buttons(gcf, text, {'Edit','Clear','Cancel'}, [0 0 0 0]);
	switch choice
	case 1
		% edit it
		bp_mem = belief(belief_index).bp(bp_index).form(ind_form);
		nbr_initial_masses = length(bp_mem.values);
	case 2
		age = 'new';
		% clear it first
		ind_form = make_empty('form',belief_index,bp_index,ind_form);
		bp_mem = belief(belief_index).bp(bp_index).form(ind_form);
	case 3
		return
	end
case 1
	age = 'new';
	ind_form = find(strcmp({belief(belief_index).bp(bp_index).form(:).type},'m'));
	bp_mem = belief(belief_index).bp(bp_index).form(ind_form);	
end			

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the labels for the cont/int limits
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% bp_mem = the bp form(1) object I am working on

% % % % % belief(belief_index).bp(bp_index) = [];
% % % % % belief(belief_index).bp(bp_index).form(1) = bp_mem;

% adding continuous and integers to element_list if needed

% produced by creating_elements
% [list_discr,list_continuous, list_integers]
% var_continuous_integers(kk).short_name = variable(ind_var(i)).short_name;
% var_continuous_integers(kk).num = num_var(i);
% var_continuous_integers(kk).ind = ind_var(i);
% var_continuous_integers(kk).type = typevar;
% var_continuous_integers(kk).min = x_min;
% var_continuous_integers(kk).max = x_max;
% var_continuous_integers(kk).frt = frt;

% % % % var_continuous_integers % is empty!!!!
% % % % next line useful to print data for control
% % % for kk = 1:length(var_continuous_integers)
% % % 	kk
% % % 	var_continuous_integers(kk).short_name 
% % % 	var_continuous_integers(kk).num 
% % % 	var_continuous_integers(kk).ind 
% % % 	var_continuous_integers(kk).type 
% % % 	var_continuous_integers(kk).min 
% % % 	var_continuous_integers(kk).max 
% % % 	var_continuous_integers(kk).frt 
% % % end

limit_mem = [];
if length(var_continuous_integers)	
	add_txt = '';
	limit_mem_x = [];
	
	[ind_fra] = frame_of_belief(belief_index); 
	
	for kk = 1:length(var_continuous_integers)
		s_min = sprintf(var_continuous_integers(kk).frt ,var_continuous_integers(kk).min);
		s_max = sprintf(var_continuous_integers(kk).frt ,var_continuous_integers(kk).max);
		add_txt = [add_txt,' ',s_min,' ',s_max];
		limit_mem_x = [ limit_mem_x var_continuous_integers(kk).min var_continuous_integers(kk).max];
		
		% storing info for UR panels (interval input)
		for iji = 1:4
			txtCI_mem{iji,2*kk-1} = ' ';
		end
		txtCI_mem{1,2*kk} = sprintf('%2i',kk);
		txtCI_mem{2,2*kk} = var_continuous_integers(kk).short_name;
		txtCI_mem{3,2*kk} = s_min;
		txtCI_mem{4,2*kk} = s_max;
		full_interval(kk,:) =[var_continuous_integers(kk).min,var_continuous_integers(kk).max];
		
	end
	for i = 1:length(element_list)
		element_list_full{i} = [element_list{i},add_txt];
		limit_mem(i,:)  = [-i limit_mem_x];
	end 
	if length(element_list) == 0
		element_list_full{1} = add_txt;
		element_list{1} = '';
	end
else
	element_list_full = element_list;
end
element_list_full_vacuous = element_list_full;
limit_mem_vacuous = limit_mem;

% bp_mem = the bp form(1) object I am working on
% limit_mem_x = the horiz vector with the inf sup of each var
% limit_mem = [-i limit_mem_x]; a matrix with nbr rows = card set discr var,  neg index = vacuous, pos = changed
% add_txt = a string with the inf sup limits all ci var
% element_list_full = the marix with line = one element disc and set of limits, as displayed
% element_list_full_vacuous = same but representing to universe		

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get the figure
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_fig = figure('name','Building bba when some variable frames are continuous and integers.');
set(gcf,'position',gui_position(:,5));
ind_fig = length(figure_data) + 1;
figure_data(ind_fig).name = 'Building bba when some variable frames are continuous and integers.';
figure_data(ind_fig).handle = hd_fig;
figure_data(ind_fig).position = gui_position(:,5);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% put its menus
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

k=0;
k=k+1;make_fig_menu(ind_fig,k,'File',0,'','on');
k=k+1;make_fig_menu(ind_fig,k,'Quit',1,'general_clb(''quit'')','on');
k=k+1;make_fig_menu(ind_fig,k,help_label,0,'','on');
k=k+1;make_fig_menu(ind_fig,k,'Show Help',3,'general_clb(''help'')','on');
menu_manager('create',ind_fig)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the mass query area at bottom			
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% ???? I put a KeyPressFcn dans le bp figure so that when hit return, mass accepted (but not belief)
% avoid mouse after entering the mass, key in keyhit
% % % % % % % set(hd_fig,'KeyPressFcn','callback_key_hit;uiresume;')

% bottom frame 
handle_building_bba(1) = uicontrol(...
'Parent', hd_fig,...
'Position',[.001 .001 .998 .048],...
'Style','Frame');


% handle_mass{} = 						userdata in clb
% 1 : 'bbm for focal set = '             
% 2 : '0.'  
% 3 : 'Total allocated masses = 0.0';  
% 4 : 'mass OK';  						mass
% 5 : 'bba OK';  						bp
% 6 : 'Cancel'  						cancel
% 7 : 'FocalSet: Done'					end_foset

% I need an extra done button for stopping entering focal sets
handle_mass(7) = uicontrol(...
'Parent', hd_fig,...
'Position',[.004 .004 .15 .042],...
'Style','Pushbutton',...
'String','FocalSet: Done',...
'Backgroundcolor','r',...
'userdata','foset_not_done',...
'Callback','general_clb(''end_foset'')',... 
'HorizontalAlignment','center');

% mass query area: text
handle_mass(1) = uicontrol(...
'Parent', hd_fig,...
'Position',[.16 .004 .135 .042],...
'Style','Text',...
'String','m focal set = ',...
'HorizontalAlignment','right');

% mass query area: get new mass
handle_mass(2) = uicontrol(...
'Parent', hd_fig,...
'Position',[.305 .004 .095 .042],...
'Style','Edit',...
'String','0.',...
'CallBack','callback_CR_edit;uiresume;');

% mass query area: text with cumulated mass
text_total = 'Total allocated masses =';
tt = [text_total,' ','0.0'];
handle_mass(3) = uicontrol(...
'Parent', hd_fig,...
'Position',[.405 .004 .29 .042],...
'Style','Text',...
'String',tt);

% mass query area: mass done button
pr_ok = 'mass OK';
bba_ok = 'bba OK';

% button mass OK
handle_mass(4) = uicontrol(...
'Parent', hd_fig,...
'Position',[.70 .004 .08 .042],...
'Style','PushButton',...
'String',pr_ok,...
'BackgroundColor',[1 0 0],...
'Callback','general_clb(''mass'')');

% button bba OK
handle_mass(5) = uicontrol(...
'Parent', hd_fig,...
'Position',[.80 .004 .08 .042],...
'Style','PushButton',...
'String',bba_ok,...
'BackgroundColor',[1 0 0],...
'Callback','general_clb(''bp'')');

% button cancel
handle_mass(6) = uicontrol(...
'Parent', hd_fig,...
'Position',[.90 .004 .08 .042],...
'Style','PushButton',...
'String','Cancel',...
'BackgroundColor',[1 0 0],...
'Callback','general_clb(''cancel'')');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% title of focal set area (top of window)		
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% list of every worlds in new product space
handle_building_bba(2) = uicontrol(...
'Parent', hd_fig,...
'Position',[.05 .050 .91 .910],...
'Style','Text',...
'HorizontalAlignment','left',...
'FontName',Which_Courier,...
'String',element_list_full,...
'Callback','general_clb(''list_worlds'')');			
% using Which_Courier is the trick to get vertical alignment	

% variable name frame
handle_building_bba(3) = uicontrol(...
'Parent', hd_fig,...
'Position',[.049 .965 .949 .033],...
'Style','Frame');

% variable name
handle_building_bba(4) = uicontrol(...
'Parent', hd_fig,...
'Position',[.05 .967 .944 .029],...
'Style','Text',...
'HorizontalAlignment','left',...
'FontName',Which_Courier,...
'String',var_name_list);

cfht = 1.05;

[useless, needed_space] = textwrap(handle_building_bba(2),element_list_full);
vspace = cfht*needed_space(4)/ length(element_list);
% cfht so height box is ok with characters	
height_box = .87*vspace;
vp = .96;

for i = 1:length(element_list)
	vp = vp - vspace;
	hd_sel(i) = uicontrol(...
	'Parent', hd_fig,...
	'Position',[.001 vp .04 height_box],...
	'Style','PushButton',...
	'BackgroundColor',[1 1 1],...
	'Callback',['general_clb(',num2str(i),');']);
end
total_bbm = 0;
mat1 = [];
mat2 = [];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the figure for the intervals if CI exist	
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

two_figures = 0;

if length(var_continuous_integers)
	
	two_figures = 1;
	
	% the figure
	hd_fig2 = figure(...
	'name','Intervals for continuous/integers.');
	set(gcf,'position',gui_position(:,1));
	ind_fig2 = length(figure_data) + 1;
	figure_data(ind_fig2).name = 'Intervals for continuous/integers.';
	figure_data(ind_fig2).handle = hd_fig2;
	figure_data(ind_fig2).position = gui_position(:,1);
	
	% its menu are the same as the UR window	
	k=0;
	k=k+1;make_fig_menu(ind_fig2,k,'File',0,'','on');
	k=k+1;make_fig_menu(ind_fig2,k,'Quit',1,'general_clb(''quit'')','on');
	k=k+1;make_fig_menu(ind_fig2,k,help_label,0,'','on');
	k=k+1;make_fig_menu(ind_fig2,k,'Show Help',3,'general_clb(''help'')','on');
	menu_manager('create',ind_fig2)
	
	% list of CI variables	
	% txtCI_mem{1,kk} = sprintf('%2i',kk);
	% txtCI_mem{2,kk} = var_name_list{length(list_discr)+kk};
	% txtCI_mem{3,kk} = s_min;
	% txtCI_mem{4,kk} = s_max;
	
	for i = 1:2*length(var_continuous_integers)+2
		colspi{i} = ' ';
	end		
	colsp = strvcat(colspi);
	
	tx1 = strvcat({' ',' n',txtCI_mem{1,:}});
	tx2 = [colsp,strvcat({' ',' name',txtCI_mem{2,:}})];
	tx3 = [colsp,strvcat({' ','   min',txtCI_mem{3,:}})];
	tx4 = [colsp,strvcat({' ','   max',txtCI_mem{4,:}})];	
	txtCI = [tx1,tx2,tx3,tx4];
	[nr,nc] = size(txtCI);
	
	hd_intervals = uicontrol(...
	'Parent', hd_fig2,...
	'Position',[.001 .001 .998 .998],...
	'Style','Text',...
	'HorizontalAlignment','left',...
	'FontName',Which_Courier,...
	'String',txtCI);
	% using Which_Courier is the trick to get vertical alignment	
	
	% full_interval is the inervals (initial = full
	% SIZE of left text and height one row!!!!
	[useless, needed_space] = textwrap(hd_intervals,{txtCI});
	needed_space(3) = needed_space(3) + .020;
	deltaV = cfht * 2*needed_space(4)/ size(txtCI,1);	
	% cfht so hieight box is ok with characters
	deltaH = (.990-needed_space(3))/2;
	width = deltaH - .01;
	posCI = [needed_space(3)   .998-1.25*deltaV   width   deltaV];
	
	for i = 1:length(var_continuous_integers)+1
		for j = 1:2
			% b uilding the pair of boxes
			% for entering intervals
			if i == 1
				if j == 1
					txtmm = '   From';
				else
					txtmm = '   To';
				end
			else
				txtmm = txtCI_mem{2+j,2*(i-1)};
			end
		
			hd_box(i,j,2)  = uicontrol(...
			'Parent', hd_fig2,...
			'Position',posCI,...
			'Style','Edit',...
			'HorizontalAlignment','left',...
			'FontName',Which_Courier,...
			'String',txtmm);
			
			posCI(1) = posCI(1) + deltaH;
		end
		posCI(1) = posCI(1) - 2*deltaH;
		posCI(2) = posCI(2) - deltaV;
	end
	% its button for OK
	hd_interval_button = uicontrol(...
	'Parent', hd_fig2,...
	'Position',[.30 .004 .40 .042],...
	'Style','Pushbutton',...
	'HorizontalAlignment','center',...
	'FontName',Which_Courier,...
	'BackgroundColor',[1 0 0],...
	'Callback','general_clb(''interval_ok'')',...
	'String','Intervals OK');
	
	figure(hd_fig)
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% entering data			
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% selected m	  the only case with continuous integers variables
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

proceed_one_bp = 1; 
mass0 = 0;
ind_mass_now = 0;
limit_contint = {}; % the set of matrices with limits, one matrix per mass

na = get(hd_fig,'name');
set(hd_fig,'name',[na,' ', upper(age)]);

if strcmp(age,'new')
	mat1 = [];
	mat2 = [];
else
	mat1 = bp_mem.values;
	mat2 = bp_mem.focal_sets;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	BEG building one bba (many masses)	
while proceed_one_bp	% loop for getting all bbm	for one bp	
	
	if length(var_continuous_integers)	
		
		% % % % 		set(handle_building_bba(2),'Callback','uiresume(gcf);');
		% % % % 		set(handle_mass(7),'userdata','foset_not_done');			
		
		% if cont/int I hide buttons not OK  
		% I keep also bba OK = 5 clb = 'UserData','bp'  and cancel
		% handle_mass{} = 
		% 1 : 'bbm for focal set = '  
		% 2 : '0.'  
		% 3 : 'Total allocated masses = 0.0'  
		% 4 : 'mass OK'  
		% 5 : 'bba OK'  
		% 6 : 'Cancel'  
		% 7 : 'FocalSet: Done'
		for i = [1 3 4] 
			set(handle_mass(i),'visible','off') ; 
			% 'bbm for focal set = '  'Total allocated masses = 0.0'  'mass OK' 
		end				
	end	
	% % % 	set(handle_mass(4),'UserData',' '); % 'mass OK'
	% % % 	set(handle_mass(5),'UserData',' '); % 'bba OK'  
	% % % 	set(handle_mass(6),'UserData',' ');	% 'Cancel'	
	
	% % % 	figure(hd_fig);		
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	BEG building one foset	
	% i wait till I select the bbm OK button		
	proceed_one_foset = 1;
	while proceed_one_foset
		
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 	
		%
		% Initiating the dispaly for one mass
		%
		% cclear the red buttons
		for i = 1:length(element_list)
			set(hd_sel(i),'BackgroundColor',[1 1 1]);
		end	
	
		ind_mass_now = ind_mass_now + 1;
		% index of the mass I am looking at now
		% when old, for one bba, a delete = a mass 0, a change = retype, an add wait to the end of the old ones and proceed
		% you cannot say 'remainder clear', you must go thru all old ones one by one		
		if strcmp(age,'new') | ind_mass_now > nbr_initial_masses	
			% I build initial universe, no selected elements, mass 0
			mass = 0;
			selected_elements = [];
			limit_mem = limit_mem_vacuous;
			add_txt_now = add_txt; % I put vacuous for ci
			element_list_full = element_list_full_vacuous;
		else	
			mass = bp_mem.values(ind_mass_now);
			foset = bp_mem.focal_sets(ind_mass_now,:);
			selected_elements = long_num2onbit(foset,cardinal);
			% for selected elements, put button in red
			for i = selected_elements
				set(hd_sel(i),'BackgroundColor',[1 0 0]);
			end		
			matrix_limits = bp_mem.contint(ind_mass_now).limits; 
			limit_mem = limit_mem_vacuous;
			element_list_full = element_list_full_vacuous;
			for i = 1:size(matrix_limits,1)
				k = matrix_limits(i,1);
				limit_mem(k,:) = matrix_limits(i,:); 
				add_val = '';
				kk = 2;
				for ij = 1:length(var_continuous_integers)	
					add_val = [add_val,' ',...
					sprintf(var_continuous_integers(ij).frt, limit_mem(k,kk)),' ',...
					sprintf(var_continuous_integers(ij).frt, limit_mem(k,kk+1))];
					kk = kk + 2;
				end
				element_list_full{k} = [element_list{k},add_val];
			end
		end	
		set(handle_mass(2),'String',num2str(mass));
		
		% bp_mem = the bp form(1) object I am working on
		% limit_mem_x = the horiz vector with the inf sup of each var
		% limit_mem = [-i limit_mem_x]; a matrix with nbr rows = card set discr var,  neg index = vacuous, pos = changed
		% tric neg i = vacuous, pos = user entered limits
		% becomes a matrix with user entered limits
		% add_txt = a string with the inf sup limits all ci var
		% element_list_full = the marix with line = one element disc and set of limits, as displayed
		% element_list_full_vacuous = same but representing to universe
		% add_val = string row vector with inf_sup for all var, as entered by query, and encoded with .frt
		
		set(handle_building_bba(2),'string', element_list_full);  % the listbox with every element
		if ind_mass_now <= nbr_initial_masses 
			set(handle_mass(5),'visible','off') % 'bba OK' 
		end
		%
		% END Initiating the dispaly for one foset/mass
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% BEG get ONE foset from display
		%				
		% showing the end foset button
		for i = [7 2 3 5 6]
			set(handle_mass(i),'visible','on');
		end
		for i = [1 4]
			set(handle_mass(i),'visible','off');
		end
	
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	BEG add/delete ONE element for foset			
		proceed_with_elements = 1;	
		while proceed_with_elements
			set(handle_building_bba(2),'value',selected_elements);  
			% the listbox with every element, I display previous foset
			flags = [];
			flag_str = [];
			figure(hd_fig)
			uiwait(hd_fig);
			
			if ~isempty(flags)
				% I click on a element button
				flag_str = 'list_worlds';
			end
		
			% what did I select ?
			% handle_mass{} = 						userdata in clb
			% 1 : 'bbm for focal set = '            useless 
			% 2 : '0.'  							useless
			% 3 : 'Total allocated masses = 0.0';  	useless
			% 4 : 'mass OK';  						mass
			% 5 : 'bba OK';  						bp
			% 6 : 'Cancel'  						cancel
			% 7 : 'FocalSet: Done'					end_foset
			% menu quit 
			% menu help
			% in the listbox
			% none repeat
			
			switch flag_str 
			case 'end_foset'
				% case I select end foset button
				% hiding the end foset button
				for i = [5 7]
					set(handle_mass(i),'visible','off');
				end
				% restoring hidden buttons 
				for i =[1 2 3 4 6]
					set(handle_mass(i),'visible','on')
				end						
			case 'bp'  
				% case I select bba OK button  
				% quit loop for one foset
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
				%
				% stroring one bba
				%
				proceed_with_elements = 0;
				proceed_one_foset = 0;
				proceed_one_bp = 0;
				if total_bbm < 1 % what is not yet allocated is given to universe				
					indx = length(mat1) + 1;
					mat1(indx) = 1-total_bbm;
					mat2(indx,:) = get_universe(cardinal);
					limit_contint{indx} = [];
				end	
				mat1 = mat1'; % it was build with mat(i) = l, thus a line, and I want a column, hence transpose
				
				contint.limits = limit_contint;
				contint.universe = limit_mem_x;
				contint.variables = [var_continuous_integers(:).num];
				% i finaly store the data in belief(belief_index).bp(bp_index).form(ind_form)....
				% pack_mass done within build_form  avoid equal foset and 0 masses
				ok = build_form(belief_index,bp_index,ind_form,'m','selected',mat2,mat1,[],contint);
				%
				% END storing one bba
				%
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			case 'cancel'	
				% I entered cancel
				% Confirm cancel of the whole bp
				text = 'Confirm you want to interrupt the present task, and go back to the previous bba data if it exists.';
				choice = text_with_n_buttons(hd_fig, text, {'Do it','Cancel'}, [0 0 0 0]);
				if choice == 1
					% case I select cancel button
					% quit loop for one foset
					proceed_with_elements = 0;
					proceed_one_foset = 0;
					proceed_one_bp = 0;
				end
			case 'quit'	
				% case I select cancel button
				% quit loop for one foset
				proceed_with_elements = 0;
				proceed_one_foset = 0;
				proceed_one_bp = 0;
			case 'mass'
				% case I select mass OK button, normaly I never comes here as uiwait done before with end_foset
				% quit loop for one foset
				% mass is read
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
				%
				% storing the mass and focal set
				%
				mass = str2num(strrep(get(handle_mass(2),'String'),'..','.'));
				on_bit = get(handle_building_bba(2),'Value');
				number_vect = long_onbit2num(on_bit, cardinal);
				% find out if this focal set not yet encountered
				% if yes cumulate mass, so never twice same focal set what is perfect
				new_focal = 1;
				
				% duplicate foset and 0 mass handled by pack_mass				
				
				% tric first element of limit_mem = index_line and neg if vacuous, pos if usefull
				% limit_mem is the limit matrix for the now bbm
				% limit_contint{} are the archives matrices, one per foset/mass, only usefull limits
				
				mat1(ind_mass_now) = mass;
				mat2(ind_mass_now,:) = number_vect;
				indx = find(limit_mem(:,1) > 0); % the list of element with a non universe contint inf sup limits 
				if isempty(indx)
					limit_contint{ind_mass_now} = []; % case only universe, stored as empty
				else
					limit_contint{ind_mass_now} = limit_mem(indx,:);
				end
				total_bbm = total_bbm + mass;	
				if total_bbm > 1
					hdw = warndlg('Error. The sum of the masses entered is > 1. I proceed but you must correct them.');
					uiwait(hdw)
				end			
				set(handle_mass(2),'String','0.');
				set(handle_mass(3),'String',[text_total,num2str(total_bbm)]);
				
				for i = [2 4]
					set(handle_mass(i),'visible','off');
				end
				for i =[1 3 5 6 7]
					set(handle_mass(i),'visible','on')
				end									
				proceed_with_elements = 0;
				
				%
				% END storing one mass foset
				%
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			case 'help'
				gcf_mem = gcf;
				hd_help = forced_display_helps(1,56);
				delete(hd_help);
				if two_figures == 1
					figure(hd_fig2)
				end
				figure(gcf_mem);
			case 'list_worlds'
				% I select a line in list box or below it (blank area)
				% we work one line at a time
				
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
				%
				% case I did not select a button but an element, I accept/build the foset
				%
				sel_now = flags;
				
				if ismember(sel_now,selected_elements)
					out_sel = sel_now;
					new_sel = [];
					selected_elements = setdiff(selected_elements,out_sel);
				else
					out_sel = [];
					new_sel = sel_now;
					selected_elements = [selected_elements, new_sel];
				end
			
			
			
			
			
				%%%%   INFINITY NOT OK, handled as 1E40      NO CONTROL INTERVALS OK
				
				
				
				
				
				% add/sub and  switch color of button
				if length(new_sel) == 0 & length(out_sel) == 1
					modif = 'sub';
					set(hd_sel(out_sel),'BackgroundColor',[1 1 1]);
				elseif length(new_sel) == 1 & length(out_sel) == 0
					modif = 'add';
					set(hd_sel(new_sel),'BackgroundColor',[1 0 0]);
				else
					modif = 'none';
				end
			
				% empty = new,    not empty = delete
				switch modif
				case 'sub'
					% delete
					element_list_full{out_sel} = [element_list{out_sel},add_txt];
					limit_mem(out_sel,:) = [-out_sel limit_mem_x];
					% tric neg i = vacuous, pos = user entered limits
					% limit_mem_x is vector of default interfvals (full intervals)
				case 'add'
					% I change foset data for one element
					add_val = '';
					kl = 1; 
					limit_mem(new_sel,kl) = new_sel;
					element_list_full{new_sel} = '';
					
					figure(hd_fig2)
					% display old intervals
					for i = 1:length(var_continuous_integers)
						set(hd_box(i+1,1,2),'string',num2str(limit_mem(new_sel,kl+1)));
						set(hd_box(i+1,2,2),'string',num2str(limit_mem(new_sel,kl+2)));	
						kl = kl + 2;
					end
					% all interval limits displayed
					% I wait for an OK in UL figure
					
					while ~strcmp(flag_str,'interval_ok');
						uiwait(hd_fig2)
					end
				
					% read new intervals	
					kl = 1;
					for i = 1:length(var_continuous_integers)
						limit_mem(new_sel,kl+1) = str2num(get(hd_box(i+1,1,2),'string'));
						limit_mem(new_sel,kl+2) = str2num(get(hd_box(i+1,2,2),'string'));
						add_val = [add_val,' ',...
						sprintf(var_continuous_integers(i).frt,limit_mem(new_sel,kl+1)),' ',...
						sprintf(var_continuous_integers(i).frt,limit_mem(new_sel,kl+2)) ];							
						kl = kl + 2;
					end
					element_list_full{new_sel} = [element_list{new_sel},add_val];
				end % switch modif				
			
				% back to initial UL figure
				figure(hd_fig)
				% turn on selected items 
				set(handle_building_bba(2),...
				'String',element_list_full);
			otherwise
				% I hit nothing usefull, repeat selection
				% I hit in wrong area (not a listbox line)
				hdw = warndlg('Please selet a button or a line with an element.');
				uiwait(hdw)
			end % switch flag_str 
			%
			% the foset is built, mass not yet collected
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%			
		end  % while proceed_with_elements
		%
		% END add/delete one element for foset
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		%
		% END get ONE foset from display 
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
	end % while proceed_one_foset, 

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	END building one foset with its MASS	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	END building one bba (many masses)
	
end % while proceed_one_bp

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% quitting	
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if two_figures == 1
	delete(hd_fig2)
	figure_data(ind_fig2) = [];
end
delete(hd_fig)
figure_data(ind_fig) = [];					
