% Object editor case Structure

if exist_fra == 0
	hdw = warndlg('There are no frames. Create them.');		
	uiwait(hdw);
else
	sel_val = [];
	set_list_selection(hd_list,[2,1,0,0])
	switch option
	case 'Structure'
		choicex = text_with_n_buttons(gcf,'Structure object. For Edit, first select it, then click on Edit.',{'New','Edit','Cancel'}, []);
		switch choicex 
		case 1
			option = 'New_Structure';
			skip_it = 0;
		case 2
			option = 'Edit_Structure';
			skip_it = 0;
		case 3
			skip_it = 1; % I do nothing and leave
		end	
	case 'New_Structure'
		skip_it = 0;
	case 'Edit_Structure'
		skip_it = 0;
	end

	if skip_it == 0
		% you ask edit and there is NO frmaes, I made it New_Structure
		if strcmp(option,'Edit_Structure') & exist_str == 0
			option = 'New_Structure';
			sel_val = -1; % new case
		end
	
		if strcmp(option,'Edit_Structure')	
			sel_val = [];
			choicex = 1;
			while length(sel_val) == 0 & choicex == 1
				choicex = text_with_n_buttons(gcf,'Select ONE Structure object, then Done',{'Done','Cancel'}, []);
				if choicex == 1
					sel_val = get(hd_list(2,2),'value');
				end
			end
			ind_str = pin_manipulation('structure','pos2ind',sel_val);	
			object = structure(ind_str);
			pos_fra = [pin_manipulation('frame','num2pos',structure(ind_str).most_refined)...
			pin_manipulation('frame','num2pos',structure(ind_str).sub_frames)];
			set(hd_list(1,2),'value',pos_fra);
			new_one = 0;
		else % new object
			sel_val = -1;
			ind_str = make_empty('structure');
			object = structure(ind_str);
			pos_fra = []; % to say none selected
			% updating pin_frame	
			useless = pin_manipulation('frame','all',[]);			
			new_one = 1;	
		end
	
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%`
		%
		% building Structure
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%`							
		
		title = 'STRUCTURE. Select also Frames.';		
		k = 0;
		k=k+1;querry{k} = 'short name';
		k=k+1;querry{k} = 'full name (= short if blank)';
		k=k+1;querry{k} = 'mapping';		
		k = 0;
		k=k+1;default_answer{k} = object.short_name;
		if strcmp(object.short_name,object.full_name)
			k=k+1;default_answer{k} = '';
		else
			k=k+1;default_answer{k} = object.full_name;
		end	
		k=k+1;default_answer{k} = num2str(object.mapping);	
		select_list(hd_list(1,:),'on','many');
		if length(pos_fra)
			set(hd_list(1,2),'value',pos_fra);
		end	
		[answer,choice] = dialog_queries(hd_full_scr_fig,title,querry,default_answer,[.005 .005],[],2,[],[],0,' ');
		clear querry default_answer
		
		if choice == 1
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%`
			%
			% getting the frames  most_refined and sub_frames
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%`							
			% pos_fra = get_sel_values(hd_list(1,:),'many','frame'); % can be a vector
			pos_fra = get(hd_list(1,2),'value');
			while length(pos_fra) == 0	& skip_it == 0			
				choicex = text_with_n_buttons(gcf,'Select the frames, then Done.',{'Done','Cancel'}, []);
				switch choicex 
				case 1
					pos_fra = get(hd_list(1,2),'value');
				case 2
					skip_it = 1;
				end
			end		
			if skip_it == 0				
				ind_fra_new = pin_manipulation('frame','pos2ind',pos_fra); % vector
				num_fra_new = pin_manipulation('frame','pos2num',pos_fra); % vector				
				card = [frame(ind_fra_new).cardinality]; % vector
				[sort_card inx_card] = sort(-card);
				
				% finding out is largest card is larger than the next largest one
				% assumption, frame with largest card is the most refined
				if length(inx_card) > 1
					card2 = card(inx_card(2));
				else
					card2 = 0; % a stupid value to be sure not equal (cont card = 1E50)
				end % if length(inx_card) > 1			
			
				if card(inx_card(1)) == card2
					% aih! at least two possible most_refined with same cardinality				
					set(hd_list(1,2),'max',1,'value',1); % clear frame list
					text = 'Select the most refined frame, then Done';
					pos_fra_mr = [];
					choice_mr = 1;
					while length(pos_fra_mr) == 0 & choice_mr == 1
						choice_mr = text_with_n_buttons(gcf, text, {'Done','Cancel'}, []);  % il bloque -> selection!!!
						pos_fra_mr = get(hd_list(1,2),'value'); % it wais till I select, but may select blank area
					end				
					if choice_mr == 1
						object.most_refined = pin_manipulation('frame','pos2num',pos_fra_mr);
						object.sub_frames = setdiff(num_fra_new,object.most_refined);
					else
						skip_it = 1;
					end
				else
					% only one possible most refined
					choice_mr = 1;
					object.most_refined = num_fra_new(inx_card(1));
					object.sub_frames = setdiff(num_fra_new,object.most_refined);
				end % if card(inx_card(1)) == card2
			
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%`
				%
				% finishing the structure
				%
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%`				
				if choice_mr == 1 & skip_it == 0					
					if isempty(answer{1})
						answer{1} = ['S',num2str(object.number)];
					end
					object.short_name = answer{1};	
					if isempty(answer{2})
						object.full_name = answer{1};
					else
						object.full_name = answer{2};
					end
					object.mapping = str2num(answer{3});
					exist_str = 1;
					% beware defining frame ... as global implies frame exists and is [] (double)`
					% and frame = object would be Ok, but not frame(1) = object
					% the tric is to say frame = object the first time, then frame(2) = object...
					
					ind_str = make_empty('structure',ind_str); % to initialize all fields
					structure(ind_str) = put_in_fields(object,structure(ind_str)); %  data saved
					
					if new_one
						nbr_str = nbr_str + 1;
					end
					% updating pin_structure	
					useless = pin_manipulation('structure','all',[]);					
					% refreshing  structure list
					delete(hd_list(2,:));
					hd_list(2,:) = listing_existing('structure', gui_pos(:,2), hd_full_scr_fig,[]);						
				end % if choice_mr == 1
			end % pos_fra == 0
		end % if choice == 1	
	end % if exist_fra == 0
end % skip it		
