% Ob ject editor  case variable
if exist_att == 0
	hdw = warndlg('There are no attributes. Create them.');		
	uiwait(hdw);
	return
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% attribute  exists
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sel_val = [];
set_list_selection(hd_list,[1,0,1,2])
switch option
case 'Variable'
	choicex = text_with_n_buttons(gcf,'Variable object. For Edit, first select it, then click on Edit.',{'New','Edit','Cancel'}, []);
	switch choicex 
	case 1
		option = 'New_Variable';
		skip_it = 0;
	case 2
		option = 'Edit_Variable';
		skip_it = 0;
	case 3
		skip_it = 1; % I do nothing and leave
	end	
case 'New_Variable'
	skip_it = 0;
case 'Edit_Variable'
	% I must decide which one
	skip_it = 0;
end
new_index_value = [];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% selecting THE variable
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if skip_it == 0
	% you ask edit and there is NO Attributes, I made it New_Variable
	if strcmp(option,'Edit_Variable') & exist_att == 0
		option = 'New_Variable';
		sel_val = -1; % new case
	end

	if strcmp(option,'Edit_Variable')
		% case edit, select object, then show it and its attribute frame
		sel_val = get(hd_list(4,2),'value');
		choicex = 1;
		while length(sel_val) ~= 1 & choicex == 1
			choicex = text_with_n_buttons(gcf,'Select ONE Variable object, then Done',{'Done','Cancel'}, []);
			if choicex == 1
				sel_val = get(hd_list(4,2),'value');
			end
		end		
		if choicex == 1
			ind_var = pin_manipulation('variable','pos2ind',sel_val);
			object  = variable(ind_var);
			ind_att = pin_manipulation('attribute','num2ind',object.attribute);
			ind_fra = pin_manipulation('frame','num2ind',object.frame);	
			pos_att = pin_manipulation('attribute','num2pos',object.attribute);
			pos_fra = pin_manipulation('frame','num2pos',object.frame);		
			nbr_index = length(attribute(ind_att).index);
			new_one = 0;			
			set(hd_list(1,2),'value',pos_fra);
			set(hd_list(3,2),'value',pos_att);
		else
			skip_it = 1;
		end
	else 
		% case new object
		ind_var = make_empty('variable');
		object = variable(ind_var);
		pos_att = []; % by default I take the no attribute
		pos_fra = []; % by default I take the no frame
		ind_att = []; 
		ind_fra = []; 
		nbr_index = 0;
		new_one = 1;
		sel_val = -1;
	end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% building its fields
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if skip_it == 0
	title = 'VARIABLE';
	k = 0;
	k=k+1;query{k} = 'short name';            
	default_answer{k} = object.short_name;
	k=k+1;query{k} = 'full name (= short if blank)';
	if strcmp(object.short_name,object.full_name)
		default_answer{k} = '';
	else
		default_answer{k} = object.full_name;
	end

	if new_one 
		k=k+1;query{k} = 'creating a variable for every possible index value';
		default_answer{k} = 'yes';
	end	
	answer{3} = 'yes'; % to be sure to get something
	
	[answer,choice] = dialog_queries(hd_full_scr_fig,title,query,default_answer,[.005 .005],[],2,[],[],0,' ');
	clear query default_answer
	proceed = 1;
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 2
	if choice == 1	
		% build the variable names
		if isempty(answer{1})
			answer{1} = ['V',num2str(object.number)];
		end
		object.short_name = answer{1};	
		if isempty(answer{2})
			object.full_name = answer{1};
		else
			object.full_name = answer{2};
		end
	
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% getting the attribute
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		pos_att = [];
		while length(pos_att) ~= 1	& skip_it == 0			
			choicex = text_with_n_buttons(gcf,'Select the attribute, then Done.',{'Done','Cancel'}, []);
			switch choicex 
			case 1
				pos_att = get(hd_list(3,2),'value');
			case 2
				skip_it = 1;
			end
		end		
	
		if skip_it == 0			
			ind_att = pin_manipulation('attribute','pos2ind',pos_att);
			object.attribute = pin_manipulation('attribute','pos2num',pos_att);
			
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% getting the frame
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			
			% if the attribute is based on a structure with only ONE frame, this is the frame of the variable				
			ind_str = pin_manipulation('structure','num2ind',attribute(ind_att).structure);
			if length(structure(ind_str).sub_frames) == 0
				% only one frame, so it is the one for var
				num_fra = structure(ind_str).most_refined;
				pos_fra = pin_manipulation('frame','num2pos',num_fra);
				ind_fra = pin_manipulation('frame','num2ind',num_fra);
				object.frame = num_fra;
			else
				% getting the frame if several possible
				pos_fra = [];
				text = 'Select the frame, then Done.';
				while length(pos_fra) ~= 1	& skip_it == 0			
					choicex = text_with_n_buttons(gcf,text,{'Done','Cancel'}, []);
					switch choicex 
					case 1
						pos_fra = get(hd_list(1,2),'value');
						if length(pos_fra) == 1
							num_fra = pin_manipulation('frame','pos2num',pos_fra);
							ind_fra = pin_manipulation('frame','num2ind',num_fra);											
							% verifying frame is member of the frames of the structure linked to attribute
							ind_str = pin_manipulation('structure','num2ind',attribute(ind_att).structure);				
							if ~ismember(num_fra,[structure(ind_str).most_refined  structure(ind_str).sub_frames]);
								% error in frame
								text = 'Frame not in structure of attribute. Select the frame, then Done.';
								pos_fra = [];									
							else
								object.frame = num_fra;
							end
						end	% if length(pos_fra) == 1
					case 2
						skip_it = 1; 
					end % switch choicex
				end	% while length(pos_fra) ~= 1	& skip_it == 0
			end
		
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% handling the index values
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			
			if skip_it == 0 % thus all input are OK     
				
				if length(attribute(ind_att).index) == 0 % no index
					answer{3} = 'no'; % don't ask all var if no index in attribute
				end
			
				% avoiding option 'all var' if one index is continuous
				forbidden_all_ind = 0;
				ind_attX = pin_manipulation('attribute','num2ind',object.attribute);
				
				if length(attribute(ind_attX).index) % only if some indexes
					ind_frames_index = pin_manipulation('frame','num2ind',[attribute(ind_attX).index(:).frame]);
					for ind_fraX = ind_frames_index  % for every index
						if strcmp('Continuous',frame(ind_fraX).type) | strcmp('Integers',frame(ind_fraX).type)
							if strcmp(answer{3},'yes')
								forbidden_all_ind = 1;
							end
							answer{3} = 'no'; % don't ask all var if any index is continuous or integers
						end
					end
				end
			
				if forbidden_all_ind 
					hdw = warndlg(['Building a variable for every possible index value is forbidden if one index is continuous or integer (too many).',...
					' Select index values for one variable only.']);
					uiwait(hdw)
				end
			
				all_var = 0;
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
				%
				% building all var (one for each possibe index values (not for continuous/integers) 
				%
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
				if new_one & strcmp(answer{3},'yes') 					
					% there are no continuous index as tested just before and made answer{3} = yes.
					all_var = 1;
					exist_var = 1;
					new_pin = get_next_pin('variable');
					variable(ind_var).number = new_pin(3); % - 1 as we have the get a new one
					useless = pin_manipulation('variable','all',[]);
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					% here I really build all these indexed variables
					%
					ind_var_mem = ind_var;
					var_ind_out = get_all_var(answer{1}, object.frame, object.attribute,ind_var);
					object = variable(ind_var);
					%
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					nbr_var = length(variable) + 1;
					useless = pin_manipulation('variable','all',[]);
					% refreshing  frame list
					delete(hd_list(4,:));
					hd_list(4,:) = listing_existing('variable', gui_pos(:,4), hd_full_scr_fig,[]);	
				end % if new_one & strcmp(answer{3},'yes') 	
			
				if all_var == 0
					% building var for some indexes one per one
					ind_var_mem = ind_var;
					One_Var_per_Index
					object = variable(ind_var);
				end % if all_var == 0	
			
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			end % if skip_it == 0
		end % skip it
	end % if choice == 1
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 2		
end % if skip_it == 0


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% storing the variable object
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if skip_it == 0 
	if new_one 
		object.index_value = new_index_value;
	end
	exist_var = 1;
	% beware defining frame ... as global implies frame exists and is [] (double)`
	% and frame = object would be Ok, but not frame(1) = object
	% the tric is to say frame = object the first time, then frame(2) = object...
	index_object = make_empty('variable',ind_var); % to initialize all fields
	variable(ind_var) = put_in_fields(object,variable(ind_var)); %  data saved
	useless = pin_manipulation('variable','all',[]);
	if new_one
		nbr_var = nbr_var + 1;
	end		
	% refreshing  variable list
	delete(hd_list(4,:));
	hd_list(4,:) = listing_existing('variable', gui_pos(:,4), hd_full_scr_fig,[]);						
end % if skip_me == 0

