function [ind_var_siblings, num_var_siblings] = find_equiv_variables

% for every variable which index is in list_var_ind, 
% find the other variables that share 
% same attribute, same frame, same set of index but not same index_value
% thus equal up to the index_value

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief

% ind_var_siblings{i}, num_var_siblings{i} rows vectors with data for variable(i)

% matrix var_matrix, one line = one variable
% a line with = [ attribute_index, frame_index]

% vector var_content = strcat('attribute_number','frame_number', index(1).name, ...)

for i = 1:length(variable)
	if ~isempty(variable(i).number)	
		var_matrix(i,1:2) = [pin_manipulation('attribute','num2ind',variable(i).attribute) ...
		pin_manipulation('frame','num2ind',variable(i).frame)] ;	
	else
		var_matrix(i,1:2) = 0;
	end	
end

[af_num_unique, iaf, jaf] = unique(var_matrix,'rows');

% var_matrix is a nx2 matrix, 
% col 1 = attribute_index
% col 2 = frame_index

% af, as in jaf, means attribute frame 

% for each variable, find all its siblings (with me) (their index and numbers)

for i = 1:length(variable)
	% i is index of variable
	var_siblings{i} = [];
	if ~isempty(variable(i).number)
		ind_var_siblings{i} = find(jaf == jaf(i))';
		num_var_siblings{i} = [variable(ind_var_siblings{i}).number]; 
	end
end
