function getting_propositions
% producing nbr variables of type logical propositions 
% all we need is their number nbr, and default names

% what we get automaticaly for each proposition:
% 	frame, structure, attribute, variable

% what we don't get
% 	 mapping belief

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%


global frame structure mapping attribute  variable belief
global pin_frame pin_structure pin_attribute  pin_variable 
global pin_mapping pin_belief 

default_answer{1} = num2str(0);
[index_fig, hd_fig] = handling_all_figures('put_in_front',{'General Window'});
Wdw_Cmd_handle = hd_fig(1);
window_name_help(1,hd_fig,'Get Propositions',[33]);

[n,choice0] = dialog_queries(Wdw_Cmd_handle, {'Request for propositions.'},...
{'Number of logical propositions. #'}, default_answer,[0 0],[],2,[],[],[],[]);

nbr = str2num(n{1});
if nbr == 0
	choice0 =2;
end

if choice0 == 1
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% If get proposition run several times, we must avoid twice p1...
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% we find all logical propositions
	nbr_max = 0;
	get_log_fr = 0;
	if isempty(frame)  % it exists as it is in global
		% I need to build a logical frame
		get_log_fr = 1;
		new_pin = get_next_pin('frame');
		ind_fra = new_pin(2);	
		fr_number = new_pin(3);	
		ind_log = ind_fra;
		num_fra = fr_number;
	else
		% no variable or no frame implies no logical proposition already created
		% what is the frame for logical proposition
		ind_fra = find(strcmp({frame(:).type},'Logical')) ;
		ind_log = min(ind_fra);		
		% there may be several if several logical frames (a bad idea, but...)	
		if isempty(ind_fra)
			% I need to build a logical frame
			get_log_fr = 1;	
			new_pin = get_next_pin('frame');
			ind_fra = new_pin(2);
			fr_number = new_pin(3);	
			ind_log = ind_fra;
			num_fra = fr_number;
		else
			fr_number = frame(ind_log).number;
			num_fra = frame(ind_fra).number; 			
		end	
	end

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% getting the names of each proposition. Long = short if blank
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% finding the max digit i encountered in a logical variable which name is pi
	for i = 1:length(variable)
		if ~isempty(variable(i).number)
			if ismember(variable(i).frame,num_fra) & strcmp(variable(i).short_name(1),'p') 
				bb = variable(i).short_name;
				bb(1) = [];
				if length(bb)
					eval('nbbr = str2num(bb);','nbbr = 0;');					
					if ~isempty(nbbr)
						nbr_max = max(nbr_max,nbbr);
					end
				end
			end
		end
	end

	% the max index i of proposition short name = pi is nbr_max
	clear queries default_answer
	for i = 1:nbr
		nbr_max = nbr_max + 1;
		queries{i} = {['proposition ', num2str(nbr_max)]};
		default_answer{i} = {strcat('p',num2str(nbr_max))};
	end
	[short_names,choice1] = dialog_queries(Wdw_Cmd_handle, {'SHORT name for each proposition (only letters, digits,_)'},...
	queries, default_answer,[0 0],[],2,[],[],[],[]);
	choice2 = 2;
	if choice1 == 1
		[full_names,choice2] = dialog_queries(Wdw_Cmd_handle, {'LONG name for each proposition. Default is short name.'},...
		queries, short_names,[0 0],[],2,[],[],[],[]);
	end

	if choice1 == 1 & choice2 == 1
		
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% I build a logical frame if not existing
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
		
		if get_log_fr
			frame(ind_fra).number = new_pin(3);
			frame(ind_fra).full_name = 'Logical';
			frame(ind_fra).short_name = 'FT';
			frame(ind_fra).elements = strvcat('F','T');
			frame(ind_fra).type = 'Logical';
			frame(ind_fra).cardinality = 2;
			frame(ind_fra).min = 0;
			frame(ind_fra).max = 0;	
		end
	
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% controling structure for frame logical exists 
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		ind_log = [];
		if length(structure)  % so it exists
			
% % 			[structure(:).most_refined]
% % 			
% % 			fr_number
% % 			
			ind_log = min(find([structure(:).most_refined]==fr_number));	
		end
	
		if isempty(ind_log) % there was no logical, I build it
			new_pin = get_next_pin('structure');
			ij = new_pin(2);
			num = new_pin(3);
			
			structure(ij).number = num ;
			structure(ij).full_name =  'Logical';
			structure(ij).short_name = 'FT';
			structure(ij).most_refined = fr_number;  
			structure(ij).sub_frames = [];
			structure(ij).mapping = [0];
			
			str_number = num;	
		else
			str_number = structure(ind_log).number;
		end
	
	
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% buidling attribute - variable 
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		new_pin = get_next_pin('attribute');
		attr_index  = new_pin(2);
		attr_number = new_pin(3);
		
		new_pin = get_next_pin('variable');
		var_index  = new_pin(2);
		var_number = new_pin(3);
		
		for i = 1:nbr
			long_prop_name = full_names{i}; 
			short_prop_name = short_names{i};
			
			attribute(attr_index).number = attr_number;   					
			attribute(attr_index).full_name =  long_prop_name; 	
			attribute(attr_index).short_name = short_prop_name;				
			attribute(attr_index).structure = str_number;     
			attribute(attr_index).index = {};
			
			variable(var_index).number = var_number;   							
			variable(var_index).full_name = long_prop_name;	
			variable(var_index).short_name = short_prop_name;				
			variable(var_index).attribute = attr_number;
			variable(var_index).frame = fr_number;			
			variable(var_index).index_value = [];
			
			attr_index = attr_index + 1; attr_number = attr_number + 1;
			var_index  = var_index  + 1; var_number  = var_number  + 1;	
			% % % % 	bel_index  = bel_index  + 1; bel_number  = bel_number  + 1;
		end
	end
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% buidling pin_XXX tables
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	get_all_pin_tables
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get window General Window
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
window_name_help(2,hd_fig,'Get Propositions',[33]);
[index_fig, hd_fig] = handling_all_figures('put_in_front',{'General Window'});
Wdw_Cmd_handle = hd_fig(1);



