% belief_case
if isempty(which_object{2}) % I am creating a belief	
	
	switch upper(text_line(1:4))
	case 'BSHN'
		belief(ind_bel).short_name = ddblank(BSHN);
		belief(ind_bel).full_name = BSHN;
		belief(ind_bel).origin = [];
		belief(ind_bel).computed = ['batch_mode'];
	case 'BFLN'
		belief(ind_bel).full_name = BFLN;
	case 'BAGN'	
		belief(ind_bel).agent = BAGN;
	case 'BTME'
		belief(ind_bel).time = BTME;
	case 'BEVC'
		belief(ind_bel).ec = BEVC;
	case 'BDVR'
		out = rd_str_num_shn(BDVR);
		list_num = [];
		for i = 1:length(out)
			new_num = variable(find(strcmp({variable(:).short_name},out{i}))).number;					
			if length(new_num) ~= 1
				disp('belief asks for an inexisting or ambiguous variable')
				ok = 0;
			else
				list_num = [list_num  new_num];
			end		
		end
		belief(ind_bel).domain_variable = list_num;			
		% put the default cardibnality
		for i = 1:length(belief(ind_bel).domain_variable)
			ind_var = pin_manipulation('variable','num2ind',belief(ind_bel).domain_variable(i));
			ind_fra = pin_manipulation('frame','num2ind',variable(ind_var).frame);
			belief(ind_bel).domain_cardinality(i) = frame(ind_fra).cardinality;
		end
		get_its_dci(ind_bel)		
	case 'BDCR'
		% do nothing, done by system belief(ind_bel).domain_cardinality = BDCR;
	case 'BCVR'
		out = rd_str_num_shn(BCVR);
		list_num = [];
		for i = 1:length(out)
			new_num = variable(find(strcmp({variable(:).short_name},out{i}))).number;
			if length(new_num) ~= 1
				disp('belief asks for an inexisting or ambiguous variable')
				ok = 0;
			else
				list_num = [list_num  new_num];
			end
		end
		belief(ind_bel).conditioning_variable = list_num;
		% put the default cardibnality
		for i = 1:length(belief(ind_bel).conditioning_variable)
			ind_var = pin_manipulation('variable','num2ind',belief(ind_bel).conditioning_variable(i));
			ind_fra = pin_manipulation('frame','num2ind',variable(ind_var).frame);
			belief(ind_bel).conditioning_cardinality(i) = frame(ind_fra).cardinality;
		end
	case 'BCCR'
		% do nothing, done by system belief(ind_bel).conditioning_cardinality = BCCR;
	case 'BCMP'
		belief(ind_bel).computed = BCMP;
		% case 'BDIS' MISSING BDIS disposable
	otherwise 
		ok = 0;
	end

elseif isempty(which_object{3}) % I am in a potential

	% creating bel cardinality if missing
	% belief(ind_bel).bp(ind_pot).
	% I must build the 2 cardinals if not done by user
	if isempty(belief(ind_bel).domain_cardinality)
		for i = 1:length(belief(ind_bel).domain_variable)				
			var_num = belief(ind_bel).domain_variable(i);
			var_ind = find([variable(:).number] == var_num);
			fra_num = [variable(var_ind).frame];
			fra_ind = find([frame(:).number] == fra_num);
			belief(ind_bel).domain_cardinality = ...
			[belief(ind_bel).domain_cardinality frame(fra_ind).cardinality];
		end
	end
	if ~isempty(belief(ind_bel).conditioning_variable)
		if isempty(belief(ind_bel).conditioning_cardinality)
			for i = 1:length(belief(ind_bel).conditioning_variable)
				var_num = belief(ind_bel).conditioning_variable(i);
				var_ind = find([variable(:).number] == var_num);
				fra_num = [variable(var_ind).frame];
				fra_ind = find([frame(:).number] == fra_num);
				belief(ind_bel).conditioning_cardinality = ...
				[belief(ind_bel).conditioning_cardinality frame(fra_ind).cardinality];
			end
		end
	else
		belief(ind_bel).conditioning_cardinality = [];
	end	

	if strcmp(upper(text_line(1:4)),'BPCN')
		% for conditional beliefs, by default each condit belief is vacuous, 
		% and then I made it different by using POTENTIAL / BPCN tells the element...  FORM
		% the case with conditional variable, finding ind_pot given the request
		% I read BPCN={'male','4','no'}
		% I need 1 4 2 if ELEM sex = Male, Female, nbr_children = 1 2 3 4 5 and married = yes no
		% then  I transform it into 2 4 1 as var1 = sex, at right
		% and compute its number-position among elements = (2-1)*10 + (4-1)*2 +(1-1) +1 = 17		
		% I don't use creating_elements as it does too many things		
		card = belief(ind_bel).conditioning_cardinality;	
		% let it be 2 3 5		
		cf_mult(1) = 1; 
		for i = 2:length(card)
			cf_mult(i) = card(i-1)*cf_mult(i-1);
			% i get 1 2 6
		end
		% data order 111 112 121 122 131 132 211.... 532
		% hence 211 is located at 7,
		% hence 532 is located at at 4*6 + 2*2 + 1*1 + 1 = 30
		num_element = 1;
		cond = '';
		for i = 1:length(belief(ind_bel).conditioning_variable)
			num_var = belief(ind_bel).conditioning_variable(i);
			ind_var = pin_manipulation('variable','num2ind',num_var);			
			pos = find_pos_element(variable(ind_var).frame,BPCN{i}); 
			num_element = num_element + (pos-1)*cf_mult(i);
			cond = [cond,variable(ind_var).short_name,'=',BPCN{i},', '];
		end	
		cond(end) = '';
		cond(end) = '';
		ind_pot = num_element;	
		out_data(2) = ind_pot; % so I send it back to calling batrch mode
		belief(ind_bel).bp(ind_pot).number = ind_pot;				
		belief(ind_bel).bp(ind_pot).full_name = ['bp',num2str(ind_pot)];
		belief(ind_bel).bp(ind_pot).cd_focal_set = num_element;
		belief(ind_bel).bp(ind_pot).condition = cond;			
	end	

else % I am in form 
	switch upper(text_line(1:4))
	case 'RAND'	
		crd = prod([belief(ind_bel).domain_cardinality]);
		nsb = min(crd,9);
		% I generate at most 512 focal sets
		vect_p = [sort(rand(1,pow2(nsb)-1)) 1];
		m = diff([0 vect_p]);			
		belief(ind_bel).bp(ind_pot).form(ind_for).type = 'm';
		belief(ind_bel).bp(ind_pot).form(ind_for).representation = 'selected';
		belief(ind_bel).bp(ind_pot).form(ind_for).values = m';
		out_foset = get_n_random_foset(pow2(nsb),crd);		
		belief(ind_bel).bp(ind_pot).form(ind_for).focal_sets = out_foset;
		belief(ind_bel).bp(ind_pot).form(ind_for).log_expr = {};
	case 'RANN'			
		crd = prod([belief(ind_bel).domain_cardinality]);
		nsb = min(crd,9);
		% I generate at most 512 focal sets
		vect_p = [sort(rand(1,pow2(nsb)-2)) 1];
		m(1) = 0;
		m(2:pow2(nsb)) = diff([0 vect_p]);			
		belief(ind_bel).bp(ind_pot).form(ind_for).type = 'm';
		belief(ind_bel).bp(ind_pot).form(ind_for).representation = 'selected';
		belief(ind_bel).bp(ind_pot).form(ind_for).values = m';
		out_foset = get_n_random_foset(pow2(nsb),crd);		
		belief(ind_bel).bp(ind_pot).form(ind_for).focal_sets = out_foset;
		belief(ind_bel).bp(ind_pot).form(ind_for).log_expr = {};				
	case 'PFRM'
		belief(ind_bel).bp(ind_pot).form(ind_for).type = lower(PFRM);
		belief(ind_bel).bp(ind_pot).form(ind_for).representation = 'selected';
		belief(ind_bel).bp(ind_pot).form(ind_for).values = [];
		belief(ind_bel).bp(ind_pot).form(ind_for).focal_sets = [];
		belief(ind_bel).bp(ind_pot).form(ind_for).log_expr = {};	
		% create temporarily for keeping it , is deleted later
	case 'PRDF'
		% get next line
		i_line = i_line + 1;
		out_i_line = i_line;		
		tx = ddblank(text_line_mem{i_line});
		tx = only_one_blank(tx);
		pos_blk = findstr(tx,' ');
		pdf = ddblank(tx(1:pos_blk(1)-1));
		nature = ddblank(tx(pos_blk(1)+1:pos_blk(2)-1));
		form_in = ddblank(tx(pos_blk(2)+1:pos_blk(3)-1));
		param_in = str2num(tx(pos_blk(3)+1:length(tx)));
		switch form_in
		case 'ab'
			option = 1;
		case 'ms'
			option = 2;
		end
	
		switch nature % bbf or BetP
		case 'bbf'
			belief(ind_bel).bp(ind_pot).form(ind_for).type = 'm_pdf';
			belief(ind_bel).bp(ind_pot).form(ind_for).representation = pdf; 
			% the pdf name (binomial,...gaussian)
			param = pdf_parameters(pdf,param_in,option);			
			belief(ind_bel).bp(ind_pot).form(ind_for).values = param; 
			% the (4) parameters of the pdf [a,b,m,std_dev]
			belief(ind_bel).bp(ind_pot).form(ind_for).focal_sets = [];
		case 'Betf'
			belief(ind_bel).bp(ind_pot).form(ind_for).type = 'BetP_pdf';
			belief(ind_bel).bp(ind_pot).form(ind_for).representation = pdf;
			param = pdf_parameters(pdf,param_in,option);	
			belief(ind_bel).bp(ind_pot).form(ind_for).values = param;
			belief(ind_bel).bp(ind_pot).form(ind_for).focal_sets = [];
			
			ind_for = make_empty('form',ind_bel,ind_pot,2);
			belief(ind_bel).bp(ind_pot).form(ind_for).type = 'm_from_BetP_pdf';
			belief(ind_bel).bp(ind_pot).form(ind_for).representation = [pdf,'_based'];
			belief(ind_bel).bp(ind_pot).form(ind_for).values = param;
			belief(ind_bel).bp(ind_pot).form(ind_for).focal_sets = [];
		end		
	
	case 'PREP'
		belief(ind_bel).bp(ind_pot).form(ind_for).representation = PREP;
	case {'PBEG','PEND'}
		% this annouces/end a new set of focal sets, so I build an empty form (already done)
	otherwise 
		ok = 0;
	end
end	
