% frame case

switch upper(text_line(1:4))
case 'FSHN'
	frame(ind_fra).short_name = ddblank(FSHN);
	frame(ind_fra).full_name = FSHN;
case 'FFLN'
	frame(ind_fra).full_name = FFLN;
case 'FTYP'
	% correcting mistyping
	switch lower(FTYP)
	case 'logical'
		frame(ind_fra).type = 'Logical';
	case 'binary'
		frame(ind_fra).type = 'Binary';
	case {'classes_un_ordered','classes un_ordered','classes_unordered',...
		'classes unordered'}
		frame(ind_fra).type = 'Classes_Un_ordered';
	case {'classes_ordered','classes ordered'}
		frame(ind_fra).type = 'Classes_Ordered';
	case {'integers','integer'}
		frame(ind_fra).type = 'Integers';
	case 'continuous'
		frame(ind_fra).type = 'Continuous';
	end			
	if strcmp(FTYP,'Logical')
		frame(ind_fra).elements = strvcat('F','T');
		frame(ind_fra).cardinality = 2;
	end	
	if strcmp(FTYP,'Binary')
		frame(ind_fra).elements = strvcat('0','1');
		frame(ind_fra).cardinality = 2;
	end	
case 'FCRD'
	% building default labels for elements
	object_def = default_labels_elements(frame(ind_fra).type,FCRD)
	frame(ind_fra).min = object_def.min;
	frame(ind_fra).max = object_def.max;
	frame(ind_fra).cardinality = object_def.cardinality;
	frame(ind_fra).elements = object_def.elements;	
case 'ELEM'
	switch frame(ind_fra).type
	case 'Binary'
		frame(ind_fra).elements = strvcat(ELEM);
	case 'Classes_Un_ordered'
		frame(ind_fra).elements = strvcat(ELEM);
		frame(ind_fra).cardinality = size(frame(ind_fra).elements,1);
	case 'Classes_Ordered'
		frame(ind_fra).elements = strvcat(ELEM);
		frame(ind_fra).cardinality = size(frame(ind_fra).elements,1);
	case {'Integers','Continuous'}
		% element is just a label, so -inf .... is OK		
		if strcmp(frame(ind_fra).type,'Integers')
			from = str2num(ELEM{1});
			to  =  str2num(ELEM{2});
			frame(ind_fra).cardinality = to - from + 1;
			frame(ind_fra).elements = strvcat(num2str([from:to]')); 
			frame(ind_fra).min = str2num(ELEM{1});
			frame(ind_fra).max = str2num(ELEM{2});
		else
			frame(ind_fra).cardinality = infinity;
			frame(ind_fra).elements = '';
			if isnumeric(ELEM{1})
				frame(ind_fra).min = str2num(ELEM{1});
			else
				frame(ind_fra).min = -infinity;
			end
			if isnumeric(ELEM{2})
				frame(ind_fra).max = str2num(ELEM{2});
			else
				frame(ind_fra).max = infinity;
			end
		end
	otherwise 
		ok = 0;
	end			
end

