% case CCR DCR

switch which_object{1}
case 'CCR'
	which_combi = 'and';
case 'DCR'
	which_combi = 'or';
end

switch upper(text_line(1:4))
case 'BSHN'
	belief(ind_bel).short_name = BSHN;
	belief(ind_bel).full_name = BSHN;
case 'BFLN'
	belief(ind_bel).full_name = BFLN;
case 'BELF'
	flagstr = BELF;		
	% do they exist
	for i = 1:length(BELF)
		ind_bel1 = find_field('belief','short_name',ddblank(flagstr{i}));
		if length(ind_bel1) ~= 1
			hdw = warndlg('In ccr-dcr, the list BELF mentions unknown short_names. Expect a crash.')
			uiwait(hdw)
		end
	end
case 'DISC' % this is what executes the combination operation
	ibel = ind_bel;
	num_belief = [];
	index_belief = [];
	bp_index = [];
	form_index = [];
	for i = 1:length(flagstr)
		ind_bel = find_field('belief','short_name',ddblank(flagstr{i}));
		index_belief = [index_belief ind_bel];
		ind_last_bel = ind_bel;
		num_belief = [num_belief   belief(ind_bel).number]; % the belief involved
		bp_index = [bp_index  1 ]; % always 1 as never conditional
		ind_for = find(strcmp({belief(ind_bel).bp(1).form(:).type},'m'));
		if isempty(ind_for)
			ind_for = make_empty('form',ind_bel,1);
			[computed_forms,uncomputed_forms, error_mode] = transform_bp(ind_bel,1,{'m'});
		end
		form_index = [form_index  ind_for ];						
		if DISC(i) > 0
			bbm_memory{i} = belief(ind_bel).bp(1).form(ind_for).values; 
			foset_mem{i} = belief(ind_bel).bp(1).form(ind_for).focal_sets;
			ind_bel_mem(i) = ind_bel;
			ind_for_mem(i) = ind_for;
			% I discount
			card = prod(belief(ind_bel).domain_cardinality);
			[new_bba, new_foset] = dicount_bba(bbm_memory{i},foset_mem{i},DISC(i),card);
			belief(ind_bel).bp(1).form(ind_for).values = new_bba;
			belief(ind_bel).bp(1).form(ind_for).focal_sets = new_foset;
		end
	end

	flags = 999; % to tell I am in batch mode (no request for entering data)
	% data needed by part_andor_dist_combi
	calculator_handle = 0; % unused but asked for 
	choice19 = 1;
	
	% needed: [index_belief' bp_index' form_index' num_belief']	
	nbr_m = length(num_belief);
	part_andor_dist_combi % preparing data request
	
	% doing the combi			
	[m_final,foc_final,var_num_final,list_fr_card ] = ...
	compute_distinct_combi(eval_expr,list_bbf_unique,list_bbf_labels);
	
	% saving results
	switch which_object{1}
	case 'CCR'
		oper = 'and';
	case 'DCR'
		oper = 'or';
	end
	org = [num_belief(1), bp_index(1)];	
	tx = [num2str(num_belief(1)),'.', num2str(bp_index(1))];
	for i = 2:length(bp_index)
		org = [org; num_belief(i),bp_index(i)];
		tx = [tx,' and ',num2str(num_belief(i)),'.', num2str(bp_index(i))];
	end
	belief(ibel).origin = org;	
	belief(ibel).computed = tx;	
	belief(ibel).domain_variable = belief(ind_last_bel).domain_variable ;
	belief(ibel).domain_cardinality = belief(ind_last_bel).domain_cardinality ;				
	belief(ibel).bp(1).form(1).type = 'm'; 
	belief(ibel).bp(1).form(1).representation = 'selected';		
	belief(ibel).bp(1).form(1).focal_sets = foc_final;
	belief(ibel).bp(1).form(1).values = m_final;
	useless = pin_manipulation('belief','all',0);
	
	% restore previous belief modified for disc
	for i = 1:length(flagstr)
		if DISC(i) > 0
			ind_bel = ind_bel_mem(i);
			ind_for = ind_for_mem(i);
			belief(ind_bel).bp(1).form(ind_for).values = bbm_memory{i};
			belief(ind_bel).bp(1).form(ind_for).focal_sets = foset_mem{i};
		end
	end	
end

