function text = demos(option)

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%


switch option

case 1 
	text = {...
	' ',...
	'DEMOS: The Chest Clinic Problem.',...
	' ',...
	'Shortness of breath (dyspnoea) (D) may be due to either tuberculosis (T), lung cancer (L) or bronchitis (B).',...
	'A recent visit to Asia (A) increases the risk of tuberculoisis, while smoking (S) increases the risk for both lung cancer and bronchitis.',...
	'The result of a single chest X-Ray (X) does not discriminate between lung cancer and tuberculosis, nor does the presence or absence of dyspnoea.',...
	'',...
	'The variables are:',... 
	'   A = Gone_to_Asia (T/F),',... 
	'   S = Smoking (Y/N),',... 
	'   D = Dyspnoea (T/F),',...
	'   F = Feber (T/F),',... 
	'   X = X_Ray normal (T/F),',... 
	'   T = Tuberculosis (T/F),',... 
	'   B = Bronchitie (T/F),',... 
	'   L = Lung cancer (T/F).',...
	' ',...
	'My patient smokes, I don''t believe he went recetnly to Asia, he complains of dyspnoea but he complains of evrything.',...
	' ',...
	'MAKING THE VARIABLES.',...
	' ',...
	'These 8 variablkes are 8 logical propositions denoted A, S, D, F, X, T, B, L.',...
	' ',...
	'Run TBMLAB by typing tbmlab <Return> in the Matlab Command Window. Proceed as already learned with the demo described in the file DemoUsingTBMLAB.pdf (in Fort_User_Data folder). Select menu Control/Short Cuts/Get logical prop.',...
	'Ask for 8 propositions, and give them the short names  A, S, D, F, X, T, B, L.',...
	'For the ful names:either you keep the default ones or you type their full names (avoid spaces, it is NOT a good practice for future readability. Use _ instead.).',...
	'We suggest Asia, Smoking, Dyspnoea, Fever, X_Ray, Tuberculosis, Bronchitie, Lung_cancer.',...
	' ',...
	'Save your new environment using menu Control/Save environement.',...
	'Give a name like My_Chest_Clin for your file. All data of this demos will be store there. I stored the example in Chest_Clin folder.',...
	' ',...
	'MAKING THE BELIEF MASSES.',...
	' ',...	
	'1: Asia prior: m(-A) = .8, m(universe) = .2. It means that you have serious reasons to believe the patient did not go to asia.',...
	'You go to the pull-down menu Objects, select Belief.  UR displays the lists of belief and variable objects, and a What to do? button menu.',...
	'Choose make a new belief. In dialog box,gives short name = A0, fullname = Asia_prior. Click OK.',...
	'Select the variable Asia (as a matter of fact is happens it was the selected one, as by default the first option is selected, so not selecting is also OK here, but not later.).',... 
	'Click Done.',...
	'TBMLAB asks if you want to go to belief potential window, click yes. See Help at UL, OK. At UR, menu: Potentials of THIS belief. Choose New:selected m. ',...
	'At UR, you get a listing of all the possible elements of the universe created with the variables used in THIS belief and just selected.',...
	'Build one focal set by cliking on F. Then at bottom, a box where you put the mass .8.',...
	'You also get a total allocated mass to remember you what was already allocated, and 3 buttons, mass OK, bba OK and Cancel.',...
	'Having put .8 in the left most box, select mass OK.',...
	'As this is the only mass given to a non universe focal set, you also select bba OK, the unallocated .2 mass is automatically given to the universe.',...
	'Select Quit: back to belief. Your first bba has been built.',...
	' ',...
	'2: Smaking prior: m(S) = 1. This just mean I am sure that the paitent is a smoker as i saw him smoking.',...
	' ',...
	'3: Dyspnoea prior: m(D) = .6, m(universe) = .4. It means patient complains of dyspnoea, but he is not very reliable, he complains for everything.',...	
	'You proceed identically with dyspnoea, except you enter names D0 and Dyspnoea_prior, select Dyspnoea, and enter .6 on T.',...
	' ',...
	'4: Rule Asia implies Tuberculosis: m(A->T) = .5, m(universe) = .5',...	
	'm(A->T) = .5, remaining .5 mass on universe. Create the belief object: names are RAT and R(A->T). When variables asked, select Asia and Tuberculosis.',...
	'Note: Multi_selection achieved on Mac by clicking while holding Command key down (or UpperCase click for all in between data selection), on PC Control Click.',...
	'When multi_selection over, select buttons  Done, then Yes. You are back menu Potentials of THIS belief, choose New: logical exprfessions.',...
	' ',...	
	'You get:',...
	'Variable List that lists those variables involved in THIS potential,',...
	'Logical Operators that lists the allowed operators. You build a focal set by creating a logical expression in the bottom box. You do not type it, you build it with the mouse.',...
	'So click successively on A, impl, T, end. A new box appears where you must enter the mass. Type .5 in it. OK. Then to say it is over, just select end. Unallocated mass given to universe. Select Quit: back to belief.',...
	'A save attitude is to select the button save belief, at least the belief entered up to now are saved, the variables had been saved previously.',...
	' ',...
	'5: Rule Smoking inceases Lung_cancer risk. This is translated by m(S->L)=..5, m(universe) = .5',....
	'The origin of these masses comes form the application of the TBM theory to risk factors and odd ratios encountered in epidemiology. Used odd ratio = 2.',... 
	'Proceed as at step 3, except you use the New: logical expressions 3 tiMes, once with S impl L .48, once with S impl not L .08, once with S impl (L and not L) .12, and system will give the .32 automatically to universe.',...
	' ',...
	'6: Rule Smoking inceases Bronchitis risk.  This is translated by m(S->B) = 2/3, m(universe) = 1/3 (odd ration 3)',...	
	'Proceed as at step 4.',...
	' ',...
	'7: Rule L or T implies X: m((L v T)-> x) = .9. m(universe) = .1',...
	'Proceed as at step 3. Use the logical expression ( L or T ) impl x .9.',...
	'Parentheses avoid confusion and is a good practice, even though TBMLAB would accept L or T impl X correctly. But this is not always true, so use parentheses.',...
	'The only thing you may NOT do is using impl and/or equiv more than once. Itertaed implications and equivalence are not understood by TBMLAB in its present version.',...
	' ',...
	'8: Rule L or T or B implies D: m((L v T v B) -> D) = .8. m(universe) = .2',...
	'Proceed as at step 6.',...
	' ',...
	'This is all. Your data base is built. Save it either with the save belief button, or much better, by going back to the menu, and using menu',... 
	'Control/Save environment in which case everything is (re)saved.',...
	'The Save belief option saves only the belief objects, not the variable objects, etc..., whereas Save environment saves everything that exists.',...
	'Still a better practice, as I said, is entering belief, building a belief, and when back to the belief menu, apply save belief for each belief. So what has been entered is protected against a crash.',...
	' ',...
	'Mistyping logical expressions.',...
	'If you enter logical expressions incorrectly, it is easy to correct before accepting it and its mass.',...
	'In fact, the buttons only create a list of characters, those you see in the box. TBMLAB just reads the content of the box, and parse it.',...
	'So you can modify the content of the box by typing directly into it, provide you respect the syntax you saw.',...
	'Erasing or adding characters is permitted, but be sure to leave blanks on both side of the operators.',...
	'This mehtod is OK except it is dangerous if you make an error. The parser is not very smart and a crash might occur.',...
	'A safer procedure is to end the construction, to select the delete option in the Potentials option, delete what you jsut create and is not correct, and restart its construction.',...
	' ',...
	'COMPUTING NEW BELIEFS',...
	' ',...
	'Select the pull-down menu Calcul/Val.Base Syst./Undirected. TBMLAB asks you to select the belief object to be combined. Select the 8 you have just created. OK.',...
	'Then TBMLAB asks you on which frame the belief should be marginalized. Select the variables on which you want to see the projection of the combined beliefs.',...
	'A good selection here is L, T, B.',...
	'TBMLAB does the computation and goes directly to the result display wondow, where you get many information on the computed belief.',...
	' ',...
	'USING GRAPHICAL METHOD',...
	' ',...
	'If you like the graphic method for displaying data, enter Menu Control/Graphic Mehtod and select button Get to EVN.',...
	'In the new window, select the menu Objects/Belief, and select the four first belief objects.',...
	'You get a not too messy EVN (Evidential Ntework). Recenter it and move the nodes to get a clear plot.',...
	'Once done, put Menu ON by clicking on the red button Menu OFF. Ask for the other belief obejcts one per one, and put them on your plot so you keep a clear plot.',...
	'Once all beliefs have been introduced, as for EVN Control/Propagate. One done, ask for Disply BetP. You get BetP for each variable in bar chart representation.',...
	'You can move the bar charts (using menu Display/Move histo and then drag and drop the histos), and see the EVN back. ',...
	'When trhough, select quit, and you are back to the buttons options, where a good idea is to save the EVN data.',...
	'Then select Quit EVN session, and Control/Quit to MATLAB. You have finished and all windows are closed.',...
	};
	
	
case 2
	text = {...
	' ',...
	'DEMOS: The flight crew problem',...
	' ',...
	'In a certain flight crew, the position of pilot, copilot and flight engineer are held by three persons, Allen, Brown and Carr,',...
	'though not necessary in that order. (This rule is sure: mass = 1.)',...
	' ',...
	'The copilot who is an only child, earns the least. (This rule becomes Copilot -> (Only Child and Earn Low). It has a mass .6, quite dubious assertion)',...
	' ',...
	'Carr, who married Brown''s sister, earns more than the pilot does. (Brown is not only child, (mass .9), Carr is not the pilot and his earning is not low (mass .8)',...
	' ',...
	'What position does each of the three person''s hold?',...
	' ',...
	'The VARIABLES.',...
	'We have 3 attributes, Oc, Ea, C1, each with one index = Pr (person) which domain is A,B,C (for Allen, Brown, Carr).',...
	' ',...
	'The FRAMES.',...
	'I need 4 frames, one for each of Oc, Ea, C1, Pr. I name them FOc, FEa, FC1, FPr.',...
	'Select menu Control/Short cuts/Get simple objects. On new window, select frame to build the 4 frames.',...
	' ',...
	'Select frame. Name = FOc, cardinality = 3. OK. In element names, enter Pil, Cop, Eng. OK.',...
	' ',...
	'Select frame. Name = FEa, cardinality = 3. OK. In element names, enter Lw, Md, Hi. OK.',...
	' ',...
	'Select frame. Name = FC1, cardinality = 2. OK. In element names, enter, N, Y. OK.',...
	' ',...
	'Select frame. Name = FPr, cardinality = 3. OK. In element names, enter A, B, C. OK.',...
	' ',...
	'The 4 frames have been built, and you receive also 4 structures called Sxxx where xxx is the frame name.',...	
	' ',...
	' ',...	
	'The ATTRIBUTES.',...
	'Build 3 attributes called Oc, Ea, C1, each with one index = Pr, and their corresponding strucure. You stay on the same window.',...
	' ',...
	'Select Attribute. Name = Oc (change text in box). OK. Select its Structure = SFOc. Done. Number of indexes for this attribute = 1. OK. Index name = Pr. OK. Select Frame = FPr. Done.',...
	' ',...
	'Select Attribute. Name = Ea. OK. Select its Structure = SFEa. Done. Number of indexes for this attribute = 1. OK. Index name = Pr. OK. Select Frame = FPr. Done.',...
	' ',...
	'Select Attribute. Name = C1. OK. Select its Structure = SFC1. Done. Number of indexes for this attribute = 1. OK. Index name = Pr. OK. Select Frame = FPr. Done.',...
	' ',...
	'Exit Get simple objects. You are back to the menus. Save your environment.',...
	' ',...
	' ',...
	'The VARIABLES.',...
	'We have 3 indexed attributes, so we build all the variables (one for each attribute x index value) in ONE instuction.',... 
	'It consists in selecting the menu Objects/Variables, button all var index. It works for any number of indexes, and the variables do not have to share the same indexes.',...
	'All you have to do is to multi_select the three attributes.',...	
	' ',....
	'Note on variable full names: the name is the attribute_name(Index_name=Index_value)_on_Frame=Frame_name.',...
	'Note on variable short names: the name is the Attribute_name(Index_value). For short name, try really to keep it short, so use short namess for attribute, Index and index frame.elements (at least those used for the attributes).',...
	' ',...
	' ',...
	'The BELIEFS.',...
	'Pull-down menu Objects/Belief. Button Make a new one.',...
	' ',...
	'Names = ClW. Multi_select variables Oc(A), Oc(B), Oc(C). Done. Yes (for I want the bp). UL, OK. New: selected m.',...
	'In the list of all possibilities, multiselect those 6 lines where the 3 occupations are different. Mass = .8. mass OK, bba OK, Quit: back to belief.',...
	' ',...
	'We must now build 3 times the same belief. So we use Duplicate -> index option that reproduces automatically the same belief for all posible combinations of the index of its variables.',...
	'It corresponds to generating : for all x, m(Oc(x) in U)=.7, m(Oc(x) in V)=.3 as many time as there are x''s',...
	'All we need is just to build one of them, and use the duplicate -> index option.',...
	'So we build a B0 belief for Allen. It will be among those built automaticaly so the names are consistent. So you can delete B0 once duplication done or just keep it, it is not important.',...
	' ',...
	'Names = B0. Multi_select variables Oc(A), Ea(A), C1(A). Done. Yes. UL, OK. New: logical expressions.',...
	'Logical expressions are fed in by clicking on the operators, the varibales and when these are not logical, by selecting the value thaty can take (you get an extre list just for that).',...
	'To get an unselected list of an unselected window,you always need an extra clck for object selection, then the specific option, hence double click.',...
	' ',...
	'Oc(A) Cop impl ( Ea(A) Lw and C1(A) Y ) end. In the new box,enter mass .6. OK. End, End (double end means no more masses).',...
	' ',...
	'For Brown and Carr, use option Duplicate -> index. You get one for Allen also as said before.',...
	' ',...
	'Names = CSt. Multi_select varibales Oc(C) and Ea(C). Done. Yes. UL, OK. New: logical expressions.',...
	'Ea(C), Md, Hi, LR, OK. and Oc(C) Cop, Eng, LR, OK,End. .7, OK,OK,Done.',... 
	' ',...
	'Names = BrOC, Select C1(B), Done. Yes. UL, OK. New: selected m.',...
	'Select N, mass = .9, mass OK, bba OK. Quit. Save belief. Quit. Done. And the data base is built and saved.',...
	' ',...
	' ',...
	'The COMPUTATION.',...
	' ', ...
	'Done as in the previous examples.',...
	};
	
	
end

