function [text, pos_but] = get_help_text_for_set_buttons(hd_figure,...
hd_buttons,index_set_buttons_mem)
% all the texts used to explain what a button does
% and computing buttons locations in pixels on full screen

% grouped for a set of button with index k

% hd_figure = the handle of the figure where the buttons are located
% hd_buttons = the handles of the buttons

% the selected text number =  index_set_buttons 
% we put in text only those for the index_set_buttons panel
% if several windows needed to display the buttons (too many in one panle), we use [from to] to select text{from:to,:}
% index_set_buttons_mem 	=   index_set_buttons 			if only one window
% 							= [ index_set_buttons from to] 	if several windows

% text{i,k} i = the button in the panel, k = 1 (nbr of lines), k=2.... the help text for one button

% avoid WindowButtonMotionFcn and a dialog_query open simultaneiously. Seems not OK on PC

%
%   Version : Jan 22,03
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% determining the location of the buttons in pixel, relative to the full screen
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

pos_but = 0;
if ishandle(hd_figure)
	% if not fig = only for printer, put hd_figure = []
	% figure position already in pixels 
	fig_pos = get(hd_figure,'position');
	for i = 1:length(hd_buttons)
		pos_prop = get(hd_buttons(i),'position');
		% poistion in pixels of the buttons
		pos_but(1,i) = fig_pos(1)   + fig_pos(3)*pos_prop(1); % x low
		pos_but(2,i) = pos_but(1,i) + fig_pos(3)*pos_prop(3); % x up
		pos_but(3,i) = fig_pos(2)   + fig_pos(4)*pos_prop(2); % y low
		pos_but(4,i) = pos_but(3,i) + fig_pos(4)*pos_prop(4); % y up
	end
end

% beware text{i,1} = nbr of used text paragraphs
clear text

% handling the case where there are several displays for one request
if length(index_set_buttons_mem) == 1
	index_set_buttons = index_set_buttons_mem;
else
	% for dialog_queries I may use several panels as too many buttons for one
	index_set_buttons = index_set_buttons_mem(1);
	from = index_set_buttons_mem(2);
	to = index_set_buttons_mem(3);
end

skip_me = 0;
switch index_set_buttons

% case 2 % Frame buttons
% 	
% 	i = 1;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'FRAME : Load';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'TBM will load the frame data previously saved in the environment folder which name was in the tooltip.';
% 	
% 	i = 2;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'FRAME : New';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'TBM displays the list of the available frame objects.';
% 	k=k+1;text{i,k} = 'TBM build a new frame object of type Binary, used for default.';
% 	k=k+1;text{i,k} = 'You can modify all the parameters of the object.';
% 	k=k+1;text{i,k} = 'You will see a dialog window in General Window. Answer the queries.';
% 	k=k+1;text{i,k} = 'If query ends with #, you must enter a number.';
% 	k=k+1;text{i,k} = 'If the query ends with MENU, there is a pull-down menu attached to the field, and you get to it with Ctrl click on Mac, right click on PC.';	
% 	k=k+1;text{i,k} = 'You cannot change the object number.';
% 	k=k+1;text{i,k} = 'To get detailed inforamtion on the various fields of the object, go to the pull-down menu Objects, Object_Help.';
% 	
% 	i = 3;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'FRAME : Edit';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'TBM displays the list of the available frame objects, and you select the one you want to display.';
% 	k=k+1;text{i,k} = 'You can modify all the parameters of the object.';
% 	k=k+1;text{i,k} = 'You will see a dialog window in General Window. You may change the content of the fileds.';
% 	k=k+1;text{i,k} = 'If query ends with #, you must enter a number.';
% 	k=k+1;text{i,k} = 'If the query ends with MENU, there is a pull-down menu attached to the field, and you get to it with Ctrl click on Mac, right click on PC.';	
% 	k=k+1;text{i,k} = 'You cannot change the object number.';
% 	k=k+1;text{i,k} = 'To get detailed inforamtion on the various fields of the object, go to the pull-down menu Objects, Object_Help.';
% 	
% 	
% 	i = 4;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'FRAME : Delete';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'TBM displays the list of the available frame objects, and you select the one you want to delete.';
% 	k=k+1;text{i,k} = 'Beware: TBM deletes the object and all those that depends on its existence. So many objects may disappear.';
% 	k=k+1;text{i,k} = 'The deletion operation cannot be recovered.';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'Will be deleted :';
% 	k=k+1;text{i,k} = 'The frame object you selected.';
% 	k=k+1;text{i,k} = 'The structure objects where the deleted frame is the most refined one.';
% 	k=k+1;text{i,k} = 'The mapping objects where the deleted frame is used';	
% 	k=k+1;text{i,k} = 'The attribute objects using a deleted structure or where an index uses a deleted frame.';
% 	k=k+1;text{i,k} = 'The variable objects using a deleted frame or a deleted attribute.';
% 	k=k+1;text{i,k} = 'The belief objects using a deleted variable as domain variable or as conditioning_variable.'	;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'Will be updated :';
% 	k=k+1;text{i,k} = 'The deleted frame is eliminated from the sub_frames fields of the strucutre objects where the deleted frame appears.';
% 	k=k+1;text{i,k} = 'The mapping field of the strcutures objects where the deleted mapping appear are updated';	
% 	
% 	
% 	i = 5;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'FRAME : Save';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'TBM will save the frame data as they are now in the environment folder which name was in the tooltip.';
% 	
% 	i = 6;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'FRAME : quit';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'You go back to pull-down menu level. Maybe you better save your data first.';
% 	
% case 3  % Structure buttons
% 
% 	i = 1;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'STRUCTURE : Load'; %X
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'TBM will load the strucure data previously saved in the environment folder which name was in the tooltip.'; %X
% 	
% 	i = 2;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'STRUCTURE : New';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'TBM displays the list of the available frame and strucure objects.';
% 	k=k+1;text{i,k} = 'TBM build a new strucure object.';%X
% 	k=k+1;text{i,k} = 'You can modify all the parameters of the object.';
% 	k=k+1;text{i,k} = 'You will see a dialog window in General Window. Answer the queries.';
% 	k=k+1;text{i,k} = 'If query ends with #, you must enter a number.';
% 	k=k+1;text{i,k} = 'If the query ends with MENU, there is a pull-down menu attached to the field, and you get to it with Ctrl click on Mac, right click on PC.';	
% 	k=k+1;text{i,k} = 'You get also requests for selecting items in the displayed object lists.';
% 	k=k+1;text{i,k} = 'You cannot change the object number.';
% 	k=k+1;text{i,k} = 'To get detailed inforamtion on the various fields of the object, go to the pull-down menu Objects, Object_Help.';
% 	
% 	i = 3;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'STRUCTURE : Edit';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'TBM displays the list of the available frame and strucure objects, and you select the strcuture object you want to display.';%X
% 	k=k+1;text{i,k} = 'You can modify all the parameters of the object.';
% 	k=k+1;text{i,k} = 'You will see a dialog window in General Window. You may change the content of the fileds.';
% 	k=k+1;text{i,k} = 'If query ends with #, you must enter a number.';
% 	k=k+1;text{i,k} = 'If the query ends with MENU, there is a pull-down menu attached to the field, and you get to it with Ctrl click on Mac, right click on PC.';	
% 	k=k+1;text{i,k} = 'You get also requests for selecting items in the displayed object lists.';
% 	k=k+1;text{i,k} = 'You cannot change the object number.';
% 	k=k+1;text{i,k} = 'To get detailed inforamtion on the various fields of the object, go to the pull-down menu Objects, Object_Help.';
% 	
% 	
% 	i = 4;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'STRUCTURE : Delete'; %X
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'TBM displays the list of the available frame objects, and you select the one you want to delete.';
% 	k=k+1;text{i,k} = 'Beware: TBM deletes the object and all those that depends on its existence. So many objects may disappear.';
% 	k=k+1;text{i,k} = 'The deletion operation cannot be recovered.';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'Will be deleted :';
% 	k=k+1;text{i,k} = 'The structure object you selected.';
% 	k=k+1;text{i,k} = 'The attribute objects using a deleted structure.';
% 	k=k+1;text{i,k} = 'The variable objects using a deleted attribute.';
% 	k=k+1;text{i,k} = 'The belief objects using a deleted variable as domain variable or as conditioning_variable.';
% 	
% 	
% 	i = 5;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'STRUCTURE : Save';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'TBM will save the frame data as they are now in the environment folder which name was in the tooltip.';
% 	
% 	i = 6;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'STRUCTURE : Quit';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'You go back to pull-down menu level. Maybe you better save your data first.';
% 	
case 4  % Mapping buttons

	i = 1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Load mapping'; %X
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'TBM will load the strucure data previously saved in the environment folder which name was in the tooltip.'; %X
	
	i = 2;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Make a new one';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'TBM displays the list of the available frame and mapping objects.';%X
	k=k+1;text{i,k} = 'TBM build a new mapping object.';%X
	k=k+1;text{i,k} = 'You can modify all the parameters of the object.';
	k=k+1;text{i,k} = 'You will see a dialog window in General Window. Answer the queries.';
	k=k+1;text{i,k} = 'If query ends with #, you must enter a number.';
	k=k+1;text{i,k} = 'If the query ends with MENU, there is a pull-down menu attached to the field, and you get to it with Ctrl click on Mac, right click on PC.';	
	k=k+1;text{i,k} = 'You get also requests for selecting items in the displayed object lists.';
	k=k+1;text{i,k} = 'You cannot change the object number.';
	k=k+1;text{i,k} = 'To get detailed inforamtion on the various fields of the object, go to the pull-down menu Objects, Object_Help.';
	
	i = 3;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Display one';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'TBM displays the list of the available frame and mapping objects, and you select the mapping object you want to display.';%X
	k=k+1;text{i,k} = 'You can modify all the parameters of the object.';
	k=k+1;text{i,k} = 'You will see a dialog window in General Window. You may change the content of the fileds.';
	k=k+1;text{i,k} = 'If query ends with #, you must enter a number.';
	k=k+1;text{i,k} = 'If the query ends with MENU, there is a pull-down menu attached to the field, and you get to it with Ctrl click on Mac, right click on PC.';	
	k=k+1;text{i,k} = 'You get also requests for selecting items in the displayed object lists.';
	k=k+1;text{i,k} = 'You cannot change the object number.';
	k=k+1;text{i,k} = 'To get detailed inforamtion on the various fields of the object, go to the pull-down menu Objects, Object_Help.';
	
	
	i = 4;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Delete some'; %X
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'TBM displays the list of the available mapping objects, and you select the one you want to delete.';
	k=k+1;text{i,k} = 'Beware: TBM deletes the object and all those that depends on its existence. So many objects may disappear.';
	k=k+1;text{i,k} = 'The deletion operation cannot be recovered.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Will be deleted :';
	k=k+1;text{i,k} = 'The mapping object you selected.';
	k=k+1;text{i,k} = 'The structure objects using the deleted mapping.';	
	k=k+1;text{i,k} = 'The attribute objects using a deleted structure.';
	k=k+1;text{i,k} = 'The variable objects using a deleted attribute.';
	k=k+1;text{i,k} = 'The belief objects using a deleted variable as domain variable or as conditioning_variable.';
	
	
	i = 5;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Save frame';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'TBM will save the frame data as they are now in the environment folder which name was in the tooltip.';
	
	i = 6;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'quit';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'You go back to pull-down menu level. Maybe you better save your data first.';
	
% case 6  % Attribute buttons
% 
% 	i = 1;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'ATTRIBUTE : Load'; %X
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'TBM will load the attribute data previously saved in the environment folder which name was in the tooltip.'; %X
% 	
% 	i = 2;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'ATTRIBUTE : New';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'TBM displays the list of the available frame, structure and attribute objects.';%X
% 	k=k+1;text{i,k} = 'TBM build a new attribute object.';%X
% 	k=k+1;text{i,k} = 'You can modify all the parameters of the object.';
% 	k=k+1;text{i,k} = 'You will see a dialog window in General Window. Answer the queries.';
% 	k=k+1;text{i,k} = 'If query ends with #, you must enter a number.';
% 	k=k+1;text{i,k} = 'If the query ends with MENU, there is a pull-down menu attached to the field, and you get to it with Ctrl click on Mac, right click on PC.';	
% 	k=k+1;text{i,k} = 'You get also requests for selecting items in the displayed object lists.';
% 	k=k+1;text{i,k} = 'You cannot change the object number.';
% 	k=k+1;text{i,k} = 'To get detailed inforamtion on the various fields of the object, go to the pull-down menu Objects, Object_Help.';
% 	
% 	i = 3;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'ATTRIBUTE : Edit';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'TBM displays the list of the available attribute, frame and strucure objects, and you select the attribute object you want to display.';%X
% 	k=k+1;text{i,k} = 'You can modify all the parameters of the object.';
% 	k=k+1;text{i,k} = 'You will see a dialog window in General Window. You may change the content of the fileds.';
% 	k=k+1;text{i,k} = 'If query ends with #, you must enter a number.';
% 	k=k+1;text{i,k} = 'If the query ends with MENU, there is a pull-down menu attached to the field, and you get to it with Ctrl click on Mac, right click on PC.';	
% 	k=k+1;text{i,k} = 'You get also requests for selecting items in the displayed object lists.';
% 	k=k+1;text{i,k} = 'You cannot change the object number.';
% 	k=k+1;text{i,k} = 'To get detailed inforamtion on the various fields of the object, go to the pull-down menu Objects, Object_Help.';
% 	
% 	
% 	i = 4;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'ATTRIBUTE : Delete'; %X
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'TBM displays the list of the available attribute objects, and you select the one you want to delete.';
% 	k=k+1;text{i,k} = 'Beware: TBM deletes the object and all those that depends on its existence. So many objects may disappear.';
% 	k=k+1;text{i,k} = 'The deletion operation cannot be recovered.';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'Will be deleted :';
% 	k=k+1;text{i,k} = 'The attribute object you selected.';
% 	k=k+1;text{i,k} = 'The variable objects using a deleted attribute.';
% 	k=k+1;text{i,k} = 'The belief objects using a deleted variable as domain variable or as conditioning_variable.';
% 	
% 	
% 	i = 5;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'ATTRIBUTE : Save';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'TBM will save the frame data as they are now in the environment folder which name was in the tooltip.';
% 	
% 	i = 6;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'ATTRIBUTE : Quit';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'You go back to pull-down menu level. Maybe you better save your data first.';
% 	
% 	
% case 7  % Variable buttons
% 
% 	i = 1;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'VARIABLE : Load'; %X
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'TBM will load the variable data previously saved in the environment folder which name was in the tooltip.'; %X
% 	
% 	i = 2;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'VARIABLE : New';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'TBM displays the list of the available frame, attribute and variable objects.';%X
% 	k=k+1;text{i,k} = 'TBM build a new variable object.';%X
% 	k=k+1;text{i,k} = 'You can modify all the parameters of the object.';
% 	k=k+1;text{i,k} = 'You will see a dialog window in General Window. Answer the queries.';
% 	k=k+1;text{i,k} = 'If query ends with #, you must enter a number.';
% 	k=k+1;text{i,k} = 'If the query ends with MENU, there is a pull-down menu attached to the field, and you get to it with Ctrl click on Mac, right click on PC.';	
% 	k=k+1;text{i,k} = 'You get also requests for selecting items in the displayed object lists.';
% 	k=k+1;text{i,k} = 'You cannot change the object number.';
% 	k=k+1;text{i,k} = 'To get detailed inforamtion on the various fields of the object, go to the pull-down menu Objects, Object_Help.';
% 	
% 	i = 3;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'VARIABLE : All variables for all indexes';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'A varaibel is defined by its attribute whichmay have indexes.';
% 	k=k+1;text{i,k} = 'We buld one variable for each index instanciation.';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'Example: attribute object Income has 2 indexes : person on frame {Joe, Bob, Tom}, year on frame {2000, 2001, 2002, 2003, 2004}.';
% 	k=k+1;text{i,k} = 'We can thus create 3 x 5 = 15 index instanciations, thus 15 variables.';
% 	k=k+1;text{i,k} = 'The variables, which frame is K_Euro (Integers from 0 to 100000), will be:';
% 	k=k+1;text{i,k} = 'Income(person = Joe, year = 2000) on frame K_Euro';
% 	k=k+1;text{i,k} = 'Income(person = Bob, year = 2000) on frame K_Euro';
% 	k=k+1;text{i,k} = 'Income(person = Tom, year = 2000) on frame K_Euro';
% 	k=k+1;text{i,k} = 'Income(person = Joe, year = 2001) on frame K_Euro';
% 	k=k+1;text{i,k} = '...';
% 	k=k+1;text{i,k} = 'Income(person = Tom, year = 2004) on frame K_Euro';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'These names are the variable full_names';
% 	k=k+1;text{i,k} = 'You get automaticaly the 15 variables. Beware of memory overflow, thousands of variables will hardly fir.';
% 	
% 	
% 	i = 4;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'VARIABLE : Edit';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'TBM displays the list of the available variable, frame and attribute objects, and you select the strcuture object you want to display.';%X
% 	k=k+1;text{i,k} = 'You can modify all the parameters of the object.';
% 	k=k+1;text{i,k} = 'You will see a dialog window in General Window. You may change the content of the fileds.';
% 	k=k+1;text{i,k} = 'If query ends with #, you must enter a number.';
% 	k=k+1;text{i,k} = 'If the query ends with MENU, there is a pull-down menu attached to the field, and you get to it with Ctrl click on Mac, right click on PC.';	
% 	k=k+1;text{i,k} = 'You get also requests for selecting items in the displayed object lists.';
% 	k=k+1;text{i,k} = 'You cannot change the object number.';
% 	k=k+1;text{i,k} = 'To get detailed inforamtion on the various fields of the object, go to the pull-down menu Objects, Object_Help.';
% 	
% 	
% 	i = 5;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'VARIABLE : Delete'; 
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'TBM displays the list of the available variable objects, and you select the one you want to delete.';
% 	k=k+1;text{i,k} = 'Beware: TBM deletes the object and all those that depends on its existence. So many objects may disappear.';
% 	k=k+1;text{i,k} = 'The deletion operation cannot be recovered.';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'Will be deleted :';
% 	k=k+1;text{i,k} = 'The variable object you selected.';
% 	k=k+1;text{i,k} = 'The belief objects using a deleted variable as domain variable or as conditioning_variable.';
% 	
% 	
% 	i = 6;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'VARIABLE : Save';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'TBM will save the frame data as they are now in the environment folder which name was in the tooltip.';
% 	
% 	i = 7;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'VARIABLE : Quit';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'You go back to pull-down menu level. Maybe you better save your data first.';
	
	
	
case 8  % Belief buttons

	i = 1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'BELIEF : New';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'TBM build a new belief.';%X
	k=k+1;text{i,k} = 'You can modify all the parameters of the object.';
	k=k+1;text{i,k} = 'You will see a dialog window in General Window. Answer the queries.';
	k=k+1;text{i,k} = 'If query ends with #, you must enter a number.';
	k=k+1;text{i,k} = 'If the query ends with MENU, there is a pull-down menu attached to the field, and you get to it with Ctrl click on Mac, right click on PC.';	
	k=k+1;text{i,k} = 'You get also requests for selecting items in the displayed object lists.';
	k=k+1;text{i,k} = 'You cannot change the object number.';
	k=k+1;text{i,k} = 'To get detailed inforamtion on the various fields of the object, go to the pull-down menu Objects, Object_Help.';
	
	i = i + 1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'BELIEF : Edit belief';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'TBM displays the list of the available belief and variable objects, and you select the belief object you want to display.';%X
	k=k+1;text{i,k} = 'You can modify all the parameters of the object.';
	k=k+1;text{i,k} = 'You will see a dialog window in General Window. You may change the content of the fileds.';
	k=k+1;text{i,k} = 'If query ends with #, you must enter a number.';
	k=k+1;text{i,k} = 'If the query ends with MENU, there is a pull-down menu attached to the field, and you get to it with Ctrl click on Mac, right click on PC.';	
	k=k+1;text{i,k} = 'You get also requests for selecting items in the displayed object lists.';
	k=k+1;text{i,k} = 'You cannot change the object number.';
	k=k+1;text{i,k} = 'To get detailed inforamtion on the various fields of the object, go to the pull-down menu Objects, Object_Help.';
	
	i = i + 1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'BELIEF : Edit bba';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Short cut to go the bba editor. Skip queries about belief object. To be used to edit only the bba.';
	
	i = i + 1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'BELIEF : Delete'; 
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'TBM displays the list of the available belief objects, and you select the one you want to delete.';
	k=k+1;text{i,k} = 'The deletion operation cannot be recovered.';
	
	i = i + 1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'BELIEF : Duplicate -> index';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'You select one belief. TBM generates new belief objects with the same values as the selected one.';
	k=k+1;text{i,k} = 'This is done for every possible values of the index of the variables involved in the selected belief.';
	
case 9

	i=1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL NEW : BetP + LCP';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Enter BetP for every element of the frame.';
	k=k+1;text{i,k} = 'TBMLAB  finds the least committed bba which pignisitic transformation is BetP (isopignistic).';
	k=k+1;text{i,k} = 'Result is a consonant belief function.';
	
	i=i+1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL NEW : Pl-likelihoods + LCP';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Enter pl (or likelihood) for every element of the frame.';
	k=k+1;text{i,k} = 'TBMLAB  finds the least committed bba which plausibility function on the elements is pl.';
	k=k+1;text{i,k} = 'Result is a consonant belief function.';
	
	i=i+1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL NEW : .m function NA';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'You provide a m function taht generates the masses.';
	k=k+1;text{i,k} = 'You give its name here.';
	k=k+1;text{i,k} = 'Usefull for interfacing with external data bases.';
	
	i=i+1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL NEW : random masses';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'TBM generates bba where the masses are random. Usefull for testing TBM.';
	
% case 10  % Result Output Options  No more used, but text might be useful one day
% 	i = 1;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'Elements Order';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'In the Bel,BetP,Pl plot at left, elements are orederd with the largest BetP at bottom.';
% 	k=k+1;text{i,k} = 'You can ask for another oder presentation.';
% 	k=k+1;text{i,k} = 'Ordered on Pl with largest Pl at bottom.';
% 	k=k+1;text{i,k} = 'Ordered according to the order of the sets.';
% 	k=k+1;text{i,k} = 'If you select none or more than 1, you get BetP order.';
% 	
% 	i = 2;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'Max number';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'The number of displayed elements is limited based on the 3 rules based on:';
% 	k=k+1;text{i,k} = 'max_number, cumululated_BetP, and max_BetP_difference.';
% 	k=k+1;text{i,k} = 'Rule 1: minimum of number of elements and 16 (you you may change it)';
% 	k=k+1;text{i,k} = 'Rule 2: display ut to a cumulated BetP of .95 (you may change it).';
% 	k=k+1;text{i,k} = 'Rule 3: display up to the case where gap between successive BetP  ordered by values is larger than.40 (you may change it))';
% 	k=k+1;text{i,k} = 'The number displayed is the smallest number obtained from the 3 rules.';
% 	k=k+1;text{i,k} = 'Rule 2 and 3 apply only if order based on BetP.';	
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'Enter here the maximum numbers of elements to be displayed.';
% 	
% 	i = 3;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'Max number';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'The number of displayed elements is limited based on the 3 rules based on:';
% 	k=k+1;text{i,k} = 'max_number, cumululated_BetP, and max_BetP_difference.';
% 	k=k+1;text{i,k} = 'Rule 1: minimum of number of elements and 16 (you you may change it)';
% 	k=k+1;text{i,k} = 'Rule 2: display ut to a cumulated BetP of .95 (you may change it).';
% 	k=k+1;text{i,k} = 'Rule 3: display up to the case where gap between successive BetP  ordered by values is larger than.40 (you may change it))';
% 	k=k+1;text{i,k} = 'The number displayed is the smallest number obtained from the 3 rules.';
% 	k=k+1;text{i,k} = 'Rule 2 and 3 apply only if order based on BetP.';	
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'Enter here the proposrtion of BetP to be displayed.';
% 	
% 	i = 4;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'Number of displayed elements';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'The number of displayed elements is limited based on the 3 rules based on:';
% 	k=k+1;text{i,k} = 'max_number, cumululated_BetP, and max_BetP_difference.';
% 	k=k+1;text{i,k} = 'Rule 1: minimum of number of elements and 16 (you you may change it)';
% 	k=k+1;text{i,k} = 'Rule 2: display ut to a cumulated BetP of .95 (you may change it).';
% 	k=k+1;text{i,k} = 'Rule 3: display up to the case where gap between successive BetP  ordered by values is larger than.40 (you may change it))';
% 	k=k+1;text{i,k} = 'The number displayed is the smallest number obtained from the 3 rules.';
% 	k=k+1;text{i,k} = 'Rule 2 and 3 apply only if order based on BetP.';	
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'Enter here the maximum difference of BetP above which display is stopped.';
% 	
% 	i = 5;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'Number of displayed masses';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'The n umber of displayed basic belief masses is limited to the largest ones.';
% 	k=k+1;text{i,k} = 'This number tells how many should be displayed.';
% 	k=k+1;text{i,k} = 'Default is 10 (or less if there are less than 10 focval sets).';
% 	k=k+1;text{i,k} = 'To change it, enter the number you want.';
% 	
% 	i = 6;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'Impact on BetP when ''impossible'' elements are eliminated.';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'TBM iteratively eliminates elements that are ''obviously'' not the actual one';
% 	k=k+1;text{i,k} = 'TBM eliminates first all the elements which plausibility is smaller than the max BetP as they cannot become more probabale than the most probable.';
% 	k=k+1;text{i,k} = 'TBM recomputes BetP, and then eliminates the element with the smallest plausibility among those remaining.';
% 	k=k+1;text{i,k} = 'Iteration stopped when there are n left over elements and BetP(elem(2)) = BetP(elem(3)) = ... BetP(elem(n) > BetP(elem(n+1))';
% 	k=k+1;text{i,k} = 'where elem(i) are the ranked elements (ranked according to their BetP values).';
% 	k=k+1;text{i,k} = 'Usually n = 2.';
% 	k=k+1;text{i,k} = 'Elimination means conditioning on those not eliminated. The ranking based on Pl does not change during the process.';
% 	k=k+1;text{i,k} = 'The idea behind this procedure is that maybe an element that was not the most probable because of the presence of highly improbale elements could become more probable once these improbable elements are eliminated. ';
% 	k=k+1;text{i,k} = 'If it is the case, the upper left panel presents the data for that new alternative that might be the most probable one.';
% 	
% 	i = 7;k=1;
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'Impact on BetP when ''impossible'' elements are eliminated.';
% 	k=k+1;text{i,k} = ' ';
% 	k=k+1;text{i,k} = 'Elimination speed : time in second between two displays.';
% 	k=k+1;text{i,k} = 'Needed so you have time to see what is happening.';
% 	k=k+1;text{i,k} = 'A 2 second delay is a nice guess, but it depends on the used hardware.';
	
case 11 % bp see

	i = 1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL VIEW : Largest m + focal';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'You get a list of the largest bbm''s.';
	k=k+1;text{i,k} = 'The number of bbm''s to be listed can be changed in the pull-down menu Param:TBM_Param.';
	k=k+1;text{i,k} = 'Focal sets are deinfed by the list of its elements.';
	
	i = i+1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL VIEW : Bel,BetP,Pl,bba';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'A full screen window presenting:';
	k=k+1;text{i,k} = 'At lower left, a plot with the values of Bel,BetP,Pl for every element. Bel and Pl are normalized, so BetP is always in between.';
	k=k+1;text{i,k} = 'At upper left, the 2 most probable elements. You might get a third: see ''movie''.';
	k=k+1;text{i,k} = 'At middle, a list of the focal sets with their mass.';
	k=k+1;text{i,k} = 'At right, several control options by which you can chnage the parameters of the displays.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'The control options are detailled in the Explain Control option you get by clicking the Explain Control toggle button';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Movie: this is an iterated animated display of BetP, with Bel and Pl, when iteratively eliminating the least plausible elements.';
	k=k+1;text{i,k} = 'The idea is to condition the bbm by eliminating the least plausible elements in a stepwise procedure.';
	k=k+1;text{i,k} = 'The purpose is to find out if the most probable element is robust when conditioning.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'By far the most efficient way to read a belief potantial.';
	
	i = i+1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL VIEW : best supported set';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'The larger the pl, the more a set is supported. ';
	k=k+1;text{i,k} = 'but pl must be weighted by the cardinality of its set.';
	k=k+1;text{i,k} = 'Following an idea of Appriou, we compute pl(A) / (|A|^r) where r is in [0,1]';
	k=k+1;text{i,k} = 'The best supported set is the one that maximizes this criteria.';
	k=k+1;text{i,k} = 'It depends on r.';
	k=k+1;text{i,k} = 'When r = 1, the best supported set is selected among the singletons.';
	k=k+1;text{i,k} = 'When r = 0, the best supported set is the universe.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Among the set of cardinality n, we only need the one with the largest pl.';
	k=k+1;text{i,k} = 'If the cardinality of the universe is small (<=15), we search the largest pl for each n in an exhaustive way.';
	k=k+1;text{i,k} = 'If the cardinality of the universe is large (>15), we use a stepwise procedure to select the sequence of best supported sets.';
	k=k+1;text{i,k} = 'We find the best set with n elements, and then we search only among the sets with n+1 elements that contain all elements selected at the previous step.';
	
	i = i+1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL VIEW : Several forms of one potential';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Listing the values of the forms selected among {m, bel, pl, b, q, wc, wd, M, Bel, Pl, Q, BetP}';
	k=k+1;text{i,k} = 'User selects those forms to be shown.';
	k=k+1;text{i,k} = 'Display done for every subset of the frame, so beware of its cardinality.';
	k=k+1;text{i,k} = 'It refuses to work for a cardinality above 12 (thus 4096 data).';
	
case 12 % bp request

	i = 1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL : Save';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'You can save the belief objects in its binary file. Among others, this save the potential you just create. Good safety measure.';
	
	i = i+1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL : Another belief';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'List of belief objects displayed.';
	k=k+1;text{i,k} = 'Select the one you wnat to use now.';
	k=k+1;text{i,k} = 'If several potential, which potentail asked on next list.';
	
	i = i+1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL : Get next potential';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'When there are several potentials for the same belief object (because it corresponds to a set of conditional bba''s)';
	k=k+1;text{i,k} = 'hit this bujtton to get the next bp object.';
	k=k+1;text{i,k} = 'If you had reached the lext bp object, you get back to the first one.';
	k=k+1;text{i,k} = 'Convenient when you want to edit, view, etc...all the sonditional beliefs.';

	i = i+1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL : Quit';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'You leave the potential editor window and get back to the calling belief window.';
	
case 14  % Belief potential buttons New

	i = 1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL NEW : Selected m. When there are Continuous or Integers variables';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Entering a bbm by defining a focal set and giving it a mass.';
	k=k+1;text{i,k} = 'For the set, you  enter them as a list of elements.';
	k=k+1;text{i,k} = 'You get a list of every element built from the non Continuous or Integers variables of this belief.';	
	k=k+1;text{i,k} = 'Focal set defined by selecting its elements, and for each element you enter the limits of the ''rectangle'' for the continuous and intevgers variables.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'You don''t have to be exhaustive. Missing data are filled by the application of the LCP (Least Commitment Principle).';
	k=k+1;text{i,k} = 'The missing mass is allocated to the universe. ';
	
	i = i+1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL NEW : Selected m. Continuous and Integers forbidden.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Entering a bbm by defining a focal set and giving it a weight.';
	k=k+1;text{i,k} = 'The weigth can be any of m,b,bel,pl,q,wc,wd.';
	k=k+1;text{i,k} = 'For the set, you can enter them in two ways: as a list of elements, or as a logical formula.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Case list of elements. You get a list of every element of the frame of this belief.';	
	k=k+1;text{i,k} = 'Focal set defined by selecting its elements.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Case logical expressions. You create the focal sets as the set of all elements that satify a logical expression. ';
	k=k+1;text{i,k} = 'Work for any variable, logical and others. Accept the logical operators and, or, not, implies, equivalent and parentheses';
	k=k+1;text{i,k} = 'All expressions are built by mouse clicking in order to avoid mistypings.';
	k=k+1;text{i,k} = 'You will get a list of the logical operators and a list of available varibales. When needed existing elements for a selected variable are also listed.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'You don''t have to be exhaustive. Missing data are filled by the application of the LCP (Least Commitment Principle).';
	k=k+1;text{i,k} = 'The only constraint is that all weights must be of the same kind (only m, or only b, or only bel...)';
	k=k+1;text{i,k} = 'If m : missing mass allocated to the universe. ';
	k=k+1;text{i,k} = 'If b, bel, pl, q : missing values fitted by LCP.';
	k=k+1;text{i,k} = 'If wc or wd : missing weights equated to 1.';
	
	i=i+1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL NEW : logical expressions';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'You create the focal sets as the set of all elements that satify a logical expression. ';
	k=k+1;text{i,k} = 'Work for any v aribale, logical and others. Accept the logical operators and, or, not, implies, equivalent and parentheses';
	k=k+1;text{i,k} = 'All expressions are built by mouse clicking in order to avoid mistypings.';
	k=k+1;text{i,k} = 'You will get a list of the logicl operators and a list of available varibales. When needed existing elements for a selected variable are also listed.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Rules for logical epxressions.';
	k=k+1;text{i,k} = 'Term t can be:';
	k=k+1;text{i,k} = 'p                      : p is the short name of a logical variable.';
	k=k+1;text{i,k} = '(v == 3)               : v is the short name of a variable , element is a number';
	k=k+1;text{i,k} = '(v in [3 5 8])';
	k=k+1;text{i,k} = '(v in [3:9 20:45])     : ( ) forbidden inside [] and inside v in [3:9 20:45]';
	k=k+1;text{i,k} = '(v in {''C1'',''C4''}) : when elements are strings	 ';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Example of expressions, with t1,t2 terms or expresssions, with classical ( ).';
	k=k+1;text{i,k} = 't1';
	k=k+1;text{i,k} = 'not t1';
	k=k+1;text{i,k} = 't1 and t2';
	k=k+1;text{i,k} = 't1 or t2';
	k=k+1;text{i,k} = 't1 impl t2 (implication becomes not t1 or t2) at most one implic operator.';
	k=k+1;text{i,k} = 't1 equiv t2 (equivalence becomes (t1 and t2) or (not t1 and not t2)) at most one equiv operator';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'VERY easy for simple implication rules.';
	k=k+1;text{i,k} = 'You enter one line like   (p and q) impl (f or g)   and its mass, and that is all.';
	
	% 	i=i+1;k=1;
	% 	k=k+1;text{i,k} = ' ';
	% 	k=k+1;text{i,k} = 'POTENTIAL NEW : Ordered data';
	% 	k=k+1;text{i,k} = ' ';
	% 	k=k+1;text{i,k} = 'Lisitng every possible focal set and giving it a mass.';
	% 	k=k+1;text{i,k} = 'You get a list of every selement in the frame of this belief.';	
	% 	k=k+1;text{i,k} = 'Focal set are iteratively defined by TBM.';
	% 	k=k+1;text{i,k} = 'You must enter a mass for every subset.';
	% 	k=k+1;text{i,k} = 'Useful when number of non zero masses about same number as size of power set.';
	
	i=i+1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL NEW : based on pdf';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Two cases: the bba is a bayesian bba.';
	k=k+1;text{i,k} = 'Case 1: the pdf is the bba.';
	k=k+1;text{i,k} = 'Case 2: the pdf is the pignistic probability function induced by some underlying bba.';
	k=k+1;text{i,k} = 'We use as bba the Least Committed Isopignistic bba.';
	k=k+1;text{i,k} = 'Possible only with some pdf and for univariate belief domain.';
	k=k+1;text{i,k} = 'For Integers: ';
	k=k+1;text{i,k} = 'Case 1.1: domain = [0,n] and pdf is binomial(p)';
	k=k+1;text{i,k} = 'For Continous: ';
	k=k+1;text{i,k} = 'Case 2.1: domain = [0,1] and pdf = beta(a,b)';
	k=k+1;text{i,k} = 'Case 2.2: domain = [0, infinity)  and pdf = exponential(t)';
	k=k+1;text{i,k} = 'Case 2.3: domain = (-infinity, infinity)  and pdf = Gaussian(mu,sigma)';
		
case 15

	i = 1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL NEW : Selected bel';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Entering a bbm by defining a focal set and giving it a weight bel.';
	k=k+1;text{i,k} = 'For the set, you can enter them in two ways: as a list of elements, or as a logical formula.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Case list of elements. You get a list of every element of the frame of this belief.';	
	k=k+1;text{i,k} = 'Focal set defined by selecting its elements.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Case logical expressions. You create the focal sets as the set of all elements that satify a logical expression. ';
	k=k+1;text{i,k} = 'Work for any variable, logical and others. Accept the logical operators and, or, not, implies, equivalent and parentheses';
	k=k+1;text{i,k} = 'All expressions are built by mouse clicking in order to avoid mistypings.';
	k=k+1;text{i,k} = 'You will get a list of the logical operators and a list of available varibales. When needed existing elements for a selected variable are also listed.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'You don''t have to be exhaustive. Missing data are filled by the application of the LCP (Least Commitment Principle).';
	
	i =i+ 1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL NEW : Selected pl';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Entering a bbm by defining a focal set and giving it a weight pl.';
	k=k+1;text{i,k} = 'For the set, you can enter them in two ways: as a list of elements, or as a logical formula.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Case list of elements. You get a list of every element of the frame of this belief.';	
	k=k+1;text{i,k} = 'Focal set defined by selecting its elements.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Case logical expressions. You create the focal sets as the set of all elements that satify a logical expression. ';
	k=k+1;text{i,k} = 'Work for any variable, logical and others. Accept the logical operators and, or, not, implies, equivalent and parentheses';
	k=k+1;text{i,k} = 'All expressions are built by mouse clicking in order to avoid mistypings.';
	k=k+1;text{i,k} = 'You will get a list of the logical operators and a list of available varibales. When needed existing elements for a selected variable are also listed.';
	
	i =i+ 1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL NEW : Selected wc';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Entering a bbm by defining a focal set and giving it a weight wc.';
	k=k+1;text{i,k} = 'For the set, you can enter them in two ways: as a list of elements, or as a logical formula.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Case list of elements. You get a list of every element of the frame of this belief.';	
	k=k+1;text{i,k} = 'Focal set defined by selecting its elements.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Case logical expressions. You create the focal sets as the set of all elements that satify a logical expression. ';
	k=k+1;text{i,k} = 'Work for any variable, logical and others. Accept the logical operators and, or, not, implies, equivalent and parentheses';
	k=k+1;text{i,k} = 'All expressions are built by mouse clicking in order to avoid mistypings.';
	k=k+1;text{i,k} = 'You will get a list of the logical operators and a list of available varibales. When needed existing elements for a selected variable are also listed.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'You don''t have to be exhaustive. Missing data are filled by the application of the LCP (Least Commitment Principle).';
	
	i =i+ 1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL NEW : Selected wd';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Entering a bbm by defining a focal set and giving it a weight wd.';
	k=k+1;text{i,k} = 'For the set, you can enter them in two ways: as a list of elements, or as a logical formula.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Case list of elements. You get a list of every element of the frame of this belief.';	
	k=k+1;text{i,k} = 'Focal set defined by selecting its elements.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Case logical expressions. You create the focal sets as the set of all elements that satify a logical expression. ';
	k=k+1;text{i,k} = 'Work for any variable, logical and others. Accept the logical operators and, or, not, implies, equivalent and parentheses';
	k=k+1;text{i,k} = 'All expressions are built by mouse clicking in order to avoid mistypings.';
	k=k+1;text{i,k} = 'You will get a list of the logical operators and a list of available varibales. When needed existing elements for a selected variable are also listed.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'You don''t have to be exhaustive. Missing data are filled by the application of the LCP (Least Commitment Principle).';
	
case 16

	i = 1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL NEW : Selected interval valued m';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Entering a bbm by defining a focal set and giving it boudaries for a weight m.';
	k=k+1;text{i,k} = 'For the set, you can enter them in two ways: as a list of elements, or as a logical formula.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Case list of elements. You get a list of every element of the frame of this belief.';	
	k=k+1;text{i,k} = 'Focal set defined by selecting its elements.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Case logical expressions. You create the focal sets as the set of all elements that satify a logical expression. ';
	k=k+1;text{i,k} = 'Work for any variable, logical and others. Accept the logical operators and, or, not, implies, equivalent and parentheses';
	k=k+1;text{i,k} = 'All expressions are built by mouse clicking in order to avoid mistypings.';
	k=k+1;text{i,k} = 'You will get a list of the logical operators and a list of available varibales. When needed existing elements for a selected variable are also listed.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'You don''t have to be exhaustive. Missing data are filled by the application of the LCP (Least Commitment Principle).';
	k=k+1;text{i,k} = ' ';	
	
	i = i+1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL NEW : Selected interval valued bel';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Entering a bbm by defining a focal set and giving it boudaries for a weight bel.';
	k=k+1;text{i,k} = 'For the set, you can enter them in two ways: as a list of elements, or as a logical formula.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Case list of elements. You get a list of every element of the frame of this belief.';	
	k=k+1;text{i,k} = 'Focal set defined by selecting its elements.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Case logical expressions. You create the focal sets as the set of all elements that satify a logical expression. ';
	k=k+1;text{i,k} = 'Work for any variable, logical and others. Accept the logical operators and, or, not, implies, equivalent and parentheses';
	k=k+1;text{i,k} = 'All expressions are built by mouse clicking in order to avoid mistypings.';
	k=k+1;text{i,k} = 'You will get a list of the logical operators and a list of available varibales. When needed existing elements for a selected variable are also listed.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'You don''t have to be exhaustive. Missing data are filled by the application of the LCP (Least Commitment Principle).';
	k=k+1;text{i,k} = ' ';
	
	i = i+1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL NEW : Selected interval valued pl';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Entering a bbm by defining a focal set and giving it boudaries for a weight pl.';
	k=k+1;text{i,k} = 'For the set, you can enter them in two ways: as a list of elements, or as a logical formula.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Case list of elements. You get a list of every element of the frame of this belief.';	
	k=k+1;text{i,k} = 'Focal set defined by selecting its elements.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Case logical expressions. You create the focal sets as the set of all elements that satify a logical expression. ';
	k=k+1;text{i,k} = 'Work for any variable, logical and others. Accept the logical operators and, or, not, implies, equivalent and parentheses';
	k=k+1;text{i,k} = 'All expressions are built by mouse clicking in order to avoid mistypings.';
	k=k+1;text{i,k} = 'You will get a list of the logical operators and a list of available varibales. When needed existing elements for a selected variable are also listed.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'You don''t have to be exhaustive. Missing data are filled by the application of the LCP (Least Commitment Principle).';
	k=k+1;text{i,k} = ' ';
	
	i = i+1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL NEW : Selected interval valued wc';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Entering a bbm by defining a focal set and giving it boudaries for a weight wc.';
	k=k+1;text{i,k} = 'For the set, you can enter them in two ways: as a list of elements, or as a logical formula.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Case list of elements. You get a list of every element of the frame of this belief.';	
	k=k+1;text{i,k} = 'Focal set defined by selecting its elements.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Case logical expressions. You create the focal sets as the set of all elements that satify a logical expression. ';
	k=k+1;text{i,k} = 'Work for any variable, logical and others. Accept the logical operators and, or, not, implies, equivalent and parentheses';
	k=k+1;text{i,k} = 'All expressions are built by mouse clicking in order to avoid mistypings.';
	k=k+1;text{i,k} = 'You will get a list of the logical operators and a list of available varibales. When needed existing elements for a selected variable are also listed.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'You don''t have to be exhaustive. Missing data are filled by the application of the LCP (Least Commitment Principle).';
	k=k+1;text{i,k} = ' ';
	
	i = i+1;k=1;
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'POTENTIAL NEW : Selected interval valued wd';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Entering a bbm by defining a focal set and giving it boudaries for a weight wd.';
	k=k+1;text{i,k} = 'For the set, you can enter them in two ways: as a list of elements, or as a logical formula.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Case list of elements. You get a list of every element of the frame of this belief.';	
	k=k+1;text{i,k} = 'Focal set defined by selecting its elements.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'Case logical expressions. You create the focal sets as the set of all elements that satify a logical expression. ';
	k=k+1;text{i,k} = 'Work for any variable, logical and others. Accept the logical operators and, or, not, implies, equivalent and parentheses';
	k=k+1;text{i,k} = 'All expressions are built by mouse clicking in order to avoid mistypings.';
	k=k+1;text{i,k} = 'You will get a list of the logical operators and a list of available varibales. When needed existing elements for a selected variable are also listed.';
	k=k+1;text{i,k} = ' ';
	k=k+1;text{i,k} = 'You don''t have to be exhaustive. Missing data are filled by the application of the LCP (Least Commitment Principle).';
	k=k+1;text{i,k} = ' ';
	
% % % % case 17 not used anymore put in the help itself
% % % % 
% % % % 	i = 1;k=1;
% % % % 	k=k+1;text{i,k} = ' ';
% % % % 	k=k+1;text{i,k} = 'Go to EVN';
% % % % 	k=k+1;text{i,k} = ' ';
% % % % 	k=k+1;text{i,k} = 'Go to the window that displays the whole network.';
% % % % 	
% % % % 	i = i + 1;k=1;
% % % % 	k=k+1;text{i,k} = ' ';
% % % % 	k=k+1;text{i,k} = 'Load Network';
% % % % 	k=k+1;text{i,k} = ' ';
% % % % 	k=k+1;text{i,k} = 'Start from an network previously saved. You can still add new beliefs to it.';
% % % % 	
% % % % 	i = i + 1;k=1;
% % % % 	k=k+1;text{i,k} = ' ';
% % % % 	k=k+1;text{i,k} = 'Save Network';
% % % % 	k=k+1;text{i,k} = ' ';
% % % % 	k=k+1;text{i,k} = 'Save the network as it is now.';
% % % % 	
% % % % 	i = i + 1;k=1;
% % % % 	k=k+1;text{i,k} = ' ';
% % % % 	k=k+1;text{i,k} = 'Save Objects';
% % % % 	k=k+1;text{i,k} = ' ';
% % % % 	k=k+1;text{i,k} = 'All objects are saved, from frames to belief objetcs.';
% % % % 	k=k+1;text{i,k} = 'Think about using another file name, otherwise past objects are over-written.';
% % % % 	k=k+1;text{i,k} = 'EVN data themselves are not saved (use the button Save Network for ot) ';
% % % % 	
% % % % 	% % % % % 	i = i + 1;k=1;
% % % % 	% % % % % 	k=k+1;text{i,k} = ' ';
% % % % 	% % % % % 	k=k+1;text{i,k} = 'Get new bel_var';
% % % % 	% % % % % 	k=k+1;text{i,k} = ' ';
% % % % 	% % % % % 	k=k+1;text{i,k} = 'You go back to the belief and variable menu to create new ones.';
% % % % 	% % % % % 	k=k+1;text{i,k} = 'The EVN data built up to here are temporarily stored,';
% % % % 	% % % % % 	k=k+1;text{i,k} = 'so you recover them when you go back to EVN with button Go to EVN';
% % % % 	
% % % % 	i = i + 1;k=1;
% % % % 	k=k+1;text{i,k} = ' ';
% % % % 	k=k+1;text{i,k} = 'Clear EVN';
% % % % 	k=k+1;text{i,k} = ' ';
% % % % 	k=k+1;text{i,k} = 'The present EVN is cleared.'; 
% % % % 	k=k+1;text{i,k} = 'its related objects are deleted.';
% % % % 	k=k+1;text{i,k} = 'You can start a new EVN.';
% % % % 	
% % % % 	i = i + 1;k=1;
% % % % 	k=k+1;text{i,k} = ' ';
% % % % 	k=k+1;text{i,k} = 'Quit EVN session';
% % % % 	k=k+1;text{i,k} = ' ';
% % % % 	k=k+1;text{i,k} = 'You leave this graphic al session.';
% % % % 	k=k+1;text{i,k} = 'You go back to the general TBMLAB Root Window';
% % % % 	k=k+1;text{i,k} = 'No save done with this option.';
% % % % 	k=k+1;text{i,k} = 'All unsavec EVN data are lost.';
	
otherwise 
	skip_me = 1;
	text = [];
end	

if skip_me == 0
	
	% I store the number of k in text{i,k} is the first term (text{i,1}) as a string
	[nl nc] = size(text);
	for il = 1:nl
		kk = 0; kmax = 0;
		while kmax == 0 & kk < nc
			kk = kk + 1;
			if size(text{il,kk}) == [0 0]
				kmax = kk - 1;
			end
		end
		if kmax == 0
			kmax = nc;
		end
		text{il,1} = num2str(kmax);
	end

	% for ultra long panels, skipping those not need now
	if length(index_set_buttons_mem) > 1
		ii = 0;
		for i = from:to
			ii = ii + 1;
			kmax = str2num(text{i,1});
			for j = 1:kmax
				textm{ii,j} = text{i,j};
			end
		end
		% necessary as length of textm{i,:) varies with i and textm{i,:} = text{j,:} NOT ok for matlab
		clear text
		text = textm;
	end
end
