function run_menu_help
% providing a list of the menus, and when selected, 
% displaying the details of the menu action

%
%   Version : Dec 31,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global pull_down_menu top_position_for_text figure_data gui_position flags

% at left,   I list the menus for selection
% ar right   I list the help details about the selected menu, see text_menu_help

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the figure for displaying the helps for each listed menu
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_help = figure('name','List of Menus');
set(gcf,'position',gui_position(:,1))
ind_fig_left = length(figure_data) + 1;
k=0;
k=k+1;make_fig_menu(ind_fig_left,k,'File',0,'','on');
k=k+1;make_fig_menu(ind_fig_left,k,'Quit',1,'general_clb(1)','on');
menu_manager('create',ind_fig_left)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% preparing the list of menus
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

k1=0; k2=0; k3=0; k4=0; k5=0; k6=0;
for i = 1:length(pull_down_menu)
	switch pull_down_menu(i).father
	case 'File'
		k1 = k1+1; par{1}{k1} = pull_down_menu(i).label;
	case 'Edit'
		k2 = k2+1; par{2}{k2} = pull_down_menu(i).label;
	case 'View'
		k3 = k3+1; par{3}{k3} = pull_down_menu(i).label;
	case 'Tools'
		k4 = k4+1; par{4}{k4} = pull_down_menu(i).label;
	case 'Tutorials'
		k5 = k5+1; par{5}{k5} = pull_down_menu(i).label;
	case 'Help'
		k6 = k6+1; par{6}{k6} = pull_down_menu(i).label;
	end
end

start_helps = length(par{1}) + length(par{2}) + length(par{3}) + length(par{4}) + length(par{5}) +1 + 11 ;
% 11 because there are 11 empty lines

ik = 0; 
for i = 1:6
	switch i
	case 1
		title = 'FILE';
	case 2
		title = 'EDIT';	
	case 3
		title = 'VIEW';	
	case 4
		title = 'TOOLS';	
	case 5
		title = 'TUTORIALS';
	case 6
		title = 'HELP';
	end
	if i > 1
		ik=ik+1;param{ik} = ' ';
	end
	ik=ik+1;param{ik} = title;
	for j = 1:length(par{i})
		ik = ik + 1;
		param{ik} = par{i}{j};
	end
end

% param communicates just the list
handle_list = listing_existing('menu', [.01 .01 .80 .90]', hd_help,param);
set(handle_list(2),'value',[1],'max', 1,'Enable','on');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the figure for displaying the helps for each listed menu
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_fig_text = figure('name','Help on menus');
set(gcf,'position',gui_position(:,5));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the loop for displaying the helps for each listed menu
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

go_on = 1;
flags = 0;
while go_on
	
	% 	choice = text_with_n_buttons(hd_help, ...
	% 	'Select the menu for which you want to see the help text.',...
	% 	{'OK','Quit'}, [.005 .005 .99 .10]);
	
	uiwait(hd_help)
	
	select_menu = get(handle_list(2),'Value');	
	selection = param{select_menu};
	% for the helps on object I need a diff name, and add a H to every Help
	if select_menu >= start_helps
		selection = [selection,'H'];
	end

	if flags == 0	
		[text,k] = text_menu_help(selection);		
		if k == 0			
			text = {' ','No help text.'};			
		end
		figure(hd_fig_text)
		hd_help_text = display_scrolling_text(hd_fig_text,[.005 .005 .99 .99],text);	
		figure(hd_help)
	else
		go_on = 0;
	end
end

delete(hd_fig_text)
delete(hd_help)
figure_data(ind_fig_left) = [];
