function  picto_with_text(k_node,color_line,color_background) 
% drawing a pictogram with a text in the middle

% k_noxde = index in node(k_node).

% label is a SHORT text to put in the middle of picto, length depends on picto
% shape can be
%	'circle'	: forced circle, OK for 1 or 2 characters.
% 	'oval'		  
% 	'rectangle'
%	'long_hexagon'	

% position_picto is the position in pixel on the whole screen (figure) 
% of the overall object on which we can click expressed as [min x max x min y max y]'

% position is those or the rectangle tohet limits the picto
% object is the object [x,y] of gravity of the picto, so cross hair as produced by [x,y] = ginput 


%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global node scaling_coef

center = node(k_node).center;

hd_picto(1) = text(center(1),center(2),node(k_node).label,...
'HorizontalAlignment','center',...
'VerticalAlign','middle',...
'Userdata','EVN_plot',...
'Color',color_line); % label typed

text_posit = get(hd_picto(1),'Extent'); % size of typed text

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% adapting shape for text size
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% using circle for circle if small text
% finding width of xxxx which fits in one circle width height  xxxx = 22 13,  WW = 20 13
hd_picto_test = text(center(1),center(2),'xxxx',...
'HorizontalAlignment','center','VerticalAlign','middle',...
'Color',color_line);

text_posit_test = get(hd_picto_test,'Extent');
size_circle = text_posit_test(3);
delete(hd_picto_test);

if strcmp(node(k_node).shape,'oval') & text_posit(3) <= size_circle
	node(k_node).shape = 'circle';
end


% text_posit([2 4]) = scaling_coef*text_posit([2 4]);



% using diamond for long_hexagon if small text
% NA first build diamond

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% shape have been adapted to text sizes
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% rescaling text_posit
% the text satys in original scale, not affected by zoom.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% drawing the shape using patch and finding position_picto_axes 
% = the external frame that contains the shape, used for finding which object is pointed
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

switch node(k_node).shape

case 'circle' 
	
	radius = scaling_coef*text_posit(4); % = 13 with Mac when scaling_coef = 1
	f = arc_circle(center,radius);
	% scaling x y according to zoom scale
	
	hd_picto(2) = patch(f(1,:),f(2,:),color_background,'Userdata','EVN_plot');
	position_picto_axes = [center(1)-radius center(1)+radius center(2)-radius center(2)+radius]';
	radius = radius/scaling_coef;
	position_picto_axes_init_sc = [center(1)-radius center(1)+radius center(2)-radius center(2)+radius]';
	
case 'oval' 

	% build on initial scales
	sh_down = .000;
	sh_up =  2*( center(2) - text_posit(2)) - text_posit(4);
	radius = (text_posit(4) + sh_up + sh_down)/2;
	
	f1 = arc_circle([text_posit(1)+text_posit(3) text_posit(2)+(sh_up+sh_down+text_posit(4))/2],...
	radius,[-90 90]);
	f2 = arc_circle([text_posit(1) text_posit(2)+(sh_up+sh_down+text_posit(4))/2],...
	radius,[90 270]);
	
	x = [text_posit(1) text_posit(1)+text_posit(3) f1(1,:) text_posit(1) f2(1,:)];
	y = [text_posit(2)-sh_down   text_posit(2)-sh_down   f1(2,:)  text_posit(2)+text_posit(4)+sh_up f2(2,:)];
	
	% rescaling values for zoom
	position_picto_axes = [center(1)+(text_posit(1)-radius-center(1))*scaling_coef ...
    center(1)+(text_posit(1)+text_posit(3)+radius-center(1))*scaling_coef ...
	center(2)+(text_posit(2)-sh_down-center(2))*scaling_coef ...
	center(2)+(text_posit(2)+text_posit(4)+sh_up-center(2))*scaling_coef]' ;
	
	position_picto_axes_init_sc = [text_posit(1)-radius ...
    text_posit(1)+text_posit(3)+radius ...
	text_posit(2)-sh_down ...
	text_posit(2)+text_posit(4)+sh_up]' ;
	
	x = center(1) + (x-center(1))*scaling_coef;
	y = center(2) + (y-center(2))*scaling_coef;
	
	hd_picto(2) = patch(x,y,color_background,'Userdata','EVN_plot');	
	
case 'rectangle' 

	% build on initial scales
	sh_down = .000;
	sh_up =  2*( center(2) - text_posit(2)) - text_posit(4);
	
	x = [text_posit(1) text_posit(1)+text_posit(3)  text_posit(1)+text_posit(3)  text_posit(1) text_posit(1)];
	y = [text_posit(2)-sh_down   text_posit(2)-sh_down  text_posit(2)+text_posit(4)+sh_up...
	text_posit(2)+text_posit(4)+sh_up text_posit(2)-sh_down];
	
	% rescaling values for zoom
	position_picto_axes = [center(1)+(text_posit(1)-center(1))*scaling_coef ...
    center(1)+(text_posit(1)+text_posit(3)-center(1))*scaling_coef ...
	center(2)+(text_posit(2)-sh_down-center(2))*scaling_coef ...
	center(2)+(text_posit(2)+text_posit(4)+sh_up-center(2))*scaling_coef]' ;
	
	position_picto_axe_init_sc = [text_posit(1) ...
    text_posit(1)+text_posit(3) ...
	text_posit(2)-sh_down ...
	text_posit(2)+text_posit(4)+sh_up]' ;
	
	x = center(1) + (x-center(1))*scaling_coef;
	y = center(2) + (y-center(2))*scaling_coef;
	
	hd_picto(2) = patch(x,y,color_background,'Userdata','EVN_plot');
	
case 'long_hexagon'

	% build on initial scales
	sh_down = .000;
	sh_up =  2*( center(2) - text_posit(2)) - text_posit(4);
	sh_rect = (text_posit(4) + sh_up + sh_down)/4;
	
	x = [text_posit(1) text_posit(1)+text_posit(3)   text_posit(1)+text_posit(3)+sh_rect ...
	text_posit(1)+text_posit(3)  text_posit(1) text_posit(1)-sh_rect text_posit(1)];
	
	sh_rect2 = 2*sh_rect;
	
	y = [text_posit(2)-sh_down   text_posit(2)-sh_down  text_posit(2)+sh_rect2    ...  
	text_posit(2)+text_posit(4)+sh_up   text_posit(2)+text_posit(4)+sh_up  text_posit(2)+sh_rect2 ...
	text_posit(2)-sh_down];
	
	% rescaling values for zoom
	position_picto_axes = [center(1)+(text_posit(1)-sh_rect-center(1))*scaling_coef ...
    center(1)+(text_posit(1)+text_posit(3)+sh_rect-center(1))*scaling_coef ...
	center(2)+(text_posit(2)-sh_down-center(2))*scaling_coef ...
	center(2)+(text_posit(2)+text_posit(4)+sh_up-center(2))*scaling_coef]' ;
	
	position_picto_axes_init_sc = [text_posit(1)-sh_rect ...
    text_posit(1)+text_posit(3)+sh_rect ...
	text_posit(2)-sh_down ...
	text_posit(2)+text_posit(4)+sh_up]' ;
		
	x = center(1) + (x-center(1))*scaling_coef;
	y = center(2) + (y-center(2))*scaling_coef;
	
	hd_picto(2) = patch(x,y,color_background,'Userdata','EVN_plot');
	
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% all shapes have been drawn
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

delete(hd_picto(1)) % done so text is in front of background color
hd_picto(1) = text(center(1),center(2),node(k_node).label,...
'HorizontalAlignment','center','VerticalAlign','middle','Userdata','EVN_plot',...
'Color',color_line);

node(k_node).hd_picto = hd_picto; % the handle vector 1 for text, 2 for shape 
node(k_node).localization = position_picto_axes; % the localization of its exteranl frame on now zoom
% [x_min x_max y_min y_max]
node(k_node).localization_init_sc = position_picto_axes_init_sc; % on the initial scale, needed for full redraw of tree
