function spread_nodes(num_nod)
% nice repartition of nodes on screen

% node(kn).number = nbr;				% its number
% node(kn).label = expr; 				% variable().short_name or belief().short_name
% node(kn).children = my_children;	% if var: number of (belief) nodes where condit refers to me 
% % if bel: the number of the node representing a var used in my domain
% node(kn).parents = my_parents;		% if var: number of (belief) nodes where domain refers to me 
% % if bel: the number of the node representing a var used in my condit
% node(kn).center = pos;				% position of its center (x,y) in pixel
% node(kn).center_initial = pos;		% position in initial plot, used for going back to initial plot
% node(kn).nature = 'variable';		% either variable or belief
% node(kn).shape = 'oval';			% shape of left riught end, oval (variable) long_hexagon (belief)
% node(kn).obj_num = num_var; 		% the number of the variable / belief I represent
% node(kn).link = [];					% the links numbers that leaves from this node
% node(kn).betp_localization = [bel_ind,ind_bp,ind_form_betp,bel_num ];
% node(kn).hd_menu = 					% the node handle
% node(kn).hd_picto
% node(kn).center
% node(kn).figure_localization
% node(kn).localization_init_sc 
% 
% link(lk).number = nlk;		% link number
% link(ik).nodes = list;		% list of node numbers to which this link attached
% link(ik).tip = 1;			% arrow or 1
% link(ik).hd_line = ...; 	% its handle
%
%   Version :Apr 24,03
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global node link
global pin_node pin_link pin_histo

ind_nod = pin_manipulation('node','num2ind',num_nod);

nbr_nodes = length(ind_nod);
if nbr_nodes == 0
	hdw = warndlg('There are no nodes to build an EVN. I skip.')
	uiwait(hdw)
	return % idiot call, no node!!!
end

% the matrix with the centers of each node xy_mat(i,k), i = x, y, k = node
xy_mat_new = reshape([node(ind_nod).center],2,nbr_nodes); 

% the matrix lk_mat(i,j) i,j = 1... nbr_node, = 1 if there is link between i and j, else 0
lk_mat = zeros(nbr_nodes);
set_of_links = unique([node(ind_nod).link]);
all_links_ind = pin_manipulation('link','num2ind',set_of_links);

for i = 1:length(set_of_links)
	ind_nod_lk = pin_manipulation('node','num2ind',link(set_of_links(i)).nodes);
	j = find(ind_nod == ind_nod_lk(1));
	k = find(ind_nod == ind_nod_lk(2));
	lk_mat(j,k) = 1;
	lk_mat(k,j) = 1;
	% [i set_of_links(i) ind_nod_lk j k];
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the loop where we measure distances and move, apply mode and redraw whole plot
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% parameter, to be re-built as window request
%
repul_dist = 200; % above it repulsion = 0, and link attraction is constant
attrac_dist = 50; % below it, link attract = 0
pow_attrac = 2; % relative importance of link attraction versus repulsion
temp = 5 ; % how many pixel at each iteration
nbr_iter = 50; % nbr iteration between oberving reult
%
% it means for one pair linked node = 110, unlinked node = 200
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


go_on = 1;
while go_on	
	xy_mat_mem = xy_mat_new;
	for irep = 1:nbr_iter
		% the matrix with the centers of each node xy_mat(i,k), i = x, y, k = node
		xy_mat = xy_mat_new;
		for i_node = 1:nbr_nodes			
			diff = [xy_mat - xy_mat(:,i_node)*ones(1,nbr_nodes)]; % vector from me to other  
			dist = sqrt(sum(diff.^2)) + .0000000000001;  % an epsilon to avoid null dist
			
			% repulsion between nodes
			cf = max(0,(1 - dist/repul_dist))./dist; % between 1 and 0, data too far (dist > k_dist, non active)
			cf(i_node) = 0; % node does not act on itself
			%  			dir_repul = sum( [diff./[[1;1]*dist]] .* [[1;1]*cf],2);			
			dir_repul = sum( diff.* [[1;1]*cf]  ,2);	
			dir_repul = dir_repul / sqrt(dir_repul'*dir_repul);
			
			% attraction between linked node (stretching the string)
			%%%%%%  			cst = lk_mat(i_node,:) .* min(1,max(0,(dist - attrac_dist))/(repul_dist - attrac_dist))  ;
			
			cst = zeros(1,nbr_nodes);
			indc = find(lk_mat(i_node,:));
			cst(indc) = min(1,max(0,(dist(indc) - attrac_dist))/(repul_dist - attrac_dist))  ;
			dir_attrac = sum( [diff(:,indc)] .* [[1;1]*cst(indc)],2);
			dir_attrac = dir_attrac / (sqrt(dir_attrac'*dir_attrac) + .0000000000001);
			
			% 			v_move = temp *(dir_repul - pow_attrac*dir_attrac);
			xy_mat_new(:,i_node) = [xy_mat(:,i_node) - temp *(dir_repul - pow_attrac*dir_attrac) ];
			
			% 			node(ind_nod(i_node)).center = [xy_mat(:,i_node) - v_move]';
		end
	end

	% redraw whole plot
	delete(node(ind_nod).hd_menu);
	delete(node(ind_nod).hd_picto);
	delete(link(all_links_ind).hd_line);
	for i_node = 1:nbr_nodes
		node(ind_nod(i_node)).center = xy_mat_new(:,i_node)';
	end

	draw_network(gcf,gca);
	
	choice = text_with_n_buttons(gcf, 'What do you want ?', {'Again','Previous','Enough'}, [1]);	
	switch choice 
	case 2 
		for i_node = 1:nbr_nodes
			node(ind_nod(i_node)).center = xy_mat_mem(:,i_node)';
		end
		% clean the previous network 
		delete(node(ind_nod).hd_menu);
		delete(node(ind_nod).hd_picto);
		delete(link(all_links_ind).hd_line);
		draw_network(gcf,gca);
		go_on = 0;
	case 3
		go_on = 0;
	end
end	% while go_on
