function run_plot_network
% the root of the VBS graphical mehtod
% now, only for the non directed case

%
%   Version : Dec 10,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute  pin_variable 
global pin_mapping pin_belief 
global root_file_name save_path file_name_begin
global flags flagstr gui_position figure_data  help_label   help_level
global node pin_node link pin_link histo pin_histo  
global need_uiresume scaling_coef
global EVN_New_Object_flag     option_EVN_Control
global pull_down_menu    hd_help_menu   pathname2TBMLABvers

global EVN_figure_exists   % useless now ???


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% I build the EVN figure, so now I have it 
% I kill useless menus and I made it not visible
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if ~EVN_figure_exists
	
	
	[hd_fig_EVN,hd_axes,hd_menu] = preparing_networks_figure('EVN');
	which_menu_EVN('Initialization')
	ind_fig_EVN = length(figure_data); % the index of the EVN Window
	
	EVN_figure_exists = 1;	% a figure window has been created, empty of course
	
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the loop into which we stay until you ask to quit EVN session
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if isempty(option_EVN_Control)
	option_EVN_Control = 'brand_new_EVN';
end

go_on = 1;
while go_on
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% Go to EVN
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% verifying I am not in case with beliefs and no variables
	if length(belief) 
		if length(variable) == 0
			hdw  = warndlg('There are beliefs, but no variables. Load its variables.');
			uiwait(hdw);
			% message and exit, get first my variables
			go_on = 0; % I quit
			out_option = 'Quit EVN';
		end
	end
	if go_on 			
		% EVN_New_Object_flag 
		% how do I know that you have built new objects and that a EVN is waiting						
		%	= 1 for new object asked wtihin an EVN uder construction
		%	= 0 if new EVN
		
		% option_EVN_Control = 
		% 	'brand_new_EVN'		I just build a new EVN from scratch
		% 	'loaded EVN'		I have loaded past data
		%	'bel_var changed'	I have asked for new bel and var objects
		
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		out_option = plot_network(hd_fig_EVN,hd_axes,hd_menu); % the real plotting
		% 		
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%%%%%%%%%%%%%%%%%%%                                     %%%%%%%%%%%%%%%%%%%%
		%%%%%%%%%%%%%%%%%%% This is where I came back from plot %%%%%%%%%%%%%%%%%%%%
		%%%%%%%%%%%%%%%%%%%                                     %%%%%%%%%%%%%%%%%%%%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		% I can come back because I select quit, load and saves, clear...
		
		EVN_New_Object_flag = 0;% I memorize it thru the global, but as not yet done still 0
		option_EVN_Control = 'just_in_out';
	end

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	switch out_option
	
	case 'Load EVN' 
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% load network: use node().localization = node().localization_init_sc, plot
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
		
		which_menu_EVN('Initialization');
		pin_node = [];pin_link = [];pin_histo = [];
		node = [];link = [];histo = [];
		
		% find the set of files storing an EVN in order to select the one you want
		out = handling_files('open');	
		
		if out{1} % thus load OK
			option_EVN_Control = 'loaded EVN'; % I have loaded past data with their pin (node, link, histo)
			skipme = 0;
		else
			option_EVN_Control = 'brand_new_EVN';
			skipme = 1; % I canceled uigetfile 
		end	
	
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% verifying loaded data are OK
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
		skip_it = 0;
		if skipme == 0
			if length(node) == 0
				% the file with loaded data was empty, absurd, I skip 
				text = 'The loaded file is empty. Nothing loaded';
				choice = text_with_n_buttons(gcf,text,{'OK'}, [1]);
				skip_it = 1;
			else	
				% I check you have loaded the objects used by the nodes
				exist_it = 1;
				for i = 1:size(pin_node,1)
					node_ind = pin_node(i,2);			
					switch node(node_ind).nature 
					case 'belief'
						if ~ismember(node(node_ind).obj_num,[belief(:).number]); 
							% it does not exists
							exist_it = 0;
						end
					case 'variable'
						if ~ismember(node(node_ind).obj_num,[variable(:).number]); 
							% it does not exists
							exist_it = 0;
						end
					end
				end
				if exist_it == 0
					% you broke something, it is stupid, I close everything in the EVN window, 
					% and all nodes/+links too.
					text = 'Loaded file corrupted. Some objects (belief and/or variable) are missing. Nothing loaded.';
					choice = text_with_n_buttons(gcf,text,{'OK'}, [1]);
					skip_it = 1;
				end			
			end
			if skip_it 	
				node = [];         link = [];         histo = [];
				pin_node = [0 0 0];pin_link = [0 0 0];pin_histo = [0 0 0];	
			else
				% I look if histo exists
				if length(histo)				
					which_menu_EVN('loaded EVN no histo');
				else
					which_menu_EVN('loaded EVN with histo');
				end					
			end	
		end
	
	case 'Save EVN'
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% save network after packing
		% I must also save belief as I add values to it
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%		
		
		% ask if belief must be saved
		choice = text_with_n_buttons(gcf,'Do you want also to save belief object?', {'Yes','No','Cancel'},[0 0 0 0]);
		
		% saving objects
		if choice == 1
			% manip_data_files('save','belief');	
			out = handling_files('save_obj');		
		end
	
		% saving EVN
		if choice <= 2
			% pack the nodes to avoid empty nodes
			k = 0;
			for i = 1:length(node)
				if ~isempty(node(i).number)
					k = k + 1;
					node(k) = node(i);
				end
			end
			for i = 1:length(node)
				node(i).localization = node(i).localization_init_sc;
			end	
			out = handling_files('save_EVN');
			option_EVN_Control = 'just_in_out'; % I just came out of EVN (for saving data) and go back			
		end
	
	case 'Save Objects'
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% save all objects as per now
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		% 		text = ['Data in the file will be overwritten',...
		% 		'A good strategy is: 1) save your initial objects in a first file. ',...
		% 		'2) save objects after running EVN under a new name, ',...
		% 		' So you can recover the original data if necessary.'];
		% 		choice = text_with_n_buttons(gcf, text, {'Confirm','Cancel'}, [0,0]);
		% 		if choice == 1		
		% 			% useless = manip_data_files('save','all');
		out = handling_files('save_obj')
		% 		end
		option_EVN_Control = 'just_in_out'; % I just came out of EVN (for savionf data) and go back		
		
	case 'Clear EVN'
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% as quit but I keep the EVN window
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
		text = ['EVN data are goind to be cleared. If not yet saved, they will be lost. Confirm.'];
		choice = text_with_n_buttons(gcf, text, {'Confirm','Cancel'}, [0,0]);
		if choice == 1				
			node = [];          link = [];          histo = [];
			pin_node = [0 0 0]; pin_link = [0 0 0]; pin_histo = [0 0 0];	
			clear_global_vbs;
			option_EVN_Control = 'brand_new_EVN'; % I can build a new EVN from scratch			
			EVN_Contro_mem = [];
			
			delete(findobj('userdata','betp_plot'))		
			delete(findobj('userdata','EVN_plot'))
			which_menu_EVN('Initialization');
		end
	
	case  'Quit EVN'
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% quit this whole session completely
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
		text = ['EVN data are goind to be cleared. If not yet saved, they will be lost. Confirm.'];
		choice = text_with_n_buttons(gcf, text, {'Confirm','Cancel'}, [0,0]);
		if choice == 1							
			go_on = 0; % this ends the buttons and EVN, I'll be back to general menus.
			
			% i clear the nodes and links and histoand computed VBS objects
			node = [];         link = [];         histo = [];
			pin_node = [0 0 0];pin_link = [0 0 0];pin_histo = [0 0 0];	
			clear_global_vbs;
			option_EVN_Control = []; % empty so later if I come back, it is indeed empty as first time I came in
			EVN_figure_exists = 0;			
			EVN_New_Object_flag = 0;
		end
	end

end % while go_on

% I close the EVN window
figure_data(ind_fig_EVN) = [];

% delete also the pull_down_menu(ind).fig_parent = 'EVN figure';
indmem = [];
for ind = 1:length(pull_down_menu)
	if strcmp(pull_down_menu(ind).fig_parent,'EVN figure')
		indmem = [indmem ind];
	end
end
pull_down_menu(indmem)= [];

delete(hd_fig_EVN); % the EVN is deleted
