function run_reset_param(option)
% user wants to change some GUI parameters

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global CallBackData  CallBackCell MenuData
global max_pc_cumul_mass bbm_display_order max_nbr_bel_create_attXindex
global width_long_text_help_window  width_demo_text  screen_size
global max_card_fmt
global Which_Courier

global my_font
% my_font.text.name = 
% my_font.text.size = 
% my_font.front_page.name = 
% my_font.front_page.size = 
% my_font.title.name = 
% my_font.title.size = 

switch option

case 1 % we change GUI paramaters
	clear queries_in default_answer
	title = {'Changing some GUI parameters'};
	queries_in{1} = 'The Character Size #';
	queries_in{2} = 'The Background Color in RBG';
	queries_in{3} = 'The Font Name';
	queries_in{4} = 'The width of the long text Root Window in Root Window #';
	
	default_answer{1} = get(0,'DefaultuicontrolFontSize');
	default_answer{2} = strcat('[',num2str(get(0,'DefaultFigureColor')),']');
	default_answer{3} = get(0,'DefaultuicontrolFontName');
	default_answer{4} = num2str(width_long_text_help_window);
	
	MenuData = [];
	MenuData(1).number = 2;
	j=0;
	j=j+1;MenuData(1).label{j} = 'grey';
	% the label to be shown
	MenuData(1).clb{j}   = 'clb_param(1,1);'; 
	% the callback function like 'fct 4' (4 is option '4'), not used
	% anymore since dialogquerry has been adapted for MacOSX
	j=j+1;MenuData(1).label{j} = 'yellow'; 
	MenuData(1).clb{j}   = 'clb_param(1,2);';
	j=j+1;MenuData(1).label{j} = 'magenta';
	MenuData(1).clb{j}   = 'clb_param(1,3);';
	j=j+1;MenuData(1).label{j} = 'cyan';
	MenuData(1).clb{j}   = 'clb_param(1,4);';
	j=j+1;MenuData(1).label{j} = 'green';
	MenuData(1).clb{j}   = 'clb_param(1,5);';
	j=j+1;MenuData(1).label{j} = 'blue';
	MenuData(1).clb{j}   = 'clb_param(1,6);';
	j=j+1;MenuData(1).label{j} = 'white'; 
	MenuData(1).clb{j}   = 'clb_param(1,7);';
	% 	j=j+1;MenuData(1).label{j} = 'Type RGB values';
	% 	MenuData(1).clb{j}   = 'clb_param(1,8);';
	
	MenuData(2).number = 3;
	j=0;
	j=j+1;MenuData(2).label{j} = Which_Courier;
	MenuData(2).clb{j}   = 'clb_param(2,1);'; 
	j=j+1;MenuData(2).label{j} = 'FixedWidth';
	MenuData(2).clb{j}   = 'clb_param(2,2);'; 
	j=j+1;MenuData(2).label{j} = 'Times New Roman';
	MenuData(2).clb{j}   = 'clb_param(2,3);'; 
	j=j+1;MenuData(2).label{j} = 'Helvetica';
	MenuData(2).clb{j}   = 'clb_param(2,4);'; 
	
	
	% explaining the actions
	text_action = {...
	'The Character Size : the size of the font used by default in all text. Too big, it will overflow buttons,...',...
	' ','The Background Color : select a color for all backgrounds.',...
	' ','The Font Name : you can select another font. Which_Courier and FixedWidth make text clearer as packing by Matlab is not always perfect.',...
	' ','The width of the long text Root Window in Root Window : for button attached helps, the width of the window with help text can be changed. Data must be a decimal between .2 and .95',...
	};
	
	% 	' ','Width Demo Text : look at window with demos text. Width can be changed. Must be between 400 and 1200'...
	
	gcf_mem = gcf;
	[useless, hd_fig] = handling_all_figures('put_in_front',{'Root Window'});	
	handle_text = display_scrolling_text(hd_fig(1), [.005 .005 .99 .99], text_action);	
	
	[useless, hd_fig] = handling_all_figures('put_in_front',{'General Window'});	
	
	[answer,choice] = dialog_queries(hd_fig,title,queries_in,...
	default_answer,[0 0],MenuData,2,[],[],[],[]);
	
	delete(handle_text)
	
	if choice == 1
		set(0,...
		'DefaultuicontrolFontName',answer{3},...
		'DefaultuicontrolFontSize',str2num(answer{1}))
		
		my_font.text.name = answer{3};
		my_font.text.size = str2num(answer{1});
		my_font.title.name = answer{3};
		my_font.title.size = str2num(answer{1});
		
		hfig = findobj('parent',0);
		% all the TBM figures, 
		hobj = findobj('type','uicontrol'); 
		% all the TBM objects but I don't want to affect those for in lower left for the wondows closing
		nhd1 = findobj('userdata','button_get_window_back');
		nhd2 = findobj('userdata','button_close_all_figures');
		hobj = setdiff([hobj]',[nhd1', nhd2']);
		hfig = setdiff([hfig]',[nhd1', nhd2']);
		
		% you can input [.8 .5 .2] or 'white'
		
		col = str2num(answer{2});
		if length(col) ~= 3
			col = answer{2};
		end
	
		if strcmp(answer{2},'grey') % the grey case
			set(hfig,'Color',[.8 .8 .8]);	
			set(hobj,'BackgroundColor',[.8 .8 .8]);	
			set(0,'DefaultuicontrolBackgroundColor',[.8 .8 .8],...
			'DefaultFigureColor',[.8 .8 .8]);
		else
			set(hfig,'Color',col);	
			set(hobj,'BackgroundColor',col);	
			set(0,'DefaultuicontrolBackgroundColor',col,...
			'DefaultFigureColor',col);
		end
	
		width_long_text_help_window = str2num(answer{4});
		% 		width_demo_text = min(floor(.95*screen_size(3)), str2num(answer{5}));
		
	end
	figure(gcf_mem)
	
case 2 % some TBM specific parameters
	clear queries_in default_answer
	title = {'Changing some TBMLAB parameters'};
	queries_in{1} = 'Percent of cumumated normalized masses to be displayed #';
	queries_in{2} = 'Masses ordered : by magnitude or as input';
	queries_in{3} = 'Max number of belief TBMLAB can create for attribute x index';
	queries_in{4} = 'Max number of elements accepted for running a FMT. If Memory Overflow, reduce it.';
	
	default_answer{1} = num2str(max_pc_cumul_mass);
	default_answer{2} = bbm_display_order;
	default_answer{3} = num2str(max_nbr_bel_create_attXindex);
	default_answer{4} = num2str(max_card_fmt);
	
	MenuData = [];
	MenuData(1).number = 2;
	j=0;
	j=j+1;MenuData(1).label{j} = 'by magnitude';
	MenuData(1).clb{j}   = 'clb_param(1,1);'; 
	j=j+1;MenuData(1).label{j} = 'as input';
	MenuData(1).clb{j}   = 'clb_param(1,2);'; 
	
	text_action = {...
	'Percent of cumumated normalized masses to be displayed : for results display, TBMLAB limits the number of dsiplayed elements.',... 
	' ','Masses ordered : by magnitude or as input : in masses display, their order is either as entrered, or by deceasing magnitude.',...
	' ','Max numbers of belief TBM can create for attribute x index : when TBM uses automated belief creation for indexed variables, the number can become too large,',...
	'creating memory overflow. This number proctects user aagainst such an event, but of course you don''t get the asked belief objects',...
	' ','To run FMT, TBMLAB builds a vector which length = pow2(cardinal). With cardinal = 20, you get Memory Overflow. With 18, it works? If still too large, reduce it.'};
	
	gcf_mem = gcf;
	[useless, hd_fig] = handling_all_figures('put_in_front',{'Root Window'});	
	handle_text = display_scrolling_text(hd_fig(1), [.005 .005 .99 .99], text_action);	
	[useless, hd_fig] = handling_all_figures('put_in_front',{'General Window'});		
	[answer,choice] = dialog_queries(hd_fig,title,queries_in,default_answer,[0 0],MenuData,2,[],[],[],[]);
	
	clear MenuData
	if choice == 1
		max_pc_cumul_mass = str2num(answer{1});	
		bbm_display_order = answer{2};
		max_nbr_bel_create_attXindex = str2num(answer{3});
		max_card_fmt = str2num(answer{4});
	end
	delete(handle_text)
	figure(gcf_mem)	
end
