function specialization_tabulator
% a display of the specialization matrices 
% exaplininf conj combination
% no normalization anywhere

%
%   Version : May 1, 2003.
%   Copyright (c) 2003 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global flag help_level
global Which_Courier

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% building the various matrices XfrY, some do not exist
% forms = m b q bel pl , never normalized
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

card = 3;
nr = pow2(card);

sp = zeros(nr);
sp(1,1) = 1;
nbr = [1 2 2 4 2 4 4 8];
pos{1} = [1];
pos{2} = [1 2];
pos{3} = [1 3];
pos{4} = [1 2 3 4];
pos{5} = [1 5];
pos{6} = [1 2 5 6];
pos{7} = [1 3 5 7];
pos{8} = [1:8];

for i = 2:8
	vect = fix(100*sort([rand(nbr(i)-1,1);1]))/100;
	vect = [vect(1); diff(vect)];
	sp(pos{i},i) = vect;
end

% dempsterian matrix
k = 0;
k=k+1;ad{k} = [1:8];
k=k+1;ad{k} = [1 3 5 7 ; 2 4 6 8];
k=k+1;ad{k} = [1 2 5 6 ; 3 4 7 8];
k=k+1;ad{k} = [1 5;2 6; 3 7; 4 8];
k=k+1;ad{k} = [1 2 3 4;5 6 7 8];
k=k+1;ad{k} = [1 3 ; 2 4 ; 5 7 ; 6 8];
k=k+1;ad{k} = [1 2 ; 3 4 ; 5 6 ; 7 8];
vect = fix(100*sort([rand(nbr(i)-1,1);1]))/100;
vect = [vect(1); diff(vect)];

go_on_sp = 1;
while go_on_sp
	dsp = [zeros(nr,nr-1) vect];
	dsp(pos{1},1) = [sum(vect(ad{1}(1,:)))];
	dsp(pos{2},2) = [sum(vect(ad{2}(1,:))) ; sum(vect(ad{2}(2,:)))];
	dsp(pos{3},3) = [sum(vect(ad{3}(1,:))) ; sum(vect(ad{3}(2,:)))];
	dsp(pos{4},4) = [sum(vect(ad{4}(1,:))) ; sum(vect(ad{4}(2,:))) ; sum(vect(ad{4}(3,:))) ; sum(vect(ad{4}(4,:)))];
	dsp(pos{5},5) = [sum(vect(ad{5}(1,:))) ; sum(vect(ad{5}(2,:)))];
	dsp(pos{6},6) = [sum(vect(ad{6}(1,:))) ; sum(vect(ad{6}(2,:))) ; sum(vect(ad{6}(3,:))) ; sum(vect(ad{6}(4,:)))];
	dsp(pos{7},7) = [sum(vect(ad{7}(1,:))) ; sum(vect(ad{7}(2,:))) ; sum(vect(ad{7}(3,:))) ; sum(vect(ad{7}(4,:)))];
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% opening the figure in tabulator
	% one option = 6 basic table (M B Q)
	% the other 8 with Bel,Pl
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	title = 'Specialization matrices and Dempsterian specialization matrices.';
	text_comment = {['A specialization matrix S = [s(A,B)], A,B subsets of W (the universe), is a non negative matrix pow2(cardinal) x pow2(cardinal)',...
	' where element s(A,B) = 0 if A is not a subset of B',...
	' and sum{s(A,B) : A} = 1.',...
	' A Dempsterian specialization matrix derived from the bba m on W, denoted D(m) = [d(A,B)] is a specialization matrix where the elements of column B are',...
	' equal to the result of conditioning the bba m on B.',...
	' Let m1 and m2 be two bba''s, and the bba m12 be the conjunctive combination of m1 and m2.',...
	' Then m12 = D(m1)*m2 = D(m2)*m1.',...
	' With specialization, masses ''flow down''. Its dual concept where mass ''flow up'' is called a generalization, but is not as usefull, so we skip it.']};
	
	dim_table = ones(2,1)*[8 8 3 7 5];
	
	switch computer
	case 'MAC2'
		h1 = 200; l1 = 50; ltab = 400;
	case 'PCWIN'
		h1 = 200; l1 = 10; ltab = 480;
	otherwise
		h1 = 200; l1 = 10; ltab = 480;
	end

	LLposition = [l1 h1; 2*l1+ltab h1];
	
	for i = 1:2
		heavy_lines(i).hori{1} = [2];
		heavy_lines(i).vert{1} = [2];
	end

	title_table = {'A specialization matrix Sp','A Dempsterian specialization matrix D'};
	comment_table = {'Let m2 = Sp*m1, then b2 >= b1 and q2<= q1. Specilaization increases information content of the bba''s',...
	'You can change a bba m in the abc column (the right most one), and get its induced Dempsterian specialization matrix D(m). When data entered, select menu New bba.'};
	
	% dim_table = for each table = nrow, ncol, option_borders, nbr_char_width, nbr_char_left_col
	
	[hd_one_panel,hd_title,hd_text] = tabulator(title,text_comment,dim_table,...
	LLposition,heavy_lines,title_table,comment_table);
	
	line_label = {'{}','a','b','ab','c','ac','bc','abc'};
	for i_tab = 1:2
		for j = 1:8
			set(hd_one_panel{i_tab}(j,9),'string',line_label{j},'horizontalalignment','center');
			set(hd_one_panel{i_tab}(9,j),'string',line_label{j},'horizontalalignment','center');
		end	
	end

	for i_tab = 1:2
		switch i_tab
		case 1		
			mat = sp;
		case 2		
			mat = dsp;
		end	
		for i = 1:8
			for j = 1:8
				if mat(i,j) == 0
					tx = '    ';
				else
					tx = sprintf(' %5.3f ',mat(i,j));
				end
				set(hd_one_panel{i_tab}(i,j),'string',tx,'horizontalalignment','center');
			end
		end
	end

	% 	hd_menu(1) = uimenu(gcf,'label','Requests');
	% 	% hd_menu(2) = uimenu(hd_menu(1),'label','New bba','callback','clbfmttab(1)');
	% 	hd_menu(2) = uimenu(hd_menu(1),'label','Quit','callback','clbfmttab(2)');
	
	set(gcf,'DefaultuicontrolUnits','normalized')
	choice = text_with_n_buttons(gcf,'New bba = type in a new bba in right most column of right matrix, other columns recomputed. To quit, select it',{'New bba','Quit'}, [-1]);
	
	if choice == 1
		for i = 1:8
			vect(i) = get_num_gui(hd_one_panel{2}(i,8));
		end		
		% 		gcf_mem = gcf;
		% 		help_level_mem = help_level;
		% 		help_level = 1;
		% 		help_text_handles = display_helps(1,48,Which_Courier);
		% 		% text 48 in init_stored_texts 
		% 		delete(help_text_handles)
		% 		help_level = help_level_mem;
		% 		figure(gcf_mem);
	else
		go_on_sp = 0;
	end	
	delete(gcf)
end

