% entering and storing the lines with instructions (those starting with ?)

%
%   Version : Sept 5, 2003.
%   Copyright (c) 2003 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

switch text_line
case '?clear'
	% the instruction for close and reopen the tabulator part of tbm_tabulator 
	lastclear = sect_number;
	ind_next_instruction = ind_next_instruction + 1;
	what_to_do(ind_next_instruction).type = 'clear';
	what_to_do(ind_next_instruction).inst = '';
	what_to_do(ind_next_instruction).section = sect_number;
	what_to_do(ind_next_instruction).evaluated = 0;
	what_to_do(ind_next_instruction).last_clear = lastclear;		
	
case '?end'			
	go_on = 0;
	k_line = k_line + 1;
	start_section = [start_section k_line+1];
	y = y - skip;
	hd_text(k_line) = text('position',[x y],...
	'String','********* END OF TUTORIAL *********',...
	'fontsize',12,...
	'FontName',ft_name,...
	'Color','k',...
	'HorizontalAlignment','left',...
	'visible','off');
	pos = get(hd_text(k_line),'extent');
	position_line(k_line) = pos(2);
	
case '?section'
	% Section : a 2 line instruction
	% ?section
	% my_labelMy Full Title    (my_label may NOT be a number)
	% Results {\bfSection num : My Full Title}
	% Output = in bold face Section num : My Full Title
	% num given by TBMLAB
	% Reference to label in   label{sect_number}
	% To mention it later, put in text   my_label (my_label MAY noit be a number)
	% It becomes Section num
	
	k_line = k_line + 1; % the section name starts in next line			
	start_section = [start_section k_line];
	sect_number = sect_number + 1;
	text_line = fgetl(fid); % I read the section name
	
	pos_label = findstr(text_line,'');
	if ~isempty(pos_label) % there is a label for the section
		label{sect_number} = lower([text_line(pos_label(1)+1:pos_label(2)-1)]);
		if pos_label(1) > 1
			t1 = text_line(1:pos_label(1)-1);
		else
			t1 = '';
		end
		if pos_label(2) < length(text_line)
			t2 = text_line(pos_label(2)+1:length(text_line));
		else
			t2 = '';
		end
		text_line = ['{\bfSection ',num2str(sect_number),' : ',t1,t2,'}'];
		text_itself = [t1 t2];
	else % no laqble for the section
		text_itself = text_line;
		text_line = ['{\bfSection ',num2str(sect_number),' : ',text_line,'}'];
	end % section label

	y = y - 3*skip/2;			
	
	hd_text(k_line) = text('position',[x y],...
	'String',text_line,...
	'fontsize',12,...
	'FontName',ft_name,...
	'Color','k',...
	'HorizontalAlignment','left',...
	'visible','off');
	pos = get(hd_text(k_line),'extent');
	position_line(k_line) = pos(2);
	
	% storing section for menu with section list, and providing its begin and end
	section_mem(sect_number).name = text_itself;
	% and a section starts at line start_section(sect_number)
	
case '?tabul'
	k_tabul = k_tabul + 1;
	line_eval = [line_eval  k_line ]; % this is next to text_line(k_line)
	tabul_instr{k_tabul} = fgetl(fid);
	ind_next_instruction = ind_next_instruction + 1;
	what_to_do(ind_next_instruction).type = 'tabul';
	what_to_do(ind_next_instruction).inst = k_tabul;
	what_to_do(ind_next_instruction).section = sect_number;
	what_to_do(ind_next_instruction).evaluated = 0;
	what_to_do(ind_next_instruction).last_clear = lastclear;
	
case '?put'
	k_put = k_put + 1;
	line_put = [line_put  k_line]; % this is next to text_line(k_line)
	put_instr{k_put,1} = fgetl(fid);
	put_instr{k_put,2} = fgetl(fid);
	ind_next_instruction = ind_next_instruction + 1;
	what_to_do(ind_next_instruction).type = 'put';
	what_to_do(ind_next_instruction).inst = k_put;
	what_to_do(ind_next_instruction).section = sect_number;
	what_to_do(ind_next_instruction).evaluated = 0;
	what_to_do(ind_next_instruction).last_clear = lastclear;
	
case '?replay'
	k_put = k_put + 1;
	line_put = [line_put  k_line]; % this is next to text_line(k_line)
	ind_next_instruction = ind_next_instruction + 1;
	what_to_do(ind_next_instruction).type = 'replay';
	what_to_do(ind_next_instruction).inst = '';
	what_to_do(ind_next_instruction).section = sect_number;
	what_to_do(ind_next_instruction).evaluated = 0;
	what_to_do(ind_next_instruction).last_clear = lastclear;
	end	
