function tabulator_command(op,paramop,ti,tj,replay_type,nbr_digit)
% excecutiong the numerous command for the tabulator

% new data are computed here, and handled by  set_data
% stored in	x_tbm_tabulator = set_data(new,ti,tj,handle_tbm_tabulator,x_tbm_tabulator,xi,xj,replay_type);
% whereas in set_data they are disp^layed in the tabulator cells

%
%   Version : Sept 4, 2003.
%   Copyright (c) 2003 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global button_size flag keyhit help_level
global nbr_bit_per_word
global pathname2TBMLABvers 
global Which_Courier

global handle_tbm_tabulator  x_tbm_tabulator obj i_obj ind_hist history

new_symb = [];
xi = history(ind_hist).index(1);
xj = history(ind_hist).index(2);
inst = history(ind_hist).instruction;

switch op

case 'label' % card, label
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% label
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	cardi = paramop{length(paramop)};
	for i = 1:length(paramop)-1
		new_symb{i} = paramop{i};
	end
	x_tbm_tabulator = set_data_symb(new_symb,ti,tj,handle_tbm_tabulator,x_tbm_tabulator,xi,xj,replay_type);
	if replay_type == 0;
		[obj,i_obj] = make_obj(obj,i_obj,[xi,xj],inst,pow2(cardi),'');
	end

case 'bba' % card
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% random bba
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	if replay_type == 0 | replay_type == 2 						
		cardi = paramop{1};
		
		hundr = 10^nbr_digit;
		m = fix(hundr*sort([rand(pow2(cardi)-1,1);1]))/hundr;
		new = [m(1); diff(m)];
		
		x_tbm_tabulator = set_data(new,ti,tj,handle_tbm_tabulator,x_tbm_tabulator,xi,xj,replay_type);
		if replay_type == 0;
			[obj,i_obj] = make_obj(obj,i_obj,[xi,xj],inst,pow2(cardi),'m');
		end
	end

case 'key' % card;out
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% enter data with keyboard
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	if replay_type == 0;
		cardi = paramop{1};
		new = zeros(pow2(cardi),1);
		x_tbm_tabulator = set_data(new,ti,tj,handle_tbm_tabulator,x_tbm_tabulator,xi,xj,replay_type);
		[obj,i_obj] = make_obj(obj,i_obj,[xi,xj],inst,pow2(cardi),paramop{2});
		% the case key from tutorial, a 'put' will put the data later, here I have put 0's
		% I need a key so an object exists, not possible with a put only		
	end

case {'m','b','bel','pl','q','wc','wd','betp'} % x_tbm_tabulator
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% unary fct
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	i = locate_obj(paramop{1},obj);
	if strcmp(op,'wc')
		op = 'w';
	end
	if i
		get_data(i,x_tbm_tabulator,obj);
		new = fmt(get_data(i,x_tbm_tabulator,obj),obj(i).form,op);
		x_tbm_tabulator = set_data(new,ti,tj,handle_tbm_tabulator,x_tbm_tabulator,xi,xj,replay_type);
		if replay_type == 0;
			[obj,i_obj] = make_obj(obj,i_obj,[xi,xj],inst,length(new),op);
			obj(i).used_by = [obj(i).used_by; xi,xj ];
		end
	end

case 'n' % x_tbm_tabulator
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% normalization
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	i = locate_obj(paramop{1},obj);
	in_form = obj(i).form;	
	new = fmt(fmt(get_data(i,x_tbm_tabulator,obj),in_form,'m','n'),'m',in_form);
	x_tbm_tabulator = set_data(new,ti,tj,handle_tbm_tabulator,x_tbm_tabulator,xi,xj,replay_type);
	if replay_type == 0;
		[obj,i_obj] = make_obj(obj,i_obj,[xi,xj],inst,length(new),in_form);
		obj(i).used_by = [obj(i).used_by; xi,xj ];
	end

case '-' % x_tbm_tabulator
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% negation
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	i = locate_obj(paramop{1},obj);
	in_form = obj(i).form;
	new = fmt(flipud(fmt(get_data(i,x_tbm_tabulator,obj),in_form,'m')),'m',in_form);
	x_tbm_tabulator = set_data(new,ti,tj,handle_tbm_tabulator,x_tbm_tabulator,xi,xj,replay_type);
	if replay_type == 0;
		[obj,i_obj] = make_obj(obj,i_obj,[xi,xj],inst,length(new),in_form);
		obj(i).used_by = [obj(i).used_by; xi,xj ];
	end

case 'ccr' % x1;x2;...;xn;out
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% conj combi rule
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	nbr = length(paramop) - 1;
	i = locate_obj(paramop{1},obj);
	in_data = fmt(get_data(i,x_tbm_tabulator,obj),obj(i).form,'q');
	obj(i).used_by = [obj(i).used_by; xi,xj ];
	for i = 2:nbr
		ik = locate_obj(paramop{i},obj);
		in_data = in_data .* fmt(get_data(ik,x_tbm_tabulator,obj),obj(ik).form,'q');
		obj(ik).used_by = [obj(ik).used_by; xi,xj ];
	end
	new = fmt(in_data,'q',paramop{nbr+1});			
	x_tbm_tabulator = set_data(new,ti,tj,handle_tbm_tabulator,x_tbm_tabulator,xi,xj,replay_type);
	if replay_type == 0;
		[obj,i_obj] = make_obj(obj,i_obj,[xi,xj],inst,length(new),paramop{nbr+1});
	end

case 'dcr' %x1;x2;...;xn;outform
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% disj combi rule
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	nbr = length(paramop) - 1;
	i = locate_obj(paramop{1},obj);
	in_data = fmt(get_data(i,x_tbm_tabulator,obj),obj(i).form,'b');
	obj(i).used_by = [obj(i).used_by; xi,xj ];
	for i = 2:nbr
		ik = locate_obj(paramop{i},obj);
		in_data = in_data .* fmt(get_data(ik,x_tbm_tabulator,obj),obj(ik).form,'b');
		obj(ik).used_by = [obj(ik).used_by; xi,xj ];
	end
	new = fmt(in_data,'b',paramop{nbr+1});				
	x_tbm_tabulator = set_data(new,ti,tj,handle_tbm_tabulator,x_tbm_tabulator,xi,xj,replay_type);
	if replay_type == 0;
		[obj,i_obj] = make_obj(obj,i_obj,[xi,xj],inst,length(new),paramop{nbr+1});
	end

case 'gbt' % x1;x2;...;xn;x_prior;conditioning_event;outform
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% gbt with prior
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	nbr = length(paramop)-3;
	for ik = 1:nbr
		i = locate_obj(paramop{ik},obj);
		pl(:,ik) = fmt(get_data(i,x_tbm_tabulator,obj),obj(i).form,'pl');
		obj(i).used_by = [obj(i).used_by; xi,xj ];
	end
	nbr_x = size(pl,1);
	if length(paramop{nbr+1}) % the prior on H
		i = locate_obj(paramop{nbr+1},obj);
		q_prior = fmt(get_data(i,x_tbm_tabulator,obj),obj(i).form,'q');  
		obj(i).used_by = [obj(i).used_by; xi,xj ];
	else
		q_prior = [ones(pow2(nbr),1)];
	end
	% conditioning event position
	loci = paramop{nbr+2}(1); 
	locj = paramop{nbr+2}(2); 
	loco = [obj(:).location];
	n = length(loco);
	poss_j = find(loco([2:2:n]) == locj);
	if length(poss_j) == 1				
		cond_ev = loci - obj(poss_j).location(1);
	else	
		for ik = 2:length(poss_j)
			if loci >= obj(poss_j(ik-1)).location(1) & loci <obj(poss_j(ik)).location(1)
				cond_ev = loci - obj(poss_j(ik-1)).location(1) + 1;
			end					
		end
	end
	ww = ones(pow2(nbr),1);
	ww(pow2(nbr) - pow2(0:nbr-1)) = pl(cond_ev,:);
	new = fmt(fmt(ww,'wc','q').*q_prior,'q',paramop{nbr+3});
	x_tbm_tabulator = set_data(new,ti,tj,handle_tbm_tabulator,x_tbm_tabulator,xi,xj,replay_type);
	if replay_type == 0;
		[obj,i_obj] = make_obj(obj,i_obj,[xi,xj],inst,length(new),paramop{nbr+3});
	end
	pl = [];
	
case 'drc' % x1;x2;...;xn;x*;out
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% drc with prior
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	nbr = length(paramop)-2;
	for ik = 1:nbr
		i = locate_obj(paramop{ik},obj);
		b(:,ik) = fmt(get_data(i,x_tbm_tabulator,obj),obj(i).form,'b');
		obj(i).used_by = [obj(i).used_by; xi,xj ];
	end
	nbr_x = size(b,1);
	if length(paramop{nbr+1}) % the prior on H
		i = locate_obj(paramop{nbr+1},obj);
		m_prior = fmt(get_data(i,x_tbm_tabulator,obj),obj(i).form,'m');
	else
		m_prior = [zeros(pow2(nbr)-1,1);1];
	end
	if length(m_prior) ~= pow2(nbr)
		% not ok
		disp('You are incoherent, length prior is not adequate, I''ll use avacuous one')
		m_prior = [zeros(pow2(nbr)-1,1);1];
	end
	b_res = zeros(nbr_x,1);
	for ik = 1:length(m_prior)
		if m_prior(ik)					
			biton = long_num2onbit(ik-1,nbr);
			b_res = b_res + m_prior(ik)*prod(b(:,[biton]),2);
		end
	end
	out_form = paramop{nbr+2};
	new = fmt(b_res,'b',out_form);
	x_tbm_tabulator = set_data(new,ti,tj,handle_tbm_tabulator,x_tbm_tabulator,xi,xj,replay_type);
	if replay_type == 0;
		[obj,i_obj] = make_obj(obj,i_obj,[xi,xj],inst,length(new),out_form);
	end
	b = [];
	
case 'disc'
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% discounting
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	i = locate_obj(paramop{1},obj);
	in_form = obj(i).form;
	in_data = fmt(get_data(i,x_tbm_tabulator,obj),in_form,'m');
	in_data = in_data * (1-paramop{2});
	in_data(length(in_data)) = in_data(length(in_data)) + paramop{2};
	new = fmt(in_data,'m',paramop{3});
	x_tbm_tabulator = set_data(new,ti,tj,handle_tbm_tabulator,x_tbm_tabulator,xi,xj,replay_type);
	if replay_type == 0;
		[obj,i_obj] = make_obj(obj,i_obj,[xi,xj],inst,length(new),in_form);
		obj(i).used_by = [obj(i).used_by; xi,xj ];
	end
end % switch op


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% function index = cell_in_which_object(x,xi,xj)
% 
% % pointer on hd_data(ti,tj)   which is x(xi,xj)
% % I climb in xj to find the instruction
% % So I know which object this cell refers to
% % definition of instr: it has ( and )
% 
% [nrx,ncx] = size(x);
% if xi > nrx | xj > ncx
% 	index = 0; % I am not on a cell with data
% else
% 	% index = xi with the instruiction, or 0 if no instruction
% 	ii = xi+1;
% 	go_on = 1;
% 	while go_on
% 		ii = ii - 1;
% 		if ii > 0		
% 			if ~isempty(findstr(x{ii,xj},'(')) &  ~isempty(findstr(x{ii,xj},')'))
% 				% it is an instruction
% 				index = ii;
% 				go_on = 0;
% 			end
% 		else
% 			index = 0;
% 			go_on = 0;
% 		end
% 	end
% end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


