function tbm_tabulator_tutorial(age,param)
% a tabulator for computing potentials (like Excel) for the tutorial only

% age = 'New, 'Old'  new = build window, 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% object
% 
% obj(i).location = [4 7]			% its origin 
% obj(i).instruction = 'm(5,8)'		% the instruction
% obj(i).used_by = [4 7; 5 9; 6 6]	% the origins of those who use me
% obj(i).length = 8					% length data under me
% obj(i).form = 'q'					% form of data  ('' = not potential)
%
% stroring the handle for transfer thru function calls
% handle.hd_top_row = hd_top_row;
% handle.hd_left_col = hd_left_col;
% handle.hd_data = hd_data;
%
% history(ii).instruction = 'blabla'
% history(ii).index = [xi,xj]
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%
%   Version : Sept 4, 2003.
%   Copyright (c) 2003 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global button_size keyhit help_level
global nbr_bit_per_word
global pathname2TBMLABvers 
global Which_Courier

global handle_tbm_tabulator  x_tbm_tabulator obj i_obj ind_hist history

nr = 30; nc = 11; 
nbr_digit = param{4};

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%           Data entry : age = Old                 %%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% called only by send_tabulator

replay_type = 0;
replay_start = []; % the instruction in history(). where data have been modified
must_be_replayed = 0;
% replay_type = 0 no replay mode, 
%             = 1 replay with random data frozen (those generated by bba) (unused) 
%             = 2 replay and bba generated data change if encountered by replay	

fri = 1;frj = 1;

ind_hist = 0;
history(1).instruction = []; % where I save each instruction, and the position xi,xj (full table, not the displayed one)
ind_hist = 0;

% get handles abck
hd_fig 			= handle_tbm_tabulator.hd_fig;
hd_title 		= handle_tbm_tabulator.hd_title;
hd_top_row 		= handle_tbm_tabulator.hd_top_row;
hd_left_col 	= handle_tbm_tabulator.hd_left_col;
hd_data 		= handle_tbm_tabulator.hd_data;
hd_corner 		= handle_tbm_tabulator.hd_corner;
hd_hl 			= handle_tbm_tabulator.hd_hl;

if strcmp(param{3},'replay')
	% Tutorial asks for a replay 
	replay_type = 2;
end

go_on = 1;	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the loop
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

while go_on 
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% the bottom buttons and the menu options
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	if replay_type == 0			
		% you enter a function
		
		% param contains i,j,op
		% I put it in the cell and made it the gco
		xi = param{1};
		xj = param{2};
		x_tbm_tabulator{xi,xj} = param{3};
		ti = xi - fri + 1;
		tj = xj - frj + 1;
		
		set(hd_data(ti,tj),'string',param{3});
		figure(hd_fig);
		set(hd_fig,'CurrentObject',hd_data(ti,tj));		
		go_on = 0;
		
		op = []; paramop = [];
		inst = ddblank(get(hd_data(ti,tj),'string'));
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		[op paramop] = parse_inst(inst);  %
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		skip_inst = 0;
	else
		% I replay the instructions
		ind_hist = ind_hist + 1;
		if ind_hist <= length(history)
			op = []; paramop = [];
			inst = history(ind_hist).instruction;
			xi = history(ind_hist).index(1);
			xj = history(ind_hist).index(2);
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			[op paramop] = parse_inst(inst);   %
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			skip_inst = 0;
		else
			% I am thru of replay
			% I refresh
			refresh_data(1,1,x_tbm_tabulator,nr,nc,handle_tbm_tabulator)
			replay_type = 0;
			replay_start = [];
			must_be_replayed = 0;
			skip_inst = 1;
			inst = '';					
		end
	end
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%		
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%%%%%%          a new instruction          %%%%%%%%%%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% we are at level of a new instruction
	if skip_inst == 0 % 
		if replay_type == 0;
			ind_hist = ind_hist + 1;
			history(ind_hist).instruction = inst;
			history(ind_hist).index = [xi xj];
			
			set(hd_data(ti,tj),'string','')
			set(hd_data(ti,tj),'string',inst)
			x_tbm_tabulator{xi,xj} = inst;					
		end
	
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% handling, displaying, storing the individual instructions for the tabulator
		%
		tabulator_command(op,paramop,ti,tj,replay_type,nbr_digit)
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
	end % if skip_inst == 0
end % while go_on 

