function [hd,he] = RM_display_one_variable(ind_belief, ind_variable, ind_attribute,  ...
ind_structure, ind_frame, vert_pos, irow, param_gui,hd_fig)
% display in object road map,the doubleline for one variable
% the data for belief can be empty if  
% this is not the first variable for the belief

% ind_belief = 0 if not first variable displayed
% vert_pos locate gui_position 2 (vertical position)
% called from road_map_objects.m

% belief variable frame attribute structure

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief
global flags

% the output for askong details on an object is made of 3 digits [i j k]
% where i = 0 if we ask for next screen, or exit, and i = index_belief
% if i > 0,  j = index_variable of belief i
% if i > 0, k = 1 to 7 according to the selected object
% k=1 for belief, k=2 for variable, k=5 for structure, k = 6 for frame...

shifth 	= param_gui(1) ; 
shiftv	= param_gui(2) ; 
texth	= param_gui(3) ; 
textv 	= param_gui(4) ; 
areah 	= param_gui(5) ; 
areav 	= param_gui(6) ; 
height_variable = param_gui(7) ;
boxh 	= param_gui(8) ;  
boxv 	= param_gui(9) ; 
here_style = 'pushbutton';
attr_extra = param_gui(10);

i = 1;k = 0;% belief

iobj = 1;
if ind_belief > 0
	clb1 = ['general_clb([',num2str(irow),',',num2str(iobj),']);'];	
	pos = [shifth  vert_pos+.008  boxh  boxv ];
	hd(i) = uicontrol(...
	'parent',hd_fig,...
	'position', pos,...
	'string',' ',...
	'style',here_style,...
	'CallBack',clb1);	
	
	pos = [2*shifth+boxh  vert_pos  texth  textv ]; 
	he(i) = uicontrol(...
	'parent',hd_fig,...
	'position', pos,...
	'string',belief(ind_belief).full_name,...
	'style','text',...
	'horizontalAlignment','left');
end

i = i + 1;  % variable
k = k + 1; 
iobj = iobj + 1;
clb2 =['general_clb([',num2str(irow),',',num2str(iobj),']);'];
pos = [areah+shifth  vert_pos+.008  boxh  boxv ];
hd(i) = uicontrol(...
'parent',hd_fig,...
'position', pos,...
'string',' ',...
'style',here_style,...
'CallBack',clb2);	

pos = [areah+2*shifth+boxh  vert_pos  texth+attr_extra  textv ]; 
he(i) = uicontrol(...
'parent',hd_fig,...
'position', pos,...
'string',variable(ind_variable).full_name,...
'style','text',...
'horizontalAlignment','left') ;


i = i + 1; % frame
k = k + 1; 
iobj = iobj + 1;
clb3 = ['general_clb([',num2str(irow),',',num2str(iobj),']);'];
pos = [k*areah+shifth+attr_extra  vert_pos+.008  boxh  boxv ];
hd(i) = uicontrol(...
'parent',hd_fig,...
'position', pos,...
'string',' ',...
'style',here_style,...
'CallBack',clb3);	

pos = [k*areah+2*shifth+boxh+attr_extra  vert_pos  texth  textv ]; 
he(i) = uicontrol(...
'parent',hd_fig,...
'position', pos,...
'string',frame(ind_frame).full_name,...
'style','text',...
'horizontalAlignment','left') ;


i = i + 1; % attribute
k = k + 1; 
iobj = iobj + 1;
clb4 = ['general_clb([',num2str(irow),',',num2str(iobj),']);'];
pos = [k*areah+shifth+attr_extra  vert_pos+.008  boxh  boxv ];
hd(i) = uicontrol(...
'parent',hd_fig,...
'position', pos,...
'string',' ',...
'style',here_style,...
'CallBack',clb4);	

pos = [k*areah+2*shifth+boxh+attr_extra  vert_pos  texth  textv ]; 
he(i) = uicontrol(...
'parent',hd_fig,...
'position', pos,...
'string',attribute(ind_attribute).full_name,...
'style','text',...
'horizontalAlignment','left') ;


i = i + 1; % structure
k = k + 1; 
iobj = iobj + 1;
clb5 = ['general_clb([',num2str(irow),',',num2str(iobj),']);'];
pos = [k*areah+shifth+attr_extra  vert_pos+.008  boxh  boxv ];
hd(i) = uicontrol(...
'parent',hd_fig,...
'position', pos,...
'string',' ',...
'style',here_style,...
'CallBack',clb5);	

pos = [k*areah+2*shifth+boxh+attr_extra  vert_pos  texth  textv ]; 
he(i) = uicontrol(...
'parent',hd_fig,...
'position', pos,...
'string',structure(ind_structure).full_name,...
'style','text',...
'horizontalAlignment','left') ;

