function road_map_objects
% displaying all objects in a structured way

% You get a full screen display of evey objects 
% starting with belief object and giving its building objects
% the orer from laft to right is: 
% belief 
% its several underlying variables
% for each variable: its frame and its attribute
% for the attribute, its structure
% note that the frame is one component of structure

%
%   Version : Jan 15, 03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief
global screen_size
global gui_position help_level help_label figure_data
global flags
global button_size
global Which_Courier

if length(belief) == 0
	% if no belief, skip.
	hdw = warndlg('No belief yet defined. I skip');
	uiwait(hdw);
	return
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get the figure
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_fig = figure('name','Road Map of Objects');
set(gcf,'position',gui_position(:,19));
ind_fig = length(figure_data) + 1;
figure_data(ind_fig).name = 'Road Map of Objects';
figure_data(ind_fig).handle = hd_fig;
figure_data(ind_fig).position = gui_position(:,19);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% put its menus
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

k=0;
k=k+1;make_fig_menu(ind_fig,k,'File',0,'','on');
k=k+1;make_fig_menu(ind_fig,k,'Quit',1,'general_clb([0,1])','on');
k=k+1;make_fig_menu(ind_fig,k, help_label,0,'','on');
k=k+1;make_fig_menu(ind_fig,k,'Show Help', 3,'general_clb([0,99])','on');

menu_manager('create',ind_fig)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% parameters for texts and button data
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

shifth = .002 ; 
boxh = .016 ;
shiftv = .005 ; 
boxv = .020 ; % box height
texth = .150;
textv = .030;  % h for text
areah = 2*shifth + boxh + texth;
areav = textv;
height_variable = textv + shiftv;
attr_extra = .045;

param_gui = [shifth shiftv texth textv areah areav height_variable boxh boxv attr_extra];

gui_pos(:,1) = get(hd_fig(1),'position')';	

% the Next Quit column
gui_pos(:,2) = [.90 .001 .098 .998]' ;

% the Next button
gui_pos(:,3) = [.902 .90 .092 .05]' ;

% the Quit button
gui_pos(:,4) = [.902 .80 .092 .05]' ;

% the top box with legend
gui_pos(:,5) = [.002   (1-areav-.002) ...
(.90 -.002)  2*areav+.003 ]' ; 
% for y0 use - .002 and not larger otherwise upper part of frame shows up and ugly

% the road map box
gui_pos(:,6) = [.01 .001 .099 gui_pos(2,5)-.003]' ;

% comments on 'click to get details'
switch computer
case 'MAC2'
% the frame
gui_pos(:,7) = [.902 .65 .092 .1 ]';
% the text
gui_pos(:,8) = [.904 .652 .088 .09 ]';
otherwise
	% the frame
gui_pos(:,7) = [.902 .6 .092 .15 ]';
% the text
gui_pos(:,8) = [.904 .602 .088 .14 ]';
end

% the window for displaying one object
gui_pos(:,9) = gui_position(:,20);

% the window for displaying text of one object
gui_pos(:,10) = [.005 .020   .990  .970]';

% the push button  to end displaying text of one object
bw = button_size(1)/(gui_pos(3,9));
bh = button_size(2)/(gui_pos(4,9));
gui_pos(:,11) = [.5-bw/2 .005   bw bh]';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% preparing the several screens for objects road map
% we ask room for all variables for those beliefs displayed on one screen
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% I need 1 line for each belief
nbr_var_per_screen = floor(gui_pos(4,6) /(textv+shiftv));

% number of objects
[n_bel] = size(pin_belief,1);
% computing the number of variables for each objects

ntot = 0; % used number of line in screen
jscr = 0; % screen index
to = 0;
for i = 1:n_bel
	n_var_in_bel{i} = belief(pin_belief(i,2)).domain_variable;
	n_var(i) = length(n_var_in_bel{i});
	ntot = ntot + n_var(i);
	if ntot > nbr_var_per_screen 
		jscr = jscr + 1; 
		from = to + 1;
		to = i - 1;
		screen(jscr,:) = [from to];
		ntot = n_var(i);
	end
end
screen(jscr+1,:) = [to+1 n_bel];
% screen jscr stores belief(position = screen(jscr,1) to screen(jscr,2))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% right box for button with next set of bel, quit road map
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% the frame

hd(1) = uicontrol(...
'parent',hd_fig,...
'position', gui_pos(:,2)',...
'style','frame');

% Next button

clb1 = ['general_clb([0,0]);'];

hd(2) = uicontrol(...
'parent',hd_fig,...
'position', gui_pos(:,3)',...
'string','Next Objects',...
'style','pushbutton',...
'BackgroundColor','red',...
'callback',clb1);	

% Quit button

clb2 = ['general_clb([0,1]);'];	

hd(3) = uicontrol(...
'parent',hd_fig,...
'position',gui_pos(:,4)',...
'string','Back to TBM',...
'style','pushbutton',...
'BackgroundColor','red',...
'callback',clb2);

% The text explaining that you can get details on one object
hd(4) = uicontrol(...
'parent',hd_fig,...
'position',gui_pos(:,7)',...
'style','frame');

hd(5) = uicontrol(...
'parent',hd_fig,...
'position',gui_pos(:,8)',...
'string',{'To get details','on one object,','click its box.'},...
'style','text');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% top box with legend of column
% belief variable frame  attribute structure
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hh = 1;
ht(hh) = uicontrol(...
'parent',hd_fig,...
'position', gui_pos(:,5)',...
'style','frame') ;

i = 1;
k=0;
pos = [k*areah+2*shifth+boxh  1-areav  texth  textv ] ;
hh = hh + 1;
ht(hh) = uicontrol(...
'parent',hd_fig,...
'position', pos,...
'string','belief',...
'style','text',...
'HorizontalAlignment','left',...
'ForegroundColor','black') ;

k=1;
pos = [k*areah+2*shifth+boxh  1-areav  texth+attr_extra  textv ] ;
hh = hh+1;
ht(hh) = uicontrol(...
'parent',hd_fig,...
'position', pos,...
'string','variable',...
'style','text',...
'HorizontalAlignment','left',...
'ForegroundColor','black') ;

k=2;
pos = [k*areah+2*shifth+boxh+attr_extra  1-areav  texth  textv ] ;
hh = hh+1;
ht(hh) = uicontrol(...
'parent',hd_fig,...
'position', pos,...
'string','frame of variable',...
'style','text',...
'HorizontalAlignment','left',...
'ForegroundColor','black') ;

k=3;
pos = [k*areah+2*shifth+boxh+attr_extra  1-areav  texth  textv ] ;
hh = hh+1;
ht(hh) = uicontrol(...
'parent',hd_fig,...
'position', pos,...
'string','attribute',...
'style','text',...
'HorizontalAlignment','left',...
'ForegroundColor','black') ;

k=4;
pos = [k*areah+2*shifth+boxh+attr_extra  1-areav  texth  textv ] ;
hh = hh+1;
ht(hh) = uicontrol(...
'parent',hd_fig,...
'position', pos,...
'string','struct. attr.',...
'style','text',...
'HorizontalAlignment','left',...
'ForegroundColor','black') ;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% detailed road map
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

nscr = size(screen,1);

go_on_screen = 1;
jscr = 1; 
while go_on_screen 
	irowvar = 0;
	vert_pos = gui_pos(2,5);
	
	hd_RM_objects = [];
	he_RM_objects = [];
	
	for ibelpos = screen(jscr,1):screen(jscr,2) % for those beliefs in screen jscr		
		
		vert_pos = vert_pos - height_variable; % where to type text
		ind_belief = pin_belief(ibelpos,2);
		num_var = n_var_in_bel{ibelpos}(1); 
		irowvar = irowvar + 1;
		
		[ind_variable, ind_attribute, ind_structure, ind_frame] = ...
		index_from_var_to_structure(num_var);
		
		[hd2,he] = RM_display_one_variable(ind_belief, ind_variable, ind_attribute, ind_structure, ...
		ind_frame, vert_pos, irowvar, param_gui,hd_fig);
		
		mat_index(irowvar,1:5) = [ind_belief, ind_variable, ind_frame, ind_attribute, ind_structure] ;
		
		hd_RM_objects(irowvar,:) = hd2;
		he_RM_objects(irowvar,:) = he;
		
		for ivar = 2:n_var(ibelpos) 			
			% foir the case a belief has several variables, the next lines don't have a belief name
			vert_pos = vert_pos - height_variable; % where to type text
			num_var = n_var_in_bel{ibelpos}(ivar);
			irowvar = irowvar + 1;
			
			[ind_variable,ind_attribute, ind_structure, ind_frame] = ...
			index_from_var_to_structure(num_var);
			
			[hd2,he] = RM_display_one_variable(0, ind_variable, ind_attribute, ind_structure, ...
			ind_frame, vert_pos, irowvar, param_gui,hd_fig);	
			
			mat_index(irowvar,1:5) = [ind_belief, ind_variable, ind_frame, ind_attribute, ind_structure] ;
			
			hd_RM_objects(irowvar,:) = hd2;
			he_RM_objects(irowvar,:) = he;
		end % of ivar, all variables
	
	end	% of one screen

	in_rm_fig = 1;
	while in_rm_fig
		flags = [];
		figure(hd_fig);
		uiwait(hd_fig);
		
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% exit and object detailed display
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		% flags are now the result of callback general_clb as they come from the uiwait and their callback
		% the call back produce 2 numbers ibel and icol stored in flags(1) and flags(2).
		% if ibel (flags(1)) = 0, it means we click on the right column request, then 
		% if icol (flags(2)) is 0 = next frame, 1 = quit
		% otherwise ibel icol are the location of the object for which we want details
		
		if flags(1) == 0 
			in_rm_fig = 0;
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% quit or next screen of road map
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			
			switch flags(2) 
			case 0 
				% ask for next frame				
				if jscr == nscr
					% no more screen
					go_on_screen = 0;
				else
					% be ready for next screen, clean previous one
					jscr = jscr + 1;
				end			
			case 1 
				% quit from button or menu (same)
				% clean the screen
				go_on_screen = 0;
			case 99 % help requested
				help_level_mem = help_level;
				help_level = 1; % I must put help level = 1 in order help to be displayed
				hd_help = display_helps(1,37);
				% display_helps put the Root Window in front with a help text
				help_level = help_level_mem;	
			end
			% some value are 0 which are NOT handles
			hd_RM_objects(find(hd_RM_objects==0)) = [];
			he_RM_objects(find(he_RM_objects==0)) = [];
			
			if length(hd_RM_objects)
				delete(hd_RM_objects)
			end
			if length(he_RM_objects)
				delete(he_RM_objects)	
			end
			% clear the last road map, the two hd_ he_ contains the handles	
			% delete works with up to 2-D (funny)
		else
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% dispaying all details for one object
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			
			memhdfig = gcf;
			% clean the screen		
			
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% draw a new figure for one object
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			
			hd_fig_object = figure('name','Details on selected object');
			set(gcf,'position',gui_position(:,20));
			ind_fig = length(figure_data) + 1;
			figure_data(ind_fig).name = 'Details on selected object';
			figure_data(ind_fig).handle = hd_fig_object;
			figure_data(ind_fig).position = gui_position(:,20);

			ind = mat_index(flags(1),flags(2));
			
			switch flags(2)
			case 1
				string = gui_display_one_object('belief', ind);
			case 2
				% variable
				string = gui_display_one_object('variable', ind);		
			case 3
				% frame
				string = gui_display_one_object('frame', ind);			
			case 4
				% attribute
				string = gui_display_one_object('attribute', ind);			
			case 5
				% structure
				string = gui_display_one_object('structure', ind);					
			end % switch flags(2)
		
			hfo = uicontrol(...
			'parent',hd_fig_object,...
			'position', gui_pos(:,10),...
			'string',string,...
			'style','text',...
			'fontname',Which_Courier,...
			'HorizontalAlignment','left') ;
			
			hbut = uicontrol(...
			'parent',hd_fig_object,...
			'position', gui_pos(:,11),...
			'string','Next',...
			'style','pushbutton',...
			'backgroundcolor','r',...
			'callback','uiresume') ;
			
			figure(hd_fig_object) ;
			uiwait(hd_fig_object) ;
			
			% getting previous figure back in front
			delete(hd_fig_object)
			figure_data(ind_fig) = [];
			ind_fig = ind_fig - 1;
		end % while in_rm_fig
	
	end % if flags(1) == 0 
end % while go_on_screen 

delete(ht)
delete(hd_fig)
figure_data(ind_fig) = [];

