function clb_results(option)
% callback for result_display

%
%   Version : Jan 15, 03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief
global flag_str
global Which_Courier
global gui_position  figure_data  flags  help_level

switch option

case 'Options'
	clear queries default_answer
	i = 0;
	i=i+1;queries{i} = 'Element Order';
	i=i+1;queries{i} = 'Maximun number of plotted elements (min 2) #';
	i=i+1;queries{i} = 'Stop display when cumulated sum of BetP is #';
	i=i+1;queries{i} = 'Stop display when difference between successive BetP is #';
	i=i+1;queries{i} = 'Maximum number of masses to be displayed';
	% 	i=i+1;queries{i} = 'Display impact of iterated elimination of ''imposible elements'': Y/N';
	% 	i=i+1;queries{i} = 'If Y, time in sec between two displays is #';
	% 	i=i+1;queries{i} = 'Show largest masses: Y/N';
	% 	i=i+1;queries{i} = 'Show simultaneous plot of Bel,BetP,Pl: Y/N';
	% 	i=i+1;queries{i} = 'Show plot BetP: Y/N';
	% 	i=i+1;queries{i} = 'Show most probable elements: Y/N';	
	% 	i=i+1;queries{i} = 'Show Bel,BetP,Pl for each variable: Y/N';
	
	def_ans = flag_str;
	
	MenuData(1).number = 1;
	MenuData(1).label{1} = 'BetP';
	MenuData(1).clb{1} = 'clb_pop_up(1);';
	MenuData(1).label{2} = 'Pl';
	MenuData(1).clb{2} = 'clb_pop_up(2);';
	MenuData(1).label{3} = 'Set Ordered';
	MenuData(1).clb{3} = 'clb_pop_up(3);';
	
	i = 0;
	i=i+1;tooltip{i} = 'Ordering displayed elements in ''Bel, BetP, Pl plot''';
	i=i+1;tooltip{i} = 'Limiting the number of displayed elements in plot: min = 2';
	i=i+1;tooltip{i} = 'Limiting the number of displayed elements in plot';
	i=i+1;tooltip{i} = 'Limiting the number of displayed elements in plot';
	i=i+1;tooltip{i} = 'Limiting the number of bbm''s displayed';
	% 	i=i+1;tooltip{i} = 'Stepwise conditioning after eliminating least pl elements';
	% 	i=i+1;tooltip{i} = 'Delay needed to see the impact of the conditioning';
	
	gcf_mem = gcf;
	
	hd_fig = figure('name','Preferences for Result Display');
	set(gcf,'position',gui_position(:,1));
	[answer,choice] = dialog_queries(hd_fig(1),'Options. When Done, ask Next.',queries,...
	def_ans,[.005 .005],MenuData,2,[],tooltip,10,'UR');	
	
	if choice == 1
		if str2num(answer{2}) <=1
			answer{2} = '2';
		end
		flag_str = answer;
		flags(2) = 1;
		flags(3) = 0;
	else
		flags(2) = 0;
		flags(3) = 0;
	end
	delete(hd_fig(1)) % the option query window	
	% get intial window back with result display
	figure(gcf_mem)
	
case 'Var_Names'
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% a figure with the short and full names of the variables
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	bel_ind = flags(1);
	flags(3) = 0;
	flags(2) = 0;
	
	% getting variables names in window instruction
	ind_var_hr = pin_manipulation('variable','num2ind',...
	[belief(bel_ind).domain_variable belief(bel_ind).conditioning_variable]);
	
	text1 = strvcat({variable(ind_var_hr).short_name});
	for i = 1:length(ind_var_hr)
		text_sep{i} = ' = ';
	end
	text2 = strvcat(text_sep);
	text3 = strvcat(variable(ind_var_hr).full_name);
	
	text_sh_lg_name = cellstr([text1,text2,text3]);
	
	nbr_var = size(text_sh_lg_name,1);
	
	font_ht = 1.4*get(0,'DefaultuicontrolFontSize');
	ht_fig = min(400, [(nbr_var + 4)*font_ht]) ; 
	% 1 for title, 1 for below to show it is end
	ht = font_ht / ht_fig;
	
	hd_names = figure(...
	'CloseRequestFcn','closereq;uiresume;',...
	'Name','Variables: short names and full names',...
	'Resize','on');
	set(gcf,'position',[200 200 500 ht_fig]);
	ik = 1;
	
	text = {'Close me with the Close Window button'};
	ik=ik+1;hd_sing(ik) = uicontrol(hd_names,...
	'fontname',Which_Courier,...
	'style','text',...
	'string',text,...
	'position',[.005 .990-ht .990 ht]);
	
	ik=ik+1;hd_sing(ik) = uicontrol(hd_names,...
	'fontname',Which_Courier,...
	'style','text',...
	'HorizontalAlignment','left',...
	'string',text_sh_lg_name,...
	'position',[.005 .005 .990 .980-ht]);
	
	uiwait(hd_names)
	
case 'Help'  % 38
	gcfmem = gcf;
	hd_help = forced_display_helps(1,38);
	delete(hd_help);
	figure(gcfmem);
	flags(2) = 0;
	flags(3) = 0;	
case 'Quit'	
	flags(2) = 0;
	flags(3) = 1;
case 'Print'
	print_figure('clb_results.m');
	flags(2) = 0;
	flags(3) = 0;	
end
uiresume;
