function results_display(bel_ind,bp_ind,form_ind)
% full window display with own menus of one bp data
% the displayed bp is in belief(beind).bp(bp_ind).form(for_ind).type = m

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

% nature of flags data
% flags(1) is the index of the belief object to be displayed
% flags(2) = 1 = change of otpions and replot, = 0 no change, do nothing
% flags(3) = 1 = quit, 2 = help

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief
global flag_str  nbr_bit_per_word  button_size
global Which_Courier
global gui_position  figure_data  flags  help_level help_label

gcf_mem = gcf ; % to remeber where I come from

% set initial parameters
nbr_worlds = prod([belief(bel_ind).domain_cardinality]);
% nbr full words, nbr remaining in next word
[nw rm] = words_for_set(nbr_worlds);

flags = [];

flags(1) = bel_ind; % needed for menu callback
flags(2) = 0;
flags(3) = 0;

elem_order = 1;
nbr_BetP = min(8,nbr_worlds);
max_cumul_BetP = .95;
max_BetP_diff = .40;
nbr_bbm_displayed = min(10,length(belief(bel_ind).bp(bp_ind).form(form_ind).values));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the options are in flag_str
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% 	flag_str{1} = 'Element Order';    BetP    Pl    Set Ordered
% 	flag_str{2} = 'Maximun number of plotted elements #';
% 	flag_str{3} = 'Stop display when cumulated sum of BetP is #';
% 	flag_str{4} = 'Stop display when difference between successive BetP is #';
% 	flag_str{5} = 'Maximum number of masses to be displayed';

flag_str = [];
i=0;
i=i+1;flag_str{i} = 'BetP';
i=i+1;flag_str{i} = num2str(nbr_BetP);
i=i+1;flag_str{i} = '.95';
i=i+1;flag_str{i} = '.40';
i=i+1;flag_str{i} = num2str(nbr_bbm_displayed);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% res_disp_1 : 
% construct Bel, BetP, Pl on elements, get normalized bbm, foset (no gui)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[BetP_elem, Bel_elem, Pl_elem, bbm, foset,mass0] = res_disp_one(bel_ind, bp_ind, form_ind);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% getting the element list
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[var_name_list, element_list, element_numbers,label_details] = ...
creating_elements(belief(bel_ind).domain_variable);

% if card v1 = 3 and card v2 = 2, and domain_variable = v1 v2 (numbers)
% element_numbers = 
% 	v2 	v1
% 	1 	1
%	1	2
%	1	3
% 	2 	1
%	2	2
%	2	3
% element_list = the text for element in frame (suppose v1 ABC v2 NY)
% 	v2 	v1
% 	N 	A
%	N	B
%	N	C
% 	Y 	A
%	Y	B
%	Y	C
% var_name = v2 v1
% label_details.text{1,:} = A B C
% label_details.text{2,:} = N Y
% element j of frame of var i in list domain_variable reverse of var_name
% label_details.length(:) = nbr char var 1, nbr char var 2

nbr_var = size(element_numbers,2);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get the figure
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

title_window = ['Display of belief ',belief(bel_ind).full_name,', potential ',num2str(bp_ind)];

hd_result_fig = figure('name',title_window);
set(gcf,'position',gui_position(:,19));
ind_fig = length(figure_data) + 1;
figure_data(ind_fig).name = title_window;
figure_data(ind_fig).handle = hd_result_fig;
figure_data(ind_fig).position = gui_position(:,19);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% put its menus
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

k=0;
k=k+1;make_fig_menu(ind_fig,k,   'File',0,'','on');
k=k+1;make_fig_menu(ind_fig,k,'Quit',1,'clb_results(''Quit'');','on');
k=k+1;make_fig_menu(ind_fig,k,'Print plot',1,'clb_results(''Print'');','on');
k=k+1;make_fig_menu(ind_fig,k,   'Tools',0,'','on');
k=k+1;make_fig_menu(ind_fig,k,'Variable names', 4,'clb_results(''Var_Names'');','on');
k=k+1;make_fig_menu(ind_fig,k,'Preferences',4,'clb_results(''Options'');','on');
k=k+1;make_fig_menu(ind_fig,k,    help_label,0,'','on');
k=k+1;make_fig_menu(ind_fig,k,'Help On', 7,'clb_results(''Help'');','on');

menu_manager('create',ind_fig)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% bottom right buttons
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	

% for the bottom right buttons XXXXXX
posfig = get(hd_result_fig,'Position');
bw = button_size(1)/posfig(3);
bh = button_size(2)/posfig(4);

% buiding left half with 3 area, XXXXXX the list of variables, the list of singletons with high BetP, the plot
ht = .03;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% sorting BetP and Pl on singletons 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	

[sort_BetP ind_sort_BetP] = sort(-BetP_elem); % negation as sort is increasing
sort_BetP = -sort_BetP; % the largest is index 1
[sort_Pl ind_sort_Pl] = sort(-Pl_elem); % negation as sort is increasing
sort_Pl = -sort_Pl; % the largest is index 1
order_plot = flag_str{1};
switch order_plot
case 'BetP'
	ind_sort = ind_sort_BetP;
case 'Pl'
	ind_sort = ind_sort_Pl;
otherwise
	ind_sort = [1:length(BetP_elem)];
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% The big loop , you leave it with Quit menu
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

go_on = 1;
while go_on
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% selecting nbr_BetP  BetP to be displayed
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
	
	nbr_BetP = min(nbr_worlds,	nbr_BetP); % at most what is asked and what is.
	max_cumul_BetP = min(max_cumul_BetP,.99999999999999); % to avoid crash with 100%	
	
	% the cumul BetP rule: up to + 1 data point
	nbr_cs = max(find(cumsum(sort_BetP) <= max_cumul_BetP));
	if ~isempty(nbr_cs)
		nbr_BetP = min(nbr_BetP,nbr_cs+1) ;
	end
	% the max BetP differential
	indd = find(-diff(sort_BetP) > max_BetP_diff);
	if ~isempty(indd)
		nbr_BetP = min(nbr_BetP,min(indd)+1)  ;	
	end

	ik = 0; 
	hd_sing = [];
	if prod(belief(bel_ind).domain_cardinality) <= 12
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% res_disp_6 : list bbm in right half
		% only if cardinality <= 12
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		[hd_sing_out, ik_out] = res_disp_six(bel_ind,bp_ind,form_ind,var_name_list,element_numbers,label_details,...
		mass0,bbm,nbr_bbm_displayed,nbr_worlds,foset,ik,hd_sing,hd_result_fig,bh);
		
		hd_sing = hd_sing_out;
		ik = ik_out;
		print_no_data = 0;
	else
		print_no_data = 1;
	end

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% selecting the element values to be displayed
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
	
	Bel_elem_sel  =  Bel_elem(ind_sort(1:nbr_BetP));
	BetP_elem_sel = BetP_elem(ind_sort(1:nbr_BetP));
	Pl_elem_sel   =   Pl_elem(ind_sort(1:nbr_BetP));
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% list of labels of displayed singletons
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	ik=ik+1;hd_sing(ik) = uicontrol(hd_result_fig,...
	'style','frame',...
	'userdata','TBM_results',...
	'position',[.005 .505 .49 .49]);
	
	ik=ik+1;hd_sing(ik) = uicontrol(hd_result_fig,...
	'fontname',Which_Courier,...
	'userdata','TBM_results',...
	'style','text',...
	'string','Symbols used in plot for the singletons with largest BetP. ',...
	'position',[.007 .99-ht .484 ht]);
	
	% finding the singletons for the plot (largest BetP)
	
	% finding the position of the | and building the list of variable names with the |
	skip_for_vert = 3; % nbr of variables between 2 displayed vertical lines 
	vert_pos = 11; 
	poss = 11;
	result = [];
	to = 0;
	var_name_with_vert = ' N   BetP | ';
	for i_var = 1:nbr_var
		poss = poss + label_details.length(nbr_var+1-i_var) + 1;
		fr = to + 1; 
		to = to + label_details.length(nbr_var+1-i_var) ;
		var_name_with_vert = [var_name_with_vert, var_name_list(fr:to),' '];	
		to = to + 1; % skip blank
		if i_var == skip_for_vert*fix(i_var/skip_for_vert)
			var_name_with_vert = [var_name_with_vert,'| '];
			poss = poss + 2;
			vert_pos = [vert_pos poss];
		end
	end

	result{1} = var_name_with_vert;
	% building the line with -----|------|----
	line_inter = '';
	for i = 1:poss
		line_inter = [line_inter,'-']; 
	end
	line_inter(vert_pos) = '|';
	
	result{2} = line_inter;
	ires = 2;
	
	for ii = 1:nbr_BetP
		if ii < 10
			el = [' ', num2str(ii) ,'  ',num2str(BetP_elem_sel(ii),'%5.3f'),' | ' ];
		else
			el = [     num2str(ii) ,'  ',num2str(BetP_elem_sel(ii),'%5.3f'),' | ' ];
		end
		for j = 1:nbr_var		
			el = [el label_details.elem_label{ind_sort(ii),j} ' '];
			if j == skip_for_vert*fix(j/skip_for_vert)
				el = [el,'| '];
			end
		end
		ires = ires + 1;
		result{ires} = el;
		if mod(ii,5) == 0
			ires = ires + 1;
			result{ires} = line_inter;
		end
	end

	ik=ik+1;hd_sing(ik) = uicontrol(hd_result_fig,...
	'fontname',Which_Courier,...
	'userdata','TBM_results',...
	'style','text',...
	'HorizontalAlignment','left',...
	'string',result,...
	'position',[.007 .510 .484 .48 - ht]);
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% plotting bel,BetP,pl on singletons
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% % % % % 	ik=ik+1;hd_sing(ik) = uicontrol(hd_result_fig,...
	% % % % % 	'userdata','TBM_results',...
	% % % % % 	'style','frame',...
	% % % % % 	'position',[.005 .005 .49 .49]);
	
	flags(2) = 0; % flmags(2) tells that change in options have been performed, thsu we must replot
	
	% plot is here
	
	pos_gr = [.090 .050 .405 .40];
	hd_plot = axes('parent',hd_result_fig,'position',pos_gr,...
	'userdata','TBM_results','Box','on');
	
	delta = .02;
	
	hdata = [Bel_elem_sel  BetP_elem_sel-Bel_elem_sel-delta/2 delta*ones(nbr_BetP,1)...	
	Pl_elem_sel-BetP_elem_sel-delta/2    ones(nbr_BetP,1)-Pl_elem_sel];
		
	hd_plot_patch = bar([1:nbr_BetP], hdata,.3,'stacked');
	colormap([1 1 1;1 .7 .7; 1 0 0; 1 .7 .7; 1 1 1]);
	
	title('Bel, BetP, Pl: elements ordered by BetP');	
	ylabel('Belief, BetP, Plausibility');
	xlabel('Singleton : codes above.');
	set(gca,'Layer','top', 'YTick',[0:.25:1], 'Xlim',[0 nbr_BetP+1],'Ylim',[0 1]);
	
	set(gca,'Ygrid','on')
	drawnow	
	
	if print_no_data == 1
		hdw = warndlg(['I do not display the masses. Cardinality = ',...
		num2str(prod(belief(bel_ind).domain_cardinality)),': max allowed = 12.',...
		' Use instead Largest m + focal in Potential Control Window (menu Edit/Belief/Edit Belief)']);
		uiwait(hdw)
	end

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% everything is plotted by now
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	button_query = 1;
	while button_query
		
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		uiwait(hd_result_fig)
		% I wait you hit a menu option
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% recreate data for display accordinhg to the requests in the option window
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		if flags(2) == 1 % for the case where param have been changed, answer in flag_str
			flags(3) = 3;
		end
	
		switch flags(3)	
		case 1 % quit, in menu
			go_on = 0;	
			button_query = 0;
		case 2 % help, in menu
			button_query = 1; % do nothing , for later XXXX
			% produce help to explain the data
			figure(hd_result_fig)
		case 3 % replot, in menu, option parameters have been chnaged
			button_query = 0;
			
			% set updated parameters
			order_plot_read = flag_str{1};
			nbr_BetP = str2num(flag_str{2});
			max_cumul_BetP = str2num(flag_str{3});
			max_BetP_diff = str2num(flag_str{4});			
			nbr_bbm_displayed = min(length(bbm),str2num(flag_str{5}));
			
			if ~strcmp(order_plot_read,order_plot)
				order_plot = order_plot_read;
				switch order_plot
				case 'BetP'
					ind_sort = ind_sort_BetP;
				case 'Pl'
					ind_sort = ind_sort_Pl;
				otherwise
					ind_sort = [1:length(BetP_elem)];
				end
			end
			% clean window with results
			delete(findobj('userdata','TBM_results'));		
			delete(hd_plot);
		end % switch flags(3)	
	end % while button_query

end % of go_on
% window_name_help(2,hd_result_fig,title_window,[38]); I had erases the (1) so not need anymore

delete(hd_result_fig); % so everything about results is deleted (even the figure itself)
figure_data(ind_fig) = [];

% I restore the window I came from
figure(gcf_mem)
flags = [];
flag_str = [];
