function run_print_one_object(option)
% display one object  or
% display all details for one variable

% option = 1 : on MATLAB Command Window
% option = 2 : on a file called TBM_One_Object, does not work yet, layout for objects not solved

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%


global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief
global gui_position  figure_data  help_level

hd_fig = figure('name','Print one object');
set(gcf,'position',gui_position(:,5));
ind_fig = length(figure_data) + 1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% put its menus
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

k=0;
k=k+1;make_fig_menu(ind_fig,k,'File',0,'','on');
k=k+1;make_fig_menu(ind_fig,k,'Quit',1,'general_clb(9)','on');

menu_manager('create',ind_fig)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% asking what you want to do
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
title = {'select the object'};
b{1} = 'frame';
b{2} = 'structure';
b{3} = 'mapping NA';
b{4} = 'attribute';
b{5} = 'variable';
b{6} = 'belief';
b{7} = 'details on a variable';
b{8} = 'details on a potential';
b{9} = 'quit';

positionUL = [.005 .005]; 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the loop into which we stay until you ask to quit
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

go_on = 1;
while go_on	
	[pushed_button, hd_buttons] = select_buttons(hd_fig,positionUL,b,title,[],{},0,0);
	
	switch pushed_button
	
	case {1,2,4,5,6} 	
		hlist = listing_existing(b{pushed_button},gui_position(:,6),hd_fig);
		
		text = 'Select in the list, the case you want to display, then Done';
		set(hlist(2),'Enable','on','max',1,'min',0,'Value',[1]);
		
		choice = text_with_n_buttons(hd_fig,text,{'Done','Cancel'}, gui_position(:,13));
		
		if choice == 2
			delete(hlist)
			go_on = 0;
		else
	
			% get the position,index,number for the requested structure
			selected_item = get(hlist(2),'Value'); % position	
			its_index = pin_manipulation(b{pushed_button},'pos2ind',selected_item);
			% the index of the object you want to see		
			delete(hlist)  % put listbox away		
			
			disp(' ')
			disp('----------------------------------------------------------')
			fprintf(1,'Details for one object of type: %s \n',[b{pushed_button}] );
			eval(strcat(b{pushed_button},'(',num2str(its_index), ')')) 		
			% displaying object on MATLAB Command Window 
			if pushed_button == 1 % frame object
				fprintf(1,'its elements are\n',[]);
				frame(its_index).elements
			end
			if pushed_button == 5 % attribute object
				if length(attribute(its_index).index)
					fprintf(1,'its indexes are',[]);
					attribute(its_index).index(:).name 
					attribute(its_index).index(:).frame 
				else
					fprintf(1,'its has no indexes\n.',[]);				
				end
			end
		
			if pushed_button == 6 % belief object
				cardinality = prod(belief(its_index).domain_cardinality);
				
				% list available forms for each bp
				for i = 1:length(belief(its_index).bp)
					fprintf(1,'Potential %4i \n',i);
					for j = 1: length(belief(its_index).bp(i).form)
						fprintf(1,'    Form %4i: type = %s\n',[j belief(its_index).bp(i).form(j).type])
					end				
				end
				fprintf(1,'\n',[])
				
				% details
				for i = 1:length(belief(its_index).bp)
					fprintf(1,'its potential %4i / %4i is\n',[i,length(belief(its_index).bp)]);
					for j = 1: length(belief(its_index).bp(i).form)
						fprintf(1,'type = %s\n',belief(its_index).bp(i).form(j).type)
						fprintf(1,'representation = %s\n',belief(its_index).bp(i).form(j).representation)
						if max(ismember(belief(its_index).bp(i).form(j).type,{'m_pdf', 'BetP_pdf','m_from_BetP_pdf'}))							
							fprintf(1,'values of the four parameters a = %7.4f, b = %7.4f, m = %7.4f, s = %7.4f :\n',...
							belief(its_index).bp(i).form(j).values)
						else
							fprintf(1,'values and sets are :\n',[])
							for iset = 1:length(belief(its_index).bp(i).form(j).values)
								fprintf(1,'%8.5f  ',belief(its_index).bp(i).form(j).values(iset))
								% skip if  empty, 						
								nfoc = size(belief(its_index).bp(i).form(j).focal_sets,1);
								if nfoc >= iset 
									display_set(belief(its_index).bp(i).form(j).focal_sets(iset,:),cardinality);
								end
							end
							% belief(its_index).bp(i).form(j).foset_meaning										
						end
					end
				end
			end
		end
	case 3
		disp('your request is not yet available')
		
	case 7 % detail on one variable
		hlist = listing_existing('variable',gui_position(:,6),hd_fig);
		
		text = 'select in the list, the variable you want to display, then Done';
		set(hlist(2),'Enable','on','max',1,'min',0,'Value',[1]);
		
		choice = text_with_n_buttons(hd_fig,text,{'Done','Cancel'}, gui_position(:,13));
		
		if choice == 2
			go_on = 0;
			delete(hlist)
		else
			% get the position,index,number for the requested structure
			selected_var = get(hlist(2),'Value'); % position of the var
			delete(hlist)  % put listbox away
			
			disp(' ')
			disp('----------------------------------------------------------')
			disp('Details on one variable.')
			disp(' ')
			disp('A variable is an attribute on a frame and attribute indexes are instanciated.')
			disp('An attribute is build on a structure and has indexes.')
			disp('A structure is a set of frames, one being the frame of this variable.')
			disp(' ')	
			variable_index = pin_manipulation('variable','pos2ind',selected_var);
			% the index of the object you want to see				
			
			disp('variable')
			variable(variable_index)
			% displaying the variable on MATLAB Command Window 
			
			% getting the frame
			index_fr = pin_manipulation('frame','num2ind',variable(variable_index).frame);
			disp('frame')
			frame(index_fr) % display it
			fprintf(1,'its elements are\n',[])
			frame(index_fr).elements
			
			% getting the attribute
			index_att = pin_manipulation('attribute','num2ind',variable(variable_index).attribute);
			disp('attribute')
			attribute(index_att) % display it
			
			% getting the structure
			index_str = pin_manipulation('structure','num2ind',attribute(index_att).structure);
			disp('structure')
			structure(index_str) % display it
		end
	case 8 % details on one bp in selected mode

		[bel_index, bp_index, form_index] = selecting_one_bel_fct;
		
		if option == 1 % on screen
			out_option = 0;
		else % on file
			answer = inputdlg(' ','Give a positive number for the saved file. To differentiate among files.',1,{'1'});
			out_option = str2num(answer{1});
		end
		showing_bp_selected(bel_index,bp_index,	out_option); 
		
	case 9
		go_on = 0;		
	end
	delete(hd_buttons)
end
% get_default windows back
[index_fig, hd_fig] = handling_all_figures('get_defaults',{});

delete(hd_fig)
figure_data(ind_fig) = [];



