function [wrapped_text, v_space] = fit_text_in_box(handle, cell_text, box_width)
% establishing size of box needed for a text

% input 
% handle    : handle of the object to which the text is going to be fitted
% cell_text	: array of cells, each containing a text, but I am protected against error

% several cell_text{i} means several text, only one paragraph accpeted for each text.
% accepted here 
%		cell_text = 'ttt', 
%		cell_text={'ttt','r'}, 
%		cell_text{1}='ttt', cell_text{2}='r', 

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%



position = [.5 .5 box_width .10];
h = uicontrol(handle,'Position',position,'visible','off'); 
% stupid but you must create a temporary object 
% as textwrap needs a handle and a box_width.
% This causes a little flash in the middle of the screen when I am used.

if ischar(cell_text) 
	[wrapped_text{1}, posit]  = protected_textwrap(h,{cell_text});
	v_space(1) = posit(4) ;
else			
	for iq = 1:length(cell_text)  % for ecah query
		% making it sure format of text is OK
		temp_text = cell_text{iq};
		while iscell(temp_text) % it shpould be a string
			temp_text  = temp_text{1}; % going from cell toward string
		end
		[wrapped_text{iq}, posit]  = protected_textwrap(h,{temp_text}) ;
		v_space(iq) = posit(4) ;
	end
end
delete(h) % delete the useles figure buld from textwrap
