function [index_fig, hd_fig] = handling_all_figures(what_todo,param)
% figure information handling

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%


% depending on what_todo:

% which	= 'create'
% All figures are open here
% simplifies adaptation for other systems
% all figure_handles are stored in ONE vector called : figure_handles
% the index = the figure, NOT the uicontrol within the figures.

% what_todo	= 'get_index'
% index_fig(i) is index k in fig_hd_name{k} = param{i}
% and param{i} is a 'text' like 'Root Window'

% what_todo	= 'put_in_front'
% Figures with name = param{k} are brought in front with figure(param{k})

% % % % % % % % what_todo	= 'get gui index'
% % % % % % % % param is a list param(i) with handle of figures
% % % % % % % % index_fig contains the index of the gui used for that figure

% output 
% index_fig	 = index of figure when get_index
% hd_fig	 = handle of the figures when put_in_front

% BEWARE param must be loke {'name'} or {'name1','name2'} or param{1} = 'name'...
% Figures CANNOT be deleted, too dangerous, as if you ask it later, you may crash
% or you have to check each time. Easier = keep all figures.

global figure_handles 
global gui_position

% For each figure (index = k), I need 
% gui_indx(k)  		the index of the gui_position
% fig_hd_name{k} 	a name
% Its handle is figure_handles(k)

% the four defaults figures MUST be numbered k = 1 to 2 
k = 0;
% The UL figures
k = k+1;fig_hd_name{k} = 'Root Window';gui_indx(k) = 1;

% % The LL figures
% k = k+1;fig_hd_name{k} = 'Comments';gui_indx(k) = 8;
% 
% % The LR figures
% k = k+1;fig_hd_name{k} = 'Instructions';gui_indx(k) = 9;

% The UR figures
k = k+1;fig_hd_name{k} = 'General Window';gui_indx(k) = 5;

% The UL alternate figures
k = k+1;fig_hd_name{k} = 'Alternate Root Window';gui_indx(k) = 1;

% The UL alternate figures
k = k+1;fig_hd_name{k} = 'Alternate Root Window 2';gui_indx(k) = 1;

% The UR alternate figures
k = k+1;fig_hd_name{k} = 'Alternate General Window';gui_indx(k) = 5;

% The UR alternate 2 figures
k = k+1;fig_hd_name{k} = 'Alternate General Window 2';gui_indx(k) = 5;

% The whole screen figure
k = k+1;fig_hd_name{k} = 'Full Screen General Window';gui_indx(k) = 19;

% A set of figures in the middle of the screen for temporary displaying data 
% and deleting it right after
k = k+1;fig_hd_name{k} = 'Temporary Window';gui_indx(k) = 20;
k = k+1;fig_hd_name{k} = 'Temporary Window Alt1';gui_indx(k) = 20;

% clean figure_handles for deleted figure
if ~strcmp(what_todo,'create')
	hd_fig_now = findobj('type','figure');
	if length(hd_fig_now)	
		for k = 1:length(figure_handles)
			if ~ismember(figure_handles(k),hd_fig_now) 
				figure_handles(k) = -1;
			end
		end	
	end
end

index_fig = [];
hd_fig = [];

switch what_todo

case 'create'
	for k = 1: 2 %4 % length(fig_hd_name)
		figure_handles(k) = figure('Name',fig_hd_name{k},'userdata','TBM_Figure');
		set(gcf,'position', gui_position(:,gui_indx(k))');	
	end
	
	set(figure_handles(1),'name', 'Root Window: Menus OFF');
	for k = 3:length(fig_hd_name)
		figure_handles(k) = -1; 
	end
	if ~strcmp(computer,'MAC2')
		% for PCWIN UNIX I must put a fictious menu in the UR figures,
		% so the upper borders have same height
		% the UR figure, 
		figure(figure_handles(2)) ; % the figure becomes the acitve one
		handle_TBM_control = uimenu('Label',' '); % and gets an empty menu
		% I muust fix the FIRST time I display, strange bug on OSX and ....
		% on MAC2 useless, but MACOSX and LINUX and PC need it (crazy)
		postemp1 = get(figure_handles(1),'position');
		postemp2 = get(figure_handles(2),'position');
		if postemp2(2) ~= postemp1(2)
			postemp2(2) = postemp1(2);
			set(figure_handles(2),'position', postemp2);
		end
	end

	% putting the UL Root Window in front
	figure(figure_handles(1));
	
	% getting the 3 extra buttons (bottom left)
	% hiding and getting back figures	
	% % % % 	windows_buttons
	
case 'put_in_front'
	for i = 1:length(param)
		index_temp = find(strcmp(fig_hd_name,param{i}));
		hd_fig(i) = give_me_figure(index_temp,fig_hd_name,gui_indx);
	end

case 'get_index'
	% find index of the figure name in what_todo
	% only used for menu_off to know where is Help Figure
	for i = 1:length(param)
		index_fig(i) = find(strcmp(fig_hd_name,param{i}));
	end
	% 	hd_fig = figure_handles(index_fig); who said it had to be activated
	
	
case 'get_defaults' % and delete the others
	% get the UR UL figures in front	
	for i = 1:2
		if ishandle(figure_handles(i))
			set(figure_handles(i),'visible','on');
		end
	end
	set(figure_handles(1),'name', 'Root Window: Menus OFF');
	
	for k = 3:length(figure_handles)
		if ishandle(figure_handles(k)); 
			delete(figure_handles(k));
		end
	end	

	% 	rewaking_TBM_figures
	% 	for i = [2 3 4 1]
	% 		hd_fig(i) = give_me_figure(i,fig_hd_name,gui_indx);
	% 	end
	% % % % case 'get gui index'
	% % % % 	% param is the handle and I want to know its gui index
	% % % % 	for i = 1:length(param)	
	% % % % 		index_fig(i) = gui_indx(find(figure_handles == param(i)))  ;
	% % % % 	end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function hd_fig = give_me_figure(index_temp,fig_hd_name,gui_indx)
% checking that figure exist, if not create it, if yes put it in front
global figure_handles 
global gui_position

% checkiong that figure_handles(index_temp) is a handle and that its related figure is still a child of root(exist)
ok_hd = 0;
if ishandle(figure_handles(index_temp))
	root_children = get(0,'children');	
	for ii = 1:length(root_children)
		if root_children(ii) == figure_handles(index_temp)
			ok_hd = 1;
		end
	end
end

if ok_hd == 1
	% so the figure is in root children and has an ok handle
	% we only wake it up
	hd_fig = figure_handles(index_temp);
	set(hd_fig,'visible','on');
	figure(hd_fig);		
else 
	% we rebuild the figure
	figure_handles(index_temp) = figure('Name',fig_hd_name{index_temp},...
	'userdata','TBM_Figure');
	set(gcf,'position', gui_position(:,gui_indx(index_temp)));	
	hd_fig = figure_handles(index_temp);
	
	if index_temp == 1 
		set(figure_handles(index_temp),'name', 'Root Window: Menus OFF');
	end	

	switch computer
	case 'MAC2'
		% mothing is needed, menu are outside figures	
	case 'PCWIND'
		if index_temp == 2 |  index_temp == 5 | index_temp == 6 % the Upper figures need extra line on PC
			handle_TBM_control = uimenu('Label',' '); % UR in PC gets an empty menu
		end
	otherwise
		if index_temp == 2 |  index_temp == 5 | index_temp == 6 % the Upper figures need extra line on PC
			handle_TBM_control = uimenu('Label',' '); % UR in other machine gets an empty menu assuming they behave like PC
		end
	end
end

