function hand = button_list(hd_fig, position, title, list, clb_in,...
hidden_buttons, tooltip)
% display a set of buttons and each time you click one it executes its callback

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

nbr_buttons = length(list);

posFig = get(hd_fig,'Position');  % not normalized as it is a figure
button_h = 20/posFig(4);	% normalized
button_w = 130/posFig(3);	% normalized
height_title = button_h ; 
skip_w =.01; skip_h = .01;

total_width = button_w + 2*skip_w ;
total_height = nbr_buttons*(button_h + skip_h) + 2*skip_h + height_title ;
% I put skip_h between buttons	
% getting buttons positions 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
%
% displaying the external frame
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
pos_frame = [ position(1)   ...
1 - position(2) -  total_height...
total_width 	total_height ];

jbk = 1;
hand(jbk) = uicontrol('Parent',hd_fig, ...
'Position',pos_frame, ...
'BackgroundColor',[.9 .9 .9],...
'Style','frame');				

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
%
% displaying the title
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	

pos = [ position(1) + skip_w ...
1 - position(2) - height_title - skip_h ...
total_width - 2*skip_h...
height_title] ;

jbk = jbk + 1;
hand(jbk) = uicontrol('Parent',hd_fig, ...
'Position',pos,...
'String',title,...
'ForegroundColor',[1 0 0],...
'Style','text');	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
%
% displaying the buttons and waiting for a pushbutton
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	

pos = [pos(1)    pos(2)   button_w      button_h];

for jb = 1:length(list)
	jbk = jbk + 1;
	hand(jbk) = uicontextmenu('Parent',hd_fig);
	
	% constructing a string for callback
	clb = strcat(clb_in,num2str(jb),');uiresume;');
	% char array built, looks like     general_clb '42'
	% and the call back put in flags(1) the number 42
	
	pos(2) = pos(2) - skip_h - button_h;
	jbk = jbk + 1;	
	hand(jbk) = uicontrol('Parent',hd_fig, ...
	'Position',pos, ...
	'String',list{jb},...
	'Callback',clb,...
	'UIContextMenu',hand(jbk-1));	
	
	hd_buttons(jb) = hand(jbk);
	
	if nargin >= 7
		% adding the tooltip if they exist
		if ~isempty(tooltip)
			set(hand(jbk) ,'TooltipString',tooltip{jb});
		end
	end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
%
% some buttons are disable and dimmed
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
if nargin >= 6
	for i = 1:length(hidden_buttons)
		set(hd_buttons(hidden_buttons(i)),'enable','off');	
	end
end

