function hui = display_list_var_element(ind_var)
% building a table with the variable short names and their possible values
% logical variables are listed as one column

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global variable frame gui_position 
global Which_Courier

[index_fig, hd_fig] = handling_all_figures('put_in_front',{'Root Window'});
Help_handle = hd_fig(1);

ind = pin_manipulation('frame','num2ind',[variable(ind_var).frame]);
nbr_row = max([frame(ind).cardinality]) + 1;

blk(1:nbr_row) = ' ';
tab = [];
i_prop = 1; % the indexes for the proposition list
col_prop{1} = 'prop';

for iv = 1:length(ind)
	jv = ind(iv);
	if jv > 1 % we skip frame(1) as logical
		elem{1} = variable(ind_var(iv)).short_name;
		for i = 1:frame(jv).cardinality
			elem{i+1} = frame(jv).elements(i,:);
		end
		for i = frame(jv).cardinality+2 : nbr_row
			elem{i} = ' ';
		end
		column = strvcat(elem);
		tab =  [tab blk' column];
	else
		i_prop = i_prop + 1;
		col_prop{i_prop} = variable(ind_var(iv)).short_name;
	end
end

if i_prop % case where there are propositions
	for i = i_prop+1:nbr_row
		col_prop{i} = ' ';
	end
	column = strvcat(col_prop);
	tab =  [tab blk' column];
	
end

hui = uicontrol('Parent', Help_handle ,...
'Style','listbox',...
'Position',gui_position(:,3),...
'String',tab,...
'FontName',Which_Courier);

