function string = gui_display_one_object(type, index)
% building a string that display the content of one opbject
% type is object type like 'frame', 'belief', ...
% index is the index of the obejct so we get object(index).
% string is the {'...',''...} vector with the test ready for uicontrol

% Do not display object details, only that it is an object 

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief

max_nbr_char_field = 30; % all field names should be less than 30 char long.

eval(['object = ', type,'(',num2str(index),');']);
f_name = fieldnames(object);
nbf = size(f_name,1);
for i = 1:nbf
	fv = getfield(object,f_name{i});
	% making all fields as strings	
	if isnumeric(fv);
		f_value{i} = num2str(fv);
	elseif isempty(fv) 
		f_value{i} = ' ';
	elseif isa(fv,'cell')  % when = {'rrr'} and not 'xx'
		% char is   'xxxxx'
		% a = {'rr'}; ischar(a) no, iscell(a) yes,  ischar(a{1}) yes
		f_value{i} = fv{1};
	elseif isa(fv,'struct')  % the bp case
		f_value{i} = 'structured object';
	else
		f_value{i} = fv;
	end 	
end	

clear string
nsymb = length(type);
blankhead(1:max_nbr_char_field - nsymb) = ' ';
string{1} = [blankhead,upper(type)];
clear blankhead ;
string{2} = ' ';
istr = 2;

for i = 1:nbf
	nsymb = length(f_name{i});
	blankhead(1:max_nbr_char_field - nsymb) = ' ';
	for ik = 1:size(f_value{i},1)
		if ik < 8 | ik == size(f_value{i},1)
			% I print the first 8 elements and the last one, avoid long list
			istr = istr + 1; 	
			string{istr} = [blankhead,f_name{i},' : ',f_value{i}(ik,:)];
		end
	end
	clear blankhead ;
end

