function [boxes_status] = list_check_boxes(title, text,fig_hd, position, active) 
% display a list of pseudo check boxes where you can click on those you want to select

% deselection achieved by clicking on a selected one.

% BEWARE checkbox and radiobutton do not work on Mac once default are changed!!!
% togglebutton is OK
% so we build a list of toggle b utton with a text to its right

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global flags
global button_size


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
%
%  preparing the dimensions
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	

nbr_buttons = length(text);

% to put the box in a nice place relative to the text
shifth = .002 ; 
boxh   = .016 ;

shiftv = .011 ; 
boxv   = .015 ; 

% text position
textv  = .030 ; 

% shift for borders
shift_border = .005;

% % % % button_size(1) = 50; % width buttons in pixel
% % % % button_size(2) = 20; % height buttons in pixel

% bottom button for Done
pss = get(fig_hd,'Position');
w_done_but = button_size(1)/pss(3); 	
h_done_but = button_size(2)/pss(4); 	

% getting wrapped title height
[Title_Wrapped, height_title] = height_of_wrapped_text(title,position(3)-4*shift_border,fig_hd);

pos_ext_frame = position;

pos_title_frame = [ position(1) + shift_border ...
position(2) + position(4) - 3*shift_border - height_title ...
position(3) - 2*shift_border...
height_title + 2*shift_border];

pos_title_text = pos_title_frame + [shift_border, shift_border,...
-2*shift_border, -2*shift_border];

pos_done_but = [position(1) + (position(3)-w_done_but)/2 ...
position(2) + shift_border    w_done_but   h_done_but];

pos_query_frame = [position(1) + shift_border ...
position(2) + 2*shift_border + h_done_but ...
position(3) - 2*shift_border ...
pos_title_frame(2) - 2*shift_border - h_done_but];

top = pos_query_frame(2) + pos_query_frame(4);

pos_qu_box = [pos_query_frame(1)+2*shifth    top+shiftv   boxh   boxv];

pos_qu_text = [pos_qu_box(1)+pos_qu_box(3)+shift_border...
top   position(3)-4*shift_border-(pos_qu_box(1)+pos_qu_box(3))     textv];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
%
% external frame
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
index_hd = 0;
index_hd = index_hd + 1;
hd(index_hd) = uicontrol('Parent',fig_hd, ...
'Position',pos_ext_frame, ...
'Style','frame');		

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
%	
% title frame + title
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	

index_hd = index_hd + 1;
hd(index_hd) = uicontrol('Parent',fig_hd, ...
'Position',pos_title_frame,...
'Style','frame');	

index_hd = index_hd + 1;
hd(index_hd) = uicontrol('Parent',fig_hd, ...
'Position',pos_title_text,...
'String',Title_Wrapped,...
'ForegroundColor',[1 0 0],...
'Style','text');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
%
% done button  
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	

index_hd = index_hd + 1;
index_Done = index_hd ;
hd(index_hd) = uicontrol('Parent',fig_hd, ...
'Position',pos_done_but ,...
'String','Done',...
'BackgroundColor',[1 0 0],...
'Style','pushbutton',...
'userdata','notDone',...
'callback','set(gco,''userdata'',''Done''), uiresume;');	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
%
% text frame
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	

index_hd = index_hd + 1;
hd(index_hd) = uicontrol('Parent',fig_hd, ...
'Position',pos_query_frame,...
'Style','frame');	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
%
% toggle button + text 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	

for i = 1:nbr_buttons
	pos_qu_text(2)	= pos_qu_text(2) - textv - shift_border;
	index_hd = index_hd + 1;
	hd(index_hd) = uicontrol(...
	'parent',fig_hd,...
	'position', pos_qu_text,...
	'string',text{i},...
	'style','text',...
	'horizontalAlignment','left') ;
	
	clb = ['run_clb_check_boxes(',num2str(i),');'];
	
	pos_qu_box(2) = pos_qu_box(2) - textv - shift_border;
	if active(i)
		index_hd = index_hd + 1;
		hd(index_hd) = uicontrol('parent',fig_hd,...
		'Style','togglebutton',...
		'position',pos_qu_box,...
		'callback',clb,...
		'backgroundcolor','white');
	end
end
figure(fig_hd) % necessary to activate the togglebuttons correctly

waitfor(hd(index_Done),'Userdata','Done')
% I wait till you push Done button

boxes_status = flags; % flags is a vector
flags = [];
delete(hd)
