function back_to_menu
% the real controller of all the pull-down menus
% this function loops as long as we don't quit TBMLAB 
% the uiwait at the end waits for a pull donw menu selection

%
%   Version : Dec 31,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global help_level  proceed_with_tbm  pull_down_menu flag
global Which_Courier  figure_data gui_position
global figure_handles  stored_text


while proceed_with_tbm
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% get the figure
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	hd_help_fig = figure_handles(1); % the help figure UL
	hd_list_menu = figure_handles(2); % the UR figure
	
	% get rid of welcome if exists
	delete(findobj('Userdata','I_am_iddle'));
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% In help figure UL, the go_on button in green
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	text = {' ','Tasks finished.','Select a menu.'}; 	
	% 'Remember: the simplest strategy = you build the objects (see File and Edit menus)',...
	% 'Then you run some algorithms or you go to the graphical interface.'};
	
	hd_useless(1) = uicontrol(hd_help_fig,'userdata','I_am_iddle',...
	'position',gui_position(:,8),...
	'style','frame',...
	'backgroundcolor',[.8 .8 .8]);
	hd_useless(1) = uicontrol(hd_help_fig,'userdata','I_am_iddle',...
	'position',gui_position(:,8) + [.005 .005 -.01 -.01]',...
	'backgroundcolor','g',...
	'style','frame');
	hd_useless(3) = uicontrol(hd_help_fig,'userdata','I_am_iddle',...
	'position',gui_position(:,8) + [.01 .01 -.02 -.02]',...
	'style','text',...
	'string',text,...
	'backgroundcolor','g',...
	'Horizontalalignment','center');
	
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% In UR figure , the actions of the menus
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	if help_level ~= 0
		% explanation of what each menu does in UR window. 
		% Can be read from time you ask menu till you choose one.
		% disappear when choosing amenu, in which case all object with userdata = 'I_am_iddle' disappear		
		% layout, forget about blanks for alignment as char not equal spaces, and tab does not work as it should
		
		set(hd_list_menu,'name','Menu actions');
		
		handle_text = uicontrol(hd_list_menu,...
		'Position',[.001 .001 .998 .998],...
		'Style','listbox',...
		'Max',1000,'Min',0,...
		'Value',[],...
		'String',stored_text{5},...
		'fontname',Which_Courier);  
		set(handle_text,'Userdata','I_am_iddle'); % so deleted when selecting any menu
		
	else 
		handle_text = uicontrol(hd_list_menu,...
		'Position',[.001 .001 .001 .001],...
		'Style','text',...
		'String',' ');
		% so handle_text exists and I can delete it later without crash	
		set(handle_text,'Userdata','I_am_iddle'); % so deleted when selecting any menu
		
% 		% I made General Window hidden with visible off so I ccan see Command Window behind
% 		% its handle is in figure_handles(2) (see handling_all_figures)
% 		% it is used ONLY in short_cuts (frames and logical propositions) and in preferences
% 		% it is rewake when entering them
% 		set(figure_handles(2),'visible','off')
% 		% but later it is rewaken . To be fixed later version	
	end % of if help level

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% wakening the pull down menus
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	figure(hd_help_fig);
	flag = 0;
	menu_on
	
	uiwait(hd_help_fig)
	
	% this will loop till I say quit
	% its uiresume are at the end of ecah uimenu instruction
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% there are special tricks here used as to handle a Matlab bug
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% if I select menu TBM Tabulator, then callback put flag = 101 and I run it from here
	% running it from callback does not work properly (frames of selected cells are frozen - remain black)
	if flag == 101
		tbm_tabulator('Full_Screen','New',[]);
		% from here 
	end

end % while proceed_with_tbm
