function color25 = list_color(option)
% list of 25 distinct colors for plot 
% the first 7 are black, red, blue, green, pink, yellow, turquoise
% if option is absent, no display, else whatever is in option, we get details about them
% normaly one use it as   color25 = list_color
% is part of global as    colors

color25 = [...
0 0 0;...
1 0 0;...
0 0 1;...
0 1 0;...
1 0 1;...
1 1 0;...
0 1 1;...
0 0 .6;...
0 .4 1;...
0 .6 1;...
0 .8 1;...
.6 1 1;...
0 .6 0;...
.6 1 .2;...
.6 0 0;...
.6 0 1;...
.8 .4 0;...
.8 .4 .8;...
.8 .6 .8;...
.8 .6 0;...
.8 .8 0;...
.8 1 .4;...
1 .8 .6;...
1 .2 .4;...
.7 1 1];

% based on 
% [xx ind ] = sort(rand(1,18))
% ind + 7
ord = [9 12 23 19 11 18 21 17 10 25 13  8 15 20 16 22 14 24];
% done to get colors at random 
color25(ord,:) = color25(8:25,:);

if nargin
	close all force
	hd_fig = figure('Units','pixels');
	set(hd_fig,'position',[5 5 1000 700]);
	pos = [-40 600 50 10];
	
	pos1 = [-100 600 80 10];
	pos2 = [-20  600 40 10];
	
	l = 0;
	i = 0
	
	pos1(1) = pos1(1) + 150;
	pos2(1) = pos2(1) + 150;
	
	pos1(2) = 600;
	pos2(2) = 600;
	k = 1;
	for j = 1:size(color,1)
		pos1(2) = pos1(2) - 15;
		pos2(2) = pos2(2) - 15;
		
		l = l + 1;
		hd(l) = uicontrol('position',pos1,...
		'style','text',...
		'Units','pixels',...
		'string',[num2str(i) num2str(j) num2str(k)]);
		
		l = l + 1;
		hd(l) = uicontrol('position',pos2,...
		'backgroundcolor',color25(j,:),...
		'Units','pixels',...
		'style','frame');		
	end
end


