function hd_help = window_name_help(in_option,hd_fig,name,help_numbers,clb_quit)
% when I open a window, I name it and I put a file menu with a File/Quit and a Help menu (2 or 4 items)

% in option = 1 = I create it, 
%			= 2 = I close it,
% 			= 3 = when hidden by other window, 
% 			= 4 = when there are other menus and all are built in the calling fct (see object_editor)
% I need hide/uiwait/rewake
% in_option negatif = no button help, only Window Help (thus 2 items)
% in_option positif =    button help, plus Window Help (thus 4 items)
% hd_fig = the handle of the new figure where I puit these menus
% name = the name for that figure
% help_numbers = the numbers of the Window helps (see init_stored_texts)
% clb_quit is the callback instruction for the quit option
% if clb_quit is not present, I don't create a menu File/Quit, I only create Help

%
%   Version : Aug 12, 03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global hd_help_object   hd_help_menu    name_calling_window  menu_type
global	help_label
% menu_type contains the type of the 7 possible menus
% they can be none, File, Quit, Window Helps On, Window Helps Off, Button Helps On, Button Helps Off

hd_help = ''; % XXXXX unused but needed to avoid a warning, to delete one day

option = abs(in_option);

switch option
case {1,3,4} % when entering window that needs a help
	ind = size(hd_help_menu,1);
	% ind is index of last window atop of which I put the present one (nested windows)
	
	% making sure past help is hidden	
	if ind
		callback_help_menu(2,[],hd_fig);
		% made past help hidden
	end

	ind = ind + 1; % ind is now index of this new window
	
	% initilaization of menu_type
	if option == 1
		for i = 1:7
			menu_type{ind,i} = 'none';
		end
	end

	% I collect the default name of the hd_fig window (the new one) that I rename
	name_calling_window{ind} = get(hd_fig,'name');
	% I rename the window
	set(hd_fig,'name',name);
	
	hd_help_object(ind) = -1; % so it exists
	% hd_help_object will be the handle of the displayed text
	% generated by    hd_help_object(ind) = display_helps(0,[help_numbers]);
	% in callback_help_menu
	
	if option < 4 % I skip when menu handled in calling fct
		if option == 1
			clb1 = ['callback_help_menu(1,[',num2str(help_numbers),'],gcf);'];  
		else 
			clb1 = ['callback_help_menu(5,[',num2str(help_numbers),'],gcf);'];  
		end
		clb2 = ['callback_help_menu(2,[],gcf);'];
		clb3 = ['callback_help_menu(3,[],gcf);'];
		clb4 = ['callback_help_menu(4,[],gcf);'];
		
		k = 0;
		if nargin >= 5
			k=k+1;hd_help_menu(ind,k) = uimenu('Label','File'); 
			menu_type{ind,k} = 'File';
			km = k;
			k=k+1;hd_help_menu(ind,k) = uimenu(hd_help_menu(ind,km),'Label','Quit','Callback',clb_quit);
			menu_type{ind,k} = 'Quit';
		end
	
		k=k+1;hd_help_menu(ind,k) = uimenu('Label',help_label);
		menu_type{ind,k} = 'Help';
		km = k;
		k=k+1;hd_help_menu(ind,k) = uimenu(hd_help_menu(ind,km),'Label','Window Helps On','Callback',clb1);
		menu_type{ind,k} = 'Window Helps On';
		k=k+1;hd_help_menu(ind,k) = uimenu(hd_help_menu(ind,km),'Label','Window Helps Off','Callback',clb2);
		menu_type{ind,k} = 'Window Helps Off';
		% off hidden initialy
		set(hd_help_menu(ind,k),'enable','off')
		
		% the help on button may not be there if there is no buttons, etc... known if option negative
		if in_option > 0
			k=k+1;hd_help_menu(ind,k) = uimenu(hd_help_menu(ind,km),'Label','Button Helps On','Callback',clb3);
			menu_type{ind,k} = 'Button Helps On';
			k=k+1;hd_help_menu(ind,k) = uimenu(hd_help_menu(ind,km),'Label','Button Helps Off','Callback',clb4);
			menu_type{ind,k} = 'Button Helps Off';
			% off hidden initialy
			% help text in Utilities/TBM_Helps/help_on_buttons/get_help_text_for_set_buttons
			set(hd_help_menu(ind,k),'enable','off')		
		end
	else
		hd_help_menu(ind,[ 1 2 3]) = ' ';
	end

case 2  % when quiting window that had a help
	ind = size(hd_help_menu,1);
	set(hd_fig,'name',name_calling_window{ind}); 
	% default name of window back
	for j = 1:size(hd_help_menu,2)
		if ishandle(hd_help_menu(ind,j)) & hd_help_menu(ind,j)  
			% so root not deleted
			delete(hd_help_menu(ind,j))	% the menu are gone
		end
	end
	if ishandle(hd_help_object(ind))
		delete(hd_help_object(ind)); % the text is gone
	end
	% dimension reduced
	name_calling_window(ind) = [];
	hd_help_menu(ind,:) = [];
	hd_help_object(ind) = [];
	
	set(hd_fig,'WindowButtonMotionFcn','')	
	
	if ind > 1
		% refresh past helps
		callback_help_menu(2,[],hd_fig);
	end
end	
