function [botom_level,hdl] = control_boxes( option,title,text,posULW,hd_fig)
% Control Panel: display of multiple queries in different forms. 

% beware of data communication with global flags. 
% when displaying flags store ihd (the handles)
% when displaying DO IT button, global flags has stored what must be read in control panel
% flags{next_one,1} = [hd_obj,...] of objects to be read
% flags{next_one,2} = ind_obj  (togglebutton, queries, muliplechoice)
% flags{next_one,3} = [val_answers,...] values of each answer at output

% botom_level = level where botom located , so I can use it as upper for enxt conrol panel
% hdl are those handle where we will have to getr some data (for hd_gr

% when DO IT puched flags contains data read

% you build the various boxes (text, togglebuttons, queries, mutliplechoice, and ONE puchbutton)
% you can change the answers and when done pushbutton for DO IT
% Once pushbutton pushed, it read all data, and excecute the actions.
%
% How to use it;
% ask the various objects, put the pushbutton. uiwait for the puchbutton

% the callback are 
% text none
% togglebuttons : get value
% queries : answers with get string
% multiplechoice : look every toggelbuttons, check which in on and off, several allowed

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global Which_Courier

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% no empty title , no empty text
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

space_fr = .003;
font = Which_Courier;
but_h = .03;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% begin gui section
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ihd = 0;
hdl = [];
position = [posULW(1)+space_fr  .005    posULW(3)-2*space_fr .95];

switch option

case 'text'
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% text only, no callback
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% wrapping title and text
	h = uicontrol(hd_fig,'Position',position,'fontname',font); 
	% stupid but you must create a temporary object 
	% as textwrap needs a handle and a box_width.
	[wrapped_title, posit]  = protected_textwrap(h,title);
	title_v_space = posit(4);
	[wrapped_text, posit]  = protected_textwrap(h,text);
	text_v_space = posit(4) ;
	delete(h);
	
	% + 2 = title and header line, need one space at top, but 2 at bottoms
	pos_frame = [posULW(1)				posULW(2)-title_v_space-text_v_space-4*space_fr		posULW(3)				title_v_space+text_v_space+4*space_fr  ];
	pos_title = [posULW(1)+space_fr		posULW(2)-title_v_space-space_fr-space_fr			posULW(3)-2*space_fr	title_v_space+space_fr ];
	pos_text  = [posULW(1)+space_fr		posULW(2)-title_v_space-text_v_space-3*space_fr		posULW(3)-2*space_fr	text_v_space+space_fr ];
	
	ihd = ihd + 1;
	hd_gr(ihd) = uicontrol('parent',hd_fig,...
	'position',pos_frame,...
	'Style','Frame');
	
	ihd = ihd + 1;
	hd_gr(ihd) = uicontrol('parent',hd_fig,...
	'position',  pos_title,...
	'String',wrapped_title,...
	'ForegroundColor','red',...
	'FontName',font,...
	'Style','Text');
	
	% get  var
	ihd = ihd + 1;
	hd_gr(ihd) = uicontrol('parent',hd_fig,...
	'position',pos_text,...
	'Style','Text',...
	'HorizontalAlignment','left',...
	'FontName',font,...
	'String',wrapped_text);
	
	hdl = [];
	
case 'togglebutton'

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% toggle buttons in a frame + text(in button, SHORT) + 1 button
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% wrapping title
	h = uicontrol(hd_fig,'Position',position,'fontname',font); 
	% stupid but you must create a temporary object 
	% as textwrap needs a handle and a box_width.
	[wrapped_title, posit]  = protected_textwrap(h,title);
	title_v_space = posit(4);
	delete(h);
	
	pos_frame = [posULW(1)				posULW(2)-title_v_space-but_h-4*space_fr		posULW(3)				title_v_space+but_h+4*space_fr  ];
	pos_title = [posULW(1)+space_fr		posULW(2)-title_v_space-space_fr-space_fr		posULW(3)-2*space_fr	title_v_space+space_fr ];
	pos_butt  = [posULW(1)+5*space_fr	posULW(2)-title_v_space-but_h-3*space_fr		posULW(3)-10*space_fr	but_h+space_fr ];
	
	ihd = ihd + 1;
	hd_gr(ihd) = uicontrol('parent',hd_fig,...
	'position',pos_frame,...
	'Style','Frame');
	
	ihd = ihd + 1;
	hd_gr(ihd) = uicontrol('parent',hd_fig,...
	'position',  pos_title,...
	'String',wrapped_title,...
	'ForegroundColor','red',...
	'FontName',font,...
	'Style','Text');
	
	ihd = ihd + 1;
	hd_gr(ihd) = uicontrol('parent',hd_fig,...
	'position',  pos_butt,...
	'String',text,...
	'ForegroundColor','red',...
	'BackgroundColor','yellow',...
	'FontName',font,...
	'Style','togglebutton');
	
	hdl(1) = hd_gr(ihd);
	
case 'pushbutton'

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% pushbuttons in a frame + title [] + text []
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	title = 'Push button only when all requests over';
	text = 'DO IT';
	
	% wrapping texts
	h = uicontrol(hd_fig,'Position',position,'fontname',font); 
	% stupid but you must create a temporary object 
	% as textwrap needs a handle and a box_width.
	[wrapped_title, posit]  = protected_textwrap(h,title);
	title_v_space = posit(4);
	delete(h);
	
	pos_frame = [posULW(1)				posULW(2)-title_v_space-but_h-4*space_fr		posULW(3)				title_v_space+but_h+4*space_fr  ];
	pos_title = [posULW(1)+space_fr		posULW(2)-title_v_space-space_fr-space_fr		posULW(3)-2*space_fr	title_v_space+space_fr ];
	pos_butt  = [posULW(1)+5*space_fr	posULW(2)-title_v_space-but_h-3*space_fr		posULW(3)-10*space_fr	but_h+space_fr ];
	
	ihd = ihd + 1;
	hd_gr(ihd) = uicontrol('parent',hd_fig,...
	'position',pos_frame,...
	'Style','Frame');
	
	ihd = ihd + 1;
	hd_gr(ihd) = uicontrol('parent',hd_fig,...
	'position',  pos_title,...
	'String',title,...
	'ForegroundColor','red',...
	'FontName',font,...
	'Style','Text');
	
	ihd = ihd + 1;
	hd_gr(ihd) = uicontrol('parent',hd_fig,...
	'position',  pos_butt,...
	'String',text,...
	'ForegroundColor','black',...
	'BackgroundColor','red',...
	'FontName',font,...
	'callback','clb_control;uiresume;',...
	'userdata','not done',...
	'Style','pushbutton');
	
	hdl(1) = hd_gr(ihd);
	
case 'multiplechoice'

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% several small toggelbuttons in a frame + title +   buttons one per text
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% wrapping texts
	h = uicontrol(hd_fig,'Position',position,'fontname',font); 
	% stupid but you must create a temporary object 
	% as textwrap needs a handle and a box_width.
	[wrapped_title, posit]  = protected_textwrap(h,title);
	title_v_space = posit(4);
	delete(h);
	position(3) = .8*posULW(3)-2*space_fr;
	
	h = uicontrol(hd_fig,'Position',position,'fontname',font); 	
	for i = 1:length(text)
		[wrapped_text{i}, posit]  = protected_textwrap(h,text{i});
		text_v_space(i) = posit(4);
	end
	delete(h);	
	
	but_h = .02;
	total_h = title_v_space + sum(text_v_space) + (3+length(text))*space_fr;
	
	pos_frame = [posULW(1)				posULW(2)-total_h 								posULW(3)				total_h  ];
	pos_title = [posULW(1)+space_fr		posULW(2)-title_v_space-space_fr-space_fr		posULW(3)-2*space_fr	title_v_space+space_fr ];
	
	ihd = ihd + 1;
	hd_gr(ihd) = uicontrol('parent',hd_fig,...
	'position',pos_frame,...
	'Style','Frame');
	
	ihd = ihd + 1;
	hd_gr(ihd) = uicontrol('parent',hd_fig,...
	'position',  pos_title,...
	'String',wrapped_title,...
	'ForegroundColor','red',...
	'FontName',font,...
	'Style','Text');
	
	posit_but  = [posULW(1)+space_fr					posULW(2)-title_v_space	.1*posULW(3)			but_h ];
	posit_text = [posit_but(1)+posit_but(3)+space_fr	posULW(2)-title_v_space-3*space_fr	.8*posULW(3)-2*space_fr	0 ];
	
	for i = 1:length(text)
		posit_text(2) = posit_text(2) - text_v_space(i) - space_fr; 
		posit_text(4) = text_v_space(i) + space_fr;
		posit_but(2)  = posit_but(2)  - text_v_space(i) - space_fr ;
		
		ihd = ihd + 1;
		hd_gr(ihd) = uicontrol('parent',hd_fig,...
		'position',  posit_text,...
		'String',wrapped_text{i},...
		'FontName',font,...
		'HorizontalAlignment','left',...		
		'Style','text');
		
		clb = 'vv = get(gco,''value'');if vv == 0; set(gco,''BackgroundColor'',''white'');else;set(gco,''BackgroundColor'',''red'');end;';
		ihd = ihd + 1;
		hd_gr(ihd) = uicontrol('parent',hd_fig,...
		'position',  posit_but,...
		'BackgroundColor','white',...
		'Callback',clb,...
		'Style','togglebutton');
		
		hdl(i) = hd_gr(ihd);
	end

case 'queries'

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% several queries in a frame + title +  boxes one per text
	% default answers alos in text, text = q1 q2 q3 ... def1 def2 def3 ...
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	nbr_text = length(text)/2;
	text{length(text)+1} = 'ht';
	%text too long for one text needed to get one line ht
	
	% wrapping texts
	position(3) = .8*posULW(3)-2*space_fr;
	h = uicontrol(hd_fig,'Position',position,'fontname',font); 
	% stupid but you must create a temporary object 
	% as textwrap needs a handle and a box_width.
	[wrapped_title, posit]  = protected_textwrap(h,title);
	title_v_space = posit(4);
	delete(h);
	position(3) = .75*posULW(3)-2*space_fr;
	
	h = uicontrol(hd_fig,'Position',position,'fontname',font); 	
	for i = 1:length(text) % I need the last one for bow height
		[wrapped_text{i}, posit]  = protected_textwrap(h,text{i});
		text_v_space(i) = posit(4);
	end
	delete(h);	
	
	box_h = text_v_space(length(text)) + 2*space_fr;
	
	total_h = title_v_space + sum(text_v_space(1:nbr_text)) + (3+nbr_text)*space_fr;
	
	pos_frame = [posULW(1)				posULW(2)-total_h 								posULW(3)				total_h  ];
	pos_title = [posULW(1)+space_fr		posULW(2)-title_v_space-space_fr-space_fr		posULW(3)-2*space_fr	title_v_space+space_fr ];
	
	ihd = ihd + 1;
	hd_gr(ihd) = uicontrol('parent',hd_fig,...
	'position',pos_frame,...
	'Style','Frame');
	
	ihd = ihd + 1;
	hd_gr(ihd) = uicontrol('parent',hd_fig,...
	'position',  pos_title,...
	'String',wrapped_title,...
	'ForegroundColor','red',...
	'FontName',font,...
	'Style','Text');
	
	posit_box  = [posULW(1)+space_fr					posULW(2)-title_v_space				.25*posULW(3)				box_h ];
	posit_text = [posit_box(1)+posit_box(3)+space_fr	posULW(2)-title_v_space-2*space_fr	.70*posULW(3)-2*space_fr	0 ];
	
	for i = 1:nbr_text
		posit_text(2) = posit_text(2) - text_v_space(i) - space_fr; 
		posit_text(4) = text_v_space(i) + space_fr;
		posit_box(2) = posit_box(2) - text_v_space(i) - space_fr ;
		
		ihd = ihd + 1;
		hd_gr(ihd) = uicontrol('parent',hd_fig,...
		'position',  posit_text,...
		'String',wrapped_text{i},...
		'FontName',font,...
		'HorizontalAlignment','left',...		
		'Style','text');
		
		ihd = ihd + 1;
		hd_gr(ihd) = uicontrol('parent',hd_fig,...
		'position',  posit_box,...
		'HorizontalAlignment','left',...
		'FontName',font,...
		'String',text{nbr_text+i},...
		'Style','edit');
		
		hdl(i) = hd_gr(ihd);
	end

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% NEW VERSION NOT FINISHED
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	
case 'new_togglebutton'

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% toggle buttons in a frame + text(in button, SHORT) + 1 button
	% title = ' ', skip title line
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% wrapping title
	h = uicontrol(hd_fig,'Position',position,'fontname',font); 
	% stupid but you must create a temporary object 
	% as textwrap needs a handle and a box_width.
	[wrapped_title, posit]  = protected_textwrap(h,title);
	title_v_space = posit(4);
	delete(h);
	
	pos_frame = [posULW(1)				posULW(2)-title_v_space-but_h-4*space_fr		posULW(3)				title_v_space+but_h+4*space_fr  ];
	if ~strcmp(title,' ')
		pos_title = [posULW(1)+space_fr		posULW(2)-title_v_space-space_fr-space_fr		posULW(3)-2*space_fr	title_v_space+space_fr ];
	else
		title_v_space = 0;
	end
	pos_butt  = [posULW(1)+5*space_fr	posULW(2)-title_v_space-but_h-3*space_fr		posULW(3)-10*space_fr	but_h+space_fr ];
	
	ihd = ihd + 1;
	hd_gr(ihd) = uicontrol('parent',hd_fig,...
	'position',pos_frame,...
	'Style','Frame');
	
	if ~strcmp(title,' ')
		ihd = ihd + 1;
		hd_gr(ihd) = uicontrol('parent',hd_fig,...
		'position',  pos_title,...
		'String',wrapped_title,...
		'ForegroundColor','red',...
		'FontName',font,...
		'Style','Text');
	end

	ihd = ihd + 1;
	hd_gr(ihd) = uicontrol('parent',hd_fig,...
	'position',  pos_butt,...
	'String',text,...
	'ForegroundColor','red',...
	'BackgroundColor','yellow',...
	'FontName',font,...
	'Style','togglebutton');
	
	hdl(1) = hd_gr(ihd);
	
case 'new_pushbutton'

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% pushbuttons in a frame + title [] + text []
	% color green blaack except if text = DO IT then red black
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	title = 'Push button only when all requests over';
	text = 'DO IT';
	
	% wrapping texts
	h = uicontrol(hd_fig,'Position',position,'fontname',font); 
	% stupid but you must create a temporary object 
	% as textwrap needs a handle and a box_width.
	[wrapped_title, posit]  = protected_textwrap(h,title);
	title_v_space = posit(4);
	delete(h);
	
	pos_frame = [posULW(1)				posULW(2)-title_v_space-but_h-4*space_fr		posULW(3)				title_v_space+but_h+4*space_fr  ];
	pos_title = [posULW(1)+space_fr		posULW(2)-title_v_space-space_fr-space_fr		posULW(3)-2*space_fr	title_v_space+space_fr ];
	pos_butt  = [posULW(1)+5*space_fr	posULW(2)-title_v_space-but_h-3*space_fr		posULW(3)-10*space_fr	but_h+space_fr ];
	
	ihd = ihd + 1;
	hd_gr(ihd) = uicontrol('parent',hd_fig,...
	'position',pos_frame,...
	'Style','Frame');
	
	ihd = ihd + 1;
	hd_gr(ihd) = uicontrol('parent',hd_fig,...
	'position',  pos_title,...
	'String',title,...
	'ForegroundColor','red',...
	'FontName',font,...
	'Style','Text');
	
	ihd = ihd + 1;
	hd_gr(ihd) = uicontrol('parent',hd_fig,...
	'position',  pos_butt,...
	'String',text,...
	'ForegroundColor','black',...
	'BackgroundColor','red',...
	'FontName',font,...
	'callback','clb_control;uiresume;',...
	'userdata','not done',...
	'Style','pushbutton');
	
	hdl(1) = hd_gr(ihd);
	
	
case 'multiplechoice_on_figure'

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% a green button push with text = title,  for getting detail request =
	% several small toggelbuttons in a frame + title +   buttons one per text
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	pos_frame = [posULW(1)				posULW(2)-but_h-4*space_fr		posULW(3)				but_h+4*space_fr  ];
	pos_butt  = [posULW(1)+5*space_fr	posULW(2)-but_h-3*space_fr		posULW(3)-10*space_fr	but_h+space_fr ];
	
	ihd = ihd + 1;
	hd_gr(ihd) = uicontrol('parent',hd_fig,...
	'position',pos_frame,...
	'Style','Frame');
	
	ihd = ihd + 1;
	hd_gr(ihd) = uicontrol('parent',hd_fig,...
	'position',  pos_butt,...
	'String',title,...
	'ForegroundColor','black',...
	'BackgroundColor','green',...
	'FontName',font,...
	'callback','clb_show_queries;uiresume;',...
	'userdata','not done',...
	'Style','pushbutton');
	
	% get window in middle of everything
	
	screen_size = get(0,'SreenSize');
	hd_fig_query = figure('Name','title');
	set(gcf,'position',[.3*screen_size(3) .3*screen_size(4)  .4*screen_size(3) .4*screen_size(4)]);
	
	position = [.01 .01 .98 .98];
	
	h = uicontrol(hd_fig,'Position',position,'fontname',font); 	
	for i = 1:length(text)
		[wrapped_text{i}, posit]  = protected_textwrap(h,text{i});
		text_v_space(i) = posit(4);
	end
	delete(h);	
	
	but_h = .02;
	but_w = .04
	posit_but  = [.02+space_fr					.98		but_w			but_h ];
	posit_text = [posit_but(1)+posit_but(3)+space_fr	posULW(2)-3*space_fr	.98 -(posit_but(1)+posit_but(3)+3*space_fr)   	0 ];
	
	for i = 1:length(text)
		posit_text(2) = posit_text(2) - text_v_space(i) - space_fr; 
		posit_text(4) = text_v_space(i) + space_fr;
		posit_but(2)  = posit_but(2)  - text_v_space(i) - space_fr ;
		
		ihd = ihd + 1;
		hd_gr(ihd) = uicontrol('parent',hd_fig,...
		'position',  posit_text,...
		'String',wrapped_text{i},...
		'FontName',font,...
		'HorizontalAlignment','left',...		
		'Style','text');
		
		clb = 'vv = get(gco,''value'');if vv == 0; set(gco,''BackgroundColor'',''white'');else;set(gco,''BackgroundColor'',''red'');end;';
		ihd = ihd + 1;
		hd_gr(ihd) = uicontrol('parent',hd_fig,...
		'position',  posit_but,...
		'BackgroundColor','white',...
		'Callback',clb,...
		'Style','togglebutton');
		
		hdl(i) = hd_gr(ihd);
	end

	% at bottom an OK cancel button 
	[choice] = text_with_n_buttons(hd_fig_query, 'Confirm your choice', {'OK','Cancel'}, [.1 .1  .8  .1])
	
	if choice == 1
		% OK option
		
	else
		% cancel we read nothing
	end


	delete(hd_fig_query)
	
case 'queries_on_figure'

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% several queries in a frame + title +  boxes one per text
	% default answers alos in text, text = q1 q2 q3 ... def1 def2 def3 ...
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	nbr_text = length(text)/2;
	text{length(text)+1} = 'ht';
	%text too long for one text needed to get one line ht
	
	% wrapping texts
	position(3) = .8*posULW(3)-2*space_fr;
	h = uicontrol(hd_fig,'Position',position,'fontname',font); 
	% stupid but you must create a temporary object 
	% as textwrap needs a handle and a box_width.
	[wrapped_title, posit]  = protected_textwrap(h,title);
	title_v_space = posit(4);
	delete(h);
	position(3) = .75*posULW(3)-2*space_fr;
	
	h = uicontrol(hd_fig,'Position',position,'fontname',font); 	
	for i = 1:length(text) % I need the last one for bow height
		[wrapped_text{i}, posit]  = protected_textwrap(h,text{i});
		text_v_space(i) = posit(4);
	end
	delete(h);	
	
	box_h = text_v_space(length(text)) + 2*space_fr;
	
	total_h = title_v_space + sum(text_v_space(1:nbr_text)) + (3+nbr_text)*space_fr;
	
	pos_frame = [posULW(1)				posULW(2)-total_h 								posULW(3)				total_h  ];
	pos_title = [posULW(1)+space_fr		posULW(2)-title_v_space-space_fr-space_fr		posULW(3)-2*space_fr	title_v_space+space_fr ];
	
	ihd = ihd + 1;
	hd_gr(ihd) = uicontrol('parent',hd_fig,...
	'position',pos_frame,...
	'Style','Frame');
	
	ihd = ihd + 1;
	hd_gr(ihd) = uicontrol('parent',hd_fig,...
	'position',  pos_title,...
	'String',wrapped_title,...
	'ForegroundColor','red',...
	'FontName',font,...
	'Style','Text');
	
	posit_box  = [posULW(1)+space_fr					posULW(2)-title_v_space				.25*posULW(3)				box_h ];
	posit_text = [posit_box(1)+posit_box(3)+space_fr	posULW(2)-title_v_space-2*space_fr	.70*posULW(3)-2*space_fr	0 ];
	
	for i = 1:nbr_text
		posit_text(2) = posit_text(2) - text_v_space(i) - space_fr; 
		posit_text(4) = text_v_space(i) + space_fr;
		posit_box(2) = posit_box(2) - text_v_space(i) - space_fr ;
		
		ihd = ihd + 1;
		hd_gr(ihd) = uicontrol('parent',hd_fig,...
		'position',  posit_text,...
		'String',wrapped_text{i},...
		'FontName',font,...
		'HorizontalAlignment','left',...		
		'Style','text');
		
		ihd = ihd + 1;
		hd_gr(ihd) = uicontrol('parent',hd_fig,...
		'position',  posit_box,...
		'HorizontalAlignment','left',...
		'FontName',font,...
		'String',text{nbr_text+i},...
		'Style','edit');
		
		hdl(i) = hd_gr(ihd);
	end

otherwise
	%
end

botom_level = pos_frame(2); % to know where starting next control box
